/*

  Some of the software provided in this file may be offered under an open source
  license. If some of the software in this file is offered under an open source
  license, information about that license will appear in this file.

  All other software provided in this file is
  Copyright (c) 2012-2014 Zulip, Inc. and is provided under the license
  described in the Zulip Terms of Service: https://zulip.com/terms
*/
/*

 The "bootstrap-notify" Software from "Goodybag, Inc." is:
 Copyright 2013 Nijiko Yonskai @nijikokun
 Copyright 2012 Goodybag, Inc.
 and is provided
 under the following license (the bootstrap-notify software has been modified):
 --
 TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION

 1. Definitions.

 "License" shall mean the terms and conditions for use, reproduction, and
 distribution as defined by Sections 1 through 9 of this document.

 "Licensor" shall mean the copyright owner or entity authorized by the copyright
 owner that is granting the License.

 "Legal Entity" shall mean the union of the acting entity and all other entities
 that control, are controlled by, or are under common control with that
 entity. For the purposes of this definition, "control" means (i) the power,
 direct or indirect, to cause the direction or management of such entity,
 whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or
 more of the outstanding shares, or (iii) beneficial ownership of such entity.

 "You" (or "Your") shall mean an individual or Legal Entity exercising
 permissions granted by this License.

 "Source" form shall mean the preferred form for making modifications, including
 but not limited to software source code, documentation source, and
 configuration files.

 "Object" form shall mean any form resulting from mechanical transformation or
 translation of a Source form, including but not limited to compiled object
 code, generated documentation, and conversions to other media types.

 "Work" shall mean the work of authorship, whether in Source or Object form,
 made available under the License, as indicated by a copyright notice that is
 included in or attached to the work (an example is provided in the Appendix
 below).

 "Derivative Works" shall mean any work, whether in Source or Object form, that
 is based on (or derived from) the Work and for which the editorial revisions,
 annotations, elaborations, or other modifications represent, as a whole, an
 original work of authorship. For the purposes of this License, Derivative Works
 shall not include works that remain separable from, or merely link (or bind by
 name) to the interfaces of, the Work and Derivative Works thereof.

 "Contribution" shall mean any work of authorship, including the original
 version of the Work and any modifications or additions to that Work or
 Derivative Works thereof, that is intentionally submitted to Licensor for
 inclusion in the Work by the copyright owner or by an individual or Legal
 Entity authorized to submit on behalf of the copyright owner. For the purposes
 of this definition, "submitted" means any form of electronic, verbal, or
 written communication sent to the Licensor or its representatives, including
 but not limited to communication on electronic mailing lists, source code
 control systems, and issue tracking systems that are managed by, or on behalf
 of, the Licensor for the purpose of discussing and improving the Work, but
 excluding communication that is conspicuously marked or otherwise designated in
 writing by the copyright owner as "Not a Contribution."

 "Contributor" shall mean Licensor and any individual or Legal Entity on behalf
 of whom a Contribution has been received by Licensor and subsequently
 incorporated within the Work.

 2. Grant of Copyright License. Subject to the terms and conditions of this
 License, each Contributor hereby grants to You a perpetual, worldwide,
 non-exclusive, no-charge, royalty-free, irrevocable copyright license to
 reproduce, prepare Derivative Works of, publicly display, publicly perform,
 sublicense, and distribute the Work and such Derivative Works in Source or
 Object form.

 3. Grant of Patent License. Subject to the terms and conditions of this
 License, each Contributor hereby grants to You a perpetual, worldwide,
 non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this
 section) patent license to make, have made, use, offer to sell, sell, import,
 and otherwise transfer the Work, where such license applies only to those
 patent claims licensable by such Contributor that are necessarily infringed by
 their Contribution(s) alone or by combination of their Contribution(s) with the
 Work to which such Contribution(s) was submitted. If You institute patent
 litigation against any entity (including a cross-claim or counterclaim in a
 lawsuit) alleging that the Work or a Contribution incorporated within the Work
 constitutes direct or contributory patent infringement, then any patent
 licenses granted to You under this License for that Work shall terminate as of
 the date such litigation is filed.

 4. Redistribution. You may reproduce and distribute copies of the Work or
 Derivative Works thereof in any medium, with or without modifications, and in
 Source or Object form, provided that You meet the following conditions:

 You must give any other recipients of the Work or Derivative Works a copy of
 this License; and You must cause any modified files to carry prominent notices
 stating that You changed the files; and You must retain, in the Source form of
 any Derivative Works that You distribute, all copyright, patent, trademark, and
 attribution notices from the Source form of the Work, excluding those notices
 that do not pertain to any part of the Derivative Works; and If the Work
 includes a "NOTICE" text file as part of its distribution, then any Derivative
 Works that You distribute must include a readable copy of the attribution
 notices contained within such NOTICE file, excluding those notices that do not
 pertain to any part of the Derivative Works, in at least one of the following
 places: within a NOTICE text file distributed as part of the Derivative Works;
 within the Source form or documentation, if provided along with the Derivative
 Works; or, within a display generated by the Derivative Works, if and wherever
 such third-party notices normally appear. The contents of the NOTICE file are
 for informational purposes only and do not modify the License. You may add Your
 own attribution notices within Derivative Works that You distribute, alongside
 or as an addendum to the NOTICE text from the Work, provided that such
 additional attribution notices cannot be construed as modifying the License.

 You may add Your own copyright statement to Your modifications and may provide
 additional or different license terms and conditions for use, reproduction, or
 distribution of Your modifications, or for any such Derivative Works as a
 whole, provided Your use, reproduction, and distribution of the Work otherwise
 complies with the conditions stated in this License.  5. Submission of
 Contributions. Unless You explicitly state otherwise, any Contribution
 intentionally submitted for inclusion in the Work by You to the Licensor shall
 be under the terms and conditions of this License, without any additional terms
 or conditions. Notwithstanding the above, nothing herein shall supersede or
 modify the terms of any separate license agreement you may have executed with
 Licensor regarding such Contributions.

 6. Trademarks. This License does not grant permission to use the trade names,
 trademarks, service marks, or product names of the Licensor, except as required
 for reasonable and customary use in describing the origin of the Work and
 reproducing the content of the NOTICE file.

 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in
 writing, Licensor provides the Work (and each Contributor provides its
 Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 KIND, either express or implied, including, without limitation, any warranties
 or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
 PARTICULAR PURPOSE. You are solely responsible for determining the
 appropriateness of using or redistributing the Work and assume any risks
 associated with Your exercise of permissions under this License.

 8. Limitation of Liability. In no event and under no legal theory, whether in
 tort (including negligence), contract, or otherwise, unless required by
 applicable law (such as deliberate and grossly negligent acts) or agreed to in
 writing, shall any Contributor be liable to You for damages, including any
 direct, indirect, special, incidental, or consequential damages of any
 character arising as a result of this License or out of the use or inability to
 use the Work (including but not limited to damages for loss of goodwill, work
 stoppage, computer failure or malfunction, or any and all other commercial
 damages or losses), even if such Contributor has been advised of the
 possibility of such damages.

 9. Accepting Warranty or Additional Liability. While redistributing the Work or
 Derivative Works thereof, You may choose to offer, and charge a fee for,
 acceptance of support, warranty, indemnity, or other liability obligations
 and/or rights consistent with this License. However, in accepting such
 obligations, You may act only on Your own behalf and on Your sole
 responsibility, not on behalf of any other Contributor, and only if You agree
 to indemnify, defend, and hold each Contributor harmless for any liability
 incurred by, or claims asserted against, such Contributor by reason of your
 accepting any such warranty or additional liability.

 END OF TERMS AND CONDITIONS
 --
*/
(function(f){var h=function(b,a){this.$element=f(b);this.$note=f('<div class="alert"></div>');this.options=f.extend(!0,{},f.fn.notify.defaults,a);this._link=null;this.options.transition?"fade"===this.options.transition?this.$note.addClass("in").addClass(this.options.transition):this.$note.addClass(this.options.transition):this.$note.addClass("fade").addClass("in");this.options.type?this.$note.addClass("alert-"+this.options.type):this.$note.addClass("alert-success");this.options.message&&("string"===
typeof this.options.message?this.$note.html(this.options.message):"object"===typeof this.options.message&&(this.options.message.html?this.$note.html(this.options.message.html):this.options.message.text&&this.$note.text(this.options.message.text)));this.options.closable&&(this._link=f('<a class="close pull-right">&times;</a>'),f(this._link).on("click",f.proxy(h.onClose,this)),this.$note.prepend(this._link));return this};h.onClose=function(){this.options.onClose();f(this.$note).remove();this.options.onClosed()};
h.prototype.show=function(){this.options.fadeOut.enabled&&this.$note.delay(this.options.fadeOut.delay||3E3).fadeOut("slow",f.proxy(h.onClose,this));this.$element.append(this.$note);this.$note.alert()};h.prototype.hide=function(){this.options.fadeOut.enabled?this.$note.delay(this.options.fadeOut.delay||3E3).fadeOut("slow",f.proxy(h.onClose,this)):h.onClose.call(this)};f.fn.notify=function(b){return new h(this,b)};f.fn.notify.defaults={type:"success",closable:!0,transition:"fade",fadeOut:{enabled:!0,
delay:3E3},message:null,onClose:function(){},onClosed:function(){}}})(window.jQuery);(function(f){function h(){this.fake=!0;this.boundary="--------FormData"+Math.random();this._fields=[]}f.FormData||(h.prototype.append=function(b,a){this._fields.push([b,a])},h.prototype.toString=function(){var b=this.boundary,a="";this._fields.forEach(function(e){a+="--"+b+"\r\n";if(e[1].name){var d=e[1];a+='Content-Disposition: form-data; name="'+e[0]+'"; filename="'+d.name+'"\r\n';a+="Content-Type: "+d.type+"\r\n\r\n";a+=d.getAsBinary()+"\r\n"}else a+='Content-Disposition: form-data; name="'+e[0]+
'";\r\n\r\n',a+=e[1]+"\r\n"});return a+="--"+b+"--"},f.FormData=h)})(window);/*

 Software from "jQuery Validation Plugin 1.9.0" is
 Copyright (c) 2006 - 2011 J?rn Zaefferer and is provided under the following
 license:
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
(function(f){f.extend(f.fn,{validate:function(h){if(this.length){var b=f.data(this[0],"validator");if(b)return b;this.attr("novalidate","novalidate");b=new f.validator(h,this[0]);f.data(this[0],"validator",b);b.settings.onsubmit&&(h=this.find("input, button"),h.filter(".cancel").click(function(){b.cancelSubmit=!0}),b.settings.submitHandler&&h.filter(":submit").click(function(){b.submitButton=this}),this.submit(function(a){function e(){if(b.settings.submitHandler){if(b.submitButton)var a=f("<input type='hidden'/>").attr("name",
b.submitButton.name).val(b.submitButton.value).appendTo(b.currentForm);b.settings.submitHandler.call(b,b.currentForm);b.submitButton&&a.remove();return!1}return!0}b.settings.debug&&a.preventDefault();if(b.cancelSubmit)return b.cancelSubmit=!1,e();if(b.form())return b.pendingRequest?(b.formSubmitted=!0,!1):e();b.focusInvalid();return!1}));return b}h&&h.debug&&window.console&&console.warn("nothing selected, can't validate, returning nothing")},valid:function(){if(f(this[0]).is("form"))return this.validate().form();
var h=!0,b=f(this[0].form).validate();this.each(function(){h&=b.element(this)});return h},removeAttrs:function(h){var b={},a=this;f.each(h.split(/\s/),function(e,d){b[d]=a.attr(d);a.removeAttr(d)});return b},rules:function(h,b){var a=this[0];if(h){var e=f.data(a.form,"validator").settings,d=e.rules,c=f.validator.staticRules(a);switch(h){case "add":f.extend(c,f.validator.normalizeRule(b));d[a.name]=c;b.messages&&(e.messages[a.name]=f.extend(e.messages[a.name],b.messages));break;case "remove":if(!b)return delete d[a.name],
c;var g={};f.each(b.split(/\s/),function(a,b){g[b]=c[b];delete c[b]});return g}}a=f.validator.normalizeRules(f.extend({},f.validator.metadataRules(a),f.validator.classRules(a),f.validator.attributeRules(a),f.validator.staticRules(a)),a);a.required&&(e=a.required,delete a.required,a=f.extend({required:e},a));return a}});f.extend(f.expr[":"],{blank:function(h){return!f.trim(""+h.value)},filled:function(h){return!!f.trim(""+h.value)},unchecked:function(f){return!f.checked}});f.validator=function(h,b){this.settings=
f.extend(!0,{},f.validator.defaults,h);this.currentForm=b;this.init()};f.validator.format=function(h,b){if(1==arguments.length)return function(){var a=f.makeArray(arguments);a.unshift(h);return f.validator.format.apply(this,a)};2<arguments.length&&b.constructor!=Array&&(b=f.makeArray(arguments).slice(1));b.constructor!=Array&&(b=[b]);f.each(b,function(a,b){h=h.replace(RegExp("\\{"+a+"\\}","g"),b)});return h};f.extend(f.validator,{defaults:{messages:{},groups:{},rules:{},errorClass:"error",validClass:"valid",
errorElement:"label",focusInvalid:!0,errorContainer:f([]),errorLabelContainer:f([]),onsubmit:!0,ignore:":hidden",ignoreTitle:!1,onfocusin:function(f,b){this.lastActive=f;this.settings.focusCleanup&&!this.blockFocusCleanup&&(this.settings.unhighlight&&this.settings.unhighlight.call(this,f,this.settings.errorClass,this.settings.validClass),this.addWrapper(this.errorsFor(f)).hide())},onfocusout:function(f,b){!this.checkable(f)&&(f.name in this.submitted||!this.optional(f))&&this.element(f)},onkeyup:function(f,
b){(f.name in this.submitted||f==this.lastElement)&&this.element(f)},onclick:function(f,b){f.name in this.submitted?this.element(f):f.parentNode.name in this.submitted&&this.element(f.parentNode)},highlight:function(h,b,a){"radio"===h.type?this.findByName(h.name).addClass(b).removeClass(a):f(h).addClass(b).removeClass(a)},unhighlight:function(h,b,a){"radio"===h.type?this.findByName(h.name).removeClass(b).addClass(a):f(h).removeClass(b).addClass(a)}},setDefaults:function(h){f.extend(f.validator.defaults,
h)},messages:{required:"This field is required.",remote:"Please fix this field.",email:"Please enter a valid email address.",url:"Please enter a valid URL.",date:"Please enter a valid date.",dateISO:"Please enter a valid date (ISO).",number:"Please enter a valid number.",digits:"Please enter only digits.",creditcard:"Please enter a valid credit card number.",equalTo:"Please enter the same value again.",accept:"Please enter a value with a valid extension.",maxlength:f.validator.format("Please enter no more than {0} characters."),
minlength:f.validator.format("Please enter at least {0} characters."),rangelength:f.validator.format("Please enter a value between {0} and {1} characters long."),range:f.validator.format("Please enter a value between {0} and {1}."),max:f.validator.format("Please enter a value less than or equal to {0}."),min:f.validator.format("Please enter a value greater than or equal to {0}.")},autoCreateRanges:!1,prototype:{init:function(){function h(a){var b=f.data(this[0].form,"validator"),c="on"+a.type.replace(/^validate/,
"");b.settings[c]&&b.settings[c].call(b,this[0],a)}this.labelContainer=f(this.settings.errorLabelContainer);this.errorContext=this.labelContainer.length&&this.labelContainer||f(this.currentForm);this.containers=f(this.settings.errorContainer).add(this.settings.errorLabelContainer);this.submitted={};this.valueCache={};this.pendingRequest=0;this.pending={};this.invalid={};this.reset();var b=this.groups={};f.each(this.settings.groups,function(a,d){f.each(d.split(/\s/),function(c,g){b[g]=a})});var a=
this.settings.rules;f.each(a,function(b,d){a[b]=f.validator.normalizeRule(d)});f(this.currentForm).validateDelegate("[type='text'], [type='password'], [type='file'], select, textarea, [type='number'], [type='search'] ,[type='tel'], [type='url'], [type='email'], [type='datetime'], [type='date'], [type='month'], [type='week'], [type='time'], [type='datetime-local'], [type='range'], [type='color'] ","focusin focusout keyup",h).validateDelegate("[type='radio'], [type='checkbox'], select, option","click",
h);this.settings.invalidHandler&&f(this.currentForm).bind("invalid-form.validate",this.settings.invalidHandler)},form:function(){this.checkForm();f.extend(this.submitted,this.errorMap);this.invalid=f.extend({},this.errorMap);this.valid()||f(this.currentForm).triggerHandler("invalid-form",[this]);this.showErrors();return this.valid()},checkForm:function(){this.prepareForm();for(var f=0,b=this.currentElements=this.elements();b[f];f++)this.check(b[f]);return this.valid()},element:function(h){this.lastElement=
h=this.validationTargetFor(this.clean(h));this.prepareElement(h);this.currentElements=f(h);var b=this.check(h);b?delete this.invalid[h.name]:this.invalid[h.name]=!0;this.numberOfInvalids()||(this.toHide=this.toHide.add(this.containers));this.showErrors();return b},showErrors:function(h){if(h){f.extend(this.errorMap,h);this.errorList=[];for(var b in h)this.errorList.push({message:h[b],element:this.findByName(b)[0]});this.successList=f.grep(this.successList,function(a){return!(a.name in h)})}this.settings.showErrors?
this.settings.showErrors.call(this,this.errorMap,this.errorList):this.defaultShowErrors()},resetForm:function(){f.fn.resetForm&&f(this.currentForm).resetForm();this.submitted={};this.lastElement=null;this.prepareForm();this.hideErrors();this.elements().removeClass(this.settings.errorClass)},numberOfInvalids:function(){return this.objectLength(this.invalid)},objectLength:function(f){var b=0,a;for(a in f)b++;return b},hideErrors:function(){this.addWrapper(this.toHide).hide()},valid:function(){return 0==
this.size()},size:function(){return this.errorList.length},focusInvalid:function(){if(this.settings.focusInvalid)try{f(this.findLastActive()||this.errorList.length&&this.errorList[0].element||[]).filter(":visible").focus().trigger("focusin")}catch(h){}},findLastActive:function(){var h=this.lastActive;return h&&1==f.grep(this.errorList,function(b){return b.element.name==h.name}).length&&h},elements:function(){var h=this,b={};return f(this.currentForm).find("input, select, textarea").not(":submit, :reset, :image, [disabled]").not(this.settings.ignore).filter(function(){!this.name&&
h.settings.debug&&window.console&&console.error("%o has no name assigned",this);return this.name in b||!h.objectLength(f(this).rules())?!1:b[this.name]=!0})},clean:function(h){return f(h)[0]},errors:function(){return f(this.settings.errorElement+"."+this.settings.errorClass,this.errorContext)},reset:function(){this.successList=[];this.errorList=[];this.errorMap={};this.toShow=f([]);this.toHide=f([]);this.currentElements=f([])},prepareForm:function(){this.reset();this.toHide=this.errors().add(this.containers)},
prepareElement:function(f){this.reset();this.toHide=this.errorsFor(f)},check:function(h){h=this.validationTargetFor(this.clean(h));var b=f(h).rules(),a=!1,e;for(e in b){var d={method:e,parameters:b[e]};try{var c=f.validator.methods[e].call(this,h.value.replace(/\r/g,""),h,d.parameters);if("dependency-mismatch"==c)a=!0;else{a=!1;if("pending"==c){this.toHide=this.toHide.not(this.errorsFor(h));return}if(!c)return this.formatAndAdd(h,d),!1}}catch(g){throw this.settings.debug&&window.console&&console.log("exception occured when checking element "+
h.id+", check the '"+d.method+"' method",g),g;}}if(!a)return this.objectLength(b)&&this.successList.push(h),!0},customMetaMessage:function(h,b){if(f.metadata){var a=this.settings.meta?f(h).metadata()[this.settings.meta]:f(h).metadata();return a&&a.messages&&a.messages[b]}},customMessage:function(f,b){var a=this.settings.messages[f];return a&&(a.constructor==String?a:a[b])},findDefined:function(){for(var f=0;f<arguments.length;f++)if(void 0!==arguments[f])return arguments[f]},defaultMessage:function(h,
b){return this.findDefined(this.customMessage(h.name,b),this.customMetaMessage(h,b),!this.settings.ignoreTitle&&h.title||void 0,f.validator.messages[b],"<strong>Warning: No message defined for "+h.name+"</strong>")},formatAndAdd:function(f,b){var a=this.defaultMessage(f,b.method),e=/\$?\{(\d+)\}/g;"function"==typeof a?a=a.call(this,b.parameters,f):e.test(a)&&(a=jQuery.format(a.replace(e,"{$1}"),b.parameters));this.errorList.push({message:a,element:f});this.errorMap[f.name]=a;this.submitted[f.name]=
a},addWrapper:function(f){this.settings.wrapper&&(f=f.add(f.parent(this.settings.wrapper)));return f},defaultShowErrors:function(){for(var f=0;this.errorList[f];f++){var b=this.errorList[f];this.settings.highlight&&this.settings.highlight.call(this,b.element,this.settings.errorClass,this.settings.validClass);this.showLabel(b.element,b.message)}this.errorList.length&&(this.toShow=this.toShow.add(this.containers));if(this.settings.success)for(f=0;this.successList[f];f++)this.showLabel(this.successList[f]);
if(this.settings.unhighlight){f=0;for(b=this.validElements();b[f];f++)this.settings.unhighlight.call(this,b[f],this.settings.errorClass,this.settings.validClass)}this.toHide=this.toHide.not(this.toShow);this.hideErrors();this.addWrapper(this.toShow).show()},validElements:function(){return this.currentElements.not(this.invalidElements())},invalidElements:function(){return f(this.errorList).map(function(){return this.element})},showLabel:function(h,b){var a=this.errorsFor(h);a.length?(a.removeClass(this.settings.validClass).addClass(this.settings.errorClass),
a.attr("generated")&&a.html(b)):(a=f("<"+this.settings.errorElement+"/>").attr({"for":this.idOrName(h),generated:!0}).addClass(this.settings.errorClass).html(b||""),this.settings.wrapper&&(a=a.hide().show().wrap("<"+this.settings.wrapper+"/>").parent()),this.labelContainer.append(a).length||(this.settings.errorPlacement?this.settings.errorPlacement(a,f(h)):a.insertAfter(h)));!b&&this.settings.success&&(a.text(""),"string"==typeof this.settings.success?a.addClass(this.settings.success):this.settings.success(a));
this.toShow=this.toShow.add(a)},errorsFor:function(h){var b=this.idOrName(h);return this.errors().filter(function(){return f(this).attr("for")==b})},idOrName:function(f){return this.groups[f.name]||(this.checkable(f)?f.name:f.id||f.name)},validationTargetFor:function(f){this.checkable(f)&&(f=this.findByName(f.name).not(this.settings.ignore)[0]);return f},checkable:function(f){return/radio|checkbox/i.test(f.type)},findByName:function(h){var b=this.currentForm;return f(document.getElementsByName(h)).map(function(a,
e){return e.form==b&&e.name==h&&e||null})},getLength:function(h,b){switch(b.nodeName.toLowerCase()){case "select":return f("option:selected",b).length;case "input":if(this.checkable(b))return this.findByName(b.name).filter(":checked").length}return h.length},depend:function(f,b){return this.dependTypes[typeof f]?this.dependTypes[typeof f](f,b):!0},dependTypes:{"boolean":function(f,b){return f},string:function(h,b){return!!f(h,b.form).length},"function":function(f,b){return f(b)}},optional:function(h){return!f.validator.methods.required.call(this,
f.trim(h.value),h)&&"dependency-mismatch"},startRequest:function(f){this.pending[f.name]||(this.pendingRequest++,this.pending[f.name]=!0)},stopRequest:function(h,b){this.pendingRequest--;0>this.pendingRequest&&(this.pendingRequest=0);delete this.pending[h.name];b&&0==this.pendingRequest&&this.formSubmitted&&this.form()?(f(this.currentForm).submit(),this.formSubmitted=!1):!b&&(0==this.pendingRequest&&this.formSubmitted)&&(f(this.currentForm).triggerHandler("invalid-form",[this]),this.formSubmitted=
!1)},previousValue:function(h){return f.data(h,"previousValue")||f.data(h,"previousValue",{old:null,valid:!0,message:this.defaultMessage(h,"remote")})}},classRuleSettings:{required:{required:!0},email:{email:!0},url:{url:!0},date:{date:!0},dateISO:{dateISO:!0},dateDE:{dateDE:!0},number:{number:!0},numberDE:{numberDE:!0},digits:{digits:!0},creditcard:{creditcard:!0}},addClassRules:function(h,b){h.constructor==String?this.classRuleSettings[h]=b:f.extend(this.classRuleSettings,h)},classRules:function(h){var b=
{};(h=f(h).attr("class"))&&f.each(h.split(" "),function(){this in f.validator.classRuleSettings&&f.extend(b,f.validator.classRuleSettings[this])});return b},attributeRules:function(h){var b={};h=f(h);for(var a in f.validator.methods){var e;(e="required"===a&&"function"===typeof f.fn.prop?h.prop(a):h.attr(a))?b[a]=e:h[0].getAttribute("type")===a&&(b[a]=!0)}b.maxlength&&/-1|2147483647|524288/.test(b.maxlength)&&delete b.maxlength;return b},metadataRules:function(h){if(!f.metadata)return{};var b=f.data(h.form,
"validator").settings.meta;return b?f(h).metadata()[b]:f(h).metadata()},staticRules:function(h){var b={},a=f.data(h.form,"validator");a.settings.rules&&(b=f.validator.normalizeRule(a.settings.rules[h.name])||{});return b},normalizeRules:function(h,b){f.each(h,function(a,e){if(!1===e)delete h[a];else if(e.param||e.depends){var d=!0;switch(typeof e.depends){case "string":d=!!f(e.depends,b.form).length;break;case "function":d=e.depends.call(b,b)}d?h[a]=void 0!==e.param?e.param:!0:delete h[a]}});f.each(h,
function(a,e){h[a]=f.isFunction(e)?e(b):e});f.each(["minlength","maxlength","min","max"],function(){h[this]&&(h[this]=Number(h[this]))});f.each(["rangelength","range"],function(){h[this]&&(h[this]=[Number(h[this][0]),Number(h[this][1])])});f.validator.autoCreateRanges&&(h.min&&h.max&&(h.range=[h.min,h.max],delete h.min,delete h.max),h.minlength&&h.maxlength&&(h.rangelength=[h.minlength,h.maxlength],delete h.minlength,delete h.maxlength));h.messages&&delete h.messages;return h},normalizeRule:function(h){if("string"==
typeof h){var b={};f.each(h.split(/\s/),function(){b[this]=!0});h=b}return h},addMethod:function(h,b,a){f.validator.methods[h]=b;f.validator.messages[h]=void 0!=a?a:f.validator.messages[h];3>b.length&&f.validator.addClassRules(h,f.validator.normalizeRule(h))},methods:{required:function(h,b,a){if(!this.depend(a,b))return"dependency-mismatch";switch(b.nodeName.toLowerCase()){case "select":return(h=f(b).val())&&0<h.length;case "input":if(this.checkable(b))return 0<this.getLength(h,b);default:return 0<
f.trim(h).length}},remote:function(h,b,a){if(this.optional(b))return"dependency-mismatch";var e=this.previousValue(b);this.settings.messages[b.name]||(this.settings.messages[b.name]={});e.originalMessage=this.settings.messages[b.name].remote;this.settings.messages[b.name].remote=e.message;a="string"==typeof a&&{url:a}||a;if(this.pending[b.name])return"pending";if(e.old===h)return e.valid;e.old=h;var d=this;this.startRequest(b);var c={};c[b.name]=h;f.ajax(f.extend(!0,{url:a,mode:"abort",port:"validate"+
b.name,dataType:"json",data:c,success:function(a){d.settings.messages[b.name].remote=e.originalMessage;var c=!0===a;if(c){var k=d.formSubmitted;d.prepareElement(b);d.formSubmitted=k;d.successList.push(b);d.showErrors()}else k={},a=a||d.defaultMessage(b,"remote"),k[b.name]=e.message=f.isFunction(a)?a(h):a,d.showErrors(k);e.valid=c;d.stopRequest(b,c)}},a));return"pending"},minlength:function(h,b,a){return this.optional(b)||this.getLength(f.trim(h),b)>=a},maxlength:function(h,b,a){return this.optional(b)||
this.getLength(f.trim(h),b)<=a},rangelength:function(h,b,a){h=this.getLength(f.trim(h),b);return this.optional(b)||h>=a[0]&&h<=a[1]},min:function(f,b,a){return this.optional(b)||f>=a},max:function(f,b,a){return this.optional(b)||f<=a},range:function(f,b,a){return this.optional(b)||f>=a[0]&&f<=a[1]},email:function(f,b){return this.optional(b)||/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i.test(f)},
url:function(f,b){return this.optional(b)||/^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i.test(f)},
date:function(f,b){return this.optional(b)||!/Invalid|NaN/.test(new Date(f))},dateISO:function(f,b){return this.optional(b)||/^\d{4}[\/-]\d{1,2}[\/-]\d{1,2}$/.test(f)},number:function(f,b){return this.optional(b)||/^-?(?:\d+|\d{1,3}(?:,\d{3})+)(?:\.\d+)?$/.test(f)},digits:function(f,b){return this.optional(b)||/^\d+$/.test(f)},creditcard:function(f,b){if(this.optional(b))return"dependency-mismatch";if(/[^0-9 -]+/.test(f))return!1;var a=0,e=0,d=!1;f=f.replace(/\D/g,"");for(var c=f.length-1;0<=c;c--){e=
f.charAt(c);e=parseInt(e,10);if(d&&9<(e*=2))e-=9;a+=e;d=!d}return 0==a%10},accept:function(f,b,a){a="string"==typeof a?a.replace(/,/g,"|"):"png|jpe?g|gif";return this.optional(b)||f.match(RegExp(".("+a+")$","i"))},equalTo:function(h,b,a){a=f(a).unbind(".validate-equalTo").bind("blur.validate-equalTo",function(){f(b).valid()});return h==a.val()}}});f.format=f.validator.format})(jQuery);
(function(f){var h={};if(f.ajaxPrefilter)f.ajaxPrefilter(function(a,b,d){b=a.port;"abort"==a.mode&&(h[b]&&h[b].abort(),h[b]=d)});else{var b=f.ajax;f.ajax=function(a){var e=("port"in a?a:f.ajaxSettings).port;return"abort"==("mode"in a?a:f.ajaxSettings).mode?(h[e]&&h[e].abort(),h[e]=b.apply(this,arguments)):b.apply(this,arguments)}}})(jQuery);
(function(f){!jQuery.event.special.focusin&&(!jQuery.event.special.focusout&&document.addEventListener)&&f.each({focus:"focusin",blur:"focusout"},function(h,b){function a(a){a=f.event.fix(a);a.type=b;return f.event.handle.call(this,a)}f.event.special[b]={setup:function(){this.addEventListener(h,a,!0)},teardown:function(){this.removeEventListener(h,a,!0)},handler:function(a){arguments[0]=f.event.fix(a);arguments[0].type=b;return f.event.handle.apply(this,arguments)}}});f.extend(f.fn,{validateDelegate:function(h,
b,a){return this.bind(b,function(b){var d=f(b.target);if(d.is(h))return a.apply(d,arguments)})}})})(jQuery);(function(f){function h(a){var b=a.data;a.isDefaultPrevented()||(a.preventDefault(),f(this).ajaxSubmit(b))}function b(a){var b=a.target,e=f(b);if(!e.is(":submit,input:image")){b=e.closest(":submit");if(0===b.length)return;b=b[0]}var d=this;d.clk=b;"image"==b.type&&(void 0!==a.offsetX?(d.clk_x=a.offsetX,d.clk_y=a.offsetY):"function"==typeof f.fn.offset?(e=e.offset(),d.clk_x=a.pageX-e.left,d.clk_y=a.pageY-e.top):(d.clk_x=a.pageX-b.offsetLeft,d.clk_y=a.pageY-b.offsetTop));setTimeout(function(){d.clk=
d.clk_x=d.clk_y=null},100)}function a(){if(f.fn.ajaxSubmit.debug){var a="[jquery.form] "+Array.prototype.join.call(arguments,"");window.console&&window.console.log?window.console.log(a):window.opera&&window.opera.postError&&window.opera.postError(a)}}var e,d;e=void 0!==f("<input type='file'/>").get(0).files;d=void 0!==window.FormData;f.fn.ajaxSubmit=function(b){function g(a){for(var e=new FormData,g=0;g<a.length;g++)e.append(a[g].name,a[g].value);if(b.extraData)for(var d in b.extraData)b.extraData.hasOwnProperty(d)&&
e.append(d,b.extraData[d]);b.data=null;a=f.extend(!0,{},f.ajaxSettings,b,{contentType:!1,processData:!1,cache:!1,type:"POST"});b.uploadProgress&&(a.xhr=function(){var a=jQuery.ajaxSettings.xhr();a.upload&&(a.upload.onprogress=function(a){var e=0,g=a.loaded||a.position,d=a.total;a.lengthComputable&&(e=Math.ceil(100*(g/d)));b.uploadProgress(a,g,d,e)});return a});a.data=null;var k=a.beforeSend;a.beforeSend=function(a,b){b.data=e;k&&k.call(this,a,b)};f.ajax(a)}function m(e){function g(){function b(){try{var e=
(q.contentWindow?q.contentWindow.document:q.contentDocument?q.contentDocument:q.document).readyState;a("state = "+e);e&&"uninitialized"==e.toLowerCase()&&setTimeout(b,50)}catch(c){a("Server abort: ",c," (",c.name,")"),d(O),M&&clearTimeout(M),M=void 0}}var e=r.attr("target"),c=r.attr("action");l.setAttribute("target",s);k||l.setAttribute("method","POST");c!=h.url&&l.setAttribute("action",h.url);!h.skipEncodingOverride&&(!k||/post/i.test(k))&&r.attr({encoding:"multipart/form-data",enctype:"multipart/form-data"});
h.timeout&&(M=setTimeout(function(){E=!0;d(N)},h.timeout));var m=[];try{if(h.extraData)for(var x in h.extraData)h.extraData.hasOwnProperty(x)&&(f.isPlainObject(h.extraData[x])&&h.extraData[x].hasOwnProperty("name")&&h.extraData[x].hasOwnProperty("value")?m.push(f('<input type="hidden" name="'+h.extraData[x].name+'">').attr("value",h.extraData[x].value).appendTo(l)[0]):m.push(f('<input type="hidden" name="'+x+'">').attr("value",h.extraData[x]).appendTo(l)[0]));h.iframeTarget||(v.appendTo("body"),q.attachEvent?
q.attachEvent("onload",d):q.addEventListener("load",d,!1));setTimeout(b,15);l.submit()}finally{l.setAttribute("action",c),e?l.setAttribute("target",e):r.removeAttr("target"),f(m).remove()}}function d(b){if(!n.aborted&&!J){try{L=q.contentWindow?q.contentWindow.document:q.contentDocument?q.contentDocument:q.document}catch(e){a("cannot access response document: ",e),b=O}if(b===N&&n)n.abort("timeout");else if(b==O&&n)n.abort("server abort");else if(L&&L.location.href!=h.iframeSrc||E){q.detachEvent?q.detachEvent("onload",
d):q.removeEventListener("load",d,!1);b="success";var c;try{if(E)throw"timeout";var g="xml"==h.dataType||L.XMLDocument||f.isXMLDoc(L);a("isXml="+g);if(!g&&(window.opera&&(null===L.body||!L.body.innerHTML))&&--Q){a("requeing onLoad callback, DOM not available");setTimeout(d,250);return}var k=L.body?L.body:L.documentElement;n.responseText=k?k.innerHTML:null;n.responseXML=L.XMLDocument?L.XMLDocument:L;g&&(h.dataType="xml");n.getResponseHeader=function(a){return{"content-type":h.dataType}[a]};k&&(n.status=
Number(k.getAttribute("status"))||n.status,n.statusText=k.getAttribute("statusText")||n.statusText);var l=(h.dataType||"").toLowerCase(),r=/(json|script|text)/.test(l);if(r||h.textarea){var m=L.getElementsByTagName("textarea")[0];if(m)n.responseText=m.value,n.status=Number(m.getAttribute("status"))||n.status,n.statusText=m.getAttribute("statusText")||n.statusText;else if(r){var x=L.getElementsByTagName("pre")[0],y=L.getElementsByTagName("body")[0];x?n.responseText=x.textContent?x.textContent:x.innerText:
y&&(n.responseText=y.textContent?y.textContent:y.innerText)}}else"xml"==l&&(!n.responseXML&&n.responseText)&&(n.responseXML=P(n.responseText));try{H=X(n,l,h)}catch(s){b="parsererror",n.error=c=s||b}}catch(A){a("error caught: ",A),b="error",n.error=c=A||b}n.aborted&&(a("upload aborted"),b=null);n.status&&(b=200<=n.status&&300>n.status||304===n.status?"success":"error");"success"===b?(h.success&&h.success.call(h.context,H,"success",n),p&&f.event.trigger("ajaxSuccess",[n,h])):b&&(void 0===c&&(c=n.statusText),
h.error&&h.error.call(h.context,n,b,c),p&&f.event.trigger("ajaxError",[n,h,c]));p&&f.event.trigger("ajaxComplete",[n,h]);p&&!--f.active&&f.event.trigger("ajaxStop");h.complete&&h.complete.call(h.context,n,b);J=!0;h.timeout&&clearTimeout(M);setTimeout(function(){h.iframeTarget||v.remove();n.responseXML=null},100)}}}var l=r[0],m,h,p,s,v,q,n,z,E,M;z=!!f.fn.prop;if(f(":input[name=submit],:input[id=submit]",l).length)alert('Error: Form elements must not have name or id of "submit".');else{if(e)for(m=0;m<
t.length;m++)e=f(t[m]),z?e.prop("disabled",!1):e.removeAttr("disabled");h=f.extend(!0,{},f.ajaxSettings,b);h.context=h.context||h;s="jqFormIO"+(new Date).getTime();h.iframeTarget?(v=f(h.iframeTarget),(e=v.attr("name"))?s=e:v.attr("name",s)):(v=f('<iframe name="'+s+'" src="'+h.iframeSrc+'" />'),v.css({position:"absolute",top:"-1000px",left:"-1000px"}));q=v[0];n={aborted:0,responseText:null,responseXML:null,status:0,statusText:"n/a",getAllResponseHeaders:function(){},getResponseHeader:function(){},
setRequestHeader:function(){},abort:function(b){var e="timeout"===b?"timeout":"aborted";a("aborting upload... "+e);this.aborted=1;if(q.contentWindow.document.execCommand)try{q.contentWindow.document.execCommand("Stop")}catch(c){}v.attr("src",h.iframeSrc);n.error=e;h.error&&h.error.call(h.context,n,e,b);p&&f.event.trigger("ajaxError",[n,h,e]);h.complete&&h.complete.call(h.context,n,e)}};(p=h.global)&&0===f.active++&&f.event.trigger("ajaxStart");p&&f.event.trigger("ajaxSend",[n,h]);if(h.beforeSend&&
!1===h.beforeSend.call(h.context,n,h))h.global&&f.active--;else if(!n.aborted){if(z=l.clk)if((e=z.name)&&!z.disabled)h.extraData=h.extraData||{},h.extraData[e]=z.value,"image"==z.type&&(h.extraData[e+".x"]=l.clk_x,h.extraData[e+".y"]=l.clk_y);var N=1,O=2;z=f("meta[name=csrf-token]").attr("content");if((e=f("meta[name=csrf-param]").attr("content"))&&z)h.extraData=h.extraData||{},h.extraData[e]=z;h.forceSync?g():setTimeout(g,10);var H,L,Q=50,J,P=f.parseXML||function(a,b){window.ActiveXObject?(b=new ActiveXObject("Microsoft.XMLDOM"),
b.async="false",b.loadXML(a)):b=(new DOMParser).parseFromString(a,"text/xml");return b&&b.documentElement&&"parsererror"!=b.documentElement.nodeName?b:null},ha=f.parseJSON||function(a){return window.eval("("+a+")")},X=function(a,b,e){var c=a.getResponseHeader("content-type")||"",g="xml"===b||!b&&0<=c.indexOf("xml");a=g?a.responseXML:a.responseText;g&&"parsererror"===a.documentElement.nodeName&&f.error&&f.error("parsererror");e&&e.dataFilter&&(a=e.dataFilter(a,b));"string"===typeof a&&("json"===b||
!b&&0<=c.indexOf("json")?a=ha(a):("script"===b||!b&&0<=c.indexOf("javascript"))&&f.globalEval(a));return a}}}}if(!this.length)return a("ajaxSubmit: skipping submit process - no element selected"),this;var k,l,r=this;"function"==typeof b&&(b={success:b});k=this.attr("method");l=this.attr("action");(l=(l="string"===typeof l?f.trim(l):"")||window.location.href||"")&&(l=(l.match(/^([^#]+)/)||[])[1]);b=f.extend(!0,{url:l,success:f.ajaxSettings.success,type:k||"GET",iframeSrc:/^https/i.test(window.location.href||
"")?"javascript:false":"about:blank"},b);l={};this.trigger("form-pre-serialize",[this,b,l]);if(l.veto)return a("ajaxSubmit: submit vetoed via form-pre-serialize trigger"),this;if(b.beforeSerialize&&!1===b.beforeSerialize(this,b))return a("ajaxSubmit: submit aborted via beforeSerialize callback"),this;var h=b.traditional;void 0===h&&(h=f.ajaxSettings.traditional);var t=[],s,q=this.formToArray(b.semantic,t);b.data&&(b.extraData=b.data,s=f.param(b.data,h));if(b.beforeSubmit&&!1===b.beforeSubmit(q,this,
b))return a("ajaxSubmit: submit aborted via beforeSubmit callback"),this;this.trigger("form-submit-validate",[q,this,b,l]);if(l.veto)return a("ajaxSubmit: submit vetoed via form-submit-validate trigger"),this;l=f.param(q,h);s&&(l=l?l+"&"+s:s);"GET"==b.type.toUpperCase()?(b.url+=(0<=b.url.indexOf("?")?"&":"?")+l,b.data=null):b.data=l;var v=[];b.resetForm&&v.push(function(){r.resetForm()});b.clearForm&&v.push(function(){r.clearForm(b.includeHidden)});if(!b.dataType&&b.target){var p=b.success||function(){};
v.push(function(a){var e=b.replaceTarget?"replaceWith":"html";f(b.target)[e](a).each(p,arguments)})}else b.success&&v.push(b.success);b.success=function(a,e,g){for(var d=b.context||this,f=0,k=v.length;f<k;f++)v[f].apply(d,[a,e,g||r,r])};s=0<f("input:file:enabled[value]",this).length;l="multipart/form-data"==r.attr("enctype")||"multipart/form-data"==r.attr("encoding");h=e&&d;a("fileAPI :"+h);!1!==b.iframe&&(b.iframe||(s||l)&&!h)?b.closeKeepAlive?f.get(b.closeKeepAlive,function(){m(q)}):m(q):(s||l)&&
h?g(q):f.ajax(b);for(s=0;s<t.length;s++)t[s]=null;this.trigger("form-submit-notify",[this,b]);return this};f.fn.ajaxForm=function(e){e=e||{};e.delegation=e.delegation&&f.isFunction(f.fn.on);if(!e.delegation&&0===this.length){var g=this.selector,d=this.context;if(!f.isReady&&g)return a("DOM not ready, queuing ajaxForm"),f(function(){f(g,d).ajaxForm(e)}),this;a("terminating; zero elements found by selector"+(f.isReady?"":" (DOM not ready)"));return this}return e.delegation?(f(document).off("submit.form-plugin",
this.selector,h).off("click.form-plugin",this.selector,b).on("submit.form-plugin",this.selector,e,h).on("click.form-plugin",this.selector,e,b),this):this.ajaxFormUnbind().bind("submit.form-plugin",e,h).bind("click.form-plugin",e,b)};f.fn.ajaxFormUnbind=function(){return this.unbind("submit.form-plugin click.form-plugin")};f.fn.formToArray=function(a,b){var d=[];if(0===this.length)return d;var k=this[0],l=a?k.getElementsByTagName("*"):k.elements;if(!l)return d;var h,n,t,s,q,v;h=0;for(v=l.length;h<
v;h++)if(q=l[h],t=q.name)if(a&&k.clk&&"image"==q.type)!q.disabled&&k.clk==q&&(d.push({name:t,value:f(q).val(),type:q.type}),d.push({name:t+".x",value:k.clk_x},{name:t+".y",value:k.clk_y}));else if((s=f.fieldValue(q,!0))&&s.constructor==Array){b&&b.push(q);n=0;for(q=s.length;n<q;n++)d.push({name:t,value:s[n]})}else if(e&&"file"==q.type&&!q.disabled)if(b&&b.push(q),s=q.files,s.length)for(n=0;n<s.length;n++)d.push({name:t,value:s[n],type:q.type});else d.push({name:t,value:"",type:q.type});else null!==
s&&"undefined"!=typeof s&&(b&&b.push(q),d.push({name:t,value:s,type:q.type,required:q.required}));if(!a&&k.clk&&(l=f(k.clk),h=l[0],(t=h.name)&&!h.disabled&&"image"==h.type))d.push({name:t,value:l.val()}),d.push({name:t+".x",value:k.clk_x},{name:t+".y",value:k.clk_y});return d};f.fn.formSerialize=function(a){return f.param(this.formToArray(a))};f.fn.fieldSerialize=function(a){var b=[];this.each(function(){var e=this.name;if(e){var d=f.fieldValue(this,a);if(d&&d.constructor==Array)for(var l=0,h=d.length;l<
h;l++)b.push({name:e,value:d[l]});else null!==d&&"undefined"!=typeof d&&b.push({name:this.name,value:d})}});return f.param(b)};f.fn.fieldValue=function(a){for(var b=[],e=0,d=this.length;e<d;e++){var l=f.fieldValue(this[e],a);null===l||("undefined"==typeof l||l.constructor==Array&&!l.length)||(l.constructor==Array?f.merge(b,l):b.push(l))}return b};f.fieldValue=function(a,b){var e=a.name,d=a.type,l=a.tagName.toLowerCase();void 0===b&&(b=!0);if(b&&(!e||a.disabled||"reset"==d||"button"==d||("checkbox"==
d||"radio"==d)&&!a.checked||("submit"==d||"image"==d)&&a.form&&a.form.clk!=a||"select"==l&&-1==a.selectedIndex))return null;if("select"==l){var h=a.selectedIndex;if(0>h)return null;for(var e=[],l=a.options,n=(d="select-one"==d)?h+1:l.length,h=d?h:0;h<n;h++){var t=l[h];if(t.selected){var s=t.value;s||(s=t.attributes&&t.attributes.value&&!t.attributes.value.specified?t.text:t.value);if(d)return s;e.push(s)}}return e}return f(a).val()};f.fn.clearForm=function(a){return this.each(function(){f("input,select,textarea",
this).clearFields(a)})};f.fn.clearFields=f.fn.clearInputs=function(a){var b=/^(?:color|date|datetime|email|month|number|password|range|search|tel|text|time|url|week)$/i;return this.each(function(){var e=this.type,d=this.tagName.toLowerCase();if(b.test(e)||"textarea"==d)this.value="";else if("checkbox"==e||"radio"==e)this.checked=!1;else if("select"==d)this.selectedIndex=-1;else if(a&&(!0===a&&/hidden/.test(e)||"string"==typeof a&&f(this).is(a)))this.value=""})};f.fn.resetForm=function(){return this.each(function(){("function"==
typeof this.reset||"object"==typeof this.reset&&!this.reset.nodeType)&&this.reset()})};f.fn.enable=function(a){void 0===a&&(a=!0);return this.each(function(){this.disabled=!a})};f.fn.selected=function(a){void 0===a&&(a=!0);return this.each(function(){var b=this.type;"checkbox"==b||"radio"==b?this.checked=a:"option"==this.tagName.toLowerCase()&&(b=f(this).parent("select"),a&&(b[0]&&"select-one"==b[0].type)&&b.find("option").selected(!1),this.selected=a)})};f.fn.ajaxSubmit.debug=!1})(jQuery);/*

 Software from "jQuery Filedrop 0.1.0", a jQuery plugin for html5 dragging files,
 is Copyright (c) Resopollution and is provided under the following license:
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
(function(f){function h(){}jQuery.event.props.push("dataTransfer");var b={fallback_id:"",url:"",refresh:1E3,paramname:"userfile",allowedfiletypes:[],raw_droppable:[],maxfiles:25,maxfilesize:1,queuefiles:0,queuewait:200,data:{},headers:{},drop:h,rawDrop:h,dragStart:h,dragEnter:h,dragOver:h,dragLeave:h,docEnter:h,docOver:h,docLeave:h,beforeEach:h,afterAll:h,rename:h,error:function(a,b,e,d){alert(a)},uploadStarted:h,uploadFinished:h,progressUpdated:h,globalProgressUpdated:h,speedUpdated:h},a="BrowserNotSupported TooManyFiles FileTooLarge FileTypeNotAllowed NotFound NotReadable AbortError ReadError".split(" "),
e,d=!1,c=0,g;f.fn.filedrop=function(k){function l(a,b){var e="?mimetype="+encodeURIComponent(b.type);s("pasted_image",b.data,b.type,{},e,function(a,b,e){return p.uploadFinished(-1,void 0,a,b,e)},function(){})}function h(a,b,e,d){var c="";if(p.data){var g=f.param(p.data).replace(/\+/g,"%20").split(/&/);f.each(g,function(){var a=this.split("=",2),b=decodeURIComponent(a[0]),a=decodeURIComponent(a[1]);c+="--";c+=d;c+="\r\n";c+='Content-Disposition: form-data; name="'+b+'"';c+="\r\n";c+="\r\n";c+=a;c+=
"\r\n"})}c+="--";c+=d;c+="\r\n";c+='Content-Disposition: form-data; name="'+p.paramname+'"';c+='; filename="'+a+'"';c+="\r\n";c+="Content-Type: "+e;c+="\r\n";c+="\r\n";c+=b;c+="\r\n";c+="--";c+=d;c+="--";return c+="\r\n"}function m(a){if(a.lengthComputable){var b=Math.round(100*a.loaded/a.total);if(this.currentProgress!==b){this.currentProgress=b;p.progressUpdated(this.index,this.file,this.currentProgress);y[this.global_progress_index]=this.currentProgress;t();var b=(new Date).getTime(),e=b-this.currentStart;
e>=p.refresh&&(p.speedUpdated(this.index,this.file,(a.loaded-this.startData)/e),this.startData=a.loaded,this.currentStart=b)}}}function t(){if(0!==y.length){var a=0,b;for(b in y)y.hasOwnProperty(b)&&(a+=y[b]);p.globalProgressUpdated(Math.round(a/y.length))}}function s(a,b,e,c,g,k,l){var s=new XMLHttpRequest,v=(new Date).getTime(),q=y.length,z="------multipartformboundary"+(new Date).getTime(),E=s.upload;caller.data("filedrop_xhr",s);p.withCredentials&&(s.withCredentials=p.withCredentials);a=a=h(a,
b,e,z);E=f.extend(E,c);E.downloadStartTime=v;E.currentStart=v;E.currentProgress=0;E.global_progress_index=q;E.startData=0;E.addEventListener("progress",m,!1);jQuery.isFunction(p.url)?s.open("POST",p.url()+g,!0):s.open("POST",p.url+g,!0);s.setRequestHeader("content-type","multipart/form-data; boundary="+z);f.each(p.headers,function(a,b){s.setRequestHeader(a,b)});s.sendAsBinary(a);y[q]=0;t();s.onload=function(){var a=null;if(s.responseText)try{a=jQuery.parseJSON(s.responseText)}catch(b){a=s.responseText}var e=
(new Date).getTime()-v,a=k(a,e,s);y[q]=100;t();!1===a&&(d=!0);(200>s.status||299<s.status)&&l(s.statusText,s.status)}}function q(){d=!1;if(!g)return p.error(a[0]),!1;if(p.allowedfiletypes.push&&p.allowedfiletypes.length)for(var b=g.length;b--;)if(!g[b].type||0>f.inArray(g[b].type,p.allowedfiletypes))return p.error(a[3],g[b]),!1;var e=0,k=0;if(c>p.maxfiles&&0===p.queuefiles)return p.error(a[1]),!1;for(var l=[],h=[],r=[],b=0;b<c;b++)l.push(b);var m=function(){var b;if(d)return!1;if(0<p.queuefiles&&
h.length>=p.queuefiles)setTimeout(m,p.queuewait);else{b=l[0];l.splice(0,1);h.push(b);try{if(!1!==p.beforeEach(g[b])){if(b===c)return;var e=new FileReader,f=1048576*p.maxfilesize;e.index=b;if(g[b].size>f)return p.error(a[2],g[b],b),h.forEach(function(a,e){a===b&&h.splice(e,1)}),k++,!0;e.onerror=function(b){switch(b.target.error.code){case b.target.error.NOT_FOUND_ERR:return p.error(a[4]),!1;case b.target.error.NOT_READABLE_ERR:return p.error(a[5]),!1;case b.target.error.ABORT_ERR:return p.error(a[6]),
!1;default:return p.error(a[7]),!1}};e.onloadend=!p.beforeSend?y:function(a){p.beforeSend(g[b],b,function(){y(a)})};e.readAsBinaryString(g[b])}else k++}catch(r){return h.forEach(function(a,e){a===b&&h.splice(e,1)}),p.error(a[0]),!1}0<l.length&&m()}},y=function(a){var b=("undefined"===typeof a.srcElement?a.target:a.srcElement).index;void 0===a.target.index&&(a.target.index=v(a.total));var d=g[a.target.index],f=a.target.index;s("string"===typeof newName?newName:d.name,a.target.result,d.type,{file:g[a.target.index],
index:a.target.index},"",function(a,g,l){e++;a=p.uploadFinished(f,d,a,g,l);e===c-k&&p.afterAll();h.forEach(function(a,e){a===b&&h.splice(e,1)});r.push(b);return a},function(a,e){p.error(a,d,b,e)})};m()}function v(a){for(var b=0;b<c;b++)if(g[b].size===a)return b}var p=f.extend({},b,k),y=[];caller=this;this.on("drop",function(b){if(0===b.dataTransfer.files.length){var e;for(e=0;e<p.raw_droppable.length;e++){var d=p.raw_droppable[e],f;a:{f=b.dataTransfer.types;for(var k=void 0,k=0;k<f.length;k++)if(f[k]===
d){f=!0;break a}f=!1}if(f)return p.rawDrop(b.dataTransfer.getData(d)),!1}}if(!1===p.drop.call(this,b))return!1;g=b.dataTransfer.files;if(null===g||void 0===g||0===g.length)return p.error(a[0]),!1;c=g.length;q();b.preventDefault();return!1}).on("dragstart",p.dragStart).on("dragenter",function(a){clearTimeout(e);a.preventDefault();p.dragEnter.call(this,a)}).on("dragover",function(a){clearTimeout(e);a.preventDefault();p.docOver.call(this,a);p.dragOver.call(this,a)}).on("dragleave",function(a){clearTimeout(e);
p.dragLeave.call(this,a);a.stopPropagation()});this.on("paste",function(a){if(!(void 0===a.originalEvent.clipboardData||void 0===a.originalEvent.clipboardData.items)){for(var b=a.originalEvent.clipboardData.items.length,e=0;e<b;e++)if("string"===a.originalEvent.clipboardData.items[e].kind)return;var c=/image.*/,d;f.each(a.originalEvent.clipboardData.items,function(a,b){if(b.type.match(c))return d=b,!1});if(void 0!==d){if(!1===p.drop.call(this,a))return!1;var g=d.getAsFile();a=new FileReader;a.onload=
function(a){l(a,{type:g.type,data:a.target.result})};a.readAsBinaryString(g)}}});this.on("imagedata-upload.zulip",function(a,b){if(!1===p.drop.call(this,void 0))return!1;l(a,b)});f(document).on("drop",function(a){a.preventDefault();p.docLeave.call(this,a);return!1}).on("dragenter",function(a){clearTimeout(e);a.preventDefault();p.docEnter.call(this,a);return!1}).on("dragover",function(a){clearTimeout(e);a.preventDefault();p.docOver.call(this,a);return!1}).on("dragleave",function(a){e=setTimeout(function(b){return function(){p.docLeave.call(b,
a)}}(this),200)});f("#"+p.fallback_id).change(function(a){p.drop(a);g=a.target.files;c=g.length;q()});return this};try{XMLHttpRequest.prototype.sendAsBinary||(XMLHttpRequest.prototype.sendAsBinary=function(a){a=Array.prototype.map.call(a,function(a){return a.charCodeAt(0)&255});a=new Uint8Array(a);this.send(a.buffer)})}catch(m){}})(jQuery);(function(f,h,b,a){f.fn.caret=function(e,d){var c,g,m=this[0],k=f.browser.msie;if("object"===typeof e&&"number"===typeof e.start&&"number"===typeof e.end)c=e.start,g=e.end;else if("number"===typeof e&&"number"===typeof d)c=e,g=d;else if("string"===typeof e)-1<(c=m.value.indexOf(e))?g=c+e[h]:c=null;else if("[object RegExp]"===Object.prototype.toString.call(e)){var l=e.exec(m.value);null!=l&&(c=l.index,g=c+l[0][h])}if("undefined"!=typeof c)return k?(k=this[0].createTextRange(),k.collapse(!0),k.moveStart("character",
c),k.moveEnd("character",g-c),k.select()):(this[0].selectionStart=c,this[0].selectionEnd=g),this[0].focus(),this;if(k)if(g=document.selection,"textarea"!=this[0].tagName.toLowerCase()){k=this.val();c=g[b]()[a]();c.moveEnd("character",k[h]);var r=""==c.text?k[h]:k.lastIndexOf(c.text);c=g[b]()[a]();c.moveStart("character",-k[h]);var n=c.text[h]}else c=g[b](),g=c[a](),g.moveToElementText(this[0]),g.setEndPoint("EndToEnd",c),r=g.text[h]-c.text[h],n=r+c.text[h];else r=m.selectionStart,n=m.selectionEnd;
c=m.value.substring(r,n);return{start:r,end:n,text:c,replace:function(a){return m.value.substring(0,r)+a+m.value.substring(n,m.value[h])}}}})(jQuery,"length","createRange","duplicate");/*

 Software from "XDate v0.8", a wrapper around JavaScript's Date object, is
 Copyright (c) 2010 C. F., Wong and is provided under the following license:
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
var XDate=function(f,h,b,a){function e(){var a=this instanceof e?this:new e,b=arguments,g=b.length,k;"boolean"==typeof b[g-1]&&(k=b[--g],b=u(b,0,g));if(g)if(1==g)if(g=b[0],g instanceof f||"number"==typeof g)a[0]=new f(+g);else if(g instanceof e){var b=a,l=new f(+g[0]);d(g)&&(l.toString=O);b[0]=l}else{if("string"==typeof g){a[0]=new f(0);a:{for(var b=g,g=k||!1,l=e.parsers,h=0,r;h<l.length;h++)if(r=l[h](b,g,a)){a=r;break a}a[0]=new f(b)}}}else a[0]=new f(N.apply(f,b)),k||(a[0]=A(a[0]));else a[0]=new f;
"boolean"==typeof k&&c(a,k);return a}function d(a){return a[0].toString===O}function c(a,b,e){b?d(a)||(e&&(a[0]=new f(N(a[0].getFullYear(),a[0].getMonth(),a[0].getDate(),a[0].getHours(),a[0].getMinutes(),a[0].getSeconds(),a[0].getMilliseconds()))),a[0].toString=O):d(a)&&(a[0]=e?A(a[0]):new f(+a[0]));return a}function g(a,b,e,c,d){var g=G(x,a[0],d);a=G(F,a[0],d);d=!1;2==c.length&&"boolean"==typeof c[1]&&(d=c[1],c=[e]);e=1==b?(e%12+12)%12:g(1);a(b,c);d&&g(1)!=e&&(a(1,[g(1)-1]),a(2,[D(g(0),g(1))]))}
function m(a,b,e,c){e=Number(e);var d=h.floor(e);a["set"+C[b]](a["get"+C[b]]()+d,c||!1);d!=e&&6>b&&m(a,b+1,(e-d)*E[b],c)}function k(a,b,c){a=a.clone().setUTCMode(!0,!0);b=e(b).setUTCMode(!0,!0);var d=0;if(0==c||1==c){for(var g=6;g>=c;g--)d/=E[g],d+=x(b,!1,g)-x(a,!1,g);1==c&&(d+=12*(b.getFullYear()-a.getFullYear()))}else 2==c?(c=a.toDate().setUTCHours(0,0,0,0),d=b.toDate().setUTCHours(0,0,0,0),d=h.round((d-c)/864E5)+(b-d-(a-c))/864E5):d=(b-a)/[36E5,6E4,1E3,1][c-3];return d}function l(a){var b=a(0),
e=a(1),c=a(2);a=new f(N(b,e,c));b=n(r(b,e,c));return h.floor(h.round((a-b)/864E5)/7)+1}function r(a,b,e){b=new f(N(a,b,e));return b<n(a)?a-1:b>=n(a+1)?a+1:a}function n(a){a=new f(N(a,0,4));a.setUTCDate(a.getUTCDate()-(a.getUTCDay()+6)%7);return a}function t(b,e,c,d){var g=G(x,b,d),f=G(F,b,d);c===a&&(c=r(g(0),g(1),g(2)));c=n(c);d||(c=A(c));b.setTime(+c);f(2,[g(2)+7*(e-1)])}function s(a,b,c,d,g){var f=e.locales,k=f[e.defaultLocale]||{},l=G(x,a,g);c=("string"==typeof c?f[c]:c)||{};return q(a,b,function(a){if(d)for(var b=
(7==a?2:a)-1;0<=b;b--)d.push(l(b));return l(a)},function(a){return c[a]||k[a]},g)}function q(b,e,c,d,g){for(var f,k,l="";f=e.match(M);){l+=e.substr(0,f.index);if(f[1]){k=l;for(var l=b,h=f[1],r=c,m=d,p=g,x=h.length,y=void 0,s="";0<x;)y=v(l,h.substr(0,x),r,m,p),y!==a?(s+=y,h=h.substr(x),x=h.length):x--;l=k+(s+h)}else f[3]?(k=q(b,f[4],c,d,g),parseInt(k.replace(/\D/g,""),10)&&(l+=k)):l+=f[7]||"'";e=e.substr(f.index+f[0].length)}return l+e}function v(a,b,c,d,g){var f=e.formatters[b];if("string"==typeof f)return q(a,
f,c,d,g);if("function"==typeof f)return f(a,g||!1,d);switch(b){case "fff":return w(c(6),3);case "s":return c(5);case "ss":return w(c(5));case "m":return c(4);case "mm":return w(c(4));case "h":return c(3)%12||12;case "hh":return w(c(3)%12||12);case "H":return c(3);case "HH":return w(c(3));case "d":return c(2);case "dd":return w(c(2));case "ddd":return d("dayNamesShort")[c(7)]||"";case "dddd":return d("dayNames")[c(7)]||"";case "M":return c(1)+1;case "MM":return w(c(1)+1);case "MMM":return d("monthNamesShort")[c(1)]||
"";case "MMMM":return d("monthNames")[c(1)]||"";case "yy":return(c(0)+"").substring(2);case "yyyy":return c(0);case "t":return p(c,d).substr(0,1).toLowerCase();case "tt":return p(c,d).toLowerCase();case "T":return p(c,d).substr(0,1);case "TT":return p(c,d);case "z":case "zz":case "zzz":return g?b="Z":(d=a.getTimezoneOffset(),a=0>d?"+":"-",c=h.floor(h.abs(d)/60),d=h.abs(d)%60,g=c,"zz"==b?g=w(c):"zzz"==b&&(g=w(c)+":"+w(d)),b=a+g),b;case "w":return l(c);case "ww":return w(l(c));case "S":return b=c(2),
10<b&&20>b?"th":["st","nd","rd"][b%10-1]||"th"}}function p(a,b){return 12>a(3)?b("amDesignator"):b("pmDesignator")}function y(a){return!isNaN(+a[0])}function x(a,b,e){return a["get"+(b?"UTC":"")+C[e]]()}function F(a,b,e,c){a["set"+(b?"UTC":"")+C[e]].apply(a,c)}function A(a){return new f(a.getUTCFullYear(),a.getUTCMonth(),a.getUTCDate(),a.getUTCHours(),a.getUTCMinutes(),a.getUTCSeconds(),a.getUTCMilliseconds())}function D(a,b){return 32-(new f(N(a,b,32))).getUTCDate()}function B(b){return function(){return b.apply(a,
[this].concat(u(arguments)))}}function G(b){var e=u(arguments,1);return function(){return b.apply(a,e.concat(u(arguments)))}}function u(e,c,d){return b.prototype.slice.call(e,c||0,d===a?e.length:d)}function I(a,b){for(var e=0;e<a.length;e++)b(a[e],e)}function w(a,b){b=b||2;for(a+="";a.length<b;)a="0"+a;return a}var C="FullYear Month Date Hours Minutes Seconds Milliseconds Day Year".split(" "),z=["Years","Months","Days"],E=[12,31,24,60,60,1E3,1],M=/(([a-zA-Z])\2*)|(\((('.*?'|\(.*?\)|.)*?)\))|('(.*?)')/,
N=f.UTC,O=f.prototype.toUTCString,H=e.prototype;H.length=1;H.splice=b.prototype.splice;H.getUTCMode=B(d);H.setUTCMode=B(c);H.getTimezoneOffset=function(){return d(this)?0:this[0].getTimezoneOffset()};I(C,function(a,b){H["get"+a]=function(){return x(this[0],d(this),b)};8!=b&&(H["getUTC"+a]=function(){return x(this[0],!0,b)});7!=b&&(H["set"+a]=function(a){g(this,b,a,arguments,d(this));return this},8!=b&&(H["setUTC"+a]=function(a){g(this,b,a,arguments,!0);return this},H["add"+(z[b]||a)]=function(a,e){m(this,
b,a,e);return this},H["diff"+(z[b]||a)]=function(a){return k(this,a,b)}))});H.getWeek=function(){return l(G(x,this,!1))};H.getUTCWeek=function(){return l(G(x,this,!0))};H.setWeek=function(a,b){t(this,a,b,!1);return this};H.setUTCWeek=function(a,b){t(this,a,b,!0);return this};H.addWeeks=function(a){return this.addDays(7*Number(a))};H.diffWeeks=function(a){return k(this,a,2)/7};e.parsers=[function(a,b,e){if(a=a.match(/^(\d{4})(-(\d{2})(-(\d{2})([T ](\d{2}):(\d{2})(:(\d{2})(\.(\d+))?)?(Z|(([-+])(\d{2})(:?(\d{2}))?))?)?)?)?$/)){var c=
new f(N(a[1],a[3]?a[3]-1:0,a[5]||1,a[7]||0,a[8]||0,a[10]||0,a[12]?1E3*Number("0."+a[12]):0));a[13]?a[14]&&c.setUTCMinutes(c.getUTCMinutes()+("-"==a[15]?1:-1)*(60*Number(a[16])+(a[18]?Number(a[18]):0))):b||(c=A(c));return e.setTime(+c)}}];e.parse=function(a){return+e(""+a)};H.toString=function(b,e,c){return b===a||!y(this)?this[0].toString():s(this,b,e,c,d(this))};H.toUTCString=H.toGMTString=function(b,e,c){return b===a||!y(this)?this[0].toUTCString():s(this,b,e,c,!0)};H.toISOString=function(){return this.toUTCString("yyyy-MM-dd'T'HH:mm:ss(.fff)zzz")};
e.defaultLocale="";e.locales={"":{monthNames:"January February March April May June July August September October November December".split(" "),monthNamesShort:"Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec".split(" "),dayNames:"Sunday Monday Tuesday Wednesday Thursday Friday Saturday".split(" "),dayNamesShort:"Sun Mon Tue Wed Thu Fri Sat".split(" "),amDesignator:"AM",pmDesignator:"PM"}};e.formatters={i:"yyyy-MM-dd'T'HH:mm:ss(.fff)",u:"yyyy-MM-dd'T'HH:mm:ss(.fff)zzz"};I("getTime valueOf toDateString toTimeString toLocaleString toLocaleDateString toLocaleTimeString toJSON".split(" "),
function(a){H[a]=function(){return this[0][a]()}});H.setTime=function(a){this[0].setTime(a);return this};H.valid=B(y);H.clone=function(){return new e(this)};H.clearTime=function(){return this.setHours(0,0,0,0)};H.toDate=function(){return new f(+this[0])};e.now=function(){return+new f};e.today=function(){return(new e).clearTime()};e.UTC=N;e.getDaysInMonth=D;"undefined"!==typeof module&&module.exports&&(module.exports=e);"function"===typeof define&&define.amd&&define([],function(){return e});return e}(Date,
Math,Array);/*

 Software from "Spin.js", which dynamically creates activity indicators, is
 Copyright (c) 2011-2013 Felix Gnass and is provided under the following license:
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
(function(f,h){"object"==typeof exports?module.exports=h():"function"==typeof define&&define.amd?define(h):f.Spinner=h()})(this,function(){function f(a,b){var e=document.createElement(a||"div"),c;for(c in b)e[c]=b[c];return e}function h(a){for(var b=1,e=arguments.length;b<e;b++)a.appendChild(arguments[b]);return a}function b(a,b,e,c){var d=["opacity",b,~~(100*a),e,c].join("-");e=0.01+100*(e/c);c=Math.max(1-(1-a)/b*(100-e),a);var g=r.substring(0,r.indexOf("Animation")).toLowerCase();l[d]||(n.insertRule("@"+
(g&&"-"+g+"-"||"")+"keyframes "+d+"{0%{opacity:"+c+"}"+e+"%{opacity:"+a+"}"+(e+0.01)+"%{opacity:1}"+(e+b)%100+"%{opacity:"+a+"}100%{opacity:"+c+"}}",n.cssRules.length),l[d]=1);return d}function a(a,b){var e=a.style,c,d;if(void 0!==e[b])return b;b=b.charAt(0).toUpperCase()+b.slice(1);for(d=0;d<k.length;d++)if(c=k[d]+b,void 0!==e[c])return c}function e(b,e){for(var c in e)b.style[a(b,c)||c]=e[c];return b}function d(a){for(var b=1;b<arguments.length;b++){var e=arguments[b],c;for(c in e)void 0===a[c]&&
(a[c]=e[c])}return a}function c(a){for(var b={x:a.offsetLeft,y:a.offsetTop};a=a.offsetParent;)b.x+=a.offsetLeft,b.y+=a.offsetTop;return b}function g(a){if("undefined"==typeof this)return new g(a);this.opts=d(a||{},g.defaults,t)}function m(){function a(b,e){return f("<"+b+' xmlns="urn:schemas-microsoft.com:vml" class="spin-vml">',e)}n.addRule(".spin-vml","behavior:url(#default#VML)");g.prototype.lines=function(b,c){function d(){return e(a("group",{coordsize:k+" "+k,coordorigin:-f+" "+-f}),{width:k,
height:k})}function g(b,k,l){h(r,h(e(d(),{rotation:360/c.lines*b+"deg",left:~~k}),h(e(a("roundrect",{arcsize:c.corners}),{width:f,height:c.width,left:c.radius,top:-c.width>>1,filter:l}),a("fill",{color:c.color,opacity:c.opacity}),a("stroke",{opacity:0}))))}var f=c.length+c.width,k=2*f,l=2*-(c.width+c.length)+"px",r=e(d(),{position:"absolute",top:l,left:l});if(c.shadow)for(l=1;l<=c.lines;l++)g(l,-2,"progid:DXImageTransform.Microsoft.Blur(pixelradius=2,makeshadow=1,shadowopacity=.3)");for(l=1;l<=c.lines;l++)g(l);
return h(b,r)};g.prototype.opacity=function(a,b,e,c){a=a.firstChild;c=c.shadow&&c.lines||0;if(a&&b+c<a.childNodes.length&&(a=(a=(a=a.childNodes[b+c])&&a.firstChild)&&a.firstChild))a.opacity=e}}var k=["webkit","Moz","ms","O"],l={},r,n=function(){var a=f("style",{type:"text/css"});h(document.getElementsByTagName("head")[0],a);return a.sheet||a.styleSheet}(),t={lines:12,length:7,width:5,radius:10,rotate:0,corners:1,color:"#000",direction:1,speed:1,trail:100,opacity:0.25,fps:20,zIndex:2E9,className:"spinner",
top:"auto",left:"auto",position:"relative"};g.defaults={};d(g.prototype,{spin:function(a){this.stop();var b=this,d=b.opts,g=b.el=e(f(0,{className:d.className}),{position:d.position,width:0,zIndex:d.zIndex}),k=d.radius+d.length+d.width,l,h;a&&(a.insertBefore(g,a.firstChild||null),h=c(a),l=c(g),e(g,{left:("auto"==d.left?h.x-l.x+(a.offsetWidth>>1):parseInt(d.left,10)+k)+"px",top:("auto"==d.top?h.y-l.y+(a.offsetHeight>>1):parseInt(d.top,10)+k)+"px"}));g.setAttribute("role","progressbar");b.lines(g,b.opts);
if(!r){var m=0,s=(d.lines-1)*(1-d.direction)/2,t,u=d.fps,n=u/d.speed,w=(1-d.opacity)/(n*d.trail/100),C=n/d.lines;(function E(){m++;for(var a=0;a<d.lines;a++)t=Math.max(1-(m+(d.lines-a)*C)%n*w,d.opacity),b.opacity(g,a*d.direction+s,t,d);b.timeout=b.el&&setTimeout(E,~~(1E3/u))})()}return b},stop:function(){var a=this.el;a&&(clearTimeout(this.timeout),a.parentNode&&a.parentNode.removeChild(a),this.el=void 0);return this},lines:function(a,c){function d(a,b){return e(f(),{position:"absolute",width:c.length+
c.width+"px",height:c.width+"px",background:a,boxShadow:b,transformOrigin:"left",transform:"rotate("+~~(360/c.lines*g+c.rotate)+"deg) translate("+c.radius+"px,0)",borderRadius:(c.corners*c.width>>1)+"px"})}for(var g=0,k=(c.lines-1)*(1-c.direction)/2,l;g<c.lines;g++)l=e(f(),{position:"absolute",top:1+~(c.width/2)+"px",transform:c.hwaccel?"translate3d(0,0,0)":"",opacity:c.opacity,animation:r&&b(c.opacity,c.trail,k+g*c.direction,c.lines)+" "+1/c.speed+"s linear infinite"}),c.shadow&&h(l,e(d("#000","0 0 4px #000"),
{top:"2px"})),h(a,h(l,d(c.color,"0 0 1px rgba(0,0,0,.1)")));return a},opacity:function(a,b,e){b<a.childNodes.length&&(a.childNodes[b].style.opacity=e)}});var s=e(f("group"),{behavior:"url(#default#VML)"});!a(s,"transform")&&s.adj?m():r=a(s,"animation");return g});(function(f){function h(a){var b=a||window.event,c=[].slice.call(arguments,1),g=0,h=0,k=0;a=f.event.fix(b);a.type="mousewheel";b.wheelDelta&&(g=b.wheelDelta/120);b.detail&&(g=-b.detail/3);k=g;void 0!==b.axis&&b.axis===b.HORIZONTAL_AXIS&&(k=0,h=-1*g);void 0!==b.wheelDeltaY&&(k=b.wheelDeltaY/120);void 0!==b.wheelDeltaX&&(h=-1*b.wheelDeltaX/120);c.unshift(a,g,h,k);return(f.event.dispatch||f.event.handle).apply(this,c)}var b=["DOMMouseScroll","mousewheel"];if(f.event.fixHooks)for(var a=b.length;a;)f.event.fixHooks[b[--a]]=
f.event.mouseHooks;f.event.special.mousewheel={setup:function(){if(this.addEventListener)for(var a=b.length;a;)this.addEventListener(b[--a],h,!1);else this.onmousewheel=h},teardown:function(){if(this.removeEventListener)for(var a=b.length;a;)this.removeEventListener(b[--a],h,!1);else this.onmousewheel=null}};f.fn.extend({mousewheel:function(a){return a?this.bind("mousewheel",a):this.trigger("mousewheel")},unmousewheel:function(a){return this.unbind("mousewheel",a)}})})(jQuery);(function(f,h){"$:nomunge";var b=f.jQuery||f.Cowboy||(f.Cowboy={}),a;b.throttle=a=function(a,d,c,g){function f(){function b(){l=+new Date;c.apply(t,q)}function m(){k=h}var t=this,s=+new Date-l,q=arguments;g&&!k&&b();k&&clearTimeout(k);g===h&&s>a?b():!0!==d&&(k=setTimeout(g?m:b,g===h?a-s:a))}var k,l=0;"boolean"!==typeof d&&(g=c,c=d,d=h);b.guid&&(f.guid=c.guid=c.guid||b.guid++);return f};b.debounce=function(b,d,c){return c===h?a(b,d,!1):a(b,c,!1!==d)}})(this);/*

 Software from "jQuery Idle", a jQuery plugin that executes a callback function
 if the user is idle, is Copyright (c) 2011-2013 Henrique Boaventura and is
 provided under the following license (the jQuery Idle software has been modified):
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
(function(f){f.fn.idle=function(h){var b=!1,a=f.extend({},{idle:6E4,events:"mousemove keydown DOMMouseScroll mousewheel mousedown touchstart touchmove",onIdle:function(){},onActive:function(){},keepTracking:!1},h),e,d=f(this),c=!1,g=function(e){c||(b&&(a.onActive.call(),b=!1),k())},m=function(){d.off(a.events,g);clearTimeout(e);c=!0},k=function(){b=!1;clearTimeout(e);l()},l=function(){e=setTimeout(function(){b=!0;m();a.onIdle.call();a.keepTracking&&setTimeout(function(){d.on(a.events,g);c=!1;l(a)},
0)},a.idle);r.timerId=e},r={cancel:m,reset:k};l(a);d.on(a.events,g);return r}})(jQuery);/*

 Autosize v1.17.7 - 2013-09-03
 Automatically adjust textarea height based on user input.
 (c) 2013 Jack Moore - http://www.jacklmoore.com/autosize
 license: http://www.opensource.org/licenses/mit-license.php
 ---
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
*/
(function(f){"function"===typeof define&&define.amd?define(["jquery"],f):f(window.jQuery||window.$)})(function(f){var h={className:"autosizejs",append:"",callback:!1,resizeDelay:10},b="fontFamily fontSize fontWeight fontStyle letterSpacing textTransform wordSpacing textIndent".split(" "),a,e=f('<textarea tabindex="-1" style="position:absolute; top:-999px; left:0; right:auto; bottom:auto; border:0; padding: 0; -moz-box-sizing:content-box; -webkit-box-sizing:content-box; box-sizing:content-box; word-wrap:break-word; height:0 !important; min-height:0 !important; overflow:hidden; transition:none; -webkit-transition:none; -moz-transition:none;"/>').data("autosize",
!0)[0];e.style.lineHeight="99px";"99px"===f(e).css("lineHeight")&&b.push("lineHeight");e.style.lineHeight="";f.fn.autosize=function(d){d=f.extend({},h,d||{});e.parentNode!==document.body&&f(document.body).append(e);return this.each(function(){function c(){var a,b;"getComputedStyle"in window?(a=window.getComputedStyle(l),b=l.getBoundingClientRect().width,f.each(["paddingLeft","paddingRight","borderLeftWidth","borderRightWidth"],function(e,c){b-=parseInt(a[c],10)}),e.style.width=b+"px"):e.style.width=
Math.max(r.width(),0)+"px"}function g(){var g={};a=l;e.className=d.className;n=parseInt(r.css("maxHeight"),10);f.each(b,function(a,b){g[b]=r.css(b)});f(e).css(g);c();if(window.chrome){var k=l.style.width;l.style.width="0px";l.style.width=k}}function h(){var b,f;a!==l?g():c();e.value=l.value+d.append;e.style.overflowY=l.style.overflowY;f=parseInt(l.style.height,10);e.scrollTop=0;e.scrollTop=9E4;b=e.scrollTop;n&&b>n?(l.style.overflowY="scroll",b=n):(l.style.overflowY="hidden",b<t&&(b=t));b+=s;f!==b&&
(l.style.height=b+"px",q&&d.callback.call(l,l))}function k(){clearTimeout(p);p=setTimeout(function(){var a=r.width();a!==y&&(y=a,h())},parseInt(d.resizeDelay,10))}var l=this,r=f(l),n,t,s=0,q=f.isFunction(d.callback),v={height:l.style.height,overflow:l.style.overflow,overflowY:l.style.overflowY,wordWrap:l.style.wordWrap,resize:l.style.resize},p,y=r.width();if(!r.data("autosize")){r.data("autosize",!0);if("border-box"===r.css("box-sizing")||"border-box"===r.css("-moz-box-sizing")||"border-box"===r.css("-webkit-box-sizing"))s=
r.outerHeight()-r.height();t=Math.max(parseInt(r.css("minHeight"),10)-s||0,r.height());r.css({overflow:"hidden",overflowY:"hidden",wordWrap:"break-word",resize:"none"===r.css("resize")||"vertical"===r.css("resize")?"none":"horizontal"});if("onpropertychange"in l)if("oninput"in l)r.on("input.autosize keyup.autosize",h);else r.on("propertychange.autosize",function(){"value"===event.propertyName&&h()});else r.on("input.autosize",h);if(!1!==d.resizeDelay)f(window).on("resize.autosize",k);r.on("autosize.resize",
h);r.on("autosize.resizeIncludeStyle",function(){a=null;h()});r.on("autosize.destroy",function(){a=null;clearTimeout(p);f(window).off("resize",k);r.off("autosize").off(".autosize").css(v).removeData("autosize")});h()}})}});(function(f){"function"===typeof define&&define.amd?define(["jquery"],f):f(jQuery)})(function(f){var h={wheelSpeed:10,wheelPropagation:!1,minScrollbarLength:null,useBothWheelAxes:!1,useKeyboard:!0,suppressScrollX:!1,suppressScrollY:!1,scrollXMarginOffset:0,scrollYMarginOffset:0},b=function(){var a=0;return function(){var b=a;a+=1;return".perfect-scrollbar-"+b}}();f.fn.perfectScrollbar=function(a,e){return this.each(function(){var d=f.extend(!0,{},h),c=f(this);"object"===typeof a?f.extend(!0,d,a):
e=a;if("update"===e)return c.data("perfect-scrollbar-update")&&c.data("perfect-scrollbar-update")(),c;if("destroy"===e)return c.data("perfect-scrollbar-destroy")&&c.data("perfect-scrollbar-destroy")(),c;if(c.data("perfect-scrollbar"))return c.data("perfect-scrollbar");c.addClass("ps-container");var g=f("<div class='ps-scrollbar-x-rail'></div>").appendTo(c),m=f("<div class='ps-scrollbar-y-rail'></div>").appendTo(c),k=f("<div class='ps-scrollbar-x'></div>").appendTo(g),l=f("<div class='ps-scrollbar-y'></div>").appendTo(m),
r,n,t,s,q,v,p,y,x=parseInt(g.css("bottom"),10),F,A,D=parseInt(m.css("right"),10),B=b(),G=function(a){d.minScrollbarLength&&(a=Math.max(a,d.minScrollbarLength));return a},u=function(){g.css({left:c.scrollLeft(),bottom:x-c.scrollTop(),width:t,display:r?"inherit":"none"});m.css({top:c.scrollTop(),right:D-c.scrollLeft(),height:s,display:n?"inherit":"none"});k.css({left:y,width:p});l.css({top:A,height:F})},I=function(){t=c.width();s=c.height();q=c.prop("scrollWidth");v=c.prop("scrollHeight");!d.suppressScrollX&&
t+d.scrollXMarginOffset<q?(r=!0,p=G(parseInt(t*t/q,10)),y=parseInt(c.scrollLeft()*(t-p)/(q-t),10)):(r=!1,y=p=0,c.scrollLeft(0));!d.suppressScrollY&&s+d.scrollYMarginOffset<v?(n=!0,F=G(parseInt(s*s/v,10)),A=parseInt(c.scrollTop()*(s-F)/(v-s),10)):(n=!1,A=F=0,c.scrollTop(0));A>=s-F&&(A=s-F);y>=t-p&&(y=t-p);u()},w=function(){var a,b;k.bind("mousedown"+B,function(e){b=e.pageX;a=k.position().left;g.addClass("in-scrolling");e.stopPropagation();e.preventDefault()});f(document).bind("mousemove"+B,function(e){if(g.hasClass("in-scrolling")){var d=
a+(e.pageX-b),f=t-p;y=0>d?0:d>f?f:d;d=parseInt(y*(q-t)/(t-p),10);c.scrollLeft(d);m.css({right:D-d});e.stopPropagation();e.preventDefault()}});f(document).bind("mouseup"+B,function(a){g.hasClass("in-scrolling")&&g.removeClass("in-scrolling")});a=b=null},C=function(){var a,b;l.bind("mousedown"+B,function(e){b=e.pageY;a=l.position().top;m.addClass("in-scrolling");e.stopPropagation();e.preventDefault()});f(document).bind("mousemove"+B,function(e){if(m.hasClass("in-scrolling")){var d=a+(e.pageY-b),f=s-
F;A=0>d?0:d>f?f:d;d=parseInt(A*(v-s)/(s-F),10);c.scrollTop(d);g.css({bottom:x-d});e.stopPropagation();e.preventDefault()}});f(document).bind("mouseup"+B,function(a){m.hasClass("in-scrolling")&&m.removeClass("in-scrolling")});a=b=null},z=function(a,b){var e=c.scrollTop();if(0===a){if(!n)return!1;if(0===e&&0<b||e>=v-s&&0>b)return!d.wheelPropagation}e=c.scrollLeft();if(0===b){if(!r)return!1;if(0===e&&0>a||e>=q-t&&0<a)return!d.wheelPropagation}return!0},E=function(){var a=!1;c.bind("mousewheel"+B,function(b,
e,g,f){e=b.deltaX?b.deltaX/10:g;f=b.deltaY?b.deltaY/10:f;d.useBothWheelAxes?n&&!r?f?c.scrollTop(c.scrollTop()-f*d.wheelSpeed):c.scrollTop(c.scrollTop()+e*d.wheelSpeed):r&&!n&&(e?c.scrollLeft(c.scrollLeft()+e*d.wheelSpeed):c.scrollLeft(c.scrollLeft()-f*d.wheelSpeed)):(c.scrollTop(c.scrollTop()-f*d.wheelSpeed),c.scrollLeft(c.scrollLeft()+e*d.wheelSpeed));I();(a=z(e,f))&&b.preventDefault()});c.bind("MozMousePixelScroll"+B,function(b){a&&b.preventDefault()})},M=function(){var a=!1;c.bind("mouseenter"+
B,function(b){a=!0});c.bind("mouseleave"+B,function(b){a=!1});var b=!1;f(document).bind("keydown"+B,function(e){if(a&&!f(document.activeElement).is(":input,[contenteditable]")){var g=0,k=0;switch(e.which){case 37:g=-3;break;case 38:k=3;break;case 39:g=3;break;case 40:k=-3;break;case 33:k=9;break;case 32:case 34:k=-9;break;case 35:k=-s;break;case 36:k=s;break;default:return}c.scrollTop(c.scrollTop()-k*d.wheelSpeed);c.scrollLeft(c.scrollLeft()+g*d.wheelSpeed);(b=z(g,k))&&e.preventDefault()}})},N=function(){var a=
function(a){a.stopPropagation()};l.bind("click"+B,a);m.bind("click"+B,function(a){var b=parseInt(F/2,10);a=(a.pageY-m.offset().top-b)/(s-F);0>a?a=0:1<a&&(a=1);c.scrollTop((v-s)*a)});k.bind("click"+B,a);g.bind("click"+B,function(a){var b=parseInt(p/2,10);a=(a.pageX-g.offset().left-b)/(t-p);0>a?a=0:1<a&&(a=1);c.scrollLeft((q-t)*a)})},O=function(){var a=function(a,b){c.scrollTop(c.scrollTop()-b);c.scrollLeft(c.scrollLeft()-a);I()},b={},e=0,d,g,k=null,l=!1;f(window).bind("touchstart"+B,function(a){l=
!0});f(window).bind("touchend"+B,function(a){l=!1});c.bind("touchstart"+B,function(a){var c=a.originalEvent.targetTouches[0];b.pageX=c.pageX;b.pageY=c.pageY;e=(new Date).getTime();null!==k&&clearInterval(k);a.stopPropagation()});c.bind("touchmove"+B,function(c){if(!l&&1===c.originalEvent.targetTouches.length){var f=c.originalEvent.targetTouches[0],k={};k.pageX=f.pageX;k.pageY=f.pageY;var f=k.pageX-b.pageX,h=k.pageY-b.pageY;a(f,h);b=k;var k=(new Date).getTime(),r=k-e;0<r&&(d=f/r,g=h/r,e=k);c.preventDefault()}});
c.bind("touchend"+B,function(b){clearInterval(k);k=setInterval(function(){0.01>Math.abs(d)&&0.01>Math.abs(g)?clearInterval(k):(a(30*d,30*g),d*=0.8,g*=0.8)},10)})},H=function(){c.bind("scroll"+B,function(a){I()})},L=function(){c.unbind(B);f(window).unbind(B);f(document).unbind(B);c.data("perfect-scrollbar",null);c.data("perfect-scrollbar-update",null);c.data("perfect-scrollbar-destroy",null);k.remove();l.remove();g.remove();m.remove();k=l=t=s=q=v=p=y=x=F=A=D=null},Q=function(a){c.addClass("ie").addClass("ie"+
a);var b=function(){u=function(){k.css({left:y+c.scrollLeft(),bottom:x,width:p});l.css({top:A+c.scrollTop(),right:D,height:F});k.hide().show();l.hide().show()}};6===a&&(function(){var a=function(){f(this).addClass("hover")},b=function(){f(this).removeClass("hover")};c.bind("mouseenter"+B,a).bind("mouseleave"+B,b);g.bind("mouseenter"+B,a).bind("mouseleave"+B,b);m.bind("mouseenter"+B,a).bind("mouseleave"+B,b);k.bind("mouseenter"+B,a).bind("mouseleave"+B,b);l.bind("mouseenter"+B,a).bind("mouseleave"+
B,b)}(),b())},J="ontouchstart"in window||window.DocumentTouch&&document instanceof window.DocumentTouch;(function(){var a=navigator.userAgent.toLowerCase().match(/(msie) ([\w.]+)/);a&&"msie"===a[1]&&Q(parseInt(a[2],10));I();H();w();C();N();J&&O();c.mousewheel&&E();d.useKeyboard&&M();c.data("perfect-scrollbar",c);c.data("perfect-scrollbar-update",I);c.data("perfect-scrollbar-destroy",L)})();return c})}});/*

 Software from "LazyLoad" is Copyright (c) 2011 Ryan Grove <ryan@wonko.com>
 and is provided under the following license:
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy of
 this software and associated documentation files (the 'Software'), to deal in
 the Software without restriction, including without limitation the rights to
 use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 the Software, and to permit persons to whom the Software is furnished to do so,
 subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all
 copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 --
/**

/**
LazyLoad makes it easy and painless to lazily load one or more external
JavaScript or CSS files on demand either during or after the rendering of a web
page.

Supported browsers include Firefox 2+, IE6+, Safari 3+ (including Mobile
Safari), Google Chrome, and Opera 9+. Other browsers may or may not work and
are not officially supported.

Visit https://github.com/rgrove/lazyload/ for more info.

@module lazyload
@class LazyLoad
@static
*/
LazyLoad=function(f){function h(a,b){var e=f.createElement(a),c;for(c in b)b.hasOwnProperty(c)&&e.setAttribute(c,b[c]);return e}function b(a){var b=k[a],c,d;b&&(c=b.callback,d=b.urls,d.shift(),l=0,d.length||(c&&c.call(b.context,b.obj),k[a]=null,r[a].length&&e(a)))}function a(){var a=navigator.userAgent;g={async:!0===f.createElement("script").async};(g.webkit=/AppleWebKit\//.test(a))||(g.ie=/MSIE|Trident/.test(a))||(g.opera=/Opera/.test(a))||(g.gecko=/Gecko\//.test(a))||(g.unknown=!0)}function e(e,
l,q,v,p){var y=function(){b(e)},x="css"===e,n=[],A,D,B,G;g||a();if(l)if(l="string"===typeof l?[l]:l.concat(),x||g.async||g.gecko||g.opera)r[e].push({urls:l,callback:q,obj:v,context:p});else{A=0;for(D=l.length;A<D;++A)r[e].push({urls:[l[A]],callback:A===D-1?q:null,obj:v,context:p})}if(!k[e]&&(G=k[e]=r[e].shift())){m||(m=f.head||f.getElementsByTagName("head")[0]);l=G.urls;A=0;for(D=l.length;A<D;++A)q=l[A],x?B=g.gecko?h("style"):h("link",{href:q,rel:"stylesheet"}):(B=h("script",{src:q}),B.async=!1),
B.className="lazyload",B.setAttribute("charset","utf-8"),g.ie&&!x&&"onreadystatechange"in B&&!("draggable"in B)?B.onreadystatechange=function(){/loaded|complete/.test(B.readyState)&&(B.onreadystatechange=null,y())}:x&&(g.gecko||g.webkit)?g.webkit?(G.urls[A]=B.href,c()):(B.innerHTML='@import "'+q+'";',d(B)):B.onload=B.onerror=y,n.push(B);A=0;for(D=n.length;A<D;++A)m.appendChild(n[A])}}function d(a){var e;try{e=!!a.sheet.cssRules}catch(c){l+=1;200>l?setTimeout(function(){d(a)},50):e&&b("css");return}b("css")}
function c(){var a=k.css,e;if(a){for(e=n.length;0<=--e;)if(n[e].href===a.urls[0]){b("css");break}l+=1;a&&(200>l?setTimeout(c,50):b("css"))}}var g,m,k={},l=0,r={css:[],js:[]},n=f.styleSheets;return{css:function(a,b,c,d){e("css",a,b,c,d)},js:function(a,b,c,d){e("js",a,b,c,d)}}}(this.document);(function(f,h,b){function a(a,b,e){for(var c=[],d=0;d<a.length;d++){var g=tinycolor(a[d]),f=0.5>g.toHsl().l?"sp-thumb-el sp-thumb-dark":"sp-thumb-el sp-thumb-light",f=f+(tinycolor.equals(b,a[d])?" sp-thumb-active":""),k=q?"background-color:"+g.toRgbString():"filter:"+g.toFilter();c.push('<span title="'+g.toHexString()+'" data-color="'+g.toRgbString()+'" class="'+f+'"><span class="sp-thumb-inner" style="'+k+';" /></span>')}return"<div class='sp-cf "+e+"'>"+c.join("")+"</div>"}function e(a,b){var e=
h.extend({},n,a);e.callbacks={move:k(e.move,b),change:k(e.change,b),show:k(e.show,b),hide:k(e.hide,b),beforeShow:k(e.beforeShow,b)};return e}function d(b,d){function g(a){Oa&&(ca.push(tinycolor(a).toHexString()),fa&&f.localStorage&&(f.localStorage[fa]=ca.join(",")))}function k(){var a=[],b=ca,e={};if(X){for(var c=0;c<ia.length;c++)for(var d=0;d<ia[c].length;d++){var g=tinycolor(ia[c][d]).toHexString();e[g]=!0}for(c=0;c<b.length;c++)g=tinycolor(b[c]).toHexString(),e.hasOwnProperty(g)||(a.push(b[c]),
e[g]=!0)}return a.reverse().slice(0,J.maxSelectionSize)}function n(){var b=M(),e=h.map(ia,function(e,c){return a(e,b,"sp-palette-row sp-palette-row-"+c)});ca&&e.push(a(k(),b,"sp-palette-row sp-palette-row-selection"));Da.html(e.join(""))}function B(){if(ya){var b=V,e=M();Ea.html(a([b,e],e,"sp-palette-row-initial"))}}function G(){(0===T||0===ba||0===ga)&&Q();K.addClass(Fa)}function u(){K.removeClass(Fa)}function I(){var a=tinycolor(R.val());a.ok?E(a):R.addClass("sp-validation-error")}function w(){aa?
z():C()}function C(){if(aa)Q();else if(!1!==Z.beforeShow(M())){for(var a=0;a<t.length;a++)t[a]&&t[a].hide();aa=!0;h(ja).bind("click.spectrum",z);h(f).bind("resize.spectrum",Ca);Y.addClass("sp-active");K.show();X&&n();Q();O();V=M();B();Z.show(V)}}function z(a){if((!a||!("click"==a.type&&2==a.button))&&aa&&!P)aa=!1,h(ja).unbind("click.spectrum",z),h(f).unbind("resize.spectrum",Ca),Y.removeClass("sp-active"),K.hide(),tinycolor.equals(M(),V)||(Pa&&"cancel"!==a?L(!0):E(V,!0)),Z.hide(M())}function E(a,
b){if(!tinycolor.equals(a,M())){var e=tinycolor(a),c=e.toHsv();da=c.h;ka=c.s;la=c.v;S=c.a;O();b||(ma=qa||e.format)}}function M(){return tinycolor.fromRatio({h:da,s:ka,v:la,a:Math.round(100*S)/100})}function N(){O();Z.move(M())}function O(){R.removeClass("sp-validation-error");H();var a=tinycolor({h:da,s:"1.0",v:"1.0"});na.css("background-color",a.toHexString());a=ma;if(1>S&&("hex"===a||"name"===a))a="rgb";var b=M(),e=b.toHexString(),c=b.toRgbString();q||1===b.alpha?ra.css("background-color",c):(ra.css("background-color",
"transparent"),ra.css("filter",b.toFilter()));if(Ba){c=b.toRgb();c.a=0;var c=tinycolor(c).toRgbString(),d="linear-gradient(left, "+c+", "+e+")";s?ea.css("filter",tinycolor(c).toFilter({gradientType:1},e)):(ea.css("background","-webkit-"+d),ea.css("background","-moz-"+d),ea.css("background","-ms-"+d),ea.css("background",d))}if(Aa){if(1>S&&("hex"===a||"name"===a))a="rgb";R.val(b.toString(a))}X&&n();B()}function H(){var a=ka*ba,b=T-la*T,a=Math.max(-U,Math.min(ba-U,a-U)),b=Math.max(-U,Math.min(T-U,b-
U));Ga.css({top:b,left:a});Ha.css({left:S*sa-Ia/2});Ja.css({top:da*ga-Ka})}function L(a){var b=M();ta&&W.val(b.toString(ma)).change();var e=!tinycolor.equals(b,V);V=b;g(b);a&&e&&Z.change(b)}function Q(){ba=na.width();T=na.height();U=Ga.height();ua.width();ga=ua.height();Ka=Ja.height();sa=La.width();Ia=Ha.width();P||K.offset(c(K,va));H()}var J=e(d,b),P=J.flat,ha=J.showPaletteOnly,X=J.showPalette||ha,ya=J.showInitial&&!P,Aa=J.showInput,Ba=J.showAlpha,Oa=J.showSelectionPalette,fa=J.localStorageKey,za=
J.theme,Z=J.callbacks,Ca=r(Q,10),aa=!1,ba=0,T=0,U=0,ga=0,sa=0,Ia=0,Ka=0,da=0,ka=0,la=0,S=1,wa=J.palette.slice(0),ia=h.isArray(wa[0])?wa:[wa],ca=J.selectionPalette.slice(0),Fa="sp-dragging",ja=b.ownerDocument,Qa=ja.body,W=h(b),K=h(p,ja).addClass(za),na=K.find(".sp-color"),Ga=K.find(".sp-dragger"),ua=K.find(".sp-hue"),Ja=K.find(".sp-slider"),ea=K.find(".sp-alpha-inner"),La=K.find(".sp-alpha"),Ha=K.find(".sp-alpha-handle"),R=K.find(".sp-input"),Da=K.find(".sp-palette"),Ea=K.find(".sp-initial"),Ma=K.find(".sp-cancel"),
Na=K.find(".sp-choose"),ta=W.is("input"),xa=ta&&!P,Y=xa?h(v).addClass(za):h([]),va=xa?Y:W,ra=Y.find(".sp-preview-inner"),oa=J.color||ta&&W.val(),V=!1,qa=J.preferredFormat,ma=qa,Pa=!J.showButtons||J.clickoutFiresChange;Na.text(J.chooseText);Ma.text(J.cancelText);(function(){function a(b){b.data&&b.data.ignore?(E(h(this).data("color")),N()):(E(h(this).data("color")),L(!0),N(),z());return!1}s&&K.find("*:not(input)").attr("unselectable","on");K.toggleClass("sp-flat",P);K.toggleClass("sp-input-disabled",
!Aa);K.toggleClass("sp-alpha-enabled",Ba);K.toggleClass("sp-buttons-disabled",!J.showButtons||P);K.toggleClass("sp-palette-disabled",!X);K.toggleClass("sp-palette-only",ha);K.toggleClass("sp-initial-disabled",!ya);K.addClass(J.className);xa&&W.hide().after(Y);P?W.after(K).hide():h(Qa).append(K.hide());if(fa&&f.localStorage)try{ca=f.localStorage[fa].split(",")}catch(b){}va.bind("click.spectrum touchstart.spectrum",function(a){w();a.stopPropagation();h(a.target).is("input")||a.preventDefault()});K.click(m);
R.change(I);R.bind("paste",function(){setTimeout(I,1)});R.keydown(function(a){13==a.keyCode&&I()});Ma.bind("click.spectrum",function(a){a.stopPropagation();a.preventDefault();z("cancel")});Na.bind("click.spectrum",function(a){a.stopPropagation();a.preventDefault();R.hasClass("sp-validation-error")||(L(!0),z())});l(La,function(a,b,e){S=a/sa;e.shiftKey&&(S=Math.round(10*S)/10);N()});l(ua,function(a,b){da=b/ga;N()},G,u);l(na,function(a,b){ka=a/ba;la=(T-b)/T;N()},G,u);oa?(E(oa),O(),ma=qa||tinycolor(oa).format,
g(oa)):O();P&&C();var e=s?"mousedown.spectrum":"click.spectrum touchstart.spectrum";Da.delegate(".sp-thumb-el",e,a);Ea.delegate(".sp-thumb-el::nth-child(1)",e,{ignore:!0},a)})();var pa={show:C,hide:z,toggle:w,reflow:Q,set:function(a){E(a);L()},get:M,destroy:function(){W.show();va.unbind("click.spectrum touchstart.spectrum");K.remove();Y.remove();t[pa.id]=null},container:K};pa.id=t.push(pa)-1;return pa}function c(a,b){var e=a.outerWidth(),c=a.outerHeight();b.outerWidth();var d=b.outerHeight(),g=a[0].ownerDocument,
f=g.documentElement,k=f.clientWidth+h(g).scrollLeft(),g=f.clientHeight+h(g).scrollTop(),f=b.offset();f.top+=d;f.left-=Math.min(f.left,f.left+e>k&&k>e?Math.abs(f.left+e-k):0);f.top-=Math.min(f.top,f.top+c>g&&g>c?Math.abs(c+d-0):0);return f}function g(){}function m(a){a.stopPropagation()}function k(a,b){var e=Array.prototype.slice,c=e.call(arguments,2);return function(){return a.apply(b,c.concat(e.call(arguments)))}}function l(a,b,e,c){function d(a){a.stopPropagation&&a.stopPropagation();a.preventDefault&&
a.preventDefault();a.returnValue=!1}function g(e){if(r){if(s&&!(9<=document.documentMode)&&!e.button)return k();var c=e.originalEvent.touches,f=c?c[0].pageY:e.pageY,c=Math.max(0,Math.min((c?c[0].pageX:e.pageX)-m.left,v)),f=Math.max(0,Math.min(f-m.top,p));q&&d(e);b.apply(a,[c,f,e])}}function k(){r&&(h(l).unbind(n),h(l.body).removeClass("sp-dragging"),c.apply(a,arguments));r=!1}b=b||function(){};e=e||function(){};c=c||function(){};var l=a.ownerDocument||document,r=!1,m={},p=0,v=0,q="ontouchstart"in
f,n={};n.selectstart=d;n.dragstart=d;n[q?"touchmove":"mousemove"]=g;n[q?"touchend":"mouseup"]=k;h(a).bind(q?"touchstart":"mousedown",function(b){if(!(b.which?3==b.which:2==b.button)&&!r&&!1!==e.apply(a,arguments))r=!0,p=h(a).height(),v=h(a).width(),m=h(a).offset(),h(l).bind(n),h(l.body).addClass("sp-dragging"),q||g(b),d(b)})}function r(a,b,e){var c;return function(){var d=this,g=arguments,f=function(){c=null;a.apply(d,g)};e&&clearTimeout(c);if(e||!c)c=setTimeout(f,b)}}var n={beforeShow:g,move:g,change:g,
show:g,hide:g,color:!1,flat:!1,showInput:!1,showButtons:!0,clickoutFiresChange:!1,showInitial:!1,showPalette:!1,showPaletteOnly:!1,showSelectionPalette:!0,localStorageKey:!1,maxSelectionSize:7,cancelText:"cancel",chooseText:"choose",preferredFormat:!1,className:"",showAlpha:!1,theme:"sp-light",palette:["fff","000"],selectionPalette:[]},t=[],s=!!/msie/i.exec(f.navigator.userAgent),q=function(){var a=document.createElement("div").style;a.cssText="background-color:rgba(0,0,0,.5)";return!!~(""+a.backgroundColor).indexOf("rgba")||
!!~(""+a.backgroundColor).indexOf("hsla")}(),v="<div class='sp-replacer'><div class='sp-preview'><div class='sp-preview-inner'></div></div><div class='sp-dd'>&#9660;</div></div>",p=function(){var a="";if(s)for(var b=1;6>=b;b++)a+="<div class='sp-"+b+"'></div>";return["<div class='sp-container'><div class='sp-palette-container'><div class='sp-palette sp-thumb sp-cf'></div></div><div class='sp-picker-container'><div class='sp-top sp-cf'><div class='sp-fill'></div><div class='sp-top-inner'><div class='sp-color'><div class='sp-sat'><div class='sp-val'><div class='sp-dragger'></div></div></div></div><div class='sp-hue'><div class='sp-slider'></div>",
a,"</div></div><div class='sp-alpha'><div class='sp-alpha-inner'><div class='sp-alpha-handle'></div></div></div></div><div class='sp-input-container sp-cf'><input class='sp-input' type='text' spellcheck='false'  /></div><div class='sp-initial sp-thumb sp-cf'></div><div class='sp-button-container sp-cf'><a class='sp-cancel' href='#'></a><button class='sp-choose'></button></div></div></div>"].join("")}();h.fn.spectrum=function(a,b){return"string"==typeof a?"get"==a?t[this.eq(0).data("spectrum.id")].get():
"container"==a?t[h(this).data("spectrum.id")].container:this.each(function(){var e=t[h(this).data("spectrum.id")];e&&("show"==a&&e.show(),"hide"==a&&e.hide(),"toggle"==a&&e.toggle(),"reflow"==a&&e.reflow(),"set"==a&&e.set(b),"destroy"==a&&(e.destroy(),h(this).removeData("spectrum.id")))}):this.spectrum("destroy").each(function(){var b=d(this,a);h(this).data("spectrum.id",b.id)})};h.fn.spectrum.load=!0;h.fn.spectrum.loadOpts={};h.fn.spectrum.draggable=l;h.fn.spectrum.defaults=n;h.fn.spectrum.processNativeColorInputs=
function(){var a=h("<input type='color' value='!' />")[0];"color"===a.type&&"!"!=a.value||h("input[type=color]").spectrum({preferredFormat:"hex6"})};(function(a){function b(a,d){if("object"==typeof a&&a.hasOwnProperty("_tc_id"))return a;var k=e(a),h=k.r,r=k.g,p=k.b,y=t(k.a);return{ok:k.ok,format:k.format,_tc_id:m++,alpha:y,toHsv:function(){var a=g(h,r,p);return{h:a.h,s:a.s,v:a.v,a:y}},toHsvString:function(){var a=g(h,r,p),b=s(360*a.h),e=s(100*a.s),a=s(100*a.v);return 1==y?"hsv("+b+", "+e+"%, "+a+
"%)":"hsva("+b+", "+e+"%, "+a+"%, "+y+")"},toHsl:function(){var a=c(h,r,p);return{h:a.h,s:a.s,l:a.l,a:y}},toHslString:function(){var a=c(h,r,p),b=s(360*a.h),e=s(100*a.s),a=s(100*a.l);return 1==y?"hsl("+b+", "+e+"%, "+a+"%)":"hsla("+b+", "+e+"%, "+a+"%, "+y+")"},toHex:function(){return f(h,r,p)},toHexString:function(a){return"#"+f(h,r,p,a)},toRgb:function(){return{r:s(h),g:s(r),b:s(p),a:y}},toRgbString:function(){return 1==y?"rgb("+s(h)+", "+s(r)+", "+s(p)+")":"rgba("+s(h)+", "+s(r)+", "+s(p)+", "+
y+")"},toName:function(){return J[f(h,r,p)]||!1},toFilter:function(a,e){var c=secondHex=f(h,r,p,!0),d=secondAlphaHex=Math.round(255*t(y)).toString(16),g=a&&a.gradientType?"GradientType = 1, ":"";if(e){var k=b(e);secondHex=k.toHex();secondAlphaHex=Math.round(255*t(k.alpha)).toString(16)}return"progid:DXImageTransform.Microsoft.gradient("+g+"startColorstr=#"+l(d)+c+",endColorstr=#"+l(secondAlphaHex)+secondHex+")"},toString:function(a){a=a||this.format;var b=!1;"rgb"===a&&(b=this.toRgbString());"hex"===
a&&(b=this.toHexString());"hex6"===a&&(b=this.toHexString(!0));"name"===a&&(b=this.toName());"hsl"===a&&(b=this.toHslString());"hsv"===a&&(b=this.toHsvString());return b||this.toHexString()}}}function e(a){var b={r:0,g:0,b:0},c=1,g=!1,f=!1;if("string"==typeof a)a:{a=a.replace(h,"").replace(r,"").toLowerCase();var l=!1;if(Q[a])a=Q[a],l=!0;else if("transparent"==a){a={r:0,g:0,b:0,a:0};break a}var m;a=(m=P.rgb.exec(a))?{r:m[1],g:m[2],b:m[3]}:(m=P.rgba.exec(a))?{r:m[1],g:m[2],b:m[3],a:m[4]}:(m=P.hsl.exec(a))?
{h:m[1],s:m[2],l:m[3]}:(m=P.hsla.exec(a))?{h:m[1],s:m[2],l:m[3],a:m[4]}:(m=P.hsv.exec(a))?{h:m[1],s:m[2],v:m[3]}:(m=P.hex6.exec(a))?{r:parseInt(m[1],16),g:parseInt(m[2],16),b:parseInt(m[3],16),format:l?"name":"hex"}:(m=P.hex3.exec(a))?{r:parseInt(m[1]+""+m[1],16),g:parseInt(m[2]+""+m[2],16),b:parseInt(m[3]+""+m[3],16),format:l?"name":"hex"}:!1}if("object"==typeof a){if(a.hasOwnProperty("r")&&a.hasOwnProperty("g")&&a.hasOwnProperty("b"))b={r:255*k(a.r,255),g:255*k(a.g,255),b:255*k(a.b,255)},g=!0,f=
"rgb";else if(a.hasOwnProperty("h")&&a.hasOwnProperty("s")&&a.hasOwnProperty("v")){var f=a.h,l=a.s,b=a.v,f=6*k(f,360),l=k(l,100),b=k(b,100),g=p.floor(f),y=f-g,f=b*(1-l);m=b*(1-y*l);l=b*(1-(1-y)*l);g%=6;b={r:255*[b,m,f,f,l,b][g],g:255*[l,b,b,m,f,f][g],b:255*[f,f,l,b,b,m][g]};g=!0;f="hsv"}else a.hasOwnProperty("h")&&(a.hasOwnProperty("s")&&a.hasOwnProperty("l"))&&(b=d(a.h,a.s,a.l),g=!0,f="hsl");a.hasOwnProperty("a")&&(c=a.a)}b.r=q(255,v(b.r,0));b.g=q(255,v(b.g,0));b.b=q(255,v(b.b,0));1>b.r&&(b.r=s(b.r));
1>b.g&&(b.g=s(b.g));1>b.b&&(b.b=s(b.b));return{ok:g,format:a&&a.format||f,r:b.r,g:b.g,b:b.b,a:c}}function c(a,b,e){a=k(a,255);b=k(b,255);e=k(e,255);var d=v(a,b,e),g=q(a,b,e),f,l=(d+g)/2;if(d==g)f=g=0;else{var h=d-g,g=0.5<l?h/(2-d-g):h/(d+g);switch(d){case a:f=(b-e)/h+(b<e?6:0);break;case b:f=(e-a)/h+2;break;case e:f=(a-b)/h+4}f/=6}return{h:f,s:g,l:l}}function d(a,b,e){function c(a,b,e){0>e&&(e+=1);1<e&&(e-=1);return e<1/6?a+6*(b-a)*e:0.5>e?b:e<2/3?a+6*(b-a)*(2/3-e):a}a=k(a,360);b=k(b,100);e=k(e,100);
if(0==b)e=b=a=e;else{var g=0.5>e?e*(1+b):e+b-e*b,f=2*e-g;e=c(f,g,a+1/3);b=c(f,g,a);a=c(f,g,a-1/3)}return{r:255*e,g:255*b,b:255*a}}function g(a,b,e){a=k(a,255);b=k(b,255);e=k(e,255);var c=v(a,b,e),d=q(a,b,e),f,l=c-d;if(c==d)f=0;else{switch(c){case a:f=(b-e)/l+(b<e?6:0);break;case b:f=(e-a)/l+2;break;case e:f=(a-b)/l+4}f/=6}return{h:f,s:0==c?0:l/c,v:c}}function f(a,b,e,c){a=[l(s(a).toString(16)),l(s(b).toString(16)),l(s(e).toString(16))];return!c&&a[0].charAt(0)==a[0].charAt(1)&&a[1].charAt(0)==a[1].charAt(1)&&
a[2].charAt(0)==a[2].charAt(1)?a[0].charAt(0)+a[1].charAt(0)+a[2].charAt(0):a.join("")}function k(a,b){"string"==typeof a&&(-1!=a.indexOf(".")&&1===t(a))&&(a="100%");var e="string"===typeof a&&-1!=a.indexOf("%");a=q(b,v(0,t(a)));e&&(a*=b/100);return 1E-6>p.abs(a-b)?1:1<=a?a%b/t(b):a}function l(a){return 1==a.length?"0"+a:""+a}var h=/^[\s,#]+/,r=/\s+$/,m=0,p=Math,s=p.round,q=p.min,v=p.max,n=p.random,t=a.parseFloat;b.fromRatio=function(a){if("object"==typeof a)for(var e in a)1===a[e]&&(a[e]="1.0");
return b(a)};b.equals=function(a,e){return!a||!e?!1:b(a).toRgbString()==b(e).toRgbString()};b.random=function(){return b.fromRatio({r:n(),g:n(),b:n()})};b.desaturate=function(a,e){var c=b(a).toHsl();c.s-=(e||10)/100;c.s=q(1,v(0,c.s));return b(c)};b.saturate=function(a,e){var c=b(a).toHsl();c.s+=(e||10)/100;c.s=q(1,v(0,c.s));return b(c)};b.greyscale=function(a){return b.desaturate(a,100)};b.lighten=function(a,e){var c=b(a).toHsl();c.l+=(e||10)/100;c.l=q(1,v(0,c.l));return b(c)};b.darken=function(a,
e){var c=b(a).toHsl();c.l-=(e||10)/100;c.l=q(1,v(0,c.l));return b(c)};b.complement=function(a){a=b(a).toHsl();a.h=(a.h+0.5)%1;return b(a)};b.triad=function(a){var e=b(a).toHsl(),c=360*e.h;return[b(a),b({h:(c+120)%360,s:e.s,l:e.l}),b({h:(c+240)%360,s:e.s,l:e.l})]};b.tetrad=function(a){var e=b(a).toHsl(),c=360*e.h;return[b(a),b({h:(c+90)%360,s:e.s,l:e.l}),b({h:(c+180)%360,s:e.s,l:e.l}),b({h:(c+270)%360,s:e.s,l:e.l})]};b.splitcomplement=function(a){var e=b(a).toHsl(),c=360*e.h;return[b(a),b({h:(c+72)%
360,s:e.s,l:e.l}),b({h:(c+216)%360,s:e.s,l:e.l})]};b.analogous=function(a,e,c){e=e||6;c=c||30;var d=b(a).toHsl();c=360/c;a=[b(a)];d.h*=360;for(d.h=(d.h-(c*e>>1)+720)%360;--e;)d.h=(d.h+c)%360,a.push(b(d));return a};b.monochromatic=function(a,e){e=e||6;for(var c=b(a).toHsv(),d=c.h,g=c.s,c=c.v,f=[],k=1/e;e--;)f.push(b({h:d,s:g,v:c})),c=(c+k)%1;return f};b.readable=function(a,e){var c=b(a).toRgb(),d=b(e).toRgb();return 10404<(d.r-c.r)*(d.r-c.r)+(d.g-c.g)*(d.g-c.g)+(d.b-c.b)*(d.b-c.b)};var Q=b.names={aliceblue:"f0f8ff",
antiquewhite:"faebd7",aqua:"0ff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000",blanchedalmond:"ffebcd",blue:"00f",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",burntsienna:"ea7e5d",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"0ff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkgrey:"a9a9a9",darkkhaki:"bdb76b",darkmagenta:"8b008b",
darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkslategrey:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dimgrey:"696969",dodgerblue:"1e90ff",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"f0f",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",
greenyellow:"adff2f",grey:"808080",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgray:"d3d3d3",lightgreen:"90ee90",lightgrey:"d3d3d3",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslategray:"789",lightslategrey:"789",lightsteelblue:"b0c4de",
lightyellow:"ffffe0",lime:"0f0",limegreen:"32cd32",linen:"faf0e6",magenta:"f0f",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370db",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",
orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"db7093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",red:"f00",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",slategrey:"708090",snow:"fffafa",springgreen:"00ff7f",
steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",wheat:"f5deb3",white:"fff",whitesmoke:"f5f5f5",yellow:"ff0",yellowgreen:"9acd32"},J=b.hexNames=function(a){var b={},e;for(e in a)a.hasOwnProperty(e)&&(b[a[e]]=e);return b}(Q),P={rgb:RegExp("rgb[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),rgba:RegExp("rgba[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),
hsl:RegExp("hsl[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),hsla:RegExp("hsla[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),hsv:RegExp("hsv[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),
hex3:/^([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/};a.tinycolor=b})(this);h(function(){h.fn.spectrum.load&&h.fn.spectrum.processNativeColorInputs()})})(this,jQuery);WinChan=function(){function f(a,b,e){a.attachEvent?a.attachEvent("on"+b,e):a.addEventListener&&a.addEventListener(b,e,!1)}function h(a,b,e){a.detachEvent?a.detachEvent("on"+b,e):a.removeEventListener&&a.removeEventListener(b,e,!1)}function b(){try{var a=navigator.userAgent;return-1!=a.indexOf("Fennec/")||-1!=a.indexOf("Firefox/")&&-1!=a.indexOf("Android")}catch(b){}return!1}function a(a){/^https?:\/\//.test(a)||(a=window.location.href);var b=/^(https?:\/\/[\-_a-zA-Z\.0-9:]+)/.exec(a);return b?b[1]:
a}function e(){for(var a=window.location,b=window.opener.frames,a=a.protocol+"//"+a.host,e=b.length-1;0<=e;e--)try{if(0===b[e].location.href.indexOf(a)&&b[e].name===d)return b[e]}catch(c){}}var d="__winchan_relay_frame",c="die",g=function(){var a=-1;"Microsoft Internet Explorer"===navigator.appName&&null!=/MSIE ([0-9]{1,}[.0-9]{0,})/.exec(navigator.userAgent)&&(a=parseFloat(RegExp.$1));return 8<=a}();return window.JSON&&window.JSON.stringify&&window.JSON.parse&&window.postMessage?{open:function(e,
k){function l(){t&&document.body.removeChild(t);t=void 0;if(v)try{v.close()}catch(a){q.postMessage(c,s)}v=q=void 0}function r(a){try{var b=JSON.parse(a.data);"ready"===b.a?q.postMessage(p,s):"error"===b.a?k&&(k(b.d),k=null):"response"===b.a&&(h(window,"message",r),h(window,"unload",l),l(),k&&(k(null,b.d),k=null))}catch(e){}}if(!k)throw"missing required callback argument";var n;e.url||(n="missing required 'url' parameter");e.relay_url||(n="missing required 'relay_url' parameter");n&&setTimeout(function(){k(n)},
0);e.window_name||(e.window_name=null);if(!e.window_features||b())e.window_features=void 0;var t,s=a(e.url);if(s!==a(e.relay_url))return setTimeout(function(){k("invalid arguments: origin of url and relay_url must match")},0);var q;g&&(t=document.createElement("iframe"),t.setAttribute("src",e.relay_url),t.style.display="none",t.setAttribute("name",d),document.body.appendChild(t),q=t.contentWindow);var v=window.open(e.url,e.window_name,e.window_features);q||(q=v);var p=JSON.stringify({a:"request",
d:e.params});f(window,"unload",l);f(window,"message",r);return{close:l,focus:function(){if(v)try{v.focus()}catch(a){}}}},onOpen:function(a){function b(a){a=JSON.stringify(a);g?t.doPost(a,n):t.postMessage(a,n)}function d(e){var c;try{c=JSON.parse(e.data)}catch(g){}c&&"request"===c.a&&(h(window,"message",d),n=e.origin,a&&setTimeout(function(){a(n,c.d,function(e){a=void 0;b({a:"response",d:e})})},0))}function r(a){if(a.data===c)try{window.close()}catch(b){}}var n="*",t=g?e():window.opener;if(!t)throw"can't find relay frame";
f(g?t:window,"message",d);f(g?t:window,"message",r);try{b({a:"ready"})}catch(s){f(t,"load",function(a){b({a:"ready"})})}var q=function(){try{h(g?t:window,"message",r)}catch(e){}a&&b({a:"error",d:"client closed window"});a=void 0;try{window.close()}catch(c){}};f(window,"unload",q);return{detach:function(){h(window,"unload",q)}}}}:{open:function(a,b,e,c){setTimeout(function(){c("unsupported browser")},0)},onOpen:function(a){setTimeout(function(){a("unsupported browser")},0)}}}();/*

 Software from "SockJS" is Copyright (c) 2011-2012 VMware, Inc. and is provided
 under the following license (the SockJS software has been modified):
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
var JSON;JSON||(JSON={});
(function(){function f(a,b){var e,g,t,s,q=d,v,p=b[a];p&&"object"==typeof p&&"function"==typeof p.toJSON&&(p=p.toJSON(a));"function"==typeof m&&(p=m.call(b,a,p));switch(typeof p){case "string":return h(p);case "number":return isFinite(p)?String(p):"null";case "boolean":case "null":return String(p);case "object":if(!p)return"null";d+=c;v=[];if("[object Array]"===Object.prototype.toString.apply(p)){s=p.length;for(e=0;e<s;e+=1)v[e]=f(e,p)||"null";t=0===v.length?"[]":d?"[\n"+d+v.join(",\n"+d)+"\n"+q+"]":
"["+v.join(",")+"]";d=q;return t}if(m&&"object"==typeof m){s=m.length;for(e=0;e<s;e+=1)"string"==typeof m[e]&&(g=m[e],t=f(g,p),t&&v.push(h(g)+(d?": ":":")+t))}else for(g in p)Object.prototype.hasOwnProperty.call(p,g)&&(t=f(g,p),t&&v.push(h(g)+(d?": ":":")+t));t=0===v.length?"{}":d?"{\n"+d+v.join(",\n"+d)+"\n"+q+"}":"{"+v.join(",")+"}";d=q;return t}}function h(a){e.lastIndex=0;return e.test(a)?'"'+a.replace(e,function(a){var b=g[a];return"string"==typeof b?b:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+
'"':'"'+a+'"'}function b(a){return 10>a?"0"+a:a}"use strict";"function"!=typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(a){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+b(this.getUTCMonth()+1)+"-"+b(this.getUTCDate())+"T"+b(this.getUTCHours())+":"+b(this.getUTCMinutes())+":"+b(this.getUTCSeconds())+"Z":null},String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(a){return this.valueOf()});var a=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
e=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,d,c,g={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},m;"function"!=typeof JSON.stringify&&(JSON.stringify=function(a,b,e){var g;c=d="";if("number"==typeof e)for(g=0;g<e;g+=1)c+=" ";else"string"==typeof e&&(c=e);m=b;if(!b||"function"==typeof b||"object"==typeof b&&"number"==typeof b.length)return f("",{"":a});throw Error("JSON.stringify");});"function"!=
typeof JSON.parse&&(JSON.parse=function(b,e){function c(a,b){var d,g,f=a[b];if(f&&"object"==typeof f)for(d in f)Object.prototype.hasOwnProperty.call(f,d)&&(g=c(f,d),void 0!==g?f[d]=g:delete f[d]);return e.call(a,b,f)}var d;b=String(b);a.lastIndex=0;a.test(b)&&(b=b.replace(a,function(a){return"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)}));if(/^[\],:{}\s]*$/.test(b.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
"]").replace(/(?:^|:|,)(?:\s*\[)+/g,"")))return d=eval("("+b+")"),"function"==typeof e?c({"":d},""):d;throw new SyntaxError("JSON.parse");})})();
SockJS=function(){var f=document,h=window,b={},a=function(){};a.prototype.addEventListener=function(a,e){this._listeners||(this._listeners={});a in this._listeners||(this._listeners[a]=[]);var c=this._listeners[a];-1===b.arrIndexOf(c,e)&&c.push(e)};a.prototype.removeEventListener=function(a,e){if(this._listeners&&a in this._listeners){var c=this._listeners[a],d=b.arrIndexOf(c,e);-1!==d&&(1<c.length?this._listeners[a]=c.slice(0,d).concat(c.slice(d+1)):delete this._listeners[a])}};a.prototype.dispatchEvent=
function(a){var b=a.type,e=Array.prototype.slice.call(arguments,0);this["on"+b]&&this["on"+b].apply(this,e);if(this._listeners&&b in this._listeners)for(var c=0;c<this._listeners[b].length;c++)this._listeners[b][c].apply(this,e)};var e=function(a,b){this.type=a;if("undefined"!==typeof b)for(var e in b)b.hasOwnProperty(e)&&(this[e]=b[e])};e.prototype.toString=function(){var a=[],b;for(b in this)if(this.hasOwnProperty(b)){var e=this[b];"function"===typeof e&&(e="[function]");a.push(b+"="+e)}return"SimpleEvent("+
a.join(", ")+")"};var d=function(a){this._events=a||[];this._listeners={}};d.prototype.emit=function(a){this._verifyType(a);if(!this._nuked){var b=Array.prototype.slice.call(arguments,1);this["on"+a]&&this["on"+a].apply(this,b);if(a in this._listeners)for(var e=0;e<this._listeners[a].length;e++)this._listeners[a][e].apply(this,b)}};d.prototype.on=function(a,b){this._verifyType(a);this._nuked||(a in this._listeners||(this._listeners[a]=[]),this._listeners[a].push(b))};d.prototype._verifyType=function(a){-1===
b.arrIndexOf(this._events,a)&&b.log("Event "+JSON.stringify(a)+" not listed "+JSON.stringify(this._events)+" in "+this)};d.prototype.nuke=function(){this._nuked=!0;for(var a=0;a<this._events.length;a++)delete this[this._events[a]];this._listeners={}};b.random_string=function(a,b){b=b||37;var e,c=[];for(e=0;e<a;e++)c.push("abcdefghijklmnopqrstuvwxyz0123456789_".substr(Math.floor(Math.random()*b),1));return c.join("")};b.random_number=function(a){return Math.floor(Math.random()*a)};b.random_number_string=
function(a){var e=(""+(a-1)).length;return(Array(e+1).join("0")+b.random_number(a)).slice(-e)};b.getOrigin=function(a){return(a+"/").split("/").slice(0,3).join("/")};b.isSameOriginUrl=function(a,b){b||(b=h.location.href);return a.split("/").slice(0,3).join("/")===b.split("/").slice(0,3).join("/")};b.getParentDomain=function(a){return/^[0-9.]*$/.test(a)||/^\[/.test(a)||!/[.]/.test(a)?a:a.split(".").slice(1).join(".")};b.objectExtend=function(a,b){for(var e in b)b.hasOwnProperty(e)&&(a[e]=b[e]);return a};
b.polluteGlobalNamespace=function(){"_jp"in h||(h._jp={})};b.closeFrame=function(a,b){return"c"+JSON.stringify([a,b])};b.userSetCode=function(a){return 1E3===a||3E3<=a&&4999>=a};b.countRTO=function(a){return 100<a?3*a:a+200};b.log=function(){h.console&&(console.log&&console.log.apply)&&console.log.apply(console,arguments)};b.bind=function(a,b){return a.bind?a.bind(b):function(){return a.apply(b,arguments)}};b.flatUrl=function(a){return-1===a.indexOf("?")&&-1===a.indexOf("#")};b.amendUrl=function(a){var e=
f.location;if(!a)throw Error("Wrong url for SockJS");if(!b.flatUrl(a))throw Error("Only basic urls are supported in SockJS");0===a.indexOf("//")&&(a=e.protocol+a);0===a.indexOf("/")&&(a=e.protocol+"//"+e.host+a);return a=a.replace(/[/]+$/,"")};b.arrIndexOf=function(a,b){for(var e=0;e<a.length;e++)if(a[e]===b)return e;return-1};b.arrSkip=function(a,e){var c=b.arrIndexOf(a,e);return-1===c?a.slice():a.slice(0,c).concat(a.slice(c+1))};b.isArray=Array.isArray||function(a){return 0<={}.toString.call(a).indexOf("Array")};
b.delay=function(a,b){"function"===typeof a&&(b=a,a=0);return setTimeout(b,a)};var c=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,g={"\x00":"\\u0000","\u0001":"\\u0001","\u0002":"\\u0002","\u0003":"\\u0003","\u0004":"\\u0004","\u0005":"\\u0005","\u0006":"\\u0006","\u0007":"\\u0007","\b":"\\b","\t":"\\t","\n":"\\n","\x0B":"\\u000b","\f":"\\f","\r":"\\r","\u000e":"\\u000e","\u000f":"\\u000f","\u0010":"\\u0010","\u0011":"\\u0011",
"\u0012":"\\u0012","\u0013":"\\u0013","\u0014":"\\u0014","\u0015":"\\u0015","\u0016":"\\u0016","\u0017":"\\u0017","\u0018":"\\u0018","\u0019":"\\u0019","\u001a":"\\u001a","\u001b":"\\u001b","\u001c":"\\u001c","\u001d":"\\u001d","\u001e":"\\u001e","\u001f":"\\u001f",'"':'\\"',"\\":"\\\\","\u007f":"\\u007f","\u0080":"\\u0080","\u0081":"\\u0081","\u0082":"\\u0082","\u0083":"\\u0083","\u0084":"\\u0084","\u0085":"\\u0085","\u0086":"\\u0086","\u0087":"\\u0087","\u0088":"\\u0088","\u0089":"\\u0089","\u008a":"\\u008a",
"\u008b":"\\u008b","\u008c":"\\u008c","\u008d":"\\u008d","\u008e":"\\u008e","\u008f":"\\u008f","\u0090":"\\u0090","\u0091":"\\u0091","\u0092":"\\u0092","\u0093":"\\u0093","\u0094":"\\u0094","\u0095":"\\u0095","\u0096":"\\u0096","\u0097":"\\u0097","\u0098":"\\u0098","\u0099":"\\u0099","\u009a":"\\u009a","\u009b":"\\u009b","\u009c":"\\u009c","\u009d":"\\u009d","\u009e":"\\u009e","\u009f":"\\u009f","\u00ad":"\\u00ad","\u0600":"\\u0600","\u0601":"\\u0601","\u0602":"\\u0602","\u0603":"\\u0603","\u0604":"\\u0604",
"\u070f":"\\u070f","\u17b4":"\\u17b4","\u17b5":"\\u17b5","\u200c":"\\u200c","\u200d":"\\u200d","\u200e":"\\u200e","\u200f":"\\u200f","\u2028":"\\u2028","\u2029":"\\u2029","\u202a":"\\u202a","\u202b":"\\u202b","\u202c":"\\u202c","\u202d":"\\u202d","\u202e":"\\u202e","\u202f":"\\u202f","\u2060":"\\u2060","\u2061":"\\u2061","\u2062":"\\u2062","\u2063":"\\u2063","\u2064":"\\u2064","\u2065":"\\u2065","\u2066":"\\u2066","\u2067":"\\u2067","\u2068":"\\u2068","\u2069":"\\u2069","\u206a":"\\u206a","\u206b":"\\u206b",
"\u206c":"\\u206c","\u206d":"\\u206d","\u206e":"\\u206e","\u206f":"\\u206f","\ufeff":"\\ufeff","\ufff0":"\\ufff0","\ufff1":"\\ufff1","\ufff2":"\\ufff2","\ufff3":"\\ufff3","\ufff4":"\\ufff4","\ufff5":"\\ufff5","\ufff6":"\\ufff6","\ufff7":"\\ufff7","\ufff8":"\\ufff8","\ufff9":"\\ufff9","\ufffa":"\\ufffa","\ufffb":"\\ufffb","\ufffc":"\\ufffc","\ufffd":"\\ufffd","\ufffe":"\\ufffe","\uffff":"\\uffff"},m=/[\x00-\x1f\ud800-\udfff\ufffe\uffff\u0300-\u0333\u033d-\u0346\u034a-\u034c\u0350-\u0352\u0357-\u0358\u035c-\u0362\u0374\u037e\u0387\u0591-\u05af\u05c4\u0610-\u0617\u0653-\u0654\u0657-\u065b\u065d-\u065e\u06df-\u06e2\u06eb-\u06ec\u0730\u0732-\u0733\u0735-\u0736\u073a\u073d\u073f-\u0741\u0743\u0745\u0747\u07eb-\u07f1\u0951\u0958-\u095f\u09dc-\u09dd\u09df\u0a33\u0a36\u0a59-\u0a5b\u0a5e\u0b5c-\u0b5d\u0e38-\u0e39\u0f43\u0f4d\u0f52\u0f57\u0f5c\u0f69\u0f72-\u0f76\u0f78\u0f80-\u0f83\u0f93\u0f9d\u0fa2\u0fa7\u0fac\u0fb9\u1939-\u193a\u1a17\u1b6b\u1cda-\u1cdb\u1dc0-\u1dcf\u1dfc\u1dfe\u1f71\u1f73\u1f75\u1f77\u1f79\u1f7b\u1f7d\u1fbb\u1fbe\u1fc9\u1fcb\u1fd3\u1fdb\u1fe3\u1feb\u1fee-\u1fef\u1ff9\u1ffb\u1ffd\u2000-\u2001\u20d0-\u20d1\u20d4-\u20d7\u20e7-\u20e9\u2126\u212a-\u212b\u2329-\u232a\u2adc\u302b-\u302c\uaab2-\uaab3\uf900-\ufa0d\ufa10\ufa12\ufa15-\ufa1e\ufa20\ufa22\ufa25-\ufa26\ufa2a-\ufa2d\ufa30-\ufa6d\ufa70-\ufad9\ufb1d\ufb1f\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40-\ufb41\ufb43-\ufb44\ufb46-\ufb4e\ufff0-\uffff]/g,
k,l=JSON&&JSON.stringify||function(a){c.lastIndex=0;c.test(a)&&(a=a.replace(c,function(a){return g[a]}));return'"'+a+'"'},r=function(a){var b,e={},c=[];for(b=0;65536>b;b++)c.push(String.fromCharCode(b));a.lastIndex=0;c.join("").replace(a,function(a){e[a]="\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4);return""});a.lastIndex=0;return e};b.quote=function(a){a=l(a);m.lastIndex=0;if(!m.test(a))return a;k||(k=r(m));return a.replace(m,function(a){return k[a]})};var n="websocket xdr-streaming xhr-streaming iframe-eventsource iframe-htmlfile xdr-polling xhr-polling iframe-xhr-polling jsonp-polling".split(" ");
b.probeProtocols=function(){for(var a={},b=0;b<n.length;b++){var e=n[b];a[e]=p[e]&&p[e].enabled()}return a};b.detectProtocols=function(a,b,e){var c={},d=[];b||(b=n);for(var g=0;g<b.length;g++){var f=b[g];c[f]=a[f]}var k=function(a){var b=a.shift();c[b]?d.push(b):0<a.length&&k(a)};!1!==e.websocket&&k(["websocket"]);c["xhr-streaming"]&&!e.null_origin?d.push("xhr-streaming"):c["xdr-streaming"]&&!e.cookie_needed&&!e.null_origin?d.push("xdr-streaming"):k(["iframe-eventsource","iframe-htmlfile"]);c["xhr-polling"]&&
!e.null_origin?d.push("xhr-polling"):c["xdr-polling"]&&!e.cookie_needed&&!e.null_origin?d.push("xdr-polling"):k(["iframe-xhr-polling","jsonp-polling"]);return d};b.createHook=function(){var a="a"+b.random_string(8);if(!("_sockjs_global"in h)){var e={};h._sockjs_global=function(a){a in e||(e[a]={id:a,del:function(){delete e[a]}});return e[a]}}return h._sockjs_global(a)};b.attachMessage=function(a){b.attachEvent("message",a)};b.attachEvent=function(a,b){"undefined"!==typeof h.addEventListener?h.addEventListener(a,
b,!1):(f.attachEvent("on"+a,b),h.attachEvent("on"+a,b))};b.detachMessage=function(a){b.detachEvent("message",a)};b.detachEvent=function(a,b){"undefined"!==typeof h.addEventListener?h.removeEventListener(a,b,!1):(f.detachEvent("on"+a,b),h.detachEvent("on"+a,b))};var t={},s=!1,q=function(){for(var a in t)t[a](),delete t[a]};b.attachEvent("unload",function(){s||(s=!0,q())});b.unload_add=function(a){var e=b.random_string(8);t[e]=a;s&&b.delay(q);return e};b.unload_del=function(a){a in t&&delete t[a]};
b.createIframe=function(a,e){var c=f.createElement("iframe"),d,g,k=function(){clearTimeout(d);try{c.onload=null}catch(a){}c.onerror=null},l=function(){c&&(k(),setTimeout(function(){c&&c.parentNode.removeChild(c);c=null},0),b.unload_del(g))},h=function(a){c&&(l(),e(a))};c.src=a;c.style.display="none";c.style.position="absolute";c.onerror=function(){h("onerror")};c.onload=function(){clearTimeout(d);d=setTimeout(function(){h("onload timeout")},2E3)};f.body.appendChild(c);d=setTimeout(function(){h("timeout")},
15E3);g=b.unload_add(l);return{post:function(a,b){try{c&&c.contentWindow&&c.contentWindow.postMessage(a,b)}catch(e){}},cleanup:l,loaded:k}};b.createHtmlfile=function(a,e){var c=new ActiveXObject("htmlfile"),d,g,f,k=function(){clearTimeout(d)},l=function(){c&&(k(),b.unload_del(g),f.parentNode.removeChild(f),f=c=null,CollectGarbage())};c.open();c.write('<html><script>document.domain="'+document.domain+'";\x3c/script></html>');c.close();c.parentWindow._jp=h._jp;var r=c.createElement("div");c.body.appendChild(r);
f=c.createElement("iframe");r.appendChild(f);f.src=a;d=setTimeout(function(){c&&(l(),e("timeout"))},15E3);g=b.unload_add(l);return{post:function(a,b){try{f&&f.contentWindow&&f.contentWindow.postMessage(a,b)}catch(e){}},cleanup:l,loaded:k}};var v=function(){};v.prototype=new d(["chunk","finish"]);v.prototype._start=function(a,e,c,d){var g=this;try{g.xhr=new XMLHttpRequest}catch(f){}if(!g.xhr)try{g.xhr=new h.ActiveXObject("Microsoft.XMLHTTP")}catch(k){}if(h.ActiveXObject||h.XDomainRequest)e+=(-1===
e.indexOf("?")?"?":"&")+"t="+ +new Date;g.unload_ref=b.unload_add(function(){g._cleanup(!0)});try{g.xhr.open(a,e,!0)}catch(l){g.emit("finish",0,"");g._cleanup();return}if(!d||!d.no_credentials)g.xhr.withCredentials="true";if(d&&d.headers)for(var r in d.headers)g.xhr.setRequestHeader(r,d.headers[r]);g.xhr.onreadystatechange=function(){if(g.xhr){var a=g.xhr;switch(a.readyState){case 3:try{var b=a.status,e=a.responseText}catch(c){}1223===b&&(b=204);e&&0<e.length&&g.emit("chunk",b,e);break;case 4:b=a.status,
1223===b&&(b=204),g.emit("finish",b,a.responseText),g._cleanup(!1)}}};g.xhr.send(c)};v.prototype._cleanup=function(a){if(this.xhr){b.unload_del(this.unload_ref);this.xhr.onreadystatechange=function(){};if(a)try{this.xhr.abort()}catch(e){}this.unload_ref=this.xhr=null}};v.prototype.close=function(){this.nuke();this._cleanup(!0)};(b.XHRCorsObject=function(){var a=this,e=arguments;b.delay(function(){a._start.apply(a,e)})}).prototype=new v;(b.XHRLocalObject=function(a,e,c){var d=this;b.delay(function(){d._start(a,
e,c,{no_credentials:!0})})}).prototype=new v;v=b.XDRObject=function(a,e,c){var d=this;b.delay(function(){d._start(a,e,c)})};v.prototype=new d(["chunk","finish"]);v.prototype._start=function(a,e,c){var d=this,g=new XDomainRequest;e+=(-1===e.indexOf("?")?"?":"&")+"t="+ +new Date;var f=g.ontimeout=g.onerror=function(){d.emit("finish",0,"");d._cleanup(!1)};g.onprogress=function(){d.emit("chunk",200,g.responseText)};g.onload=function(){d.emit("finish",200,g.responseText);d._cleanup(!1)};d.xdr=g;d.unload_ref=
b.unload_add(function(){d._cleanup(!0)});try{d.xdr.open(a,e),d.xdr.send(c)}catch(k){f()}};v.prototype._cleanup=function(a){if(this.xdr){b.unload_del(this.unload_ref);this.xdr.ontimeout=this.xdr.onerror=this.xdr.onprogress=this.xdr.onload=null;if(a)try{this.xdr.abort()}catch(e){}this.unload_ref=this.xdr=null}};v.prototype.close=function(){this.nuke();this._cleanup(!0)};b.isXHRCorsCapable=function(){return h.XMLHttpRequest&&"withCredentials"in new XMLHttpRequest?1:h.XDomainRequest&&f.domain?2:u.enabled()?
3:4};var p=function(a,e,c){if(this===h)return new p(a,e,c);var d=this,g;d._options={devel:!1,debug:!1,protocols_whitelist:[],info:void 0,rtt:void 0};c&&b.objectExtend(d._options,c);d._base_url=b.amendUrl(a);d._server=d._options.server||b.random_number_string(1E3);d._options.protocols_whitelist&&d._options.protocols_whitelist.length?g=d._options.protocols_whitelist:(g="string"===typeof e&&0<e.length?[e]:b.isArray(e)?e:null)&&d._debug('Deprecated API: Use "protocols_whitelist" option instead of supplying protocol list as a second parameter to SockJS constructor.');
d._protocols=[];d.protocol=null;d.readyState=p.CONNECTING;d._ir=N(d._base_url);d._ir.onfinish=function(a,e){d._ir=null;a?(d._options.info&&(a=b.objectExtend(a,d._options.info)),d._options.rtt&&(e=d._options.rtt),d._applyInfo(a,e,g),d._didClose()):d._didClose(1002,"Can't connect to server",!0)}};p.prototype=new a;p.version="0.3.4";p.CONNECTING=0;p.OPEN=1;p.CLOSING=2;p.CLOSED=3;p.prototype._debug=function(){this._options.debug&&b.log.apply(b,arguments)};p.prototype._dispatchOpen=function(){this.readyState===
p.CONNECTING?(this._transport_tref&&(clearTimeout(this._transport_tref),this._transport_tref=null),this.readyState=p.OPEN,this.dispatchEvent(new e("open"))):this._didClose(1006,"Server lost session")};p.prototype._dispatchMessage=function(a){this.readyState===p.OPEN&&this.dispatchEvent(new e("message",{data:a}))};p.prototype._dispatchHeartbeat=function(a){this.readyState===p.OPEN&&this.dispatchEvent(new e("heartbeat",{}))};p.prototype._didClose=function(a,c,d){var g=this;if(!(g.readyState!==p.CONNECTING&&
g.readyState!==p.OPEN&&g.readyState!==p.CLOSING)){g._ir&&(g._ir.nuke(),g._ir=null);g._transport&&(g._transport.doCleanup(),g._transport=null);var f=new e("close",{code:a,reason:c,wasClean:b.userSetCode(a)});if(!b.userSetCode(a)&&g.readyState===p.CONNECTING&&!d){if(g._try_next_protocol(f))return;f=new e("close",{code:2E3,reason:"All transports failed",wasClean:!1,last_event:f})}g.readyState=p.CLOSED;b.delay(function(){g.dispatchEvent(f)})}};p.prototype._didMessage=function(a){switch(a.slice(0,1)){case "o":this._dispatchOpen();
break;case "a":a=JSON.parse(a.slice(1)||"[]");for(var b=0;b<a.length;b++)this._dispatchMessage(a[b]);break;case "m":a=JSON.parse(a.slice(1)||"null");this._dispatchMessage(a);break;case "c":a=JSON.parse(a.slice(1)||"[]");this._didClose(a[0],a[1]);break;case "h":this._dispatchHeartbeat()}};p.prototype._try_next_protocol=function(a){var e=this;e.protocol&&(e._debug("Closed transport:",e.protocol,""+a),e.protocol=null);e._transport_tref&&(clearTimeout(e._transport_tref),e._transport_tref=null);for(;;){a=
e.protocol=e._protocols.shift();if(!a)return!1;if(p[a]&&!0===p[a].need_body&&(!f.body||"undefined"!==typeof f.readyState&&"complete"!==f.readyState))return e._protocols.unshift(a),e.protocol="waiting-for-load",b.attachEvent("load",function(){e._try_next_protocol()}),!0;if(!p[a]||!p[a].enabled(e._options))e._debug("Skipping transport:",a);else{e._transport_tref=b.delay((e._options.rto||0)*(p[a].roundTrips||1)||5E3,function(){e.readyState===p.CONNECTING&&e._didClose(2007,"Transport timeouted")});var c=
b.random_string(8),c=e._base_url+"/"+e._server+"/"+c;e._debug("Opening transport:",a," url:"+c," RTO:"+e._options.rto);e._transport=new p[a](e,c,e._base_url);return!0}}};p.prototype.close=function(a,e){if(a&&!b.userSetCode(a))throw Error("INVALID_ACCESS_ERR");if(this.readyState!==p.CONNECTING&&this.readyState!==p.OPEN)return!1;this.readyState=p.CLOSING;this._didClose(a||1E3,e||"Normal closure");return!0};p.prototype.send=function(a){if(this.readyState===p.CONNECTING)throw Error("INVALID_STATE_ERR");
this.readyState===p.OPEN&&this._transport.doSend(b.quote(""+a));return!0};p.prototype._applyInfo=function(a,e,c){this._options.info=a;this._options.rtt=e;this._options.rto=b.countRTO(e);this._options.info.null_origin=!f.domain;e=b.probeProtocols();this._protocols=b.detectProtocols(e,c,a)};v=p.websocket=function(a,e){var c=this,d=e+"/websocket",d="https"===d.slice(0,5)?"wss"+d.slice(5):"ws"+d.slice(4);c.ri=a;c.url=d;d=h.WebSocket||h.MozWebSocket;$(document).trigger($.Event("websocket_preopen.zulip",
{}));c.ws=new d(c.url);c.ws.onmessage=function(a){c.ri._didMessage(a.data)};c.unload_ref=b.unload_add(function(){c.ws.close()});c.ws.onclose=function(){c.ri._didMessage(b.closeFrame(1006,"WebSocket connection broken"))}};v.prototype.doSend=function(a){this.ws.send("["+a+"]")};v.prototype.doCleanup=function(){var a=this.ws;a&&(a.onmessage=a.onclose=null,a.close(),b.unload_del(this.unload_ref),this.unload_ref=this.ri=this.ws=null)};v.enabled=function(){return!(!h.WebSocket&&!h.MozWebSocket)};v.roundTrips=
2;var y=function(){};y.prototype.send_constructor=function(a){this.send_buffer=[];this.sender=a};y.prototype.doSend=function(a){this.send_buffer.push(a);this.send_stop||this.send_schedule()};y.prototype.send_schedule_wait=function(){var a=this,e;a.send_stop=function(){a.send_stop=null;clearTimeout(e)};e=b.delay(25,function(){a.send_stop=null;a.send_schedule()})};y.prototype.send_schedule=function(){var a=this;if(0<a.send_buffer.length){var b="["+a.send_buffer.join(",")+"]";a.send_stop=a.sender(a.trans_url,
b,function(b,e){a.send_stop=null;!1===b?a.ri._didClose(1006,"Sending error "+e):a.send_schedule_wait()});a.send_buffer=[]}};y.prototype.send_destructor=function(){this._send_stop&&this._send_stop();this._send_stop=null};var x=function(a,e,c){if(!("_send_form"in this)){var d=this._send_form=f.createElement("form"),g=this._send_area=f.createElement("textarea");g.name="d";d.style.display="none";d.style.position="absolute";d.method="POST";d.enctype="application/x-www-form-urlencoded";d.acceptCharset=
"UTF-8";d.appendChild(g);f.body.appendChild(d)}var d=this._send_form,g=this._send_area,k="a"+b.random_string(8);d.target=k;d.action=a+"/jsonp_send?i="+k;var l;try{l=f.createElement('<iframe name="'+k+'">')}catch(h){l=f.createElement("iframe"),l.name=k}l.id=k;d.appendChild(l);l.style.display="none";try{g.value=e}catch(r){b.log("Your browser is seriously broken. Go home! "+r.message)}d.submit();var m=function(a){l.onerror&&(l.onreadystatechange=l.onerror=l.onload=null,b.delay(500,function(){l.parentNode.removeChild(l);
l=null}),g.value="",c(!0))};l.onerror=l.onload=m;l.onreadystatechange=function(a){"complete"==l.readyState&&m()};return m},F=function(a){return function(b,e,c){(new a("POST",b+"/xhr_send",e)).onfinish=function(a,b){c(200===a||204===a,"http status "+a)};return function(a){c(!1,a)}}},A=function(a,e){var c,d=f.createElement("script"),g,k=function(a){g&&(g.parentNode.removeChild(g),g=null);d&&(clearTimeout(c),d.parentNode.removeChild(d),d=d.onreadystatechange=d.onerror=d.onload=d.onclick=null,e(a),e=
null)},l=!1,h=null;d.id="a"+b.random_string(8);d.src=a;d.type="text/javascript";d.charset="UTF-8";d.onerror=function(a){h||(h=setTimeout(function(){l||k(b.closeFrame(1006,"JSONP script loaded abnormally (onerror)"))},1E3))};d.onload=function(a){k(b.closeFrame(1006,"JSONP script loaded abnormally (onload)"))};d.onreadystatechange=function(a){if(/loaded|closed/.test(d.readyState)){if(d&&d.htmlFor&&d.onclick){l=!0;try{d.onclick()}catch(e){}}d&&k(b.closeFrame(1006,"JSONP script loaded abnormally (onreadystatechange)"))}};
if("undefined"===typeof d.async&&f.attachEvent)if(/opera/i.test(navigator.userAgent))g=f.createElement("script"),g.text="try{var a = document.getElementById('"+d.id+"'); if(a)a.onerror();}catch(x){};",d.async=g.async=!1;else{try{d.htmlFor=d.id,d.event="onclick"}catch(r){}d.async=!0}"undefined"!==typeof d.async&&(d.async=!0);c=setTimeout(function(){k(b.closeFrame(1006,"JSONP script loaded abnormally (timeout)"))},35E3);var m=f.getElementsByTagName("head")[0];m.insertBefore(d,m.firstChild);g&&m.insertBefore(g,
m.firstChild);return k},v=p["jsonp-polling"]=function(a,e){b.polluteGlobalNamespace();this.ri=a;this.trans_url=e;this.send_constructor(x);this._schedule_recv()};v.prototype=new y;v.prototype._schedule_recv=function(){var a=this;a._recv_stop=D(a.trans_url+"/jsonp",A,function(b){a._recv_stop=null;b&&(a._is_closing||a.ri._didMessage(b));a._is_closing||a._schedule_recv()})};v.enabled=function(){return!0};v.need_body=!0;v.prototype.doCleanup=function(){this._is_closing=!0;this._recv_stop&&this._recv_stop();
this.ri=this._recv_stop=null;this.send_destructor()};var D=function(a,e,c){var d="a"+b.random_string(6);a=a+"?c="+escape("_jp."+d);var g=0;e=e(a,function(a){switch(g){case 0:delete h._jp[d];c(a);break;case 1:c(a);g=2;break;case 2:delete h._jp[d]}});h._jp[d]=e;return function(){h._jp[d]&&(g=1,h._jp[d](b.closeFrame(1E3,"JSONP user aborted read")))}},v=function(){};v.prototype=new y;v.prototype.run=function(a,b,e,c,d){this.ri=a;this.trans_url=b;this.send_constructor(F(d));this.poll=new O(a,c,b+e,d)};
v.prototype.doCleanup=function(){this.poll&&(this.poll.abort(),this.poll=null)};var B=p["xhr-streaming"]=function(a,e){this.run(a,e,"/xhr_streaming",J,b.XHRCorsObject)};B.prototype=new v;B.enabled=function(){return h.XMLHttpRequest&&"withCredentials"in new XMLHttpRequest&&!/opera/i.test(navigator.userAgent)};B.roundTrips=2;B.need_body=!0;y=p["xdr-streaming"]=function(a,e){this.run(a,e,"/xhr_streaming",J,b.XDRObject)};y.prototype=new v;y.enabled=function(){return!!h.XDomainRequest};y.roundTrips=2;
var G=p["xhr-polling"]=function(a,e){this.run(a,e,"/xhr",J,b.XHRCorsObject)};G.prototype=new v;G.enabled=B.enabled;G.roundTrips=2;B=p["xdr-polling"]=function(a,e){this.run(a,e,"/xhr",J,b.XDRObject)};B.prototype=new v;B.enabled=y.enabled;B.roundTrips=2;var u=function(){};u.prototype.i_constructor=function(a,e,c){var d=this;d.ri=a;d.origin=b.getOrigin(c);d.base_url=c;d.trans_url=e;a=c+"/iframe.html";d.ri._options.devel&&(a+="?t="+ +new Date);d.window_id=b.random_string(8);a+="#"+d.window_id;d.iframeObj=
b.createIframe(a,function(a){d.ri._didClose(1006,"Unable to load an iframe ("+a+")")});d.onmessage_cb=b.bind(d.onmessage,d);b.attachMessage(d.onmessage_cb)};u.prototype.doCleanup=function(){if(this.iframeObj){b.detachMessage(this.onmessage_cb);try{this.iframeObj.iframe.contentWindow&&this.postMessage("c")}catch(a){}this.iframeObj.cleanup();this.onmessage_cb=this.iframeObj=this.iframeObj=null}};u.prototype.onmessage=function(a){if(a.origin===this.origin){var b=a.data.slice(0,8),e=a.data.slice(8,9);
a=a.data.slice(9);if(b===this.window_id)switch(e){case "s":this.iframeObj.loaded();this.postMessage("s",JSON.stringify([p.version,this.protocol,this.trans_url,this.base_url]));break;case "t":this.ri._didMessage(a)}}};u.prototype.postMessage=function(a,b){this.iframeObj.post(this.window_id+a+(b||""),this.origin)};u.prototype.doSend=function(a){this.postMessage("m",a)};u.enabled=function(){var a=navigator&&navigator.userAgent&&-1!==navigator.userAgent.indexOf("Konqueror");return("function"===typeof h.postMessage||
"object"===typeof h.postMessage)&&!a};var I,w=function(a,e){parent!==h?parent.postMessage(I+a+(e||""),"*"):b.log("Can't postMessage, no parent window.",a,e)},C=function(){};C.prototype._didClose=function(a,e){w("t",b.closeFrame(a,e))};C.prototype._didMessage=function(a){w("t",a)};C.prototype._doSend=function(a){this._transport.doSend(a)};C.prototype._doCleanup=function(){this._transport.doCleanup()};b.parent_origin=void 0;p.bootstrap_iframe=function(){var a;I=f.location.hash.slice(1);b.attachMessage(function(e){if(e.source===
parent&&("undefined"===typeof b.parent_origin&&(b.parent_origin=e.origin),e.origin===b.parent_origin)){var c=e.data.slice(0,8),d=e.data.slice(8,9);e=e.data.slice(9);if(c===I)switch(d){case "s":var g=JSON.parse(e),c=g[0],d=g[1];e=g[2];g=g[3];c!==p.version&&b.log('Incompatibile SockJS! Main site uses: "'+c+'", the iframe: "'+p.version+'".');if(!b.flatUrl(e)||!b.flatUrl(g)){b.log("Only basic urls are supported in SockJS");break}if(!b.isSameOriginUrl(e)||!b.isSameOriginUrl(g)){b.log("Can't connect to different domain from within an iframe. ("+
JSON.stringify([h.location.href,e,g])+")");break}a=new C;a._transport=new C[d](a,e,g);break;case "m":a._doSend(e);break;case "c":a&&a._doCleanup(),a=null}}});w("s")};var z=function(a,e){var c=this;b.delay(function(){c.doXhr(a,e)})};z.prototype=new d(["finish"]);z.prototype.doXhr=function(a,e){var c=this,d=(new Date).getTime(),g=new e("GET",a+"/info?cb="+b.random_string(10)),f=b.delay(8E3,function(){g.ontimeout()});g.onfinish=function(a,b){clearTimeout(f);f=null;if(200===a){var e=(new Date).getTime()-
d,g=JSON.parse(b);"object"!==typeof g&&(g={});c.emit("finish",g,e)}else c.emit("finish")};g.ontimeout=function(){g.close();c.emit("finish")}};var E=function(a){var e=this,c=function(){var b=new u;b.protocol="w-iframe-info-receiver";var c=function(a){"string"===typeof a&&"m"===a.substr(0,1)?(a=JSON.parse(a.substr(1)),e.emit("finish",a[0],a[1])):e.emit("finish");b.doCleanup();b=null};b.i_constructor({_options:{},_didClose:c,_didMessage:c},a,a)};f.body?c():b.attachEvent("load",c)};E.prototype=new d(["finish"]);
var M=function(){var a=this;b.delay(function(){a.emit("finish",{},2E3)})};M.prototype=new d(["finish"]);var N=function(a){if(b.isSameOriginUrl(a))return new z(a,b.XHRLocalObject);switch(b.isXHRCorsCapable()){case 1:return new z(a,b.XHRLocalObject);case 2:return new z(a,b.XDRObject);case 3:return new E(a);default:return new M}};(C["w-iframe-info-receiver"]=function(a,e,c){(new z(c,b.XHRLocalObject)).onfinish=function(b,e){a._didMessage("m"+JSON.stringify([b,e]));a._didClose()}}).prototype.doCleanup=
function(){};d=p["iframe-eventsource"]=function(){this.protocol="w-iframe-eventsource";this.i_constructor.apply(this,arguments)};d.prototype=new u;d.enabled=function(){return"EventSource"in h&&u.enabled()};d.need_body=!0;d.roundTrips=3;(C["w-iframe-eventsource"]=function(a,e){this.run(a,e,"/eventsource",H,b.XHRLocalObject)}).prototype=new v;d=p["iframe-xhr-polling"]=function(){this.protocol="w-iframe-xhr-polling";this.i_constructor.apply(this,arguments)};d.prototype=new u;d.enabled=function(){return h.XMLHttpRequest&&
u.enabled()};d.need_body=!0;d.roundTrips=3;(C["w-iframe-xhr-polling"]=function(a,e){this.run(a,e,"/xhr",J,b.XHRLocalObject)}).prototype=new v;d=p["iframe-htmlfile"]=function(){this.protocol="w-iframe-htmlfile";this.i_constructor.apply(this,arguments)};d.prototype=new u;d.enabled=function(){return u.enabled()};d.need_body=!0;d.roundTrips=3;(C["w-iframe-htmlfile"]=function(a,e){this.run(a,e,"/htmlfile",Q,b.XHRLocalObject)}).prototype=new v;var O=function(a,b,e,c){this.ri=a;this.Receiver=b;this.recv_url=
e;this.AjaxObject=c;this._scheduleRecv()};O.prototype._scheduleRecv=function(){var a=this,b=a.poll=new a.Receiver(a.recv_url,a.AjaxObject);b.onmessage=function(b){a.ri._didMessage(b.data)};b.onclose=function(e){a.poll=b=b.onmessage=b.onclose=null;a.poll_is_closing||("permanent"===e.reason?a.ri._didClose(1006,"Polling error ("+e.reason+")"):a._scheduleRecv())}};O.prototype.abort=function(){this.poll_is_closing=!0;this.poll&&this.poll.abort()};var H=function(a){var c=this,d=new EventSource(a);d.onmessage=
function(a){c.dispatchEvent(new e("message",{data:unescape(a.data)}))};c.es_close=d.onerror=function(a,g){var f=g?"user":2!==d.readyState?"network":"permanent";c.es_close=d.onmessage=d.onerror=null;d.close();d=null;b.delay(200,function(){c.dispatchEvent(new e("close",{reason:f}))})}};H.prototype=new a;H.prototype.abort=function(){this.es_close&&this.es_close({},!0)};var L,Q=function(a){var c=this;b.polluteGlobalNamespace();c.id="a"+b.random_string(6,26);a+=(-1===a.indexOf("?")?"?":"&")+"c="+escape("_jp."+
c.id);if(void 0===L)if("ActiveXObject"in h)try{L=!!new ActiveXObject("htmlfile")}catch(d){}else L=!1;var g=L?b.createHtmlfile:b.createIframe,f;h._jp[c.id]={start:function(){f.loaded()},message:function(a){c.dispatchEvent(new e("message",{data:a}))},stop:function(){c.iframe_close({},"network")}};c.iframe_close=function(a,b){f.cleanup();c.iframe_close=f=null;delete h._jp[c.id];c.dispatchEvent(new e("close",{reason:b}))};f=g(a,function(a){c.iframe_close({},"permanent")})};Q.prototype=new a;Q.prototype.abort=
function(){this.iframe_close&&this.iframe_close({},"user")};var J=function(a,b){var c=this,d=0;c.xo=new b("POST",a,null);c.xo.onchunk=function(a,b){if(200===a)for(;;){var g=b.slice(d),f=g.indexOf("\n");if(-1===f)break;d+=f+1;g=g.slice(0,f);c.dispatchEvent(new e("message",{data:g}))}};c.xo.onfinish=function(a,b){c.xo.onchunk(a,b);c.xo=null;c.dispatchEvent(new e("close",{reason:200===a?"network":"permanent"}))}};J.prototype=new a;J.prototype.abort=function(){this.xo&&(this.xo.close(),this.dispatchEvent(new e("close",
{reason:"user"})),this.xo=null)};p.getUtils=function(){return b};p.getIframeTransport=function(){return u};return p}();"_sockjs_onload"in window&&setTimeout(_sockjs_onload,1);"function"===typeof define&&define.amd&&define("sockjs",[],function(){return SockJS});/*

 Software from "Handlebars", an extension to the Mustache templating language, is
 Copyright (C) 2011 by Yehuda Katz and is provided under the following license:
 --
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 --
*/
var Handlebars=function(){var f=function(){function a(b){this.string=b}a.prototype.toString=function(){return""+this.string};return a}(),h=function(a){function b(a){return f[a]||"&amp;"}var e={},f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},k=/[&<>"'`]/g,l=/[&<>"'`]/;e.extend=function(a,b){for(var e in b)Object.prototype.hasOwnProperty.call(b,e)&&(a[e]=b[e])};var h=Object.prototype.toString;e.toString=h;var n=function(a){return"function"===typeof a};n(/x/)&&(n=function(a){return"function"===
typeof a&&"[object Function]"===h.call(a)});e.isFunction=n;var t=Array.isArray||function(a){return a&&"object"===typeof a?"[object Array]"===h.call(a):!1};e.isArray=t;e.escapeExpression=function(e){if(e instanceof a)return e.toString();if(!e&&0!==e)return"";e=""+e;return!l.test(e)?e:e.replace(k,b)};e.isEmpty=function(a){return!a&&0!==a?!0:t(a)&&0===a.length?!0:!1};return e}(f),b=function(){function a(e,d){var f;d&&d.firstLine&&(f=d.firstLine,e+=" - "+f+":"+d.firstColumn);for(var l=Error.prototype.constructor.call(this,
e),h=0;h<b.length;h++)this[b[h]]=l[b[h]];f&&(this.lineNumber=f,this.column=d.firstColumn)}var b="description fileName lineNumber message name number stack".split(" ");a.prototype=Error();return a}(),a=function(a,b){function e(a,b){this.helpers=a||{};this.partials=b||{};f(this)}function f(a){a.registerHelper("helperMissing",function(a){if(2!==arguments.length)throw new n("Missing helper: '"+a+"'");});a.registerHelper("blockHelperMissing",function(b,e){var c=e.inverse||function(){},d=e.fn;s(b)&&(b=
b.call(this));return!0===b?d(this):!1===b||null==b?c(this):t(b)?0<b.length?a.helpers.each(b,e):c(this):d(b)});a.registerHelper("each",function(a,b){var e=b.fn,c=b.inverse,d=0,g="",f;s(a)&&(a=a.call(this));b.data&&(f=p(b.data));if(a&&"object"===typeof a)if(t(a))for(var k=a.length;d<k;d++)f&&(f.index=d,f.first=0===d,f.last=d===a.length-1),g+=e(a[d],{data:f});else for(k in a)a.hasOwnProperty(k)&&(f&&(f.key=k,f.index=d,f.first=0===d),g+=e(a[k],{data:f}),d++);0===d&&(g=c(this));return g});a.registerHelper("if",
function(a,b){s(a)&&(a=a.call(this));return!b.hash.includeZero&&!a||h.isEmpty(a)?b.inverse(this):b.fn(this)});a.registerHelper("unless",function(b,e){return a.helpers["if"].call(this,b,{fn:e.inverse,inverse:e.fn,hash:e.hash})});a.registerHelper("with",function(a,b){s(a)&&(a=a.call(this));if(!h.isEmpty(a))return b.fn(a)});a.registerHelper("log",function(b,e){var c=e.data&&null!=e.data.level?parseInt(e.data.level,10):1;a.log(c,b)})}function k(a,b){v.log(a,b)}var l={},h=a,n=b;l.VERSION="1.3.0";l.COMPILER_REVISION=
4;l.REVISION_CHANGES={1:"<= 1.0.rc.2",2:"== 1.0.0-rc.3",3:"== 1.0.0-rc.4",4:">= 1.0.0"};var t=h.isArray,s=h.isFunction,q=h.toString;l.HandlebarsEnvironment=e;e.prototype={constructor:e,logger:v,log:k,registerHelper:function(a,b,e){if("[object Object]"===q.call(a)){if(e||b)throw new n("Arg not supported with multiple helpers");h.extend(this.helpers,a)}else e&&(b.not=e),this.helpers[a]=b},registerPartial:function(a,b){"[object Object]"===q.call(a)?h.extend(this.partials,a):this.partials[a]=b}};var v=
{methodMap:{"0":"debug",1:"info",2:"warn",3:"error"},DEBUG:0,INFO:1,WARN:2,ERROR:3,level:3,log:function(a,b){if(v.level<=a){var e=v.methodMap[a];"undefined"!==typeof console&&console[e]&&console[e].call(console,b)}}};l.logger=v;l.log=k;var p=function(a){var b={};h.extend(b,a);return b};l.createFrame=p;return l}(h,b),e=function(a,b,e){function f(a,b,e){var c=function(a,c){c=c||{};return b(a,c.data||e)};c.program=a;c.depth=0;return c}var k={},l=e.COMPILER_REVISION,h=e.REVISION_CHANGES;k.checkRevision=
function(a){var e=a&&a[0]||1;if(e!==l){if(e<l)throw new b("Template was precompiled with an older version of Handlebars than the current runtime. Please update your precompiler to a newer version ("+h[l]+") or downgrade your runtime to an older version ("+h[e]+").");throw new b("Template was precompiled with a newer version of Handlebars than the current runtime. Please update your runtime to a newer version ("+a[1]+").");}};k.template=function(e,g){if(!g)throw new b("No environment passed to template");
var k={escapeExpression:a.escapeExpression,invokePartial:function(a,e,d,f,k,l){var h=g.VM.invokePartial.apply(this,arguments);if(null!=h)return h;if(g.compile)return h={helpers:f,partials:k,data:l},k[e]=g.compile(a,{data:void 0!==l},g),k[e](d,h);throw new b("The partial "+e+" could not be compiled when running in runtime-only mode");},programs:[],program:function(a,b,e){var c=this.programs[a];e?c=f(a,b,e):c||(c=this.programs[a]=f(a,b));return c},merge:function(b,e){var c=b||e;b&&(e&&b!==e)&&(c={},
a.extend(c,e),a.extend(c,b));return c},programWithDepth:g.VM.programWithDepth,noop:g.VM.noop,compilerInfo:null};return function(a,b){b=b||{};var c=b.partial?b:g,d,f;b.partial||(d=b.helpers,f=b.partials);c=e.call(k,c,a,d,f,b.data);b.partial||g.VM.checkRevision(k.compilerInfo);return c}};k.programWithDepth=function(a,b,e){var c=Array.prototype.slice.call(arguments,3),d=function(a,d){d=d||{};return b.apply(this,[a,d.data||e].concat(c))};d.program=a;d.depth=c.length;return d};k.program=f;k.invokePartial=
function(a,e,d,g,f,k){g={partial:!0,helpers:g,partials:f,data:k};if(void 0===a)throw new b("The partial "+e+" could not be found");if(a instanceof Function)return a(d,g)};k.noop=function(){return""};return k}(h,b,a);return function(a,b,e,f,k){var l=function(){var l=new a.HandlebarsEnvironment;f.extend(l,a);l.SafeString=b;l.Exception=e;l.Utils=f;l.VM=k;l.template=function(a){return k.template(a,l)};return l},h=l();h.create=l;return h}(a,f,b,h,e)}();(function(){function f(a){this.tokens=[];this.tokens.links={};this.options=a||k.defaults;this.rules=f.rules.normal;this.options.gfm&&(this.rules=this.options.tables?f.rules.tables:f.rules.gfm)}function h(a,e){this.options=e||k.defaults;this.links=a;this.rules=t.normal;this.renderer=this.options.renderer||new b;this.renderer.options=this.options;if(!this.links)throw Error("Tokens array requires a `links` property.");this.options.zulip?this.rules=t.zulip:this.options.gfm?this.rules=this.options.breaks?
t.breaks:t.gfm:this.options.pedantic&&(this.rules=t.pedantic)}function b(a){this.options=a||{}}function a(a){this.tokens=[];this.token=null;this.options=a||k.defaults;this.options.renderer=this.options.renderer||new b;this.renderer=this.options.renderer;this.renderer.options=this.options}function e(a,b){return a.replace(!b?/&(?!#?\w+;)/g:/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function d(a){return a.replace(/&([#\w]+);/g,function(a,b){b=
b.toLowerCase();return"colon"===b?":":"#"===b.charAt(0)?"x"===b.charAt(1)?String.fromCharCode(parseInt(b.substring(2),16)):String.fromCharCode(+b.substring(1)):""})}function c(a,b){a=a.source;b=b||"";return function p(e,c){if(!e)return RegExp(a,b);c=c.source||c;c=c.replace(/(^|[^\[])\^/g,"$1");a=a.replace(e,c);return p}}function g(){}function m(a){for(var b=1,e,c;b<arguments.length;b++)for(c in e=arguments[b],e)Object.prototype.hasOwnProperty.call(e,c)&&(a[c]=e[c]);return a}function k(b,c,d){if(d||
"function"===typeof c){d||(d=c,c=null);c=m({},k.defaults,c||{});var g=c.highlight,l,h,t=0;r=0;n=[];for(var A=0;A<c.preprocessors.length;A++)b=c.preprocessors[A](b);try{l=f.lex(b,c)}catch(D){return d(D)}h=l.length;var B=function(){var b,e;try{b=a.parse(l,c)}catch(f){e=f}c.highlight=g;return e?d(e):d(null,b)};if(!g||3>g.length)return B();delete c.highlight;if(!h)return B();for(;t<l.length;t++)(function(a){return"code"!==a.type?--h||B():g(a.text,a.lang,function(b,e){if(null==e||e===a.text)return--h||
B();a.text=e;a.escaped=!0;--h||B()})})(l[t])}else try{c&&(c=m({},k.defaults,c));r=0;n=[];for(t=0;t<k.defaults.preprocessors.length;t++)b=k.defaults.preprocessors[t](b);return a.parse(f.lex(b,c),c)}catch(G){G.message+="\nPlease report this to https://github.com/chjj/marked.";if((c||k.defaults).silent)return"<p>An error occured:</p><pre>"+e(G.message+"",!0)+"</pre>";throw G;}}var l={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:g,hr:/^( *[-*_]){3,} *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,
nptable:g,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,blockquote:/^( *>[^\n]+(\n[^\n]+)*\n*)+/,list:/^( *)(bull) [\s\S]+?(?:hr|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:/^ *(?:comment|closed|closing) *(?:\n{2,}|\s*$)/,def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n+|$)/,table:g,paragraph:/^((?:[^\n]+\n?(?!hr|heading|lheading|blockquote|tag|def))+)\n*/,text:/^[^\n]+/,bullet:/(?:[*+-]|\d+\.)/,item:/^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/};l.item=c(l.item,"gm")(/bull/g,l.bullet)();
l.list=c(l.list)(/bull/g,l.bullet)("hr",/\n+(?=(?: *[-*_]){3,} *(?:\n+|$))/)();l._tag="(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:/|[^\\w\\s@]*@)\\b";l.html=c(l.html)("comment",/\x3c!--[\s\S]*?--\x3e/)("closed",/<(tag)[\s\S]+?<\/\1>/)("closing",/<tag(?:"[^"]*"|'[^']*'|[^'">])*?>/)(/tag/g,l._tag)();l.paragraph=c(l.paragraph)("hr",l.hr)("heading",l.heading)("lheading",l.lheading)("blockquote",l.blockquote)("tag",
"<"+l._tag)("def",l.def)();l.normal=m({},l);l.gfm=m({},l.normal,{fences:/^ *(`{3,}|~{3,}) *(\S+)? *\n([\s\S]+?)\s*\1 *(?:\n+|$)/,paragraph:/^/});l.gfm.paragraph=c(l.paragraph)("(?!","(?!"+l.gfm.fences.source.replace("\\1","\\2")+"|"+l.list.source.replace("\\1","\\3")+"|")();l.tables=m({},l.gfm,{nptable:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,table:/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/});f.rules=l;f.lex=function(a,b){return(new f(b)).lex(a)};f.prototype.lex=
function(a){a=a.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n");return this.token(a,!0)};var r=0,n=[];f.prototype.token=function(a,b){a=a.replace(/^ +$/gm,"");for(var e,c,d,g,f,k,h;a;){if(d=this.rules.newline.exec(a))a=a.substring(d[0].length),1<d[0].length&&this.tokens.push({type:"space"});if(d=this.rules.code.exec(a))a=a.substring(d[0].length),d=d[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:!this.options.pedantic?d.replace(/\n+$/,""):
d});else if(d=this.rules.fences.exec(a))a=a.substring(d[0].length),this.tokens.push({type:"code",lang:d[2],text:d[3]});else if(d=this.rules.heading.exec(a))a=a.substring(d[0].length),this.tokens.push({type:"heading",depth:d[1].length,text:d[2]});else if(b&&(d=this.rules.nptable.exec(a))){a=a.substring(d[0].length);f={type:"table",header:d[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:d[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:d[3].replace(/\n$/,"").split("\n")};for(k=0;k<f.align.length;k++)/^ *-+: *$/.test(f.align[k])?
f.align[k]="right":/^ *:-+: *$/.test(f.align[k])?f.align[k]="center":/^ *:-+ *$/.test(f.align[k])?f.align[k]="left":f.align[k]=null;for(k=0;k<f.cells.length;k++)f.cells[k]=f.cells[k].split(/ *\| */);this.tokens.push(f)}else if(d=this.rules.lheading.exec(a))a=a.substring(d[0].length),this.tokens.push({type:"heading",depth:"="===d[2]?1:2,text:d[1]});else if(d=this.rules.hr.exec(a))a=a.substring(d[0].length),this.tokens.push({type:"hr"});else if(d=this.rules.blockquote.exec(a))a=a.substring(d[0].length),
this.tokens.push({type:"blockquote_start"}),d=d[0].replace(/^ *> ?/gm,""),this.token(d,b),this.tokens.push({type:"blockquote_end"});else if(d=this.rules.list.exec(a)){a=a.substring(d[0].length);g=d[2];this.tokens.push({type:"list_start",ordered:1<g.length});d=d[0].match(this.rules.item);e=!1;h=d.length;for(k=0;k<h;k++)f=d[k],c=f.length,f=f.replace(/^ *([*+-]|\d+\.) +/,""),~f.indexOf("\n ")&&(c-=f.length,f=!this.options.pedantic?f.replace(RegExp("^ {1,"+c+"}","gm"),""):f.replace(/^ {1,4}/gm,"")),this.options.smartLists&&
k!==h-1&&(c=l.bullet.exec(d[k+1])[0],g!==c&&!(1<g.length&&1<c.length)&&(a=d.slice(k+1).join("\n")+a,k=h-1)),c=e||/\n\n(?!\s*$)/.test(f),k!==h-1&&(e="\n"===f.charAt(f.length-1),c||(c=e)),this.tokens.push({type:c?"loose_item_start":"list_item_start"}),this.token(f,!1),this.tokens.push({type:"list_item_end"});this.tokens.push({type:"list_end"})}else if(d=this.rules.html.exec(a))a=a.substring(d[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:"pre"===d[1]||"script"===d[1]||
"style"===d[1],text:d[0]});else if(b&&(d=this.rules.def.exec(a)))a=a.substring(d[0].length),this.tokens.links[d[1].toLowerCase()]={href:d[2],title:d[3]};else if(b&&(d=this.rules.table.exec(a))){a=a.substring(d[0].length);f={type:"table",header:d[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:d[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:d[3].replace(/(?: *\| *)?\n$/,"").split("\n")};for(k=0;k<f.align.length;k++)/^ *-+: *$/.test(f.align[k])?f.align[k]="right":/^ *:-+: *$/.test(f.align[k])?
f.align[k]="center":/^ *:-+ *$/.test(f.align[k])?f.align[k]="left":f.align[k]=null;for(k=0;k<f.cells.length;k++)f.cells[k]=f.cells[k].replace(/^ *\| *| *\| *$/g,"").split(/ *\| */);this.tokens.push(f)}else if(b&&(d=this.rules.paragraph.exec(a)))a=a.substring(d[0].length),this.tokens.push({type:"paragraph",text:"\n"===d[1].charAt(d[1].length-1)?d[1].slice(0,-1):d[1]});else if(d=this.rules.text.exec(a))a=a.substring(d[0].length),this.tokens.push({type:"text",text:d[0]});else if(a)throw Error("Infinite loop on byte: "+
a.charCodeAt(0));}return this.tokens};var t={escape:/^\\([\\`*{}\[\]()#+\-.!_>])/,autolink:/^<([^ >]+(@|:\/)[^ >]+)>/,url:g,tag:/^\x3c!--[\s\S]*?--\x3e|^<\/?\w+(?:"[^"]*"|'[^']*'|[^'">])*?>/,link:/^!?\[(inside)\]\(href\)/,reflink:/^!?\[(inside)\]\s*\[([^\]]*)\]/,nolink:/^!?\[((?:\[[^\]]*\]|[^\[\]])*)\]/,strong:/^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,em:/^\b_((?:__|[\s\S])+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,br:/^ {2,}\n(?!\s*$)/,del:g,emoji:g,usermention:g,
realm_filters:[],text:/^[\s\S]+?(?=[\\<!\[_*`]| {2,}\n|$)/,_inside:/(?:\[[^\]]*\]|[^\[\]]|\](?=[^\[]*\]))*/,_href:/\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/};t.link=c(t.link)("inside",t._inside)("href",t._href)();t.reflink=c(t.reflink)("inside",t._inside)();t.normal=m({},t);t.pedantic=m({},t.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/});t.gfm=m({},t.normal,{escape:c(t.escape)("])","~|])")(),url:/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,
del:/^~~(?=\S)([\s\S]*?\S)~~/,text:c(t.text)("]|","~]|")("|","|https?://|")()});t.breaks=m({},t.gfm,{br:c(t.br)("{2,}","*")(),text:c(t.gfm.text)("{2,}","*")()});t.zulip=m({},t.breaks,{emoji:/^:([A-Za-z0-9_\-\+]+?):/,usermention:/^(@\*\*([^\*]+)?\*\*)/m,realm_filters:[],text:c(t.breaks.text)("]|","@:]|")()});h.rules=t;h.output=function(a,b,e){return(new h(b,e)).output(a)};h.prototype.inlineReplacement=function(a,b,e){var c,d="";a.lastIndex=0;if(c=a.exec(b)){var g=a.lastIndex,f=b.substring(0,g-c[0].length),
f=this.output(f),d=d+f;b=b.substring(g);d+=e(a,c.slice(1),c[0])}return[b,d]};h.prototype.output=function(a){for(var b="",c,d,g;a;)if(g=this.rules.escape.exec(a))a=a.substring(g[0].length),b+=g[1];else{var f=this;this.rules.realm_filters.forEach(function(c){c=f.inlineReplacement(c,a,function(a,b,c){d=f.realm_filter(a,b,c);return void 0!==d?(d=e(d),f.renderer.link(d,d,c)):c});a=c[0];b+=c[1]});if(g=this.rules.autolink.exec(a))a=a.substring(g[0].length),"@"===g[2]?(c=":"===g[1].charAt(6)?this.mangle(g[1].substring(7)):
this.mangle(g[1]),d=this.mangle("mailto:")+c):d=c=e(g[1]),b+=this.renderer.link(d,null,c);else if(g=this.rules.url.exec(a))a=a.substring(g[0].length),d=c=e(g[1]),b+=this.renderer.link(d,null,c);else if(g=this.rules.tag.exec(a))a=a.substring(g[0].length),b+=this.options.sanitize?e(g[0]):g[0];else if(g=this.rules.link.exec(a))a=a.substring(g[0].length),b+=this.outputLink(g,{href:g[2],title:g[3]});else if((g=this.rules.reflink.exec(a))||(g=this.rules.nolink.exec(a)))a=a.substring(g[0].length),c=(g[2]||
g[1]).replace(/\s+/g," "),c=this.links[c.toLowerCase()],!c||!c.href?(b+=g[0].charAt(0),a=g[0].substring(1)+a):b+=this.outputLink(g,c);else if(g=this.rules.usermention.exec(a))a=a.substring(g[0].length),b+=this.usermention(g[2],g[1]);else if(g=this.rules.strong.exec(a))a=a.substring(g[0].length),b+=this.renderer.strong(this.output(g[2]||g[1]));else if(g=this.rules.em.exec(a))a=a.substring(g[0].length),b+=this.renderer.em(this.output(g[2]||g[1]));else if(g=this.rules.code.exec(a))a=a.substring(g[0].length),
b+=this.renderer.codespan(e(g[2],!0));else if(g=this.rules.br.exec(a))a=a.substring(g[0].length),b+=this.renderer.br();else if(g=this.rules.del.exec(a))a=a.substring(g[0].length),b+=this.renderer.del(this.output(g[1]));else if(g=this.rules.emoji.exec(a))a=a.substring(g[0].length),b+=this.emoji(g[1]);else if(g=this.rules.text.exec(a))a=a.substring(g[0].length),b+=e(this.smartypants(g[0]));else if(a)throw Error("Infinite loop on byte: "+a.charCodeAt(0));}return b};h.prototype.outputLink=function(a,
b){var c=e(b.href),d=b.title?e(b.title):null;return"!"!==a[0].charAt(0)?this.renderer.link(c,d,this.output(a[1])):this.renderer.image(c,d,e(a[1]))};h.prototype.emoji=function(a){return"function"!==typeof this.options.emojiHandler?":"+a+":":this.options.emojiHandler(a)};h.prototype.realm_filter=function(a,b,e){if("function"===typeof this.options.realmFilterHandler)return this.options.realmFilterHandler(a,b)};h.prototype.usermention=function(a,b){if("function"!==typeof this.options.userMentionHandler)return b;
var e=this.options.userMentionHandler(a);return void 0!==e?e:b};h.prototype.smartypants=function(a){return!this.options.smartypants?a:a.replace(/--/g,"\u2014").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201c").replace(/"/g,"\u201d").replace(/\.{3}/g,"\u2026")};h.prototype.mangle=function(a){for(var b="",e=a.length,c=0,d;c<e;c++)d=a.charCodeAt(c),0.5<Math.random()&&(d="x"+d.toString(16)),b+="&#"+d+";";return b};b.prototype.code=
function(a,b,c){if(this.options.highlight){var d=this.options.highlight(a,b);null!=d&&d!==a&&(c=!0,a=d)}return!b?"<pre><code>"+(c?a:e(a,!0))+"\n</code></pre>":'<pre><code class="'+this.options.langPrefix+e(b,!0)+'">'+(c?a:e(a,!0))+"\n</code></pre>\n"};b.prototype.blockquote=function(a){return"<blockquote>\n"+a+"</blockquote>\n"};b.prototype.html=function(a){return a};b.prototype.heading=function(a,b,e){return"<h"+b+' id="'+this.options.headerPrefix+e.toLowerCase().replace(/[^\w]+/g,"-")+'">'+a+"</h"+
b+">\n"};b.prototype.hr=function(){return"<hr>\n"};b.prototype.list=function(a,b){var e=b?"ol":"ul";return"<"+e+">\n"+a+"</"+e+">\n"};b.prototype.listitem=function(a){return"<li>"+a+"</li>\n"};b.prototype.paragraph=function(a){return"<p>"+a+"</p>\n"};b.prototype.table=function(a,b){return"<table>\n<thead>\n"+a+"</thead>\n<tbody>\n"+b+"</tbody>\n</table>\n"};b.prototype.tablerow=function(a){return"<tr>\n"+a+"</tr>\n"};b.prototype.tablecell=function(a,b){var e=b.header?"th":"td";return(b.align?"<"+
e+' style="text-align:'+b.align+'">':"<"+e+">")+a+"</"+e+">\n"};b.prototype.strong=function(a){return"<strong>"+a+"</strong>"};b.prototype.em=function(a){return"<em>"+a+"</em>"};b.prototype.codespan=function(a){return"<code>"+a+"</code>"};b.prototype.br=function(){return"<br>"};b.prototype.del=function(a){return"<del>"+a+"</del>"};b.prototype.link=function(a,b,e){if(this.options.sanitize){try{var c=decodeURIComponent(d(a)).replace(/[^\w:]/g,"").toLowerCase()}catch(g){return""}if(0===c.indexOf("javascript:"))return""}a=
'<a href="'+a+'"';b&&(a+=' title="'+b+'"');return a+(">"+e+"</a>")};b.prototype.image=function(a,b,e){a='<img src="'+a+'" alt="'+e+'"';b&&(a+=' title="'+b+'"');return a+">"};a.parse=function(b,e,c){e=new a(e,c);b=e.parse(b);return b=e.postprocess(b)};a.prototype.parse=function(a){this.inline=new h(a.links,this.options,this.renderer);this.tokens=a.reverse();for(a="";this.next();)a+=this.tok();return a};a.prototype.postprocess=function(a){for(var b=0;b<n.length;b++){var c=n[b],d=c[0],g=c[1],g=c[2]?
g+"\n":e(g);a=a.replace("<p>"+d+"</p>",g)}return a};a.prototype.next=function(){return this.token=this.tokens.pop()};a.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0};a.prototype.parseText=function(){for(var a=this.token.text;"text"===this.peek().type;)a+="\n"+this.next().text;return this.inline.output(a)};a.prototype.tok=function(){switch(this.token.type){case "space":return"";case "hr":return this.renderer.hr();case "heading":return this.renderer.heading(this.inline.output(this.token.text),
this.token.depth,this.token.text);case "code":return this.renderer.code(this.token.text,this.token.lang,this.token.escaped);case "table":var a="",b="",e,c,d,g;d="";for(e=0;e<this.token.header.length;e++)d+=this.renderer.tablecell(this.inline.output(this.token.header[e]),{header:!0,align:this.token.align[e]});a+=this.renderer.tablerow(d);for(e=0;e<this.token.cells.length;e++){c=this.token.cells[e];d="";for(g=0;g<c.length;g++)d+=this.renderer.tablecell(this.inline.output(c[g]),{header:!1,align:this.token.align[g]});
b+=this.renderer.tablerow(d)}return this.renderer.table(a,b);case "blockquote_start":for(b="";"blockquote_end"!==this.next().type;)b+=this.tok();return this.renderer.blockquote(b);case "list_start":b="";for(a=this.token.ordered;"list_end"!==this.next().type;)b+=this.tok();return this.renderer.list(b,a);case "list_item_start":for(b="";"list_item_end"!==this.next().type;)b+="text"===this.token.type?this.parseText():this.tok();return this.renderer.listitem(b);case "loose_item_start":for(b="";"list_item_end"!==
this.next().type;)b+=this.tok();return this.renderer.listitem(b);case "html":return b=!this.token.pre&&!this.options.pedantic?this.inline.output(this.token.text):this.token.text,this.renderer.html(b);case "paragraph":return this.renderer.paragraph(this.inline.output(this.token.text));case "text":return this.renderer.paragraph(this.parseText())}};g.exec=g;k.options=k.setOptions=function(a){m(k.defaults,a);return k};k.defaults={gfm:!0,emoji:!1,tables:!0,breaks:!1,pedantic:!1,sanitize:!1,smartLists:!1,
silent:!1,highlight:null,langPrefix:"lang-",smartypants:!1,headerPrefix:"",renderer:new b,preprocessors:[]};k.Parser=a;k.parser=a.parse;k.Renderer=b;k.Lexer=f;k.lexer=f.lex;k.InlineLexer=h;k.inlineLexer=h.output;k.parse=k;k.stashHtml=function(a,b){var e="klzzwxhzsd:"+r;r++;n.push([e,a,b]);return e};"object"===typeof exports?module.exports=k:"function"===typeof define&&define.amd?define(function(){return k}):this.marked=k}).call(function(){return this||("undefined"!==typeof window?window:global)}());(function(){var f=Handlebars.template,h=Handlebars.templates=Handlebars.templates||{};h.email_address_hint=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];this.merge(e,b.helpers);var g;b=this.escapeExpression;return a=""+("\n<div>\n\n<p>You can send emails to "+b((g=(g=a&&a.page_params,null==g||!1===g?g:g.product_name),"function"===typeof g?g.apply(a):g))+'! Just copy and use this address as an email recipient, and:</p>\n\n<img class="subscription-email-hint-image" src="static/images/integrations/zulip_mail.png" />\n\n<ul>\n<li>The email will be forwarded to this stream</li>\n<li>The email subject will become the '+
b((g=(g=a&&a.page_params,null==g||!1===g?g:g.product_name),"function"===typeof g?g.apply(a):g))+" topic</li>\n<li>The email body will become the "+b((g=(g=a&&a.page_params,null==g||!1===g?g:g.product_name),"function"===typeof g?g.apply(a):g))+" message</li>\n</ul>\n\n</div>\n")});h.compose_notification=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b='\n<div class="compose-notifications-content">\n    ';(d=e.note)?d=d.call(a,{hash:{},
data:c}):(d=a&&a.note,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);b+=g(d)+" ";if((d=e["if"].call(a,a&&a.link_class,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){var c,d;c='<a href="#" class="';(d=e.link_class)?d=d.call(a,{hash:{},data:b}):(d=a&&a.link_class,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'" data-msgid="';(d=e.link_msg_id)?d=d.call(a,{hash:{},data:b}):(d=a&&a.link_msg_id,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'">';(d=e.link_text)?
d=d.call(a,{hash:{},data:b}):(d=a&&a.link_text,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);return c+=g(d)+"</a>"},c),data:c}))||0===d)b+=d;return b+'\n    <button type="button" class="out-of-view-notification-close close">\u00d7</button>\n</div>\n'});h.bot_avatar_row=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b='<li class="bot-information-box">\n    <div class="image">\n        <img src="';(g=e.avatar_url)?g=g.call(a,
{hash:{},data:c}):(g=a&&a.avatar_url,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="avatar" />\n    </div>\n    <div class="bot_info">\n        <div class="name">';(g=e.name)?g=g.call(a,{hash:{},data:c}):(g=a&&a.name,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'</div>\n        <div class="email">\n            <span class="field">Username</span>\n            <span class="value">';(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?
g.call(a,{hash:{},data:c}):g);b+=d(g)+'</span>\n        </div>\n        <div class="api_key">\n            <span class="field">API Key</span>\n            <span class="api-key-value-and-button">\n               <span class="value">';(g=e.api_key)?g=g.call(a,{hash:{},data:c}):(g=a&&a.api_key,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'\n               </span>\n               <button type="submit" class="btn btn-secondary regenerate_bot_api_key" title="Generate new API key" data-email="';
(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">\n                   <i class="icon-vector-refresh"></i>\n               </button>\n            </span>\n            <div class="api_key_error text-error"></div>\n        </div>\n        <div class="edit-bot-buttons">\n           <button type="submit" class="btn btn-primary open_edit_bot_form" title="Edit bot" data-email="';(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,
g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">\n            <i class="icon-vector-pencil"></i>\n           </button>\n           <button type="submit" class="btn btn-danger delete_bot" title="Delete bot" data-email="';(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">\n            <i class="icon-vector-trash"></i>\n           </button>\n        </div>\n        <div id="bot_delete_error';(g=e.id_suffix)?g=g.call(a,
{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="alert alert-error hide"></div>\n    </div>\n    <div class=\'edit_bot\'>\n        <form class="edit_bot_form form-horizontal" data-email="';(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">\n            <div class="bot_edit_errors alert alert-error hide"></div>\n            <div class="edit_bot_email">';(g=e.email)?g=g.call(a,
{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'</div>\n            <div class="edit-bot-form-box">\n              <div class="control-group">\n               <label for="edit_bot_name';(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="control-label">Full name</label>\n               <div class="controls">\n                  <input type="text" name="bot_name" id="edit_bot_name';
(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="edit_bot_name required" maxlength=50 />\n                  <div><label for="edit_bot_name';(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" generated="true" class="text-error"></label></div>\n               </div>\n              </div>\n              <div class="control-group new-bot-ui">\n                <label for="edit_bot_default_sending_stream';
(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="control-label">Send to stream</label>\n                <select name="bot_default_sending_stream" class="edit_bot_default_sending_stream" id="edit_bot_default_sending_stream';(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'"></select>\n              </div>\n              <div class="control-group new-bot-ui">\n                <label for="edit_bot_default_events_register_stream';
(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="control-label">Listen on</label>\n                <select name="bot_default_events_register_stream" class="edit_bot_default_events_register_stream" id="edit_bot_default_events_register_stream';(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'"></select>\n              </div>\n              <div class="control-group">\n               <label for="bot_avatar_file_input';
(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="control-label">Avatar</label>\n               <input type="file" id="bot_avatar_file_input';(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" name="bot_avatar_file_input" class="notvisible edit_bot_avatar_file_input" value="Upload avatar" />\n                <div class="controls">\n                  <div class="edit_bot_avatar_file"></div>\n                  <button type="button" class="btn btn-default edit_bot_avatar_upload_button">Choose avatar</button>\n                  <button type="button" class="btn btn-default edit_bot_avatar_clear_button">Clear avatar</button>\n                </div>\n               <div><label for="edit_bot_avatar_file';
(g=e.id_suffix)?g=g.call(a,{hash:{},data:c}):(g=a&&a.id_suffix,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=d(g)+'" generated="true" class="edit_bot_avatar_error text-error"></label></div>\n              </div>\n              <div class="control-group">\n               <div class="controls">\n                  <input type="submit" class="btn btn-primary edit_bot_button" value="Save" />\n                  <button type="submit" class="btn btn-default reset_edit_bot">Cancel</button>\n               </div>\n               <div class="edit_bot_spinner"></div>\n              </div>\n            </div>\n        </form>\n    </div>\n</li>\n'});
h.topic_edit_form=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];this.merge(e,b.helpers);return'\n\n<form id="topic_edit_form" class="form-horizontal">\n\n          <input type="text" value="" class="message_edit_topic" id="message_edit_topic" />\n            <button type="button" class="topic_edit_save primary"><i class="icon-vector-ok"></i></button>\n            <button type="button" class="topic_edit_cancel primary"><i class="icon-vector-remove"></i></button>\n\n    <div class="alert alert-error edit_error hide"></div>\n</form>\n'});
h.tutorial_home=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};d=this.escapeExpression;b='\n\n<div class="tutorial-popover popover-';(e=e.placement)?a=e.call(a,{hash:{},data:c}):(e=a&&a.placement,a="function"===typeof e?e.call(a,{hash:{},data:c}):e);return b+=d(a)+'" id="tutorial-home">\n\n    <p>You can <b>narrow</b> to a stream or topic by <b>clicking on it</b>, or\n       see messages from all streams at once from your Home view.</p>\n\n    <div class="tutorial-done-button">\n      <button class="btn btn-primary" type="submit" id="tutorial-home-next">Next</button>\n    </div>\n</div>\n'});
h.bankruptcy_modal=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};d=this.escapeExpression;b='\n\n<div class="modal-body">\n  <p>It\'s been a while! Since you were last here, you received <b>';(e=e.unread_count)?a=e.call(a,{hash:{},data:c}):(e=a&&a.unread_count,a="function"===typeof e?e.call(a,{hash:{},data:c}):e);return b+=d(a)+"</b> new messages.</p>\n  <p>Do you want to skip to your latest messages?</p>\n</div>\n"});h.announce_stream_docs=f(function(b,a,
e,d,c){this.compilerInfo=[4,">= 1.0.0"];this.merge(e,b.helpers);return"\n<div>\n\n  <p>Lets everyone know about the new stream,<br />\n  even if you don't add them.</p>\n\n</div>\n"});h.stream_member_list_entry=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b='<tr>\n    <td class="subscriber-name">';(g=e.name)?g=g.call(a,{hash:{},data:c}):(g=a&&a.name,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'</td>\n    <td class="subscriber-email">';
(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+"</td>\n    ";if((g=e["if"].call(a,a&&a.displaying_for_admin,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){return'\n    <td class="unsubscribe">\n        <div class="subscriber_list_remove">\n            <form class="form-inline remove-subscriber-form">\n                    <input type="submit" name="unsubscribe" value="Unsubscribe"\n                           class="btn btn-danger remove-subscriber-button" />\n            </form>\n        </div>\n    </td>\n    '},
c),data:c}))||0===g)b+=g;return b+"\n</tr>\n"});h.propagate_notification_change=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];this.merge(e,b.helpers);return'<div>\n    <p>Apply this change to all stream subscriptions?</p>\n\n    <div class="control-group">\n        <div class="controls propagate-notifications-controls">\n            <button type="button"\n                    class="yes_propagate_notifications btn btn-primary btn-small">Yes</button>\n            <button type="button"\n                    class="no_propagate_notifications btn btn-default btn-small">No</button>\n        </div>\n    </div>\n</div>'});
h.stream_sidebar_row=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g,f,k=this.escapeExpression,l=e.helperMissing;b='\n\n<li data-name="';(g=e.name)?d=g.call(a,{hash:{},data:c}):(g=a&&a.name,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'" class="narrow-filter';if((d=e["if"].call(a,a&&a.not_in_home_view,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){return" out_of_home_view"},c),data:c}))||0===d)b+=d;b+='"\n    id="stream_sidebar_';
(g=e.id)?d=g.call(a,{hash:{},data:c}):(g=a&&a.id,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'">\n\n    \n\n    <div class="subscription_block selectable_sidebar_block" data-name="';(g=e.name)?d=g.call(a,{hash:{},data:c}):(g=a&&a.name,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'">\n\n      <div id="stream_sidebar_swatch_';(g=e.id)?d=g.call(a,{hash:{},data:c}):(g=a&&a.id,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'" class="streamlist_swatch';
if((d=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:this.noop,fn:this.program(3,function(a,b){return" private-stream-swatch"},c),data:c}))||0===d)b+=d;b+='"\n       style="background-color: ';(g=e.color)?d=g.call(a,{hash:{},data:c}):(g=a&&a.color,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'">&nbsp;</div>\n\n      <a href="';(g=e.uri)?d=g.call(a,{hash:{},data:c}):(g=a&&a.uri,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'" class="subscription_name">';(g=e.name)?
d=g.call(a,{hash:{},data:c}):(g=a&&a.name,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'\n      </a>\n\n      <div class="count"><div class="value"></div></div>\n\n      <span id="stream_sidebar_privacy_swatch_';(g=e.id)?d=g.call(a,{hash:{},data:c}):(g=a&&a.id,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=k(d)+'" class="stream-privacy" style="color: ';(g=e.color)?d=g.call(a,{hash:{},data:c}):(g=a&&a.color,d="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=
k(d)+'">\n        '+k((g=e.partial||a&&a.partial,f={hash:{},data:c},g?g.call(a,"stream_privacy",f):l.call(a,"partial","stream_privacy",f)))+'\n      </span>\n\n    </div>\n    <span class="arrow stream-sidebar-arrow"><i class="icon-vector-chevron-down"></i></span>\n\n</li>\n'});h.message_info_popover_content=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b=""+('\n<ul class="nav nav-list actions_popover sender_info_popover" data-email="'+
d((g=(g=a&&a.message,null==g||!1===g?g:g.sender_email),"function"===typeof g?g.apply(a):g))+'">\n  <div class="popover_info">\n    <li>Sent by <b>'+d((g=(g=a&&a.message,null==g||!1===g?g:g.sender_full_name),"function"===typeof g?g.apply(a):g))+"</b></li>\n    <li class='my_email'>"+d((g=(g=a&&a.message,null==g||!1===g?g:g.sender_email),"function"===typeof g?g.apply(a):g))+"</li>\n    <hr />\n\n    <li>"+d((g=(g=a&&a.message,null==g||!1===g?g:g.full_date_str),"function"===typeof g?g.apply(a):g))+"</li>\n    <li>"+
d((g=(g=a&&a.message,null==g||!1===g?g:g.full_time_str),"function"===typeof g?g.apply(a):g))+"</li>\n    ");if((g=e["if"].call(a,(g=a&&a.message,null==g||!1===g?g:g.historical),{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){return'\n    <li class="small">(Message sent when you were not subscribed)</li>\n    '},c),data:c}))||0===g)b+=g;b+='\n  </div>\n  <hr />\n  <li>\n    <a href="#" class="respond_personal_button">\n      <i class="icon-vector-edit"></i> Send '+d((g=(g=a&&a.message,null==
g||!1===g?g:g.sender_full_name),"function"===typeof g?g.apply(a):g))+' a private message\n    </a>\n  </li>\n  <li>\n    <a href="';(g=e.pm_with_uri)?g=g.call(a,{hash:{},data:c}):(g=a&&a.pm_with_uri,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" class="narrow_to_private_messages">\n      <i class="icon-vector-user"></i> Narrow to private messages with '+d((g=(g=a&&a.message,null==g||!1===g?g:g.sender_full_name),"function"===typeof g?g.apply(a):g))+'\n    </a>\n  </li>\n  <li>\n    <a href="';
(g=e.sent_by_uri)?g=g.call(a,{hash:{},data:c}):(g=a&&a.sent_by_uri,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=d(g)+'" class="narrow_to_messages_sent">\n      <i class="icon-vector-bullhorn"></i> Narrow to messages sent by '+d((g=(g=a&&a.message,null==g||!1===g?g:g.sender_full_name),"function"===typeof g?g.apply(a):g))+"\n    </a>\n  </li>\n</ul>\n"});h.recipient_row=f(function(b,a,e,d,c){function g(a,b){return'\n             <i class="icon-vector-lock invite-stream-icon" title="This is an invite-only stream"></i>\n           '}
function f(a,b){var c,d;c="\n              ";(d=e.match_subject)?d=d.call(a,{hash:{},data:b}):(d=a&&a.match_subject,d=typeof d===s?d.call(a,{hash:{},data:b}):d);if(d||0===d)c+=d;return c+"\n            "}function k(a,b){var c,d;c="\n              ";(d=e.subject)?d=d.call(a,{hash:{},data:b}):(d=a&&a.subject,d=typeof d===s?d.call(a,{hash:{},data:b}):d);return c+=q(d)+"\n            "}function l(a,b){return'\n            <i class="icon-vector-pencil always_visible_topic_edit"></i>\n          '}function h(a,
b){var c,d;c="\n            ";if((d=e["if"].call(a,a&&a.on_hover_topic_edit,{hash:{},inverse:v.noop,fn:v.program(11,n,b),data:b}))||0===d)c+=d;return c+"\n          "}function n(a,b){return'\n            <i class="icon-vector-pencil on_hover_topic_edit"></i>\n            '}function t(a,b){var e;return e=""+('\n          <a href="'+q(typeof a===s?a.apply(a):a)+'" target="_blank">\n            <i class="icon-vector-external-link-sign"></i>\n          </a>\n          ')}this.compilerInfo=[4,">= 1.0.0"];
e=this.merge(e,b.helpers);c=c||{};b="";var s="function",q=this.escapeExpression,v=this;if((a=e["if"].call(a,a&&a.is_stream,{hash:{},inverse:v.program(15,function(a,b){var c,d;c='\n  <div class="message_header message_header_private_message dark_background">\n    <div class="message-header-wrapper">\n      <div class="message-header-contents">\n        <a class="message_label_clickable narrows_by_recipient"\n           href="';(d=e.pm_with_url)?d=d.call(a,{hash:{},data:b}):(d=a&&a.pm_with_url,d=typeof d===
s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'"\n           title="Narrow to your private messages with ';(d=e.display_reply_to)?d=d.call(a,{hash:{},data:b}):(d=a&&a.display_reply_to,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'">\n        You and ';(d=e.display_reply_to)?d=d.call(a,{hash:{},data:b}):(d=a&&a.display_reply_to,d=typeof d===s?d.call(a,{hash:{},data:b}):d);return c+=q(d)+"\n        </a>\n      </div>\n    </div>\n  </div>\n"},c),fn:v.program(1,function(a,b){var c,d;c='\n  <div class="message_header message_header_stream right_part">\n    <div class="message-header-wrapper">\n      <div class="message-header-contents">\n        \n        <a class="message_label_clickable narrows_by_recipient stream_label ';
(d=e.color_class)?d=d.call(a,{hash:{},data:b}):(d=a&&a.color_class,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'"\n           style="background: ';(d=e.background_color)?d=d.call(a,{hash:{},data:b}):(d=a&&a.background_color,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+"; border-left-color: ";(d=e.background_color)?d=d.call(a,{hash:{},data:b}):(d=a&&a.background_color,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+';"\n           href="';(d=e.stream_url)?d=d.call(a,{hash:{},
data:b}):(d=a&&a.stream_url,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'"\n           title="Narrow to stream &quot;';(d=e.display_recipient)?d=d.call(a,{hash:{},data:b}):(d=a&&a.display_recipient,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'&quot;">\n           \n           ';if((d=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:v.noop,fn:v.program(2,g,b),data:b}))||0===d)c+=d;c+="\n             ";(d=e.display_recipient)?d=d.call(a,{hash:{},data:b}):(d=a&&a.display_recipient,
d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'\n        </a>\n\n        \n        <span class="copy-paste-text">&gt;</span>\n\n        \n        <span class="stream_topic">\n          \n          <a class="message_label_clickable narrows_by_subject"\n             href="';(d=e.topic_url)?d=d.call(a,{hash:{},data:b}):(d=a&&a.topic_url,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'"\n             title="Narrow to stream &quot;';(d=e.display_recipient)?d=d.call(a,{hash:{},data:b}):(d=
a&&a.display_recipient,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+"&quot;, topic &quot;";(d=e.subject)?d=d.call(a,{hash:{},data:b}):(d=a&&a.subject,d=typeof d===s?d.call(a,{hash:{},data:b}):d);c+=q(d)+'&quot;">\n            ';if((d=e["if"].call(a,a&&a.use_match_properties,{hash:{},inverse:v.program(6,k,b),fn:v.program(4,f,b),data:b}))||0===d)c+=d;c+="\n          </a>\n\n          \n          ";if((d=e["if"].call(a,a&&a.always_visible_topic_edit,{hash:{},inverse:v.program(10,h,b),fn:v.program(8,
l,b),data:b}))||0===d)c+=d;c+="\n\n          \n          ";if((d=e.each.call(a,a&&a.subject_links,{hash:{},inverse:v.noop,fn:v.program(13,t,b),data:b}))||0===d)c+=d;c+='\n        </span>\n\n        <span class="topic_edit">\n          <span class="topic_edit_form" id="';(d=e.id)?d=d.call(a,{hash:{},data:b}):(d=a&&a.id,d=typeof d===s?d.call(a,{hash:{},data:b}):d);return c+=q(d)+'"></span>\n        </span>\n      </div>\n    </div>\n  </div>\n'},c),data:c}))||0===a)b+=a;return b+"\n"});h.admin_tab=
f(function(b,a,e,d,c){function g(a,b){return'checked="checked"'}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var f;d=this.escapeExpression;b='<div class="row-fluid">\n  <div class="span12">\n    <div class="administration">\n      <div class="alert" id="administration-status"></div>\n      <h1>Administration</h1>\n\n      <form class="form-horizontal admin-realm">\n        <div class="control-group admin-realm">\n          <div class="alert" id="admin-realm-name-status"></div>\n\t  <div class="alert" id="admin-realm-restricted-to-domain-status"></div>\n\t  <div class="alert" id="admin-realm-invite-required-status"></div>\n\t  <div class="alert" id="admin-realm-invite-by-admins-only-status"></div>\n          <label for="realm_name" class="control-label">Your organization\'s name</label>\n          <div class="controls">\n            <input type="text" id="id_realm_name" name="realm_name" class="admin-realm-name"\n                   value="';
(f=e.realm_name)?f=f.call(a,{hash:{},data:c}):(f=a&&a.realm_name,f="function"===typeof f?f.call(a,{hash:{},data:c}):f);b+=d(f)+'" />\n          </div>\n        </div>\n        <div class="control-group">\n          <label for="realm_restricted_to_domain" title="If checked, only users with an @';(f=e.domain)?f=f.call(a,{hash:{},data:c}):(f=a&&a.domain,f="function"===typeof f?f.call(a,{hash:{},data:c}):f);b+=d(f)+' e-mail address will be able to join the organization." class="control-label">Users restricted to ';
(f=e.domain)?f=f.call(a,{hash:{},data:c}):(f=a&&a.domain,f="function"===typeof f?f.call(a,{hash:{},data:c}):f);b+=d(f)+'</label>\n          <div class="controls">\n\t    <input type="checkbox" id="id_realm_restricted_to_domain" name="realm_restricted_to_domain" ';if((f=e["if"].call(a,a&&a.realm_restricted_to_domain,{hash:{},inverse:this.noop,fn:this.program(1,g,c),data:c}))||0===f)b+=f;b+=' />\n          </div>\n        </div>\n        <div class="control-group">\n          <label for="realm_invite_required" title="If checked, users must be invited in order to join your organization." class="control-label">E-mail invitation required</label>\n          <div class="controls">\n\t    <input type="checkbox" id="id_realm_invite_required" name="realm_invite_required" ';
if((f=e["if"].call(a,a&&a.realm_invite_required,{hash:{},inverse:this.noop,fn:this.program(1,g,c),data:c}))||0===f)b+=f;b+=' />\n          </div>\n        </div>\n        <div class="control-group">\n          <label for="realm_invite_by_admins_only" id="id_realm_invite_by_admins_only_label" title="If checked, only administrators may invite new users." class="control-label';if((f=e.unless.call(a,a&&a.realm_invite_required,{hash:{},inverse:this.noop,fn:this.program(3,function(a,b){return" control-label-disabled"},
c),data:c}))||0===f)b+=f;b+='">Only admins may invite</label>\n          <div class="controls">\n\t    <input type="checkbox" id="id_realm_invite_by_admins_only" name="realm_invite_by_admins_only" ';if((f=e.unless.call(a,a&&a.realm_invite_required,{hash:{},inverse:this.noop,fn:this.program(5,function(a,b){return'disabled="disabled"'},c),data:c}))||0===f)b+=f;b+=" ";if((f=e["if"].call(a,a&&a.realm_invite_by_admins_only,{hash:{},inverse:this.noop,fn:this.program(1,g,c),data:c}))||0===f)b+=f;return b+
' />\n          </div>\n        </div>\n        <input type="submit" class="btn btn-default" value="Save" />\n      </form>\n\n      <h2>Users</h2>\n      <table class="table table-condensed table-striped">\n        <tbody id="admin_users_table" class="admin_user_table">\n          <th>Name</th>\n          <th>Email</th>\n          <th>Actions</th>\n        </tbody>\n      </table>\n      <div id="admin_page_users_loading_indicator"></div>\n      <h2>Bots</h2>\n      <table class="table table-condensed table-striped">\n        <tbody id="admin_bots_table" class="admin_bot_table">\n          <th>Name</th>\n          <th>Email</th>\n          <th>Owner</th>\n          <th>Actions</th>\n        </tbody>\n      </table>\n      <div id="admin_page_bots_loading_indicator"></div>\n      <h2>Streams</h2>\n      <table class="table table-condensed table-striped">\n        <tbody id="admin_streams_table" class="admin_stream_table">\n          <th>Name</th>\n          <th>Actions</th>\n        </tbody>\n      </table>\n      <div id="admin_page_streams_loading_indicator"></div>\n      <h2>Deactivated Users</h2>\n      <table class="table table-condensed table-striped">\n        <tbody id="admin_deactivated_users_table" class="admin_user_table">\n          <th>Name</th>\n          <th>Email</th>\n          <th>Actions</th>\n        </tbody>\n      </table>\n      <div id="admin_page_deactivated_users_loading_indicator"></div>\n      <div id="deactivation_user_modal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="deactivation_user_modal_label" aria-hidden="true">\n        <div class="modal-header">\n          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">\u00d7</button>\n          <h3 id="deactivation_user_modal_label">Deactivate <span class="email"></span></h3>\n        </div>\n        <div class="modal-body">\n          <p>By deactivating <strong><span class="user_name"></span></strong> &lt;<span class="email"></span>&gt;, they will be logged out immediately.</p>\n          <p>Their password will be cleared from our systems, and any bots they maintain will be disabled.</p>\n        </div>\n        <div class="modal-footer">\n          <button class="btn btn-default" data-dismiss="modal" aria-hidden="true">Cancel</button>\n          <button class="btn btn-danger" id="do_deactivate_user_button">Deactivate now</button>\n        </div>\n      </div>\n      <div id="deactivation_stream_modal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="deactivation_stream_modal_label" aria-hidden="true">\n        <div class="modal-header">\n          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">\u00d7</button>\n          <h3 id="deactivation_stream_modal_label">Delete stream <span class="stream_name"></span></h3>\n        </div>\n        <div class="modal-body">\n          <p>Deleting this stream will immediately unsubscribe everyone, and the stream\'s content will not be recoverable. <strong>Are you sure you want to do this?</strong></p>\n        </div>\n        <div class="modal-footer">\n          <button class="btn btn-default" data-dismiss="modal" aria-hidden="true">Cancel</button>\n          <button class="btn btn-danger" id="do_deactivate_stream_button">Yes, delete this stream</button>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n'});
h.sidebar_subject_list=f(function(b,a,e,d,c){function g(a,b){return"zero-subject-unreads"}function f(a,b){return"muted_topic"}function k(a,b){return" zoom-out-hide"}function l(a,b){return"zero_count"}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var h=this,n=this.escapeExpression;b="<ul class='expanded_subjects' data-stream='";(d=e.stream)?d=d.call(a,{hash:{},data:c}):(d=a&&a.stream,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);b+=n(d)+"'>\n    ";if((d=e.each.call(a,a&&
a.subjects,{hash:{},inverse:h.noop,fn:h.program(1,function(a,b){var c,d;c="\n    <li class='";if((d=e["if"].call(a,a&&a.is_zero,{hash:{},inverse:h.noop,fn:h.program(2,g,b),data:b}))||0===d)c+=d;c+=" ";if((d=e["if"].call(a,a&&a.is_muted,{hash:{},inverse:h.noop,fn:h.program(4,f,b),data:b}))||0===d)c+=d;c+=" ";if((d=e["if"].call(a,a&&a.zoom_out_hide,{hash:{},inverse:h.noop,fn:h.program(6,k,b),data:b}))||0===d)c+=d;c+=" expanded_subject' data-name='";(d=e.topic_name)?d=d.call(a,{hash:{},data:b}):(d=a&&
a.topic_name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=n(d)+"'>\n      <span class='subject_box'>\n        <a href='";(d=e.url)?d=d.call(a,{hash:{},data:b}):(d=a&&a.url,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=n(d)+'\' class="subject-name">\n          ';(d=e.topic_name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.topic_name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=n(d)+'\n        </a>\n        <div class="subject_count ';if((d=e["if"].call(a,a&&a.is_zero,{hash:{},
inverse:h.noop,fn:h.program(8,l,b),data:b}))||0===d)c+=d;c+='">\n            <div class="value">';(d=e.unread)?d=d.call(a,{hash:{},data:b}):(d=a&&a.unread,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);return c+=n(d)+'</div>\n        </div>\n      </span>\n      <span class="arrow topic-sidebar-arrow">\n        <i class="icon-vector-chevron-down"></i>\n      </span>\n    </li>\n    '},c),data:c}))||0===d)b+=d;b+="\n    ";if((d=e["if"].call(a,a&&a.want_show_more_topics_links,{hash:{},inverse:h.noop,
fn:h.program(10,function(a,b){var d,c;d='\n    <li class="show-more-topics" data-stream="';(c=e.stream)?c=c.call(a,{hash:{},data:b}):(c=a&&a.stream,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=n(c)+'">\n      <a href="#">(more topics)</a>\n    </li>\n    '},c),data:c}))||0===d)b+=d;return b+"\n</ul>\n"});h.actions_popover_content=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b='\n<ul class="nav nav-list actions_popover pull-right">\n  ';
if((d=e["if"].call(a,a&&a.can_edit_message,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){var e,d;return e=""+('\n  <li>\n    <a href="#" class="popover_edit_message" data-msgid="'+g((d=(d=a&&a.message,null==d||!1===d?d:d.id),"function"===typeof d?d.apply(a):d))+'">\n      <i class="icon-vector-pencil"></i> Edit\n    </a>\n  </li>\n  ')},c),data:c}))||0===d)b+=d;b+='\n\n  <li>\n    <a href="#" class="respond_button">\n      <i class="icon-vector-share-alt"></i> Reply\n    </a>\n  </li>\n\n  <li>\n    <a href="#" class="popover_toggle_collapse" data-msgid="'+
g((d=(d=a&&a.message,null==d||!1===d?d:d.id),"function"===typeof d?d.apply(a):d))+'">\n      <i class="';if((d=e["if"].call(a,(d=a&&a.message,null==d||!1===d?d:d.collapsed),{hash:{},inverse:this.program(5,function(a,b){return"icon-vector-minus"},c),fn:this.program(3,function(a,b){return"icon-vector-plus"},c),data:c}))||0===d)b+=d;b+='"></i>\n        ';if((d=e["if"].call(a,(d=a&&a.message,null==d||!1===d?d:d.collapsed),{hash:{},inverse:this.program(9,function(a,b){return"Collapse"},c),fn:this.program(7,
function(a,b){return"Un-collapse"},c),data:c}))||0===d)b+=d;b+="\n    </a>\n  </li>\n\n  ";if((d=e["if"].call(a,a&&a.can_mute_topic,{hash:{},inverse:this.noop,fn:this.program(11,function(a,b){var e,d;return e=""+('\n  <li>\n    <a href="#" class="popover_mute_topic" data-msg-stream="'+g((d=(d=a&&a.message,null==d||!1===d?d:d.stream),"function"===typeof d?d.apply(a):d))+'" data-msg-topic="'+g((d=(d=a&&a.message,null==d||!1===d?d:d.subject),"function"===typeof d?d.apply(a):d))+'">\n      <i class="icon-vector-eye-close"></i>\n      Mute the topic <b>'+
g((d=(d=a&&a.message,null==d||!1===d?d:d.subject),"function"===typeof d?d.apply(a):d))+"</b>\n    </a>\n  </li>\n  ")},c),data:c}))||0===d)b+=d;b+="\n\n  ";if((d=e["if"].call(a,a&&a.can_unmute_topic,{hash:{},inverse:this.noop,fn:this.program(13,function(a,b){var e,d;return e=""+('\n  <li>\n    <a href="#" class="popover_unmute_topic" data-msg-stream="'+g((d=(d=a&&a.message,null==d||!1===d?d:d.stream),"function"===typeof d?d.apply(a):d))+'" data-msg-topic="'+g((d=(d=a&&a.message,null==d||!1===d?d:
d.subject),"function"===typeof d?d.apply(a):d))+'">\n      <i class="icon-vector-eye-open"></i>\n      Unmute the topic <b>'+g((d=(d=a&&a.message,null==d||!1===d?d:d.subject),"function"===typeof d?d.apply(a):d))+"</b>\n    </a>\n  </li>\n  ")},c),data:c}))||0===d)b+=d;b+='\n\n  <li>\n    <a href="';(e=e.conversation_time_uri)?d=e.call(a,{hash:{},data:c}):(e=a&&a.conversation_time_uri,d="function"===typeof e?e.call(a,{hash:{},data:c}):e);return b+=g(d)+'" class="popover_narrow_by_conversation_and_time" data-msgid="'+
g((d=(d=a&&a.message,null==d||!1===d?d:d.id),"function"===typeof d?d.apply(a):d))+'">\n      <i class="icon-vector-link"></i> Link to this conversation\n    </a>\n  </li>\n\n</ul>\n'});h.change_stream_privacy=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="";var g=this.escapeExpression;if((d=e["if"].call(a,a&&a.can_make_public,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){var d,c;d='\n  <button class="btn btn-primary make-stream-public-button" data-stream-name="';
(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=g(c)+'" tabindex="-1">\n    Make stream public\n  </button>\n'},c),data:c}))||0===d)b+=d;b+="\n";if((d=e["if"].call(a,a&&a.can_make_private,{hash:{},inverse:this.noop,fn:this.program(3,function(a,b){var d,c;d='\n  <button class="btn btn-danger make-stream-private-button" data-stream-name="';(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c="function"===typeof c?c.call(a,{hash:{},
data:b}):c);return d+=g(c)+'" tabindex="-1">\n    Make stream private\n  </button>\n'},c),data:c}))||0===d)b+=d;return b+'\n<div class="change-stream-privacy-feedback"></div>\n'});h.subscription_table_body=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="";var g=e.helperMissing,f=this.escapeExpression;if((d=e["if"].call(a,a&&a.can_create_streams,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){return'\n  <div id="create_stream_row">\n      <div class="subscription_table_elem">\n        <form id="add_new_subscription" class="form-inline" action="">\n          <input type="text" name="stream_name" id="create_stream_name"\n                 placeholder="Stream name" value="" />\n          <input type="submit" class="btn btn-primary"\n                 id="create_stream_button" value="Create new stream" />\n        </form>\n      </div>\n  </div>\n'},
c),data:c}))||0===d)b+=d;b+="\n\n";if((d=e.each.call(a,a&&a.subscriptions,{hash:{},inverse:this.noop,fn:this.program(3,function(a,b){var d,c,h;return d=""+("\n"+f((c=e.partial||a&&a.partial,h={hash:{},data:b},c?c.call(a,"subscription",h):g.call(a,"partial","subscription",h)))+"\n")},c),data:c}))||0===d)b+=d;return b+"\n"});h.new_stream_users=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b='\n<a href="#" class="subs_set_all_users">Check all</a> |\n<a href="#" class="subs_unset_all_users">Uncheck all</a>\n<div id="user-checkboxes">\n  ';
if((a=e.each.call(a,a&&a.users,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){var e,d;return e=""+('\n  <label class="checkbox">\n    <input type="checkbox" name="user" value="'+g((d=a&&a.email,"function"===typeof d?d.apply(a):d))+'" /> '+g((d=a&&a.full_name,"function"===typeof d?d.apply(a):d))+" ("+g((d=a&&a.email,"function"===typeof d?d.apply(a):d))+")\n  </label><br />\n  ")},c),data:c}))||0===a)b+=a;return b+"\n</div>\n\n"});h.user_presence_rows=f(function(b,a,e,d,c){function g(a,
b){return"user-with-count "}function f(a,b){return""}function k(a,b){return" my_fullname"}function l(a,b){var d;(d=e.num_unread)?d=d.call(a,{hash:{},data:b}):(d=a&&a.num_unread,d=typeof d===h?d.call(a,{hash:{},data:b}):d);return n(d)}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var h="function",n=this.escapeExpression,t=this;b="\n";if((a=e.each.call(a,a&&a.users,{hash:{},inverse:t.noop,fn:t.program(1,function(a,b){var d,c;d='\n<li data-email="';(c=e.email)?c=c.call(a,{hash:{},
data:b}):(c=a&&a.email,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+'" class="user_sidebar_entry ';if((c=e["if"].call(a,a&&a.num_unread,{hash:{},inverse:t.noop,fn:t.program(2,g,b),data:b}))||0===c)d+=c;d+="narrow-filter user_";(c=e.type)?c=c.call(a,{hash:{},data:b}):(c=a&&a.type,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+'">\n  <span class="selectable_sidebar_block';if((c=e["if"].call(a,a&&a.mobile,{hash:{},inverse:t.noop,fn:t.program(4,f,b),data:b}))||0===c)d+=c;d+='">\n    <span class="user-status-indicator"></span>\n    <span class="user-device-indicator">';
if((c=e["if"].call(a,a&&a.mobile,{hash:{},inverse:t.noop,fn:t.program(4,f,b),data:b}))||0===c)d+=c;d+='</span>\n      <a href="#" data-email="';(c=e.email)?c=c.call(a,{hash:{},data:b}):(c=a&&a.email,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+'" data-name="';(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+'" title="';(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+" ";(c=e.type_desc)?
c=c.call(a,{hash:{},data:b}):(c=a&&a.type_desc,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+'"\n         class="';if((c=e["if"].call(a,a&&a.my_fullname,{hash:{},inverse:t.noop,fn:t.program(6,k,b),data:b}))||0===c)d+=c;d+='">';(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c=typeof c===h?c.call(a,{hash:{},data:b}):c);d+=n(c)+'</a>\n  </span>\n  <span class="count"><span class="value">';if((c=e["if"].call(a,a&&a.num_unread,{hash:{},inverse:t.noop,fn:t.program(8,l,b),data:b}))||0===c)d+=
c;return d+'</span></span>\n  <span class="arrow"><i class="icon-vector-chevron-down"></i></span>\n</li>\n'},c),data:c}))||0===a)b+=a;return b+"\n"});h.invite_subscription=f(function(b,a,e,d,c){function g(a,b){return'checked="true"'}function f(a,b){return'<i class="icon-vector-lock"></i>'}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var k=this.escapeExpression,h=this;b='\n<a href="#" class="invite_check_all_button">Check all</a> |\n<a href="#" class="invite_uncheck_all_button">Uncheck all</a>\n<div id="stream-checkboxes">\n  ';
if((a=e.each.call(a,a&&a.streams,{hash:{},inverse:h.noop,fn:h.program(1,function(a,b){var d,c;d='\n  <label class="checkbox">\n    <input type="checkbox" name="stream" value="';(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);d+=k(c)+'"\n           ';if((c=e.unless.call(a,a&&a.invite_only,{hash:{},inverse:h.noop,fn:h.program(2,g,b),data:b}))||0===c)d+=c;d+=" /> ";(c=e.name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c="function"===typeof c?
c.call(a,{hash:{},data:b}):c);d+=k(c)+"\n    ";if((c=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:h.noop,fn:h.program(4,f,b),data:b}))||0===c)d+=c;return d+"\n  </label>\n  "},c),data:c}))||0===a)b+=a;return b+"\n</div>\n\n"});h.message_edit_form=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b='\n\n<form id="message_edit_form" class="form-horizontal">\n';if((d=e["if"].call(a,a&&a.is_stream,{hash:{},inverse:this.noop,fn:this.program(1,
function(a,b){var d,c;d='\n    <div class="control-group">\n        <label class="control-label edit-control-label" for="message_edit_topic">Topic</label>\n        <div class="controls edit-controls">\n          <input type="text" value="';(c=e.topic)?c=c.call(a,{hash:{},data:b}):(c=a&&a.topic,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=g(c)+'" class="message_edit_topic" id="message_edit_topic" />\n          <select class=\'message_edit_topic_propagate\' style=\'display:none;\'>\n            <option selected="selected" value="change_one"> Change only this message topic</option>\n            <option value="change_later"> Change later messages to this topic</option>\n            <option value="change_all"> Change previous and following messages to this topic</option>\n          </select>\n        </div>\n    </div>\n'},
c),data:c}))||0===d)b+=d;b+='\n    <div class="control-group">\n        <div class="controls edit-controls">\n            <textarea class="message_edit_content" id="message_edit_content">';(d=e.content)?d=d.call(a,{hash:{},data:c}):(d=a&&a.content,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);return b+=g(d)+'</textarea>\n        </div>\n    </div>\n    <div class="control-group">\n        <div class="controls edit-controls">\n            <button type="button" class="message_edit_save btn btn-primary btn-small">Save</button>\n            <button type="button" class="message_edit_cancel btn btn-default btn-small">Cancel</button>\n        </div>\n    </div>\n    <div class="alert alert-error edit_error hide"></div>\n</form>\n'});
h.subscription_setting_icon=f(function(b,a,e,d,c){function g(a,b){return"in"}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="";var f=this.escapeExpression,k=this,h=e.blockHelperMissing;if((a=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:k.program(3,function(a,b){var d,c,q;d='\n <span class="color_swatch fade ';q={hash:{},inverse:k.noop,fn:k.program(4,g,b),data:b};(c=e.subscribed)?c=c.call(a,q):(c=a&&a.subscribed,c="function"===typeof c?c.call(a,q):c);e.subscribed||(c=h.call(a,
c,{hash:{},inverse:k.noop,fn:k.program(4,g,b),data:b}));if(c||0===c)d+=c;d+='" style="background-color: ';(c=e.color)?c=c.call(a,{hash:{},data:b}):(c=a&&a.color,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=f(c)+'"></span>\n'},c),fn:k.program(1,function(a,b){var d,c;d='\n   <span class="subscription_lock"><i class="icon-vector-lock" style="color: ';(c=e.color)?c=c.call(a,{hash:{},data:b}):(c=a&&a.color,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=f(c)+'"></i></span>\n'},
c),data:c}))||0===a)b+=a;return b+"\n"});h.tutorial_stream=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};d=this.escapeExpression;b='\n\n<div class="tutorial-popover popover-';(e=e.placement)?a=e.call(a,{hash:{},data:c}):(e=a&&a.placement,a="function"===typeof e?e.call(a,{hash:{},data:c}):e);return b+=d(a)+'" id="tutorial-stream">\n    <p>\n        <b>Streams</b> are like chat rooms or mailing lists. You can easily\n        <b>join</b>, <b>leave</b>, and <b>make</b> them.\n    </p>\n\n    <div class="tutorial-done-button">\n      <button class="btn btn-primary" type="submit" id="tutorial-stream-next">Next</button>\n    </div>\n</div>\n'});
h.tab_bar=f(function(b,a,e,d,c){function g(a,b){var d,c;d='data-name="';(c=e.data)?c=c.call(a,{hash:{},data:b}):(c=a&&a.data,c=typeof c===q?c.call(a,{hash:{},data:b}):c);return d+=v(c)+'"'}function f(a,b){return'\n      <i class="icon-vector-narrow icon-vector-small"></i>\n    '}function k(a,b){var d,c;d="\n      ";if((c=e["if"].call(a,a&&a.home,{hash:{},inverse:p.program(9,r,b),fn:p.program(7,h,b),data:b}))||0===c)d+=c;return d+"\n    "}function h(a,b){var d,c;d='\n        <a href="';(c=e.hash)?
c=c.call(a,{hash:{},data:b}):(c=a&&a.hash,c=typeof c===q?c.call(a,{hash:{},data:b}):c);return d+=v(c)+'"><i class="icon-vector-home"></i></a>\n      '}function r(a,b){var c,d;c='\n        <a href="';(d=e.hash)?d=d.call(a,{hash:{},data:b}):(d=a&&a.hash,d=typeof d===q?d.call(a,{hash:{},data:b}):d);c+=v(d)+'">';(d=e.title)?d=d.call(a,{hash:{},data:b}):(d=a&&a.title,d=typeof d===q?d.call(a,{hash:{},data:b}):d);return c+=v(d)+"</a>\n      "}function n(a,b){var d,c;d="\n      ";if((c=e["if"].call(a,a&&
a.home,{hash:{},inverse:p.noop,fn:p.program(12,t,b),data:b}))||0===c)d+=c;d+="\n      ";if((c=e.unless.call(a,a&&a.home,{hash:{},inverse:p.noop,fn:p.program(14,s,b),data:b}))||0===c)d+=c;return d+"\n    "}function t(a,b){return'\n        <i class="icon-vector-home"></i>\n      '}function s(a,b){var d,c;d="\n        ";(c=e.title)?c=c.call(a,{hash:{},data:b}):(c=a&&a.title,c=typeof c===q?c.call(a,{hash:{},data:b}):c);return d+=v(c)+"\n      "}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);
c=c||{};var q="function",v=this.escapeExpression,p=this;b='<ul id="tab_list">\n';if((a=e.each.call(a,a&&a.tabs,{hash:{},inverse:p.noop,fn:p.program(1,function(a,b){var d,c;d='\n  <li class="';(c=e.active)?c=c.call(a,{hash:{},data:b}):(c=a&&a.active,c=typeof c===q?c.call(a,{hash:{},data:b}):c);d+=v(c)+" ";(c=e.cls)?c=c.call(a,{hash:{},data:b}):(c=a&&a.cls,c=typeof c===q?c.call(a,{hash:{},data:b}):c);d+=v(c)+'"  ';if((c=e["if"].call(a,a&&a.data,{hash:{},inverse:p.noop,fn:p.program(2,g,b),data:b}))||
0===c)d+=c;d+=">\n    ";if((c=e["if"].call(a,a&&a.icon,{hash:{},inverse:p.noop,fn:p.program(4,f,b),data:b}))||0===c)d+=c;d+="\n    \n    ";if((c=e["if"].call(a,a&&a.hash,{hash:{},inverse:p.program(11,n,b),fn:p.program(6,k,b),data:b}))||0===c)d+=c;return d+"\n  </li>\n"},c),data:c}))||0===a)b+=a;return b+"\n</ul>"});h.topic_sidebar_actions=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b='<ul class="nav nav-list topics_popover">\n  <li>\n    <a class="narrow_to_topic" data-stream-name="';
(d=e.stream_name)?d=d.call(a,{hash:{},data:c}):(d=a&&a.stream_name,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);b+=g(d)+'" data-topic-name="';(d=e.topic_name)?d=d.call(a,{hash:{},data:c}):(d=a&&a.topic_name,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);b+=g(d)+'">\n      <i class="icon-vector-bullhorn"></i>\n      Narrow to topic <b>';(d=e.topic_name)?d=d.call(a,{hash:{},data:c}):(d=a&&a.topic_name,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);b+=g(d)+"</b>\n    </a>\n  </li>\n\n\n  ";
if((d=e["if"].call(a,a&&a.can_mute_topic,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){var c,d;c='\n  <li>\n    <a href="#" class="sidebar-popover-mute-topic" data-stream-name="';(d=e.stream_name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.stream_name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'" data-topic-name="';(d=e.topic_name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.topic_name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'">\n      <i class="icon-vector-eye-close"></i>\n      Mute the topic <b>';
(d=e.topic_name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.topic_name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);return c+=g(d)+"</b>\n    </a>\n  </li>\n  "},c),data:c}))||0===d)b+=d;b+="\n\n  ";if((d=e["if"].call(a,a&&a.can_unmute_topic,{hash:{},inverse:this.noop,fn:this.program(3,function(a,b){var d,c;d='\n  <li>\n    <a href="#" class="sidebar-popover-unmute-topic" data-stream-name="';(c=e.stream_name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.stream_name,c="function"===typeof c?c.call(a,{hash:{},
data:b}):c);d+=g(c)+'" data-topic-name="';(c=e.topic_name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.topic_name,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);d+=g(c)+'">\n      <i class="icon-vector-eye-open"></i>\n      Unmute the topic <b>';(c=e.topic_name)?c=c.call(a,{hash:{},data:b}):(c=a&&a.topic_name,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=g(c)+"</b>\n    </a>\n  </li>\n  "},c),data:c}))||0===d)b+=d;return b+"\n\n</ul>\n"});h.admin_user_list=f(function(b,a,e,d,c){function g(a,
b){var c,d;c='\n    <td>\n      <span class="owner">';(d=e.bot_owner)?d=d.call(a,{hash:{},data:b}):(d=a&&a.bot_owner,d=typeof d===t?d.call(a,{hash:{},data:b}):d);return c+=s(d)+"</span>\n    </td>\n  "}function f(a,b){return'\n      <button class="btn deactivate btn-danger">\n        Deactivate\n      </button>\n    '}function k(a,b){return'\n      <button class="btn reactivate btn-warning">\n        Reactivate\n      </button>\n    '}function h(a,b){var c,d;c="\n        ";if((d=e["if"].call(a,a&&
a.is_admin,{hash:{},inverse:q.program(11,n,b),fn:q.program(9,r,b),data:b}))||0===d)c+=d;return c+"\n      "}function r(a,b){return'\n          <button class="btn remove-admin btn-danger">\n            Remove admin\n          </button>\n        '}function n(a,b){return'\n          <button class="btn make-admin btn-warning">\n            Make admin\n          </button>\n        '}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="";var t="function",s=this.escapeExpression,q=this;
if((a=e["with"].call(a,a&&a.user,{hash:{},inverse:q.noop,fn:q.program(1,function(a,b){var c,d;c='\n<tr class="user_row" id="user_';(d=e.email)?d=d.call(a,{hash:{},data:b}):(d=a&&a.email,d=typeof d===t?d.call(a,{hash:{},data:b}):d);c+=s(d)+'">\n  <td>\n    <span class="user_name">';(d=e.full_name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.full_name,d=typeof d===t?d.call(a,{hash:{},data:b}):d);c+=s(d)+'</span>\n  </td>\n  <td>\n    <span class="email">';(d=e.email)?d=d.call(a,{hash:{},data:b}):(d=a&&a.email,
d=typeof d===t?d.call(a,{hash:{},data:b}):d);c+=s(d)+"</span>\n  </td>\n  ";if((d=e["if"].call(a,a&&a.is_bot,{hash:{},inverse:q.noop,fn:q.program(2,g,b),data:b}))||0===d)c+=d;c+="\n  <td>\n    ";if((d=e["if"].call(a,a&&a.is_active,{hash:{},inverse:q.program(6,k,b),fn:q.program(4,f,b),data:b}))||0===d)c+=d;c+='\n    <span class="user-admin-settings">\n      ';if((d=e["if"].call(a,a&&a.is_active_human,{hash:{},inverse:q.noop,fn:q.program(8,h,b),data:b}))||0===d)c+=d;return c+"\n    </span>\n    <div class='admin-user-status'>\n    </div>\n  </td>\n</tr>\n"},
c),data:c}))||0===a)b+=a;return b+"\n"});h.tutorial_message=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};d=this.escapeExpression;b='\n\n<div class="tutorial-popover popover-';(e=e.placement)?c=e.call(a,{hash:{},data:c}):(e=a&&a.placement,c="function"===typeof e?e.call(a,{hash:{},data:c}):e);return b+=d(c)+'" id="tutorial-message">\n    <p>Welcome to '+d((c=(c=a&&a.page_params,null==c||!1===c?c:c.product_name),"function"===typeof c?c.apply(a):c))+"!</p>\n\n    <p>Messages in "+
d((c=(c=a&&a.page_params,null==c||!1===c?c:c.product_name),"function"===typeof c?c.apply(a):c))+' go to a <b>stream</b> and have a <b>topic</b>.</p>\n\n    <div class="tutorial-done-button">\n      <button class="btn btn-primary" type="submit" id="tutorial-message-next">Next</button>\n    </div>\n</div>\n'});h.settings_tab=f(function(b,a,e,d,c){function g(a,b){return'\n                checked="yes"\n              '}function f(a,b){return'\n                   checked="yes"\n                   '}function k(a,
b){return'\n                 checked="yes"\n              '}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var h;d=this.escapeExpression;b=""+('<h1><i class="icon-vector-wrench settings-icon"></i>Settings</h1>\n\n<div id="settings-change-box">\n\n  <div class="alert" id="settings-status"></div>\n\n  <div id="account-settings" class="settings-section">\n    <div class="settings-section-title"><i class="icon-vector-user settings-section-icon"></i>Your Account</div>\n    <div class="account-settings-form">\n      <form action="/json/settings/change" method="post"\n            class="form-horizontal your-account-settings">\n        <div class="control-group" id="name_change_container">\n          <label for="full_name" class="control-label">Full name</label>\n          <div class="controls">\n            <input type="text" name="full_name" id="full_name"\n                   value="'+
d((h=(h=a&&a.page_params,null==h||!1===h?h:h.fullname),"function"===typeof h?h.apply(a):h))+'" />\n          </div>\n        </div>\n\n        ');if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.password_auth_enabled),{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){return'\n        <div class="control-group" id="pw_change_link">\n          <label for="change_password_button" class="control-label">Password</label>\n          <div class="controls">\n            <button class="btn btn-default change_password_button" data-dismiss="modal" aria-hidden="true">Change Password</button>\n          </div>\n        </div>\n\n        <div id="pw_change_controls">\n          <div class="control-group">\n            <label for="old_password" class="control-label">Old password</label>\n            <div class="controls">\n              <input type="password" autocomplete="off"\n                     name="old_password" id="old_password" value="" />\n              (<a href="/accounts/password/reset/" target="_blank">Forgotten it?</a>)\n            </div>\n          </div>\n\n          <div class="control-group">\n            <label for="new_password" class="control-label">New password</label>\n            <div class="controls">\n              <input type="password" autocomplete="off"\n                     name="new_password" id="new_password" value="" />\n            </div>\n          </div>\n\n          <div class="control-group">\n            <label class="control-label">Password strength</label>\n            <div class="controls">\n              <div class="progress" id="pw_strength">\n                <div class="bar bar-danger" style="width: 10%;"></div>\n              </div>\n            </div>\n          </div>\n\n          <div class="control-group">\n            <label for="confirm_password" class="control-label">Confirm password</label>\n            <div class="controls">\n              <input type="password" autocomplete="off"\n                     name="confirm_password" id="confirm_password" value="" />\n            </div>\n          </div>\n\n        </div>\n        '},
c),data:c}))||0===h)b+=h;b+='\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="submit" name="change_settings"\n                   value="Save changes" class="btn btn-big btn-primary" />\n          </div>\n        </div>\n\n        <div class="user-avatar-section">\n          <p>\n            <img id="user-settings-avatar" src="'+d((h=(h=a&&a.page_params,null==h||!1===h?h:h.avatar_url),"function"===typeof h?h.apply(a):h))+'" />\n          </p>\n          <div id="user_avatar_file_input_error" class="text-error"></div>\n          <div id="user_avatar_file"></div>\n          <input type="file" name="user_avatar_file_input" class="notvisible" id="user_avatar_file_input" value="Upload avatar" />\n          <div id="upload_avatar_spinner"></div>\n          <button class="btn btn-default" id="user_avatar_upload_button">Customize avatar</button>\n        </div>\n\n      </form>\n\n    </div>\n  </div>\n\n  <div>\n    <div id="display-settings" class="settings-section">\n      <div class="settings-section-title"><i class="icon-vector-time settings-section-icon"></i>\n      Display Settings</div>\n      <div class="alert" id="display-settings-status"></div>\n      <div class="display-settings-form">\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="left_side_userlist" id="left_side_userlist"\n              ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.left_side_userlist),{hash:{},inverse:this.noop,fn:this.program(3,g,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n        <label for="left_side_userlist" class="control-label">Display user list on left side in narrow windows.</label>\n        </div>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="twenty_four_hour_time" id="twenty_four_hour_time"\n              ';if((h=
e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.twenty_four_hour_time),{hash:{},inverse:this.noop,fn:this.program(3,g,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="twenty_four_hour_time" class="control-label">\n            Display time in 24-hour format (17:00 instead of 5:00 PM)\n          </label>\n        </div>\n      </div>\n    </div>\n  </div>\n\n  <div>\n    <div id="notification-settings" class="settings-section">\n      <div class="settings-section-title"><i class="icon-vector-warning-sign settings-section-icon"></i>Notifications</div>\n      <div class="notification-reminder">You\'ll receive notifications when a message arrives and '+
d((h=(h=a&&a.page_params,null==h||!1===h?h:h.product_name),"function"===typeof h?h.apply(a):h))+' isn\'t in focus or the message is offscreen.</div>\n      <div class="alert" id="notify-settings-status"></div>\n      <div class="notification-settings-form">\n        <h4>Stream messages</h4>\n\n        <p>Unless I say otherwise for a particular stream, I want:</p>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="enable_stream_desktop_notifications"\n                   id="enable_stream_desktop_notifications"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.stream_desktop_notifications_enabled),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_stream_desktop_notifications" class="control-label">\n            Desktop notifications\n          </label>\n          <div class="propagate_stream_notifications_change"></div>\n        </div>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="enable_stream_sounds" id="enable_stream_sounds"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.stream_sounds_enabled),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_stream_sounds" class="control-label">\n            Audible notifications\n          </label>\n          <div class="propagate_stream_notifications_change"></div>\n        </div>\n\n        <p class="notification-settings-note">\n          Change notification settings for individual streams on your <a\n          href="/#subscriptions">Streams page</a>.\n        </p>\n\n        <h4>Private messages and @-mentions</h4>\n\n        <p>I want:</p>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="enable_desktop_notifications" id="enable_desktop_notifications"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.desktop_notifications_enabled),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_desktop_notifications" class="control-label">\n            Desktop notifications\n          </label>\n        </div>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="enable_sounds" id="enable_sounds"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.sounds_enabled),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_sounds" class="control-label">\n            Audible notifications\n          </label>\n        </div>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="enable_offline_email_notifications" id="enable_offline_email_notifications"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.enable_offline_email_notifications),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_offline_email_notifications" class="control-label">\n            Email notifications when offline\n          </label>\n        </div>\n\n        <div class="control-group">\n          <div class="controls">\n            <input type="checkbox" name="enable_offline_push_notifications" id="enable_offline_push_notifications"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.enable_offline_push_notifications),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_offline_push_notifications" class="control-label">\n            Mobile push notifications when offline\n          </label>\n        </div>\n\n\t<div id="other_notifications">\n        <h4>Other notifications</h4>\n\n        <p>I want:</p>\n\n        <div class="control-group" id="digest_container">\n          <div class="controls">\n            <input type="checkbox" name="enable_digest_emails" id="enable_digest_emails"\n                   ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.enable_digest_emails),{hash:{},inverse:this.noop,fn:this.program(5,f,c),data:c}))||0===h)b+=h;b+=' />\n          </div>\n          <label for="enable_digest_emails" class="control-label">\n            Digest emails when I\'m away\n          </label>\n        </div>\n\t\n\t</div>\n\n        <div class="control-group">\n          <div class="controls notification-submission">\n            <input type="submit" id="change_notification_settings"\n                   name="change_notification_settings" value="Save changes"\n                   class="btn btn-big btn-primary" />\n          </div>\n        </div>\n      </div>\n\n    </div>\n\n  </div>\n</div>\n\n<div id="bot-settings" class="settings-section">\n\n  <div class="settings-section-title"><i class="icon-vector-github settings-section-icon"></i>Your Bots</div>\n\n  <div class="bot-settings-form">\n    <p class="bot-settings-note">Looking for our <a href="/integrations" target="_blank">Integrations</a>\n      or <a href="/api" target="_blank">API</a> documentation?</p>\n\n    <ol id="bots_list">\n    </ol>\n    <div id="bot_table_error" class="alert alert-error hide"></div>\n    <form id="create_bot_form" class="form-horizontal">\n      <div class="add-new-bot-box">\n        <div class="settings-section-title new-bot-section-title">Add a New Bot</div>\n        <div class="new-bot-form">\n          <div class="control-group">\n            <label for="create_bot_name" class="control-label">Full name</label>\n            <input type="text" name="bot_name" id="create_bot_name" class="required"\n                   maxlength=100 placeholder="Full Bot Name" value="" />\n            <div><label for="create_bot_name" generated="true" class="text-error"></label></div>\n          </div>\n          <div class="control-group">\n            <label for="bot_short_name" class="control-label">Username</label>\n            <input type="text" name="bot_short_name" id="create_bot_short_name" class="required bot_local_part"\n                   placeholder="bot_user_name" value="" />-bot@'+
d((h=(h=a&&a.page_params,null==h||!1===h?h:h.domain),"function"===typeof h?h.apply(a):h))+'\n            <div><label for="create_bot_short_name" generated="true" class="text-error"></label></div>\n          </div>\n          <div class="control-group new-bot-ui">\n            <label for="create_bot_default_sending_stream" class="control-label">Send to stream</label>\n            <select name="bot_default_sending_stream" id="create_bot_default_sending_stream"></select>\n          </div>\n          <div class="control-group new-bot-ui">\n            <label for="create_bot_default_events_register_stream" class="control-label">Listen on</label>\n            <select name="bot_default_events_register_stream" id="create_bot_default_events_register_stream"></select>\n          </div>\n          <div class="control-group">\n            <div class="controls">\n              <div id="bot_avatar_file"></div>\n              <input type="file" name="bot_avatar_file_input" class="notvisible" id="bot_avatar_file_input" value="Upload avatar" />\n              <button class="btn btn-default" id="bot_avatar_clear_button">Clear avatar</button>\n              <button class="btn btn-default" id="bot_avatar_upload_button">Customize avatar</button> (Optional)\n            </div>\n          </div>\n          <p>\n            <div id="bot_avatar_file_input_error" class="text-error"></div>\n          </p>\n          <div class="control-group">\n            <div class="controls">\n              <input type="submit" class="btn btn-primary" id="create_bot_button" value="Create Bot" />\n            </div>\n          </div>\n        </div>\n      </div>\n    </form>\n\n    <hr class="settings_separator" />\n\n    <div class="form-horizontal" id="api_key_button_box">\n      <p class="api-key-note">For most bots using the API, you\'ll want to give each bot\n        its own name and API key using the above section.  But if you\n        want to write a bot that can access your own private\n        messages, you should use your personal API key.\n      </p>\n      <div class="control-group">\n        <button class="btn btn-default" id="api_key_button">Show/change your API key</button>\n      </div>\n    </div>\n    <div id="get_api_key_box">\n      <p>Please re-enter your password to confirm your identity.\n        (<a href="/accounts/password/reset/" target="_blank">Forgotten it?</a>)</p>\n      <form action="/json/fetch_api_key" method="post" class="form-horizontal">\n        <div class="control-group">\n          <label for="password" class="control-label">Current password</label>\n          <input type="password" autocomplete="off"\n                 name="password" id="get_api_key_password" value="" />\n        </div>\n        <div class="control-group">\n          <input type="submit" name="view_api_key" value="Get API key"\n                 class="btn btn-primary" />\n        </div>\n      </form>\n    </div>\n    <div id="show_api_key_box">\n      <p>Your API key:</p>\n      <p><b><span id="api_key_value"></span></b></p>\n      <button type="submit" class="btn btn-primary regenerate_api_key">\n        Generate new API Key\n      </button>\n      <div id="user_api_key_error text-error">\n      </div>\n    </div>\n\n  </div>\n</div>\n\n<div id="word-alert-settings" class="settings-section">\n  <div class="settings-section-title"><i class="icon-vector-book settings-section-icon"></i>Custom Word Alerts</div>\n  <ul id="word-alerts">\n  </ul>\n</div>\n\n<div class="ui-settings">\n  <div id="ui-settings" class="settings-section">\n    <div class="settings-section-title"><i class="icon-vector-beaker settings-section-icon"></i>'+
d((h=(h=a&&a.page_params,null==h||!1===h?h:h.product_name),"function"===typeof h?h.apply(a):h))+' Labs</div>\n    <div class="alert" id="ui-settings-status"></div>\n    <div class="ui-settings-form">\n      <p>\n        Warning: the below features are experimental features and may not work as well as you would like.\n      </p>\n      <div class="control-group">\n        <div class="controls">\n          <input type="checkbox" name="autoscroll_forever" id="autoscroll_forever"\n                 ';
if((h=e["if"].call(a,(h=a&&a.page_params,null==h||!1===h?h:h.autoscroll_forever),{hash:{},inverse:this.noop,fn:this.program(7,k,c),data:c}))||0===h)b+=h;b+=' />\n        </div>\n        <label for="autoscroll_forever" class="control-label">\n          Always auto-scroll to new messages\n        </label>\n\n        <div class="controls">\n          <input type="checkbox" name="default_desktop_notifications" id="default_desktop_notifications"\n                 ';if((h=e["if"].call(a,(h=a&&a.page_params,
null==h||!1===h?h:h.default_desktop_notifications),{hash:{},inverse:this.noop,fn:this.program(7,k,c),data:c}))||0===h)b+=h;return b+' />\n        </div>\n        <label for="default_desktop_notifications" class="control-label">\n          Enable desktop notifications for new streams\n        </label>\n\n      </div>\n      <div class="control-group">\n        <div class="controls ui-submission">\n          <input type="submit" name="change_settings" value="Save changes" class="btn btn-big btn-primary" />\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n'});
h.tutorial_title=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b='\n\n<h4 class="popover-';(g=e.placement)?g=g.call(a,{hash:{},data:c}):(g=a&&a.placement,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">';(g=e.title)?g=g.call(a,{hash:{},data:c}):(g=a&&a.title,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=d(g)+"</h4>\n"});h["compose-invite-users"]=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];
e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b='<div class="compose_invite_user" data-useremail="';(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">\n\t<strong>';(g=e.name)?g=g.call(a,{hash:{},data:c}):(g=a&&a.name,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=d(g)+'</strong> is not subscribed to this stream.\n    <div class="compose_invite_user_controls">\n\t   <span class="compose_invite_user_error alert alert-error" style="display: none;">Unable to subscribe user</span>\n\t   <button href="" class="compose_invite_link btn" >Subscribe</button><button type="button" class="compose_invite_close close">\u00d7</button>\n    </div>\n</div>\n'});
h.subscription=f(function(b,a,e,d,c){function g(a,b){return" btn-success subscribed-button"}function f(a,b){return"\n        Subscribed\n        "}function h(a,b){return"\n        Subscribe\n        "}function l(a,b){return"in"}function r(a,b){return"checked"}function n(a,b){return"hide-mute-note"}function t(a,b){return"muted-sub"}function s(a,b){return'disabled="disabled"'}function q(a,b){var d,c;d='\n      <div class="stream-email-box">\n          <span class="sub_settings_title">Email address <i class="icon-vector-question-sign stream-email-hint" id="email-address-hint-';
(c=e.stream_id)?c=c.call(a,{hash:{},data:b}):(c=a&&a.stream_id,c=typeof c===y?c.call(a,{hash:{},data:b}):c);d+=x(c)+'"></i></span>\n      <div class="stream-email">\n          <span class="email-address">';(c=e.email_address)?c=c.call(a,{hash:{},data:b}):(c=a&&a.email_address,c=typeof c===y?c.call(a,{hash:{},data:b}):c);return d+=x(c)+"</span>\n      </div>\n      </div>\n      "}function v(a,b){var d,c,g,f;d='\n        <div class="admin-settings">\n          <span class="sub_settings_title">Administrator settings</span>\n          <div class="rename-stream">\n            <form class="form-inline">\n              <input type="text" name="new-name" value="" class="input-block new-stream-name" tabindex="-1" />\n              <input type="submit" name="rename" value="Rename stream" class="btn btn-danger stream-rename-button" tabindex="-1" />\n            </form>\n          </div>\n          <div class="change-stream-description">\n            <form class="form-inline">\n              <input type="hidden" name="stream_name" value="';
(g=e.name)?c=g.call(a,{hash:{},data:b}):(g=a&&a.name,c=typeof g===y?g.call(a,{hash:{},data:b}):g);d+=x(c)+'" />\n              <input type="text" name="description" value="';(g=e.description)?c=g.call(a,{hash:{},data:b}):(g=a&&a.description,c=typeof g===y?g.call(a,{hash:{},data:b}):g);return d+=x(c)+'" class="input-block description" tabindex="-1" />\n              <input type="submit" name="change-stream-description" value="Change stream description" class="btn btn-danger change-stream-description-button" tabindex="-1" />\n            </form>\n          </div>\n          <div class="change-stream-privacy">\n            '+
x((g=e.partial||a&&a.partial,f={hash:{},data:b},g?g.call(a,"change_stream_privacy",f):F.call(a,"partial","change_stream_privacy",f)))+"\n          </div>\n        </div>\n      "}function p(a,b){return'\n      <div class="subscriber_list_settings">\n        <span class="sub_settings_title">Stream membership</span>\n        <div class="subscriber_list_add">\n          <form class="form-inline">\n            <input type="text" name="principal" placeholder="Email address" value="" class="input-block" tabindex="-1" />\n            <input type="submit" name="add_subscriber" value="Add" class="btn btn-primary add-subscriber-button" tabindex="-1 "/>\n          </form>\n        </div>\n      </div>\n      <div class="subscriber-list-box">\n        <div class="subscriber_list_container">\n          <div class="subscriber_list_loading_indicator"></div>\n          <div class="alert alert-error hide"></div>\n          <div class="alert alert-warning hide"></div>\n          <table class="subscriber-list">\n          </table>\n        </div>\n      </div>\n      '}
this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var y="function",x=this.escapeExpression,F=e.helperMissing,A=this,D=e.blockHelperMissing;b="\n";if((a=e["with"].call(a,a,{hash:{},inverse:A.noop,fn:A.program(1,function(a,b){var d,c,w,C;d='\n<div class="subscription_row" id="subscription_';(w=e.stream_id)?c=w.call(a,{hash:{},data:b}):(w=a&&a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" data-subscription-id="';(w=e.stream_id)?c=w.call(a,{hash:{},data:b}):(w=a&&
a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'">\n    <div class="subscription_table_elem subscription_header collapsed" data-toggle="collapse" data-target="#subscription_settings_';(w=e.stream_id)?c=w.call(a,{hash:{},data:b}):(w=a&&a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'">\n      <span class="subscription-setting-icon">\n        '+x((w=e.partial||a&&a.partial,C={hash:{},data:b},w?w.call(a,"subscription_setting_icon",C):F.call(a,"partial","subscription_setting_icon",
C)))+'\n      </span>\n      <span class="subscription_block">\n      <span class="subscription_name subscription-name-row">';(w=e.name)?c=w.call(a,{hash:{},data:b}):(w=a&&a.name,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'</span>\n      <span class="subscription_description subscription-description-row">';(w=e.description)?c=w.call(a,{hash:{},data:b}):(w=a&&a.description,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'</span>\n      </span>\n      <span class="sub_arrow"><i class="icon-vector-chevron-down"></i></span>\n      <button class="btn sub_unsub_button btn-default';
C={hash:{},inverse:A.noop,fn:A.program(2,g,b),data:b};(w=e.subscribed)?c=w.call(a,C):(w=a&&a.subscribed,c=typeof w===y?w.call(a,C):w);e.subscribed||(c=D.call(a,c,{hash:{},inverse:A.noop,fn:A.program(2,g,b),data:b}));if(c||0===c)d+=c;d+='"\n              type="button" name="subscription">\n        ';C={hash:{},inverse:A.noop,fn:A.program(4,f,b),data:b};(w=e.subscribed)?c=w.call(a,C):(w=a&&a.subscribed,c=typeof w===y?w.call(a,C):w);e.subscribed||(c=D.call(a,c,{hash:{},inverse:A.noop,fn:A.program(4,
f,b),data:b}));if(c||0===c)d+=c;d+="\n        ";C={hash:{},inverse:A.program(6,h,b),fn:A.noop,data:b};(w=e.subscribed)?c=w.call(a,C):(w=a&&a.subscribed,c=typeof w===y?w.call(a,C):w);e.subscribed||(c=D.call(a,c,{hash:{},inverse:A.program(6,h,b),fn:A.noop,data:b}));if(c||0===c)d+=c;d+='\n      </button>\n    </div>\n\n    <div id="subscription_settings_';(w=e.stream_id)?c=w.call(a,{hash:{},data:b}):(w=a&&a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" class="collapse subscription_settings">\n      <div class="regular_subscription_settings collapse ';
C={hash:{},inverse:A.noop,fn:A.program(8,l,b),data:b};(w=e.subscribed)?c=w.call(a,C):(w=a&&a.subscribed,c=typeof w===y?w.call(a,C):w);e.subscribed||(c=D.call(a,c,{hash:{},inverse:A.noop,fn:A.program(8,l,b),data:b}));if(c||0===c)d+=c;d+='">\n        <div class="subscription-type">\n          '+x((w=e.partial||a&&a.partial,C={hash:{},data:b},w?w.call(a,"subscription_type",C):F.call(a,"partial","subscription_type",C)))+'\n        </div>\n        <div class="subscription-config">\n        <ul>\n          <li>\n            <div id="sub_setting_not_in_home_view" class="sub_setting_checkbox sub-mute-setting">\n              <input id="mutestream-';
(w=e.stream_id)?c=w.call(a,{hash:{},data:b}):(w=a&&a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" class="sub_setting_control" type="checkbox" tabindex="-1" ';if((c=e.unless.call(a,a&&a.in_home_view,{hash:{},inverse:A.noop,fn:A.program(10,r,b),data:b}))||0===c)d+=c;d+=' />\n              <label class="subscription-control-label">Mute stream</label>\n              <p class="mute-note ';if((c=e["if"].call(a,a&&a.in_home_view,{hash:{},inverse:A.noop,fn:A.program(12,n,b),data:b}))||
0===c)d+=c;d+='">Muted streams don\'t show up in your home view or generate notifications unless you are mentioned.</p>\n            </div>\n          </li>\n          <li>\n\n            <div id="sub_desktop_notifications_setting"\n                 class="sub_setting_checkbox sub_notification_setting ';if((c=e.unless.call(a,a&&a.in_home_view,{hash:{},inverse:A.noop,fn:A.program(14,t,b),data:b}))||0===c)d+=c;d+='">\n              <input id="desktop-notifystream-';(w=e.stream_id)?c=w.call(a,{hash:{},
data:b}):(w=a&&a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" class="sub_setting_control" type="checkbox" tabindex="-1" ';if((c=e["if"].call(a,a&&a.desktop_notifications,{hash:{},inverse:A.noop,fn:A.program(10,r,b),data:b}))||0===c)d+=c;d+=" ";if((c=e.unless.call(a,a&&a.in_home_view,{hash:{},inverse:A.noop,fn:A.program(16,s,b),data:b}))||0===c)d+=c;d+='/>\n              <label class="subscription-control-label">Receive desktop <br />notifications</label>\n            </div>\n\n            <div id="sub_audible_notifications_setting"\n                 class="sub_setting_checkbox sub_notification_setting ';
if((c=e.unless.call(a,a&&a.in_home_view,{hash:{},inverse:A.noop,fn:A.program(14,t,b),data:b}))||0===c)d+=c;d+='">\n              <input id="audible-notifystream-';(w=e.stream_id)?c=w.call(a,{hash:{},data:b}):(w=a&&a.stream_id,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" class="sub_setting_control" type="checkbox" tabindex="-1" ';if((c=e["if"].call(a,a&&a.audible_notifications,{hash:{},inverse:A.noop,fn:A.program(10,r,b),data:b}))||0===c)d+=c;d+=" ";if((c=e.unless.call(a,a&&a.in_home_view,
{hash:{},inverse:A.noop,fn:A.program(16,s,b),data:b}))||0===c)d+=c;d+='/>\n              <label class="subscription-control-label">Receive audible<br />notifications</label>\n            </div>\n\n          </li>\n          <li>\n            <span class="sub_setting_control">\n              <input stream_name="';(w=e.name)?c=w.call(a,{hash:{},data:b}):(w=a&&a.name,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" class="colorpicker" id="streamcolor" type="text" value="';(w=e.color)?c=w.call(a,
{hash:{},data:b}):(w=a&&a.color,c=typeof w===y?w.call(a,{hash:{},data:b}):w);d+=x(c)+'" tabindex="-1" />\n            </span>\n            <label for="streamcolor" class="subscription-control-label">Stream color</label>\n          </li>\n        </ul>\n        </div>\n      </div>\n      ';if((c=(w=e.if_and||a&&a.if_and,C={hash:{},inverse:A.noop,fn:A.program(18,q,b),data:b},w?w.call(a,a&&a.subscribed,a&&a.email_address,C):F.call(a,"if_and",a&&a.subscribed,a&&a.email_address,C)))||0===c)d+=c;d+="\n\n      ";
if((c=e["if"].call(a,a&&a.is_admin,{hash:{},inverse:A.noop,fn:A.program(20,v,b),data:b}))||0===c)d+=c;d+="\n\n      ";C={hash:{},inverse:A.noop,fn:A.program(22,p,b),data:b};(w=e.render_subscribers)?c=w.call(a,C):(w=a&&a.render_subscribers,c=typeof w===y?w.call(a,C):w);e.render_subscribers||(c=D.call(a,c,{hash:{},inverse:A.noop,fn:A.program(22,p,b),data:b}));if(c||0===c)d+=c;return d+"\n    </div>\n</div>\n"},c),data:c}))||0===a)b+=a;return b+"\n"});h.message_group=f(function(b,a,e,d,c){function g(a,
b,c){var d,g,r,D;d="\n\n";if((g=e["if"].call(a,a&&a.show_date,{hash:{},inverse:q.noop,fn:q.program(3,f,b),data:b}))||0===g)d+=g;d+="\n\n";if((g=e["if"].call(a,a&&a.bookend_top,{hash:{},inverse:q.noop,fn:q.program(5,h,b),data:b}))||0===g)d+=g;d+='\n\n<div class="recipient_row" id="';(r=e.message_group_id)?g=r.call(a,{hash:{},data:b}):(r=a&&a.message_group_id,g=typeof r===n?r.call(a,{hash:{},data:b}):r);d+=s(g)+'">\n  '+s((r=e.partial||c&&c.partial,D={hash:{},data:b},r?r.call(a,"recipient_row","use_match_properties",
c&&c.use_match_properties,D):t.call(a,"partial","recipient_row","use_match_properties",c&&c.use_match_properties,D)))+"\n  ";if((g=e.each.call(a,a&&a.message_containers,{hash:{},inverse:q.noop,fn:q.programWithDepth(7,l,b,c),data:b}))||0===g)d+=g;d+="\n</div>\n\n";if((g=e["if"].call(a,a&&a.bookend_bottom,{hash:{},inverse:q.noop,fn:q.program(5,h,b),data:b}))||0===g)d+=g;return d+"\n\n"}function f(a,b){var c,d;c='\n<div class="date_row">';(d=e.show_date)?d=d.call(a,{hash:{},data:b}):(d=a&&a.show_date,
d=typeof d===n?d.call(a,{hash:{},data:b}):d);if(d||0===d)c+=d;return c+"</div>\n"}function h(a,b){var d,c,g;return d=""+("\n"+s((c=e.partial||a&&a.partial,g={hash:{},data:b},c?c.call(a,"bookend",g):t.call(a,"partial","bookend",g)))+"\n")}function l(a,b,d){var c;c="\n  ";if((a=e["with"].call(a,a,{hash:{},inverse:q.noop,fn:q.programWithDepth(8,r,b,d),data:b}))||0===a)c+=a;return c+"\n  "}function r(a,b,c){var d,g;return a=""+("\n    "+s((d=e.partial||c&&c.partial,g={hash:{},data:b},d?d.call(a,"single_message",
"use_match_properties",c&&c.use_match_properties,"table_name",c&&c.table_name,g):t.call(a,"partial","single_message","use_match_properties",c&&c.use_match_properties,"table_name",c&&c.table_name,g)))+"\n  ")}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var n="function",t=e.helperMissing,s=this.escapeExpression,q=this;b="\n\n";if((a=e.each.call(a,a&&a.message_groups,{hash:{},inverse:q.noop,fn:q.programWithDepth(1,function(a,b,c){var d;d="\n";if((a=e["with"].call(a,a,{hash:{},
inverse:q.noop,fn:q.programWithDepth(2,g,b,c),data:b}))||0===a)d+=a;return d+"\n"},c,a),data:c}))||0===a)b+=a;return b+"\n"});h.tutorial_subject=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};d=this.escapeExpression;b='\n\n<div class="tutorial-popover popover-';(e=e.placement)?a=e.call(a,{hash:{},data:c}):(e=a&&a.placement,a="function"===typeof e?e.call(a,{hash:{},data:c}):e);return b+=d(a)+'" id="tutorial-subject">\n\n    <p>\n        The <b>topic</b> of a conversation is one or two words that describe\n        what it is about, for example: <b>Bug #345</b>, <b>lunch</b>, or\n        <b>logo</b>. Don\'t overthink it.\n    </p>\n\n    <div class="tutorial-done-button">\n      <button class="btn btn-primary" type="submit" id="tutorial-subject-next">Next</button>\n    </div>\n</div>\n'});
h.alert_word_settings_item=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b='\n<li class="alert-word-item" data-word=\'';(d=e.word)?d=d.call(a,{hash:{},data:c}):(d=a&&a.word,d="function"===typeof d?d.call(a,{hash:{},data:c}):d);b+=g(d)+"'>\n\t";if((d=e["if"].call(a,a&&a.editing,{hash:{},inverse:this.program(3,function(a,b){var c,d;c="\n\t\t";(d=e.word)?d=d.call(a,{hash:{},data:b}):(d=a&&a.word,d="function"===typeof d?d.call(a,{hash:{},
data:b}):d);return c+=g(d)+'<button class="btn btn-default btn-mini remove-alert-word" type="button"><i class="icon-vector-remove"></i></button>\n\t'},c),fn:this.program(1,function(a,b){return'\n\t\t<input class="edit-alert-word input-medium" type="text" placeholder="Alert Word" /><button class="btn btn-default btn-mini add-alert-word" type="button">Add</button>\n\t'},c),data:c}))||0===d)b+=d;return b+"\n</li>\n"});h.stream_sidebar_actions=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=
this.merge(e,b.helpers);c=c||{};var g,f=this.escapeExpression;b=""+('\n<ul class="nav nav-list streams_popover" data-id="'+f((g=(g=a&&a.stream,null==g||!1===g?g:g.stream_id),"function"===typeof g?g.apply(a):g))+'" data-name="'+f((g=(g=a&&a.stream,null==g||!1===g?g:g.name),"function"===typeof g?g.apply(a):g))+'">\n  <li>\n    <a class="narrow_to_stream">\n      <i class="icon-vector-bullhorn"></i>\n      Narrow to stream <b>'+f((g=(g=a&&a.stream,null==g||!1===g?g:g.name),"function"===typeof g?g.apply(a):
g))+'</b>\n    </a>\n  </li>\n  <li>\n    <a class="toggle_home">\n      ');if((g=e["if"].call(a,(g=a&&a.stream,null==g||!1===g?g:g.in_home_view),{hash:{},inverse:this.program(3,function(a,b){var d,c;return d=""+('\n      <i class="icon-vector-eye-open"></i>\n      Unmute the stream <b>'+f((c=(c=a&&a.stream,null==c||!1===c?c:c.name),"function"===typeof c?c.apply(a):c))+"</b>\n      ")},c),fn:this.program(1,function(a,b){var c,d;return c=""+('\n      <i class="icon-vector-eye-close"></i>\n      Mute the stream <b>'+
f((d=(d=a&&a.stream,null==d||!1===d?d:d.name),"function"===typeof d?d.apply(a):d))+"</b>\n      ")},c),data:c}))||0===g)b+=g;return b+='\n    </a>\n  </li>\n  <li>\n    <a class="compose_to_stream">\n      <i class="icon-vector-edit"></i>\n      Compose a message to stream <b>'+f((g=(g=a&&a.stream,null==g||!1===g?g:g.name),"function"===typeof g?g.apply(a):g))+'</b>\n    </a>\n  </li>\n  <li>\n    <a class="open_stream_settings">\n      <i class="icon-vector-cog"></i>\n      Stream settings\n    </a>\n  </li>\n  <li>\n    <span class="colorpicker-container"><input stream_name="'+
f((g=(g=a&&a.stream,null==g||!1===g?g:g.name),"function"===typeof g?g.apply(a):g))+'" class="colorpicker" type="text" value="'+f((g=(g=a&&a.stream,null==g||!1===g?g:g.color),"function"===typeof g?g.apply(a):g))+'" /></span>\n    <a class="custom_color">Choose custom color</a>\n  </li>\n\n</ul>\n'});h.stream_privacy=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="\n";if((a=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:this.noop,fn:this.program(1,function(a,
b){return'\n  <i class="icon-vector-lock"></i>\n'},c),data:c}))||0===a)b+=a;return b+"\n"});h.bookend=f(function(b,a,e,d,c){function g(a,b){return"trailing_bookend"}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var f=this,h=this.escapeExpression;b="\n\n";if((a=e["if"].call(a,a&&a.bookend_content,{hash:{},inverse:f.noop,fn:f.program(1,function(a,b){var d,c;d='\n<div class="';if((c=e["if"].call(a,a&&a.trailing,{hash:{},inverse:f.noop,fn:f.program(2,g,b),data:b}))||0===c)d+=c;d+=
' bookend sub-unsub-message">\n    <span>';(c=e.bookend_content)?c=c.call(a,{hash:{},data:b}):(c=a&&a.bookend_content,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=h(c)+"</span>\n</div>\n"},c),data:c}))||0===a)b+=a;return b+"\n"});h.group_pms=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g=this.escapeExpression;b="\n";if((a=e.each.call(a,a&&a.group_pms,{hash:{},inverse:this.noop,fn:this.program(1,function(a,b){var c,d;c='\n<li data-emails="';
(d=e.emails)?d=d.call(a,{hash:{},data:b}):(d=a&&a.emails,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'" class="group-pms-sidebar-entry narrow-filter">\n  <span class="selectable_sidebar_block">\n    <span class="group-pm-status-indicator" style="background:rgba(68,194,29,';(d=e.fraction_present)?d=d.call(a,{hash:{},data:b}):(d=a&&a.fraction_present,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+');"></span>\n    <a href="#" data-name="';(d=e.name)?d=d.call(a,{hash:{},
data:b}):(d=a&&a.name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'" title="';(d=e.name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);c+=g(d)+'" class="group-pm-link">';(d=e.short_name)?d=d.call(a,{hash:{},data:b}):(d=a&&a.short_name,d="function"===typeof d?d.call(a,{hash:{},data:b}):d);return c+=g(d)+'</a>\n  </span>\n  <span class="count"><span class="value"></span></span>\n</li>\n'},c),data:c}))||0===a)b+=a;return b+"\n"});h.user_sidebar_actions=
f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b='\n<ul class="nav nav-list user_popover" data-email="';(g=e.email)?g=g.call(a,{hash:{},data:c}):(g=a&&a.email,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'">\n  <li>\n    <a class="narrow_to_private_messages">\n      <i class="icon-vector-user"></i>\n      Narrow to private messages with <b>';(g=e.name)?g=g.call(a,{hash:{},data:c}):(g=a&&a.name,g="function"===
typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'</b>\n    </a>\n  </li>\n  <li>\n    <a class="narrow_to_messages_sent">\n      <i class="icon-vector-bullhorn"></i>\n      Narrow to messages sent by <b>';(g=e.name)?g=g.call(a,{hash:{},data:c}):(g=a&&a.name,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'</b>\n    </a>\n  </li>\n  <li>\n    <a class="compose_private_message">\n      <i class="icon-vector-edit"></i>\n      Compose a message to <b>';(g=e.name)?g=g.call(a,{hash:{},data:c}):
(g=a&&a.name,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=d(g)+"</b>\n    </a>\n  </li>\n\n</ul>\n"});h.subscription_type=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="This is\n";if((a=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:this.program(3,function(a,b){return'a <span class="icon-vector-globe"></span> <b>public stream</b>. Anybody in your organization can join.'},c),fn:this.program(1,function(a,b){return'an <span class="icon-vector-lock"></span> <b>invite-only stream</b>. Only people who have been invited can access its content, but&nbsp;any&nbsp;member&nbsp;of&nbsp;the&nbsp;stream can&nbsp;invite&nbsp;others.\n'},
c),data:c}))||0===a)b+=a;return b+"\n"});h.notification=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g;d=this.escapeExpression;b='\n<div>\n    <div class="notifications-gravatar">\n        <img src="';(g=e.gravatar_url)?g=g.call(a,{hash:{},data:c}):(g=a&&a.gravatar_url,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+'" />\n    </div>\n    <div class="notifications-content">\n        <div class="title">';(g=e.title)?g=g.call(a,{hash:{},
data:c}):(g=a&&a.title,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);b+=d(g)+"</div>\n        ";(g=e.content)?g=g.call(a,{hash:{},data:c}):(g=a&&a.content,g="function"===typeof g?g.call(a,{hash:{},data:c}):g);return b+=d(g)+"\n    </div>\n</div>\n"});h.tutorial_reply=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};d=this.escapeExpression;b='\n\n<div class="tutorial-popover popover-';(e=e.placement)?a=e.call(a,{hash:{},data:c}):(e=a&&a.placement,a="function"===
typeof e?e.call(a,{hash:{},data:c}):e);return b+=d(a)+'" id="tutorial-reply">\n\n    <p><b>Reply</b> to a message by <b>clicking on it</b>. The stream\n        and topic will automatically be filled in.</p>\n\n    <div class="tutorial-done-button">\n      <button class="btn btn-primary" type="submit" id="tutorial-reply-next">Next</button>\n    </div>\n</div>\n'});h.single_message=f(function(b,a,e,d,c){function g(a,b){return" private-message"}function f(a,b){return" include-sender"}function h(a,b){return" mention"}
function l(a,b){return" last_message"}function r(a,b){return" prev_is_same_sender"}function n(a,b){var d;(d=e.background_color)?d=d.call(a,{hash:{},data:b}):(d=a&&a.background_color,d=typeof d===w?d.call(a,{hash:{},data:b}):d);return C(d)}function t(a,b){return"#444444"}function s(a,b){var d,c,g;d='\n          <span class="message_sender';g={hash:{},inverse:z.program(22,q,b),fn:z.noop,data:b};(c=e.status_message)?c=c.call(a,g):(c=a&&a.status_message,c=typeof c===w?c.call(a,g):c);e.status_message||
(c=E.call(a,c,{hash:{},inverse:z.program(22,q,b),fn:z.noop,data:b}));if(c||0===c)d+=c;d+='">\n            \n            <div class="inline_profile_picture';g={hash:{},inverse:z.noop,fn:z.program(22,q,b),data:b};(c=e.status_message)?c=c.call(a,g):(c=a&&a.status_message,c=typeof c===w?c.call(a,g):c);e.status_message||(c=E.call(a,c,{hash:{},inverse:z.noop,fn:z.program(22,q,b),data:b}));if(c||0===c)d+=c;d+='"\n                 style="background-image: url(\'';(c=e.small_avatar_url)?c=c.call(a,{hash:{},
data:b}):(c=a&&a.small_avatar_url,c=typeof c===w?c.call(a,{hash:{},data:b}):c);d+=C(c)+'\');"/><span class="';g={hash:{},inverse:z.program(24,v,b),fn:z.noop,data:b};(c=e.status_message)?c=c.call(a,g):(c=a&&a.status_message,c=typeof c===w?c.call(a,g):c);e.status_message||(c=E.call(a,c,{hash:{},inverse:z.program(24,v,b),fn:z.noop,data:b}));if(c||0===c)d+=c;g={hash:{},inverse:z.noop,fn:z.program(26,p,b),data:b};(c=e.status_message)?c=c.call(a,g):(c=a&&a.status_message,c=typeof c===w?c.call(a,g):c);e.status_message||
(c=E.call(a,c,{hash:{},inverse:z.noop,fn:z.program(26,p,b),data:b}));if(c||0===c)d+=c;d+='">';if((c=e.unless.call(a,a&&a.status_message,{hash:{},inverse:z.program(30,x,b),fn:z.program(28,y,b),data:b}))||0===c)d+=c;return d+"</span>\n          </span>\n          "}function q(a,b){return" sender_info_hover"}function v(a,b){return"sender_name"}function p(a,b){return"sender-status"}function y(a,b){var c;return C((c=(c=a&&a.msg,null==c||!1===c?c:c.sender_full_name),typeof c===w?c.apply(a):c))}function x(a,
b){var c,d,g;c='<span class="sender_name';g={hash:{},inverse:z.noop,fn:z.program(31,F,b),data:b};(d=e.status_message)?d=d.call(a,g):(d=a&&a.status_message,d=typeof d===w?d.call(a,g):d);e.status_message||(d=E.call(a,d,{hash:{},inverse:z.noop,fn:z.program(31,F,b),data:b}));if(d||0===d)c+=d;c+=' sender_info_hover">'+C((d=(d=a&&a.msg,null==d||!1===d?d:d.sender_full_name),typeof d===w?d.apply(a):d))+"</span>";(d=e.status_message)?d=d.call(a,{hash:{},data:b}):(d=a&&a.status_message,d=typeof d===w?d.call(a,
{hash:{},data:b}):d);if(d||0===d)c+=d;return c}function F(a,b){return"-in-status"}function A(a,b){var d,c;d='\n          <div class="message_edit_notice" title="Edited (';(c=e.last_edit_timestr)?c=c.call(a,{hash:{},data:b}):(c=a&&a.last_edit_timestr,c=typeof c===w?c.call(a,{hash:{},data:b}):c);return d+=C(c)+')">EDITED</div>\n          '}function D(a,b){return" sender-status-controls"}function B(a,b){var d;return(d=(d=(d=a&&a.msg,null==d||!1===d?d:d.match_content),typeof d===w?d.apply(a):d))||0===
d?d:""}function G(a,b){var d;return(d=(d=(d=a&&a.msg,null==d||!1===d?d:d.content),typeof d===w?d.apply(a):d))||0===d?d:""}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var u,I,w="function",C=this.escapeExpression,z=this,E=e.blockHelperMissing,M=e.helperMissing;b=""+('<div zid="'+C((u=(u=a&&a.msg,null==u||!1===u?u:u.id),typeof u===w?u.apply(a):u))+'" id="');(d=e.table_name)?u=d.call(a,{hash:{},data:c}):(d=a&&a.table_name,u=typeof d===w?d.call(a,{hash:{},data:c}):d);b+=C(u)+C((u=
(u=a&&a.msg,null==u||!1===u?u:u.id),typeof u===w?u.apply(a):u))+'"\n  class="message_row';if((u=(u=(u=(u=a&&a.msg,null==u||!1===u?u:u.is_stream),typeof u===w?u.apply(a):u),E.call(a,u,{hash:{},inverse:z.program(1,g,c),fn:z.noop,data:c})))||0===u)b+=u;I={hash:{},inverse:z.noop,fn:z.program(3,f,c),data:c};(d=e.include_sender)?u=d.call(a,I):(d=a&&a.include_sender,u=typeof d===w?d.call(a,I):d);e.include_sender||(u=E.call(a,u,{hash:{},inverse:z.noop,fn:z.program(3,f,c),data:c}));if(u||0===u)b+=u;I={hash:{},
inverse:z.noop,fn:z.program(5,h,c),data:c};(d=e.contains_mention)?u=d.call(a,I):(d=a&&a.contains_mention,u=typeof d===w?d.call(a,I):d);e.contains_mention||(u=E.call(a,u,{hash:{},inverse:z.noop,fn:z.program(5,h,c),data:c}));if(u||0===u)b+=u;I={hash:{},inverse:z.noop,fn:z.program(7,l,c),data:c};(d=e.include_footer)?u=d.call(a,I):(d=a&&a.include_footer,u=typeof d===w?d.call(a,I):d);e.include_footer||(u=E.call(a,u,{hash:{},inverse:z.noop,fn:z.program(7,l,c),data:c}));if(u||0===u)b+=u;if((u=(u=(u=(u=a&&
a.msg,null==u||!1===u?u:u.unread),typeof u===w?u.apply(a):u),E.call(a,u,{hash:{},inverse:z.noop,fn:z.program(9,function(a,b){return" unread"},c),data:c})))||0===u)b+=u;b+=" ";if((u=e["if"].call(a,(u=a&&a.msg,null==u||!1===u?u:u.local_id),{hash:{},inverse:z.noop,fn:z.program(11,function(a,b){return"local"},c),data:c}))||0===u)b+=u;b+=' selectable_row">\n  <div class="unread_marker"><div class="unread-marker-fill"></div></div>\n  <div class="messagebox';I={hash:{},inverse:z.program(13,r,c),fn:z.noop,
data:c};(d=e.include_sender)?u=d.call(a,I):(d=a&&a.include_sender,u=typeof d===w?d.call(a,I):d);e.include_sender||(u=E.call(a,u,{hash:{},inverse:z.program(13,r,c),fn:z.noop,data:c}));if(u||0===u)b+=u;if((u=(u=(u=(u=a&&a.msg,null==u||!1===u?u:u.is_stream),typeof u===w?u.apply(a):u),E.call(a,u,{hash:{},inverse:z.program(1,g,c),fn:z.noop,data:c})))||0===u)b+=u;b+=" ";if((u=e["if"].call(a,a&&a.next_is_same_sender,{hash:{},inverse:z.noop,fn:z.program(15,function(a,b){return"next_is_same_sender"},c),data:c}))||
0===u)b+=u;b+='"\n       style="box-shadow: inset 2px 0px 0px 0px ';if((u=e["if"].call(a,(u=a&&a.msg,null==u||!1===u?u:u.is_stream),{hash:{},inverse:z.program(19,t,c),fn:z.program(17,n,c),data:c}))||0===u)b+=u;b+=", -1px 0px 0px 0px ";if((u=e["if"].call(a,(u=a&&a.msg,null==u||!1===u?u:u.is_stream),{hash:{},inverse:z.program(19,t,c),fn:z.program(17,n,c),data:c}))||0===u)b+=u;b+=';">\n    <div class="messagebox-border">\n      <div class="messagebox-content">\n        <div class="message_top_line">\n          ';
I={hash:{},inverse:z.noop,fn:z.program(21,s,c),data:c};(d=e.include_sender)?u=d.call(a,I):(d=a&&a.include_sender,u=typeof d===w?d.call(a,I):d);e.include_sender||(u=E.call(a,u,{hash:{},inverse:z.noop,fn:z.program(21,s,c),data:c}));if(u||0===u)b+=u;b+='\n          <span class="message_time';if((u=e["if"].call(a,(u=a&&a.msg,null==u||!1===u?u:u.local_id),{hash:{},inverse:z.noop,fn:z.program(33,function(a,b){return" notvisible"},c),data:c}))||0===u)b+=u;if((u=e["if"].call(a,a&&a.status_message,{hash:{},
inverse:z.noop,fn:z.program(35,function(a,b){return" status-time"},c),data:c}))||0===u)b+=u;b+='">';(d=e.timestr)?u=d.call(a,{hash:{},data:c}):(d=a&&a.timestr,u=typeof d===w?d.call(a,{hash:{},data:c}):d);b+=C(u)+"</span>\n          ";if((u=(d=e.if_and||a&&a.if_and,I={hash:{},inverse:z.noop,fn:z.program(37,A,c),data:c},d?d.call(a,a&&a.last_edit_timestr,a&&a.include_sender,I):M.call(a,"if_and",a&&a.last_edit_timestr,a&&a.include_sender,I)))||0===u)b+=u;b+='\n          <div class="message_controls';
I={hash:{},inverse:z.noop,fn:z.program(39,D,c),data:c};(d=e.status_message)?u=d.call(a,I):(d=a&&a.status_message,u=typeof d===w?d.call(a,I):d);e.status_message||(u=E.call(a,u,{hash:{},inverse:z.noop,fn:z.program(39,D,c),data:c}));if(u||0===u)b+=u;b+='">\n            <div class="star">\n              <span class="message_star ';if((u=e["if"].call(a,(u=a&&a.msg,null==u||!1===u?u:u.starred),{hash:{},inverse:z.program(43,function(a,b){return"icon-vector-star-empty empty-star"},c),fn:z.program(41,function(a,
b){return"icon-vector-star"},c),data:c}))||0===u)b+=u;b+='"\n                    title="';if((u=e["if"].call(a,(u=a&&a.msg,null==u||!1===u?u:u.starred),{hash:{},inverse:z.program(47,function(a,b){return"Star"},c),fn:z.program(45,function(a,b){return"Unstar"},c),data:c}))||0===u)b+=u;b+=' this message"></span>\n            </div>\n            <div class="info actions_hover">\n              <i class="icon-vector-chevron-down"></i>\n            </div>\n            <div class="message_failed ';if((u=
e.unless.call(a,(u=a&&a.msg,null==u||!1===u?u:u.failed_request),{hash:{},inverse:z.noop,fn:z.program(49,function(a,b){return"notvisible"},c),data:c}))||0===u)b+=u;b+='">\n              <span class="failed_text">Not delivered </span><i class="icon-vector-refresh refresh-failed-message"></i><i class="icon-vector-pencil edit-failed-message"></i><i class="icon-vector-remove-sign remove-failed-message"></i>\n            </div>\n          </div>\n        </div>\n        <div class="message_content">';if((u=
e.unless.call(a,a&&a.status_message,{hash:{},inverse:z.noop,fn:z.program(51,function(a,b){var d;return(d=e["if"].call(a,a&&a.use_match_properties,{hash:{},inverse:z.program(54,G,b),fn:z.program(52,B,b),data:b}))||0===d?d:""},c),data:c}))||0===u)b+=u;b+="</div>\n        ";if((u=e["if"].call(a,a&&a.last_edit_timestr,{hash:{},inverse:z.noop,fn:z.program(56,function(a,b){var d,c;d="\n          ";if((c=e.unless.call(a,a&&a.include_sender,{hash:{},inverse:z.noop,fn:z.program(37,A,b),data:b}))||0===c)d+=
c;return d+"\n        "},c),data:c}))||0===u)b+=u;return b+='\n        <div class="message_edit">\n          <div class="message_edit_form" id="'+C((u=(u=a&&a.msg,null==u||!1===u?u:u.id),typeof u===w?u.apply(a):u))+'"></div>\n        </div>\n        <div class="message_expander message_length_controller" title="See the rest of this message">[More...]</div>\n        <div class="message_condenser message_length_controller" title="Make this message take up less space on the screen">[Condense this message]</div>\n      </div>\n    </div>\n  </div>\n</div>\n'});
h.admin_streams_list=f(function(b,a,e,d,c){function g(a,b){return'<i class="icon-vector-lock "></i>'}this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};b="";var f=this,h=this.escapeExpression;if((a=e["with"].call(a,a&&a.stream,{hash:{},inverse:f.noop,fn:f.program(1,function(a,b){var d,c;d='\n<tr class="stream_row">\n  <td>\n      ';if((c=e["if"].call(a,a&&a.invite_only,{hash:{},inverse:f.noop,fn:f.program(2,g,b),data:b}))||0===c)d+=c;d+='\n      <span class="stream_name">';(c=e.name)?
c=c.call(a,{hash:{},data:b}):(c=a&&a.name,c="function"===typeof c?c.call(a,{hash:{},data:b}):c);return d+=h(c)+'</span>\n  </td>\n  <td>\n      <button class="btn deactivate btn-danger">\n        Delete stream\n      </button>\n  </td>\n</tr>\n'},c),data:c}))||0===a)b+=a;return b+"\n"});h.message_info_popover_title=f(function(b,a,e,d,c){this.compilerInfo=[4,">= 1.0.0"];e=this.merge(e,b.helpers);c=c||{};var g,f=this.escapeExpression;b="\n";if((g=e["if"].call(a,(g=a&&a.message,null==g||!1===g?g:g.is_stream),
{hash:{},inverse:this.program(3,function(a,b){return"\nPrivate message\n"},c),fn:this.program(1,function(a,b){var d,c;return d=""+("\nMessage to stream <b>"+f((c=(c=a&&a.message,null==c||!1===c?c:c.stream),"function"===typeof c?c.apply(a):c))+"</b>\n")},c),data:c}))||0===g)b+=g;return b+"\n"})})();var feature_flags=function(){var f={};f.do_not_share_the_love=page_params.voyager;f.log_send_times=!1;f.collect_send_times=!1;f.use_socket=!0;f.local_echo=!0;f.disable_message_editing=_.contains(["mit.edu"],page_params.domain);f.full_width=!1;f.new_bot_ui=!1;f.fade_at_stream_granularity=!1;f.cleanup_before_reload=!0;f.fade_users_when_composing=!0;f.mark_read_at_bottom=!0;f.propagate_topic_edits=!0;f.clicking_notification_causes_narrow=!0;f.negated_search=!0;f.collapsible=!1;f.dropbox_integration=
!1;return f}();var loading=function(){return{make_indicator:function(f,h){h=h||{};var b=f;b.empty();if(void 0!==h.abs_positioned&&h.abs_positioned){var a=b.attr("id"),e=$('<div id="'+a+'_box_container"></div>');b.append(e);b=e;e=$('<div id="'+a+'_box"></div>');b.append(e);b=e}a=$('<div class="loading_indicator_spinner"></div>');b.append(a);e=0;void 0!==h.text&&""!==h.text&&(e=$('<span class="loading_indicator_text"></span>'),e.text(h.text),b.append(e),e=20+e.width());b.css({width:38+e,height:38});f.css({display:"block",
"white-space":"nowrap"});b=(new Spinner({lines:8,length:0,width:9,radius:9,speed:1.25,shadow:!1,zIndex:1E3})).spin(a[0]);f.data("spinner_obj",b);f.data("destroying",!1);$(b.el).css({left:"50%",top:"50%"})},destroy_indicator:function(f){if(!f.data("destroying")){f.data("destroying",!0);var h=f.data("spinner_obj");void 0!==h&&h.stop();f.removeData("spinner_obj");f.empty();f.css({width:0,height:0,display:"none"})}}}}();"undefined"!==typeof module&&(module.exports=loading);var util=function(){var f={random_int:function(b,a){return Math.floor(Math.random()*(a-b+1))+b},lower_bound:function(b,a,e,d,c){var g,f;void 0===d?(g=0,f=b.length):(g=a,f=e,a=d,e=c);void 0===e&&(e=function(a,b){return a<b});for(f-=g;0<f;)d=Math.floor(f/2),c=g+d,e(b[c],a,c)?(g=c,g++,f=f-d-1):f=d;return g},same_stream_and_subject:function(b,a){return b.stream.toLowerCase()===a.stream.toLowerCase()&&b.subject.toLowerCase()===a.subject.toLowerCase()},same_major_recipient:function(b,a){if(void 0===b||
void 0===a||b.type!==a.type)return!1;switch(b.type){case "private":return b.reply_to===a.reply_to;case "stream":return b.stream.toLowerCase()===a.stream.toLowerCase()}return!1},same_recipient:function(b,a){if(void 0===b||void 0===a||b.type!==a.type)return!1;switch(b.type){case "private":return b.reply_to===a.reply_to;case "stream":return f.same_stream_and_subject(b,a)}return!1},same_sender:function(b,a){return void 0!==b&&void 0!==a&&b.sender_email===a.sender_email},normalize_recipients:function(b){b=
_.map(b.split(","),$.trim);b=_.filter(b,function(a){return 0<a.length});b.sort();return b.join(",")},robust_uri_decode:function(b){for(var a=b.length;0<a;)try{return decodeURIComponent(b.substring(0,a))}catch(e){if(!(e instanceof URIError))throw e;a--}return""}};f.strcmp=function(){try{return(new Intl.Collator).compare}catch(b){}return function(a,b){return a<b?-1:a>b?1:0}}();f.escape_regexp=function(b){return b.replace(/([.*+?\^=!:${}()|\[\]\/\\])/g,"\\$1")};f.array_compare=function(b,a){if(b.length!==
a.length)return!1;var e;for(e=0;e<b.length;++e)if(b[e]!==a[e])return!1;return!0};var h={};f.CachedValue=function(b){this._value=h;_.extend(this,b)};f.CachedValue.prototype={get:function(){this._value===h&&(this._value=this.compute_value());return this._value},reset:function(){this._value=h}};f.enforce_arity=function(b){return function(){if(b.length!==arguments.length)throw Error("Function '"+b.name+"' called with "+arguments.length+" arguments, but expected "+b.length);return b.apply(this,arguments)}};
f.execute_early=function(b){if(page_params.test_suite)$(document).one("phantom_page_loaded",b);else $(b)};return f}();"undefined"!==typeof module&&(module.exports=util);function Dict(f){this._items={};this._opts=_.extend({},{fold_case:!1},f)}Dict.from=function(f,h){if("object"!==typeof f||null===f)throw new TypeError("Cannot convert argument to Dict");var b=new Dict(h);_.each(f,function(a,e){b.set(e,a)});return b};Dict.from_array=function(f,h){if(!(f instanceof Array))throw new TypeError("Argument is not an array");var b=new Dict(h);_.each(f,function(a){b.set(a,!0)});return b};
(function(){Dict.prototype={_munge:function(f){if(void 0===f)blueslip.error("Tried to call a Dict method with an undefined key.");else return this._opts.fold_case&&(f=f.toLowerCase()),":"+f},clone:function(){var f=new Dict(this._opts);f._items=_.clone(this._items);return f},get:function(f){f=this._items[this._munge(f)];return void 0===f?void 0:f.v},set:function(f,h){this._items[this._munge(f)]={k:f,v:h};return h},setdefault:function(f,h){var b=this._items[this._munge(f)];return void 0===b?this.set(f,
h):b.v},has:function(f){return _.has(this._items,this._munge(f))},del:function(f){return delete this._items[this._munge(f)]},keys:function(){return _.pluck(_.values(this._items),"k")},values:function(){return _.pluck(_.values(this._items),"v")},items:function(){return _.map(_.values(this._items),function(f){return[f.k,f.v]})},num_items:function(){return _.keys(this._items).length},each:function(f){return _.each(this._items,function(h){f(h.v,h.k)})}}})();
"undefined"!==typeof module&&(module.exports=Dict);var localstorage=function(){var f={},h=!1;f.supported=function(){try{return window.hasOwnProperty("localStorage")&&null!==window.localStorage}catch(b){return h||(blueslip.error("Client browser does not support local storage, will lose socket message on reload"),h=!0),!1}};return f}();var channel=function(){function f(a){feature_flags.cleanup_before_reload&&(e.push(a),50<e.length&&blueslip.warn("The length of pending_requests is over 50. Most likely they are not being correctly removed."))}function h(a){feature_flags.cleanup_before_reload&&(a=_.indexOf(e,a),-1!==a&&e.splice(a,1))}function b(a,b){var e=a.error;void 0===e&&(e=function(){});a.error=function(b,c,f){h(b);if(403===b.status)try{-1!==$.parseJSON(b.responseText).msg.indexOf("CSRF Error:")&&reload.initiate({immediate:!0})}catch(k){blueslip.error("Unexpected 403 response from server",
{xhr:b.responseText,args:a},k.stack)}return e(b,c,f)};var m=a.success;void 0===m&&(m=function(){});a.success=function(e,g,k){h(k);if(!e&&b)blueslip.log("Retrying idempotent"+a),setTimeout(function(){var b=$.ajax(a);f(b)},0);else return m(e,g,k)};var k=$.ajax(a);f(k);return k}var a={},e=[];a.abort_all=function(){_.each(e,function(a){a.abort()})};a.get=function(a){var c=_.extend({type:"GET",dataType:"json"},a);return b(c,a.idempotent)};a.post=function(a){var c=_.extend({type:"POST",dataType:"json"},
a);return b(c,a.idempotent)};a.put=function(a){var c=_.extend({type:"PUT",dataType:"json"},a);return b(c,a.idempotent)};a.del=function(a){var c=_.extend({type:"DELETE",dataType:"json"},a);return b(c,a.idempotent)};a.patch=function(b){!1===b.processData?b.data.append("method","PATCH"):b.data=_.extend({},b.data,{method:"PATCH"});return a.post(b,b.idempotent)};a.xhr_error_message=function(a,b){"4"===b.status.toString().charAt(0)&&(a+=": "+$.parseJSON(b.responseText).msg);return a};return a}();var csrf_token;
$(function(){page_params.have_initial_messages&&!page_params.needs_tutorial?loading.make_indicator($("#page_loading_indicator"),{text:"Loading..."}):page_params.needs_tutorial||$("#first_run_message").show();csrf_token=$('input[name="csrfmiddlewaretoken"]').attr("value");$.ajaxSetup({beforeSend:function(f,h){!/^http:.*/.test(h.url)&&!/^https:.*/.test(h.url)&&f.setRequestHeader("X-CSRFToken",csrf_token)}});$("body").ajaxError(function(f,h){401===h.status&&window.location.replace(page_params.login_page)});!1!==
page_params.password_auth_enabled&&$.getScript("/static/third/zxcvbn/zxcvbn.js");"undefined"!==typeof $&&($.fn.expectOne=function(){blueslip&&1!==this.length&&blueslip.error("Expected one element in jQuery set, "+this.length+" found");return this})});var muting=function(){var f={},h=new Dict({fold_case:!0});f.mute_topic=function(b,a){var e=h.get(b);e||(e=new Dict({fold_case:!0}),h.set(b,e));e.set(a,!0)};f.unmute_topic=function(b,a){var e=h.get(b);e&&e.del(a)};f.is_topic_muted=function(b,a){if(void 0===b)return!1;var e=h.get(b);return e&&e.get(a)};f.get_muted_topics=function(){var b=[];h.each(function(a,e){_.each(a.keys(),function(a){b.push([e,a])})});return b};f.set_muted_topics=function(b){h=new Dict({fold_case:!0});_.each(b,function(a){f.mute_topic(a[0],
a[1])})};return f}();"undefined"!==typeof module&&(module.exports=muting);var muting_ui=function(){var f={},h=0;f.rerender=function(){stream_list.update_streams_sidebar();current_msg_list.rerender_after_muting_changes();current_msg_list!==home_msg_list&&home_msg_list.rerender_after_muting_changes()};f.persist_and_rerender=function(){f.rerender();var b={muted_topics:JSON.stringify(muting.get_muted_topics())};h=(new Date).getTime();channel.post({url:"/json/set_muted_topics",idempotent:!0,data:b})};f.handle_updates=function(b){(new Date).getTime()<h+1E3||(muting.set_muted_topics(b),
f.rerender())};$(function(){muting.set_muted_topics(page_params.muted_topics)});return f}();var viewport=function(){function f(a,b,c,d,e,g){_.every(a,function(a){var f=a.getBoundingClientRect();f=e?f.top>c&&(f.bottom<d||f.height>d-c&&f.top<d):f.bottom>c&&f.top<d;return f?(b.push(g(a)),!0):!1})}function h(a,b,c,d,e){var h=m.get()-g.get(),q=Math.floor(h/b);b=[];h=a.prevAll("div."+d+":lt("+q+")");d=a.nextAll("div."+d+":lt("+q+")");f(a,b,g.get(),m.get(),e,c);f(h,b,g.get(),m.get(),e,c);f(d,b,g.get(),m.get(),e,c);return b}function b(b,c){d[b]=new util.CachedValue({compute_value:function(){return c.call(a.message_pane)}});
return function(){return 0!==arguments.length?(d[b].reset(),c.apply(a.message_pane,arguments)):d[b].get()}}var a={},e,d={},c=!1;a.at_top=function(){return 0>=a.scrollTop()};a.message_viewport_info=function(){var a={},b=$(".floating_recipient");a.visible_top=b.offset().top+b.outerHeight();b=$("#compose");a.visible_height=b.position().top-a.visible_top;return a};a.at_bottom=function(){var b=a.scrollTop()+a.height(),c=a.message_pane.prop("scrollHeight");return b+2>=c};a.bottom_message_visible=function(){var a=
rows.last_visible();return a.length?(a=a[0].getBoundingClientRect().bottom,$("#compose")[0].getBoundingClientRect().top>a):!1};a.is_below_visible_bottom=function(b){return b>a.scrollTop()+a.height()-$("#compose").height()};a.set_message_position=function(b,c,d,e){e*=d.visible_height;e+c>d.visible_height&&(e=d.visible_height-c,0>e&&(e=0));c=d.visible_top-a.scrollTop();suppress_scroll_pointer_update=!0;a.scrollTop(b-(e+c))};var g=new util.CachedValue({compute_value:function(){return $(".floating_recipient").offset().top+
$(".floating_recipient").outerHeight()}}),m=new util.CachedValue({compute_value:function(){return $("#compose")[0].getBoundingClientRect().top}});a.visible_groups=function(a){var b=current_msg_list.selected_row();if(void 0===b||0===b.length)return[];b=rows.get_message_recipient_row(b);return h(b,75,function(a){return a},"recipient_row",a)};a.visible_messages=function(a){var b=current_msg_list.selected_row();return h(b,25,function(a){return current_msg_list.get(rows.id($(a)))},"message_row",a)};a.scrollTop=
function(b){var c=a.message_pane.scrollTop();if(void 0===b)return c;var d=a.message_pane.scrollTop(b),e=a.message_pane.scrollTop(),g=$("#bottom_whitespace").offset().top-viewport.height();0<g&&(0<b&&0===c&&0===e)&&(blueslip.info("ScrollTop did nothing when scrolling to "+b+", fixing..."),a.message_pane.scrollTop(1),d=a.message_pane.scrollTop(b),0===a.message_pane.scrollTop()&&blueslip.info("ScrollTop fix did not work when scrolling to "+b+"!  space_to_scroll was "+g));return d};a.set_message_offset=
function(b){var c=current_msg_list.selected_row();a.scrollTop(a.scrollTop()+c.offset().top-b)};a.height=b("height",$(a.message_pane).height);a.width=b("width",$(a.message_pane).width);a.stop_auto_scrolling=function(){c&&a.message_pane.stop()};a.is_narrow=function(){return 975>=window.innerWidth};a.system_initiated_animate_scroll=function(b){suppress_scroll_pointer_update=!0;var d=a.scrollTop();c=!0;a.message_pane.animate({scrollTop:d+b,always:function(){c=!1}})};a.user_initiated_animate_scroll=function(b){suppress_scroll_pointer_update=
!0;c=!1;var d=a.scrollTop();a.message_pane.animate({scrollTop:d+b})};$(function(){e=$(window);a.message_pane=$(".app");e.resize(function(){d.height.reset();d.width.reset();g.reset();m.reset()});$(document).on("compose_started compose_canceled compose_finished",function(){m.reset()})});return a}();var rows=function(){var f={next_visible:function(b){if(void 0===b||0===b.length)return $();var a=b.next(".selectable_row");if(0!==a.length)return a;b=f.get_message_recipient_row(b);b=$(b).nextAll(".recipient_row");return 0===b.length?$():$(".selectable_row:first",b[0])},prev_visible:function(b){if(void 0===b||0===b.length)return $();var a=b.prev(".selectable_row");if(0!==a.length)return a;b=f.get_message_recipient_row(b);b=$(b).prevAll(".recipient_row");return 0===b.length?$():$(".selectable_row:last",
b[0])},first_visible:function(){return $(".focused_table .selectable_row:first")},last_visible:function(){return $(".focused_table .selectable_row:last")},id:function(b){return parseFloat(b.attr("zid"),10)}},h={zhome:!0,zfilt:!0};f.get_table=function(b){return!h.hasOwnProperty(b)?$():$("#"+b)};f.get_closest_group=function(b){return $(b).closest("div.recipient_row")};f.first_message_in_group=function(b){return $("div.message_row:first",b)};f.get_message_recipient_row=function(b){return $(b).parent(".recipient_row").expectOne()};
f.get_message_recipient_header=function(b){return $(b).parent(".recipient_row").find(".message_header").expectOne()};f.recipient_from_group=function(b){return message_store.get(f.id($(b).children(".message_row").first().expectOne()))};f.id_for_recipient_row=function(b){var a=f.first_message_in_group(b);return 0===a.length?f.id(b):f.id(a)};return f}();var unread=function(){var f={},h=new Dict,b=new Dict({fold_case:!0}),a=new Dict;f.suppress_unread_counts=!0;f.message_unread=function(a){return void 0===a?!1:void 0===a.flags||-1===a.flags.indexOf("read")};f.update_unread_subjects=function(a,d){var c=stream_data.canonicalized_name(a.stream),g=stream_data.canonicalized_name(a.subject);if(void 0!==d.subject&&b.has(c)&&b.get(c).has(g)&&b.get(c).get(g).get(a.id)){var f=stream_data.canonicalized_name(d.subject);b.get(c).get(g).del(a.id);0===b.get(c).get(g).num_items()&&
b.get(c).del(g);b.get(c).setdefault(f,new Dict);b.get(c).get(f).set(a.id,!0)}};f.process_loaded_messages=function(e){_.each(e,function(d){if(f.message_unread(d)){"private"===d.type&&(a.setdefault(d.reply_to,new Dict),a.get(d.reply_to).set(d.id,!0));if("stream"===d.type){var c=stream_data.canonicalized_name(d.stream),e=stream_data.canonicalized_name(d.subject);b.setdefault(c,new Dict);b.get(c).setdefault(e,new Dict);b.get(c).get(e).set(d.id,!0)}d.mentioned&&h.set(d.id,!0)}})};f.process_read_message=
function(e){if("private"===e.type){var d=a.get(e.reply_to);d&&d.del(e.id)}if("stream"===e.type){var c=stream_data.canonicalized_name(e.stream),d=stream_data.canonicalized_name(e.subject);if(c=b.get(c))(d=c.get(d))&&d.del(e.id)}h.del(e.id)};f.declare_bankruptcy=function(){a=new Dict;b=new Dict({fold_case:!0})};f.num_unread_current_messages=function(){var a=0;_.each(current_msg_list.all(),function(b){b.id>current_msg_list.selected_id()&&f.message_unread(b)&&(a+=1)});return a};f.get_counts=function(){var e=
{private_message_count:0,home_unread_messages:0};e.mentioned_message_count=h.num_items();e.stream_count=new Dict;e.subject_count=new Dict;e.pm_count=new Dict;b.each(function(a,d){if(!stream_data.is_subscribed(d))return!0;if(b.has(d)){e.subject_count.set(d,new Dict);var f=0;b.get(d).each(function(a,b){var c=a.num_items();e.subject_count.get(d).set(b,c);muting.is_topic_muted(d,b)||(f+=c)});e.stream_count.set(d,f);stream_data.in_home_view(d)&&(e.home_unread_messages+=f)}});var d=0;a.each(function(a,
b){var f=a.num_items();e.pm_count.set(b,f);d+=f});e.private_message_count=d;e.home_unread_messages+=d;narrow.active()?e.unread_in_current_view=f.num_unread_current_messages():e.unread_in_current_view=e.home_unread_messages;return e};f.num_unread_for_subject=function(a,d){var c=0;b.has(a)&&b.get(a).has(d)&&(c=b.get(a).get(d).num_items());return c};f.num_unread_for_person=function(b){return!a.has(b)?0:a.get(b).num_items()};f.update_unread_counts=function(){if(!f.suppress_unread_counts){var a=unread.get_counts();
stream_list.update_dom_with_unread_counts(a);notifications.update_title_count(a.home_unread_messages);notifications.update_pm_count(a.private_message_count)}};f.enable=function(){f.suppress_unread_counts=!1;f.update_unread_counts()};f.mark_all_as_read=function(a){_.each(all_msg_list.all(),function(a){a.flags=a.flags||[];a.flags.push("read")});unread.declare_bankruptcy();f.update_unread_counts();channel.post({url:"/json/update_message_flags",idempotent:!0,data:{messages:JSON.stringify([]),all:!0,op:"add",
flag:"read"},success:a})};f.mark_messages_as_read=function(a,b){b=b||{};var c=!1;_.each(a,function(a){unread.message_unread(a)&&(current_msg_list===narrowed_msg_list&&(unread_messages_read_in_narrow=!0),"server"!==b.from&&message_flags.send_read(a),a.flags=a.flags||[],a.flags.push("read"),a.unread=!1,unread.process_read_message(a,b),home_msg_list.show_message_as_read(a,b),all_msg_list.show_message_as_read(a,b),narrowed_msg_list&&narrowed_msg_list.show_message_as_read(a,b),notifications.close_notification(a),
c=!0)});c&&f.update_unread_counts()};f.mark_message_as_read=function(a,b){f.mark_messages_as_read([a],b)};f.process_visible=function(a){notifications.window_has_focus()&&(feature_flags.mark_read_at_bottom?viewport.bottom_message_visible()&&f.mark_current_list_as_read():f.mark_messages_as_read(viewport.visible_messages(!0)))};f.mark_current_list_as_read=function(a){f.mark_messages_as_read(current_msg_list.all(),a)};return f}();"undefined"!==typeof module&&(module.exports=unread);var stream_list=function(){function f(){if(narrow.active()){var a=narrow.filter().operands("stream");if(a)return a[0]}return!1}function h(a,b,c){var d=b.toLowerCase();return(a=_.find($(a,c),function(a){return $(a).attr("data-name").toLowerCase()===d}))?$(a):$()}function b(a,b){if("stream"===a){var c=stream_data.get_sub(b);return $("#stream_sidebar_"+c.stream_id)}return"private"===a?0>b.indexOf(",")?$("li.user_sidebar_entry[data-email='"+b+"']"):$("li.group-pms-sidebar-entry[data-emails='"+b+"']"):
h("#"+a+"_filters > li",b)}function a(){popovers.hide_all();v=!0;$("#streams_list").expectOne().removeClass("zoom-out");$("#streams_list").expectOne().addClass("zoom-in");p=f();$("#stream_filters li.narrow-filter").each(function(){var a=$(this);a.attr("data-name")===p?a.show():a.hide()})}function e(){popovers.hide_all();v=!1;$("#streams_list").expectOne().removeClass("zoom-in");$("#streams_list").expectOne().addClass("zoom-out");$("#stream_filters li.narrow-filter").show()}function d(a,c){var d=b("stream",
a);return h(".expanded_subjects li.expanded_subject",c,d)}function c(a){var b=stream_data.get_sub(a);a={name:a,id:b.stream_id,uri:narrow.by_stream_uri(a),not_in_home_view:!1===stream_data.in_home_view(a),invite_only:b.invite_only,color:stream_data.get_color(a)};a.dark_background=stream_color.get_color_class(a.color);a=$(templates.render("stream_sidebar_row",a));$("#stream_filters").append(a);return a}function g(a,b,c){0===c?(a.hide(),a.parent().hasClass("subscription_block")?a.parent(".subscription_block").removeClass("stream-with-count"):
a.parent().hasClass("user_sidebar_entry")?a.parent(".user_sidebar_entry").removeClass("user-with-count"):a.parent().hasClass("group-pms-sidebar-entry")&&a.parent(".group-pms-sidebar-entry").removeClass("group-with-count"),b.text("")):(a.show(),a.parent().hasClass("subscription_block")?a.parent(".subscription_block").addClass("stream-with-count"):a.parent().hasClass("user_sidebar_entry")?a.parent(".user_sidebar_entry").addClass("user-with-count"):a.parent().hasClass("group-pms-sidebar-entry")&&a.parent(".group-pms-sidebar-entry").addClass("group-with-count"),
b.text(c))}function m(a,c,d){a=b(a,c).find(".count");c=a.find(".value");g(a,c,d)}function k(a,b){if(0===b)return a.is(":animated")?a.stop(!0,!0).hide():a.hide(500);if(0<b&&1E3>b)return a.show(500),a.text(b);a.show(500);return a.text("1k+")}function l(){popovers.hide_topic_sidebar_popover();$("ul.expanded_subjects").remove()}function r(a,c){l();var e=b("stream",a),g=q._build_subject_list(a,c,5);e.append(g);c&&d(a,c).addClass("active-subject-filter")}function n(a){var c=b("global",a);c.addClass("new_messages");
setTimeout(function(){c.removeClass("new_messages");c.addClass("new_messages_fadeout")},3E3);setTimeout(function(){c.removeClass("new_messages_fadeout")},6E3)}function t(a){a>y&&n("private");y=a}function s(a){a>x&&n("mentioned");x=a}var q={},v=!1,p="",y=0,x=0,F;q.build_stream_list=function(){var a=stream_data.subscribed_streams();if(0!==a.length){var b=40<a.length;a.sort(function(a,c){if(b){if(recent_subjects.has(c)&&!recent_subjects.has(a))return 1;if(!recent_subjects.has(c)&&recent_subjects.has(a))return-1}return util.strcmp(a,
c)});if(!(void 0!==F&&util.array_compare(F,a))){F=a;var c=$("#stream_filters");c.empty();var d=[];_.each(a,function(a){var c=$(stream_data.get_sub(a).sidebar_li);b&&(recent_subjects.has(a)?c.removeClass("inactive_stream"):c.addClass("inactive_stream"));d.push(c.get(0))});$(d).appendTo(c)}}};q.set_in_home_view=function(a,c){var d=b("stream",a);c?d.removeClass("out_of_home_view"):d.addClass("out_of_home_view")};q.add_stream_to_sidebar=function(a){return q.get_stream_li(a).length?!1:c(a)};q.redraw_stream_privacy=
function(a){var b=q.get_stream_li(a),c=b.find(".stream-privacy"),b=b.find(".streamlist_swatch"),d=stream_data.get_sub(a);a=stream_data.get_color(a);a=stream_color.get_color_class(a);a={invite_only:d.invite_only,dark_background:a};d.invite_only?b.addClass("private-stream-swatch"):b.removeClass("private-stream-swatch");b=templates.render("stream_privacy",a);c.html(b)};q.get_stream_li=function(a){return b("stream",a)};q.get_count=function(a,c){return b(a,c).find(".count .value").text()};q.set_subject_count=
function(a,b,c){a=d(a,b).find(".subject_count");b=a.find(".value");0===a.length||0===b.length||(a.removeClass("zero_count"),g(a,b,c))};q.remove_narrow_filter=function(a,c){b(c,a).remove()};q._build_subject_list=function(a,b,c){var d=recent_subjects.get(a)||[];b&&(b=b.toLowerCase());var e=[],g=!1;_.each(d,function(d,f){var h=d.subject,k=unread.num_unread_for_subject(a,d.canon_subject),l=f<c||0<k||b===h;l||(g=!0);h={topic_name:h,unread:k,is_zero:0===k,is_muted:muting.is_topic_muted(a,h),zoom_out_hide:!l,
url:narrow.by_stream_subject_uri(a,h)};e.push(h)});return templates.render("sidebar_subject_list",{subjects:e,want_show_more_topics_links:g,stream:a})};q.update_streams_sidebar=function(){q.build_stream_list();if(narrow.active()){var a=narrow.filter().operands("stream"),b=narrow.filter().operands("topic"),c;0!==a.length&&(0!==b.length&&(c=b[0]),stream_data.is_subscribed(a[0])&&r(a[0],c))}};q.set_presence_list_count=function(a,b){m("private",a,b)};q.update_dom_with_unread_counts=function(a){a.stream_count.each(function(a,
b){m("stream",b,a)});a.subject_count.each(function(a,b){a.each(function(a,c){q.set_subject_count(b,c,a)})});a.pm_count.each(function(a,b){q.set_presence_list_count(b,a)});m("global","private",a.private_message_count);m("global","mentioned",a.mentioned_message_count);m("global","home",a.home_unread_messages);k($("#streamlist-toggle-unreadcount"),a.home_unread_messages);k($("#userlist-toggle-unreadcount"),a.private_message_count);t(a.private_message_count);s(a.mentioned_message_count)};q.rename_stream=
function(a){a.sidebar_li=c(a.name);q.build_stream_list()};$(function(){$(document).on("narrow_activated.zulip",function(a){v&&f()!==p&&e();$("ul.filters li").removeClass("active-filter active-subject-filter");l();var c=a.filter.operands("in");0!==c.length&&-1!==["all","home"].indexOf(c[0])&&$("#global_filters li[data-name='"+c[0]+"']").addClass("active-filter");c=a.filter.operands("is");0!==c.length&&-1!==["private","starred","mentioned"].indexOf(c[0])&&$("#global_filters li[data-name='"+c[0]+"']").addClass("active-filter");
c=a.filter.operands("stream");if(0!==c.length&&stream_data.is_subscribed(c[0])){var d=b("stream",c[0]),g=a.filter.operands("topic"),h;0!==g.length?h=g[0]:d.addClass("active-filter");r(c[0],h);unread.process_visible()}a=a.filter.operands("pm-with");1===a.length&&$("#user_presences li[data-email='"+a[0]+"']").addClass("active-filter")});$(document).on("narrow_deactivated.zulip",function(a){v&&e();$("ul.filters li").removeClass("active-filter active-subject-filter");l();$("#global_filters li[data-name='home']").addClass("active-filter")});
$(document).on("sub_obj_created.zulip",function(a){if(a.sub.subscribed){var b=q.add_stream_to_sidebar(a.sub.name);b&&(a.sub.sidebar_li=b)}});$(document).on("subscription_add_done.zulip",function(a){var b=q.add_stream_to_sidebar(a.sub.name);b&&(a.sub.sidebar_li=b);q.build_stream_list()});$(document).on("subscription_remove_done.zulip",function(a){q.remove_narrow_filter(a.sub.name,"stream");F=void 0});$(".show-all-streams").on("click",function(a){e();a.preventDefault();a.stopPropagation()});$("#stream_filters").on("click",
".show-more-topics",function(b){$(b.target).parents(".show-more-topics").attr("data-name");a();b.preventDefault();b.stopPropagation()});$("#stream_filters").on("click","li .subscription_block",function(a){if(!a.metaKey&&!a.ctrlKey){ui.home_tab_obscured()&&ui.change_tab_to("#home");var b=$(a.target).parents("li").attr("data-name");narrow.by("stream",b,{select_first_unread:!0,trigger:"sidebar"});a.preventDefault();a.stopPropagation()}});$("#stream_filters").on("click",".subject_box",function(a){if(!a.metaKey&&
!a.ctrlKey){ui.home_tab_obscured()&&ui.change_tab_to("#home");var b=$(a.target).parents("ul").attr("data-stream"),c=$(a.target).parents("li").attr("data-name");narrow.activate([{operator:"stream",operand:b},{operator:"topic",operand:c}],{select_first_unread:!0,trigger:"sidebar"});a.preventDefault()}})});return q}();"undefined"!==typeof module&&(module.exports=stream_list);var Filter=function(){function f(a,b,d){switch(b){case "is":if("private"===d)return"private"===a.type;if("starred"===d)return a.starred;if("mentioned"===d)return a.mentioned;if("alerted"===d)return a.alerted;break;case "in":if("home"===d)return a="private"===a.type||a.mentioned||void 0!==page_params.narrow_stream&&a.stream.toLowerCase()===page_params.narrow_stream.toLowerCase()?!0:stream_data.in_home_view(a.stream),a;break;case "id":return a.id.toString()===d;case "stream":if("stream"!==a.type)return!1;
d=d.toLowerCase();return"mit.edu"===page_params.domain?(b=/^(?:un)*(.+?)(?:\.d)*$/i.exec(d),null!==b&&void 0!==b[1]&&(d=b[1]),RegExp(/^(un)*/.source+util.escape_regexp(d)+/(\.d)*$/.source,"i").test(a.stream)):a.stream.toLowerCase()===d;case "topic":if("stream"!==a.type)return!1;d=d.toLowerCase();return"mit.edu"===page_params.domain?(b=/^(.*?)(?:\.d)*$/i.exec(d)[1],(""===b||"personal"===b.toLowerCase()||'(instance "")'===b.toLowerCase()?/^(|personal|\(instance ""\))(\.d)*$/i:RegExp(/^/.source+util.escape_regexp(b)+
/(\.d)*$/.source,"i")).test(a.subject)):a.subject.toLowerCase()===d;case "sender":return a.sender_email.toLowerCase()===d;case "pm-with":return"private"===a.type&&a.reply_to.toLowerCase()===d.split(",").sort().join(",")}return!0}function h(a){this._operators=void 0===a?[]:this._canonicalize_operators(a)}var b={from:"sender",subject:"topic"};h.canonicalize_operator=function(a){a=a.toLowerCase();return b.hasOwnProperty(a)?b[a]:a};h.canonicalize_term=function(a){var b=a.negated,d=a.operator;a=a.operand;
b||(b=!1);d=h.canonicalize_operator(d);switch(d){case "has":a=a.replace(/s$/,"");break;case "stream":a=stream_data.get_name(a);break;case "topic":break;case "sender":case "pm-with":a=a.toString().toLowerCase();"me"===a&&(a=page_params.email);break;case "search":a=a.toString().toLowerCase().replace(/[\u201c\u201d]/g,'"');break;default:a=a.toString().toLowerCase()}return{negated:b,operator:d,operand:a}};h.parse=function(a){var b=[],d=[],c,g,f;a=a.match(/"[^"]+"|\S+/g);if(null===a)return b;_.each(a,
function(a){var h;h=a.split(":");'"'===a[0]||1===h.length?d.push(a):(c=!1,a=h.shift(),feature_flags.negated_search&&"-"===a[0]&&(c=!0,a=a.slice(1)),h=h.join(":"),"pm-with"!==a&&"sender"!==a&&(h=h.replace(/\+/g," ")),g=util.robust_uri_decode(h),f={negated:c,operator:a,operand:g},b.push(f))});0<d.length&&(g=d.join(" "),f={operator:"search",operand:g,negated:!1},b.push(f));return b};h.unparse=function(a){return _.map(a,function(a){return"search"===a.operator?a.operand:(a.negated?"-":"")+a.operator+":"+
a.operand.toString().replace(/%/g,"%25").replace(/\+/g,"%2B").replace(/ /g,"+")}).join(" ")};h.prototype={predicate:function(){void 0===this._predicate&&(this._predicate=this._build_predicate());return this._predicate},operators:function(){return this._operators},public_operators:function(){return _.filter(this._operators,function(a){return!(void 0!==page_params.narrow_stream&&"stream"===a.operator&&a.operand.toLowerCase()===page_params.narrow_stream.toLowerCase())})},operands:function(a){return _.chain(this._operators).filter(function(b){return!b.negated&&
b.operator===a}).map(function(a){return a.operand}).value()},has_operand:function(a,b){return _.any(this._operators,function(d){return!d.negated&&d.operator===a&&d.operand===b})},has_operator:function(a){return _.any(this._operators,function(b){return b.negated&&!_.contains(["search","has"],b.operator)?!1:b.operator===a})},is_search:function(){return this.has_operator("search")},can_apply_locally:function(){return!this.is_search()&&!this.has_operator("has")},_canonicalize_operators:function(a){return _.map(a,
function(a){return h.canonicalize_term(a)})},filter_with_new_topic:function(a){var b=_.map(this._operators,function(b){b=_.clone(b);"topic"===b.operator&&!b.negated&&(b.operand=a);return b});return new h(b)},has_topic:function(a,b){return this.has_operand("stream",a)&&this.has_operand("topic",b)},_build_predicate:function(){var a=this._operators;return!this.can_apply_locally()?function(){return!0}:function(b){return _.all(a,function(a){var c=f(b,a.operator,a.operand);a.negated&&(c=!c);return c})}}};
h.operator_to_prefix=function(a,b){var d;if("search"===a)return b?"Exclude":"Search for";d=b?"Exclude ":"Narrow to ";switch(a){case "stream":return d+"stream";case "near":return d+"messages around";case "has":return d+"messages with one or more";case "id":return d+"message ID";case "topic":return d+"topic";case "sender":return d+"messages sent by";case "pm-with":return d+"private messages with";case "in":return d+"messages in"}return""};h.describe=function(a){if(0===a.length)return"Go to Home view";
var b=[];2<=a.length&&("stream"===a[0].operator&&!a[0].negated&&"topic"===a[1].operator&&!a[1].negated)&&(b=["Narrow to "+a[0].operand+" > "+a[1].operand],a=a.slice(2));a=_.map(a,function(a){var b=a.operand,e=h.canonicalize_operator(a.operator);if("is"===e){a=a.negated?"Exclude ":"Narrow to ";if("private"===b)return a+"all private messages";if("starred"===b)return a+"starred messages";if("mentioned"===b)return a+"mentioned messages";if("alerted"===b)return a+"alerted messages"}else if(a=h.operator_to_prefix(e,
a.negated),""!==a)return a+" "+b;return"Narrow to (unknown operator)"});return b.concat(a).join(", ")};return h}();"undefined"!==typeof module&&(module.exports=Filter);var narrow=function(){function f(a){var b=new Dict,d=new Dict;_.each(a,function(a){var c=a.operator;b.has(c)?d.del(c):(d.set(c,a.operand),b.set(c,!0))});return d}function h(a){void 0===a.network_time||(void 0===a.initial_core_time||void 0===a.initial_free_time)||channel.post({url:"/json/report_narrow_time",data:{initial_core:(a.initial_core_time-a.start_time).toString(),initial_free:(a.initial_free_time-a.start_time).toString(),network:(a.network_time-a.start_time).toString()}})}function b(){var a=
$("#empty_narrow_message");if(void 0===e)return a;var b=e.operators()[0],d=b.operator,b=b.operand;if("is"===d){if("starred"===b)return $("#empty_star_narrow_message");if("mentioned"===b)return $("#empty_narrow_all_mentioned");if("private"===b)return $("#empty_narrow_all_private_message")}else{if("stream"===d&&!stream_data.is_subscribed(b))return $("#nonsubbed_stream_narrow_message");if("search"===d)return $("#empty_search_narrow_message");if("pm-with"===d)return-1===b.indexOf(",")?$("#empty_narrow_private_message"):
$("#empty_narrow_multi_private_message")}return a}var a={},e,d;a._set_current_filter=function(a){e=a};a.active=function(){return void 0!==e};a.filter=function(){return e};a.predicate=function(){return void 0===e?function(){return!0}:e.predicate()};a.operators=function(){return void 0===e?(new Filter(page_params.narrow)).operators():e.operators()};a.public_operators=function(){return void 0===e?void 0:e.public_operators()};a.search_string=function(){return Filter.unparse(a.operators())};a.set_compose_defaults=
function(b){var d=f(a.operators());d.has("stream")&&(b.stream=stream_data.get_name(d.get("stream")));d.has("topic")&&(b.subject=d.get("topic"));d.has("pm-with")&&(b.private_message_recipient=d.get("pm-with"))};a.stream=function(){if(void 0!==e){var a=e.operands("stream");if(1===a.length)return a[0]}};a.activate=function(b,d){function f(){if(!narrowed_msg_list.empty()){if(d.select_first_unread){s=narrowed_msg_list.last().id;var a=_.find(narrowed_msg_list.all(),unread.message_unread);a&&(s=a.id)}a=
!d.select_first_unread&&void 0!==narrowed_msg_list.get(s)&&void 0!==q;narrowed_msg_list.select_id(s,{then_scroll:!a,use_closest:!0,force_rerender:!0});a&&viewport.set_message_offset(q)}}var k=new Date,l=a.active();notifications.clear_compose_notifications();if(0===b.length)return a.deactivate();var r=new Filter(b),n=r.operators();blueslip.debug("Narrowed",{operators:_.map(n,function(a){return a.operator}),trigger:d?d.trigger:void 0,previous_id:current_msg_list.selected_id()});var t=compose.has_message_content();
t?compose_fade.update_message_list():compose.cancel();d=_.defaults({},d,{then_select_id:home_msg_list.selected_id(),select_first_unread:!1,first_unread_from_server:!1,from_reload:!1,change_hash:!0,trigger:"unknown"});r.has_operator("near")&&(d.then_select_id=parseInt(r.operands("near")[0],10),d.select_first_unread=!1);r.has_operator("id")&&(d.then_select_id=parseInt(r.operands("id")[0],10),d.select_first_unread=!1);-1===d.then_select_id&&!d.first_unread_from_server&&(blueslip.warn("Setting then_select_id to page_params.initial_pointer."),
d.then_select_id=page_params.initial_pointer,d.select_first_unread=!1);var s=d.then_select_id,q;l||(unread_messages_read_in_narrow=!1);!d.select_first_unread&&0<current_msg_list.get_row(s).length&&(q=current_msg_list.get_row(s).offset().top);e=r;l=a.muting_enabled();-1!==current_msg_list.selected_id()&&(0===current_msg_list.selected_row().length&&blueslip.debug("narrow.activate missing selected row",{selected_id:current_msg_list.selected_id(),selected_idx:current_msg_list.selected_idx(),selected_idx_exact:current_msg_list._items.indexOf(current_msg_list.get(current_msg_list.selected_id())),
render_start:current_msg_list.view._render_win_start,render_end:current_msg_list.view._render_win_end}),current_msg_list.pre_narrow_offset=current_msg_list.selected_row().offset().top);d.first_unread_from_server&&d.from_reload&&(s=page_params.initial_narrow_pointer,q=page_params.initial_narrow_offset,d.first_unread_from_server=!1,d.select_first_unread=!1,home_msg_list.pre_narrow_offset=page_params.initial_offset);var v=new MessageList("zfilt",e,{collapse_messages:!e.is_search(),muting_enabled:l});
v.start_time=k;$("body").addClass("narrowed_view");$("#zfilt").addClass("focused_table");$("#zhome").removeClass("focused_table");current_msg_list=narrowed_msg_list=v;void 0!==all_msg_list.get(s)&&e.can_apply_locally()&&message_store.add_messages(all_msg_list.all(),narrowed_msg_list,{delay_render:!0});var p=narrowed_msg_list.empty();message_store.load_old_messages({anchor:s.toFixed(),num_before:50,num_after:50,msg_list:narrowed_msg_list,use_first_unread_anchor:d.first_unread_from_server,cont:function(a){ui.hide_loading_more_messages_indicator();
p&&f();v.network_time=new Date;h(v)},cont_will_add_messages:!1});p?ui.show_loading_more_messages_indicator():(message_store.reset_load_more_status(),f());d.change_hash&&hashchange.save_narrow(n);$("#search_query").val(Filter.unparse(n));search.update_button_visibility();!t&&("sidebar"===d.trigger&&a.narrowed_by_reply())&&(a.narrowed_to_topic()?compose.start("stream"):compose.start("private"));$(document).trigger($.Event("narrow_activated.zulip",{msg_list:narrowed_msg_list,filter:e,trigger:d.trigger}));
v.initial_core_time=new Date;setTimeout(function(){v.initial_free_time=new Date;h(v)},0)};a.by=function(b,d,e){a.activate([{operator:b,operand:d}],e)};a.by_subject=function(b,d){var e=message_store.get(b);"stream"!==e.type?a.by_recipient(b,d):(unread.mark_message_as_read(e),e=[{operator:"stream",operand:e.stream},{operator:"topic",operand:e.subject}],d=_.defaults({},d,{then_select_id:b}),a.activate(e,d))};a.by_recipient=function(b,d){d=_.defaults({},d,{then_select_id:b});var e=message_store.get(b);
unread.mark_message_as_read(e);switch(e.type){case "private":a.by("pm-with",e.reply_to,d);break;case "stream":a.by("stream",e.stream,d)}};a.by_time_travel=function(a,b){b=_.defaults({},b,{then_select_id:a});narrow.activate([{operator:"near",operand:a}],b)};a.by_id=function(a,b){b=_.defaults({},b,{then_select_id:a});narrow.activate([{operator:"id",operand:a}],b)};a.by_conversation_and_time=function(a,b){var d=[{operator:"near",operand:a}],e=message_store.get(a);b=_.defaults({},b,{then_select_id:a});
"stream"!==e.type?d.push({operator:"pm-with",operand:e.reply_to}):(d.push({operator:"stream",operand:e.stream}),d.push({operator:"topic",operand:e.subject}));narrow.activate(d,b)};a.deactivate=function(){if(void 0!==e)if(d={start_time:new Date},blueslip.debug("Unnarrowed"),ui.actively_scrolling())setTimeout(a.deactivate,50);else{compose.has_message_content()||compose.cancel();e=void 0;a.hide_empty_narrow_message();$("body").removeClass("narrowed_view");$("#zfilt").removeClass("focused_table");$("#zhome").addClass("focused_table");
current_msg_list=home_msg_list;condense.condense_and_collapse($("#zhome tr.message_row"));$("#search_query").val("");message_store.reset_load_more_status();hashchange.save_narrow();if(-1!==current_msg_list.selected_id()){var b=0<current_msg_list.selected_row().length&&void 0!==current_msg_list.pre_narrow_offset,g={then_scroll:!0,use_closest:!0,empty_ok:!0};unread_messages_read_in_narrow?b=(b=_.find(current_msg_list.all(),unread.message_unread))?b.id:current_msg_list.last().id:(b&&(g.target_scroll_offset=
current_msg_list.pre_narrow_offset),b=current_msg_list.selected_id());current_msg_list.select_id(b,g)}compose_fade.update_message_list();$(document).trigger($.Event("narrow_deactivated.zulip",{msg_list:current_msg_list}));d.initial_core_time=new Date;setTimeout(function(){d.initial_free_time=new Date;void 0===d||(void 0===d.start_time||void 0===d.initial_core_time||void 0===d.initial_free_time)||(channel.post({url:"/json/report_unnarrow_time",data:{initial_core:(d.initial_core_time-d.start_time).toString(),
initial_free:(d.initial_free_time-d.start_time).toString()}}),d={})})}};a.restore_home_state=function(){ui.home_tab_obscured()||a.deactivate();maybe_scroll_to_selected()};a.show_empty_narrow_message=function(){$(".empty_feed_notice").hide();b().show()};a.hide_empty_narrow_message=function(){$(".empty_feed_notice").hide()};a.pm_with_uri=function(a){return"#narrow/pm-with/"+hashchange.encodeHashComponent(a)};a.by_sender_uri=function(a){return"#narrow/sender/"+hashchange.encodeHashComponent(a)};a.by_stream_uri=
function(a){return"#narrow/stream/"+hashchange.encodeHashComponent(a)};a.by_stream_subject_uri=function(a,b){return"#narrow/stream/"+hashchange.encodeHashComponent(a)+"/subject/"+hashchange.encodeHashComponent(b)};a.by_message_uri=function(a){return"#narrow/id/"+hashchange.encodeHashComponent(a)};a.by_near_uri=function(a){return"#narrow/near/"+hashchange.encodeHashComponent(a)};a.by_conversation_and_time_uri=function(a){return"stream"===a.type?"#narrow/stream/"+hashchange.encodeHashComponent(a.stream)+
"/subject/"+hashchange.encodeHashComponent(a.subject)+"/near/"+hashchange.encodeHashComponent(a.id):"#narrow/pm-with/"+hashchange.encodeHashComponent(a.reply_to)+"/near/"+hashchange.encodeHashComponent(a.id)};a.narrowed_to_pms=function(){return void 0===e?!1:e.has_operator("pm-with")||e.has_operand("is","private")};a.narrowed_by_reply=function(){if(void 0===e)return!1;var a=e.operators();return 1===a.length&&1===e.operands("pm-with").length||2===a.length&&1===e.operands("stream").length&&1===e.operands("topic").length};
a.narrowed_to_topic=function(){return void 0===e?!1:e.has_operator("stream")&&e.has_operator("topic")};a.narrowed_to_search=function(){return void 0!==e&&e.is_search()};a.muting_enabled=function(){return!a.narrowed_to_topic()&&!a.narrowed_to_search()&&!a.narrowed_to_pms()};return a}();"undefined"!==typeof module&&(module.exports=narrow);var reload=function(){function f(a){a&&(a.clear(),a._items=[{id:1}])}function h(b,c,e){if(!a){c&&(void 0===b&&(b=0),b="#reload:send_after_reload="+Number(b),b+="+csrf_token="+encodeURIComponent(csrf_token),"stream"===compose.composing()?(b=b+"+msg_type=stream"+("+stream="+encodeURIComponent(compose.stream_name())),b+="+subject="+encodeURIComponent(compose.subject())):"private"===compose.composing()&&(b+="+msg_type=private",b+="+recipient="+encodeURIComponent(compose.recipient())),compose.composing()&&
(b+="+msg="+encodeURIComponent(compose.message_content())),c=home_msg_list.selected_id(),-1!==c&&(b+="+pointer="+c),c=home_msg_list.selected_row(),narrow.active()?(b+="+offset="+home_msg_list.pre_narrow_offset,c=narrowed_msg_list.selected_id(),-1!==c&&(b+="+narrow_pointer="+c),c=narrowed_msg_list.selected_row(),0<c.length&&(b+="+narrow_offset="+c.offset().top)):0<c.length&&(b+="+offset="+c.offset().top),c=window.location.hash,0!==c.length&&"#"===c[0]&&(c=c.slice(1)),b+="+oldhash="+encodeURIComponent(c),
window.location.replace(b));void 0===e&&(e="Reloading");ui.report_message(e,$("#reloading-application"));blueslip.log("Starting server requested page reload");a=!0;if(feature_flags.cleanup_before_reload)try{$("*").off(),channel.abort_all(),$("#main_div").empty(),server_events.cleanup_event_queue(),f(all_msg_list),f(home_msg_list),f(narrowed_msg_list),message_store.clear()}catch(h){blueslip.error("Failed to cleanup before reloading",void 0,h.stack)}window.location.reload(!0)}}var b={},a=!1,e=!1;b.is_pending=
function(){return e};b.is_in_progress=function(){return a};b.initialize=function(){var a=window.location.toString(),a=a.substring(a.indexOf("#")+1);if(0===a.search("reload:")){var a=a.replace(/^reload:/,""),a=a.split("+"),b={};_.each(a,function(a){a=a.split("=");b[a[0]]=decodeURIComponent(a[1])});if(b.csrf_token===csrf_token){void 0!==b.msg&&(a=parseInt(b.send_after_reload,10),compose.start(b.msg_type,{stream:b.stream||"",subject:b.subject||"",private_message_recipient:b.recipient||"",content:b.msg||
""}),a&&compose.finish());if(a=parseInt(b.pointer,10))page_params.orig_initial_pointer=page_params.initial_pointer,page_params.initial_pointer=a;if(a=parseInt(b.offset,10))page_params.initial_offset=a;if(a=parseInt(b.narrow_pointer,10))page_params.initial_narrow_pointer=a;if(a=parseInt(b.narrow_offset,10))page_params.initial_narrow_offset=a;activity.new_user_input=!1;hashchange.changehash(b.oldhash)}}};b.initiate=function(a){function b(){h(!1,a.save_state,a.message)}a=_.defaults({},a,{immediate:!1,
save_state:!0,send_after_reload:!1});a.immediate&&h(a.send_after_reload,a.save_state,a.message);if(!e){e=!0;var g,f=18E5+util.random_int(0,3E5),k=3E5+util.random_int(0,6E4),l=6E4+util.random_int(0,6E4),r,n;setTimeout(b,f);r=function(){g.cancel();g=$(document).idle({idle:l,onIdle:b});$(document).off("compose_canceled.zulip compose_finished.zulip",r);$(document).on("compose_started.zulip",n)};n=function(){g.cancel();g=$(document).idle({idle:k,onIdle:b});$(document).off("compose_started.zulip",n);$(document).on("compose_canceled.zulip compose_finished.zulip",
r)};compose.composing()?(g=$(document).idle({idle:k,onIdle:b}),$(document).on("compose_canceled.zulip compose_finished.zulip",r)):(g=$(document).idle({idle:l,onIdle:b}),$(document).on("compose_started.zulip",n))}};window.addEventListener("beforeunload",function(){a=!0});return b}();var compose_fade=function(){function f(){rows.get_table(current_msg_list.table_name).find(".recipient_row, .message_row").removeClass("faded").removeClass("unfaded");k=!0;floating_recipient_bar.update()}function h(){feature_flags.fade_users_when_composing&&$(".user_sidebar_entry").removeClass("faded").removeClass("unfaded")}function b(a,b){b?a.removeClass("unfaded").addClass("faded"):a.removeClass("faded").addClass("unfaded")}function a(){var a,c,d=!1,e=viewport.visible_groups(!1);k=!1;for(a=0;a<
e.length;a++)c=rows.first_message_in_group(e[a]),c=current_msg_list.get(rows.id(c)),d=!l(m,c),b($(e[a]),d);setTimeout(function(c,e){var g=rows.get_table(current_msg_list.table_name).find(".recipient_row");if(!(current_msg_list!==c||!compose.composing()||compose.recipient()!==e)){d=!1;for(a=0;a<g.length;a++){var f=$(g[a]);d=!l(m,rows.recipient_from_group(f));b(f,d)}floating_recipient_bar.update()}},0,current_msg_list,compose.recipient())}function e(){feature_flags.fade_users_when_composing&&_.forEach($(".user_sidebar_entry"),
function(a){a=$(a);var b=g.would_receive_message(a.attr("data-email"));!0===b?a.addClass("unfaded").removeClass("faded"):!1===b?a.addClass("faded").removeClass("unfaded"):a.removeClass("faded").removeClass("unfaded")})}function d(){return void 0===m||"stream"===m.type&&(!stream_data.get_sub(m.stream)||""===m.subject)?!0:"private"===m.type&&""===m.reply_to}function c(){d()?k||(f(),h()):(a(),e())}var g={},m,k=!1,l=feature_flags.fade_at_stream_granularity?util.same_major_recipient:util.same_recipient;
g.set_focused_recipient=function(a){void 0===a&&(m=void 0);m={type:a};"stream"===m.type?(m.stream=$("#stream").val(),m.subject=$("#subject").val()):m.reply_to=util.normalize_recipients($("#private_message_recipient").val())};g.would_receive_message=function(a){if(a===page_params.email)return!0;if("stream"===m.type){var b=people.realm_get(a),c=stream_data.get_sub(m.stream);return b&&c&&b.is_bot&&!c.invite_only?void 0:stream_data.user_is_subscribed(m.stream,a)}return-1!==m.reply_to.split(",").indexOf(a)};
g.update_faded_users=function(){d()?h():e()};g.update_faded_messages=_.debounce(c,50);g.start_compose=function(a){g.set_focused_recipient(a);c()};g.clear_compose=function(){m=void 0;f();h()};g.update_message_list=function(){d()?f():a()};g.update_rendered_message_groups=function(a,c){d()||_.each(a,function(a){var d=c(a);a=!l(m,a.message_containers[0].msg);b(d,a)})};$(function(){$(document).on("peer_subscribe.zulip",function(a){g.update_faded_users()});$(document).on("peer_unsubscribe.zulip",function(a){g.update_faded_users()})});
return g}();var fenced_code=function(){function f(a){a=a.split("\n\n");var b=[];_.each(a,function(a){a=a.split("\n");b.push(_.map(_.reject(a,function(a){return""===a}),function(a){return"> "+a}).join("\n"))});return b.join("\n\n")}var h={},b=/^(~{3,}|`{3,})[ ]*(\{?\.?([a-zA-Z0-9_+-]*)\}?[ ]*)$/,a=function(a){return a},e=function(a){return a};h.set_stash_func=function(b){a=b};h.set_escape_func=function(a){e=a};h.process_fenced_code=function(d){function c(b,c,d){return function(){var g=[];return"quote"===d?{handle_line:function(a){a===
c?this.done():k(g,a)},done:function(){var a=f(g.join("\n"));b.push("");b.push(a);b.push("");h.pop()}}:{handle_line:function(a){a===c?this.done():g.push(a)},done:function(){var c;c=g.join("\n");for(c+="\n";2<c.length&&"\n\n"===c.substr(c.length-2);)c=c.substring(0,c.length-1);c='<div class="codehilite"><pre>'+e(c)+"</pre></div>\n";c=a(c,!0);b.push("");b.push(c);b.push("");h.pop()}}}()}d=d.split("\n");var g=[],h=[],k;k=function(a,d){var e=b.exec(d);e?(e=c(a,e[1],e[3]),h.push(e)):a.push(d)};var l=function(){return{handle_line:function(a){k(g,
a)},done:function(){h.pop()}}}();h.push(l);for(_.each(d,function(a){h[h.length-1].handle_line(a)});0!==h.length;)h[h.length-1].done();2<g.length&&""!==g[g.length-2]&&g.push("");return g.join("\n")};return h}();"undefined"!==typeof module&&(module.exports=fenced_code);var echo=function(){function f(a,b){a.content=a.raw_content;var c=b.find(".refresh-failed-message");c.toggleClass("rotating",!0);a.queue_id=page_params.event_queue_id;var d=new Date;compose.transmit_message(a,function(b){c.toggleClass("rotating",!1);b=b.id;c.toggleClass("rotating",!1);compose.send_message_success(a.local_id,b,d,!0);message_store.get(b).failed_request=!1;ui.show_failed_message_success(b)},function(b){n.message_send_error(a.local_id,b);c.toggleClass("rotating",!1);blueslip.log("Manual resend of message failed")})}
function h(a){var b=["read"];(-1<a.content.indexOf('data-user-email="'+page_params.email+'"')||-1<a.content.indexOf('data-user-email="*"'))&&b.push("mentioned");0===a.raw_content.indexOf("/me ")&&(0===a.content.indexOf("<p>")&&a.content.lastIndexOf("</p>")===a.content.length-4)&&b.push("is_me_message");a.flags=b}function b(a){var b=a.subject,c=[];_.each(v,function(a){var d=a[0];a=a[1];for(var e;null!==(e=d.exec(b));){var g=1,f=a;_.each(e.slice(1),function(a){f=f.replace("\\"+g,a);g++});c.push(f)}});
a.subject_links=c}function a(){var a=page_params.max_message_id;"undefined"!==typeof all_msg_list&&void 0!==all_msg_list.last()&&(a=all_msg_list.last().id);a=Math.max(0,a);return parseFloat((a+0.01).toFixed(3))}function e(a,c){var d=$.extend({},a);d.raw_content=d.content;d.content=n.apply_markdown(d.content);d.content_type="text/html";d.sender_email=page_params.email;d.sender_full_name=page_params.fullname;d.avatar_url=page_params.avatar_url;d.timestamp=(new XDate).getTime()/1E3;d.local_id=c;d.id=
d.local_id;h(d);b(d);t[d.local_id]=d;s[d.local_id]=d;if("stream"===d.type)d.display_recipient=d.stream;else{var e=a.private_message_recipient.split(",");d.display_recipient=_.map(e,function(a){a=a.trim();var b=people.get_by_email(a);return void 0!==b?b:{email:a,full_name:a,skeleton:!0}})}message_store.insert_new_messages([d]);return d.local_id}function d(a){_.each([all_msg_list,home_msg_list,current_msg_list],function(b){b.remove_and_rerender([a])})}function c(a){message_edit.start_local_failed_edit(current_msg_list.get_row(a.local_id),
a)}function g(a,b){return a.replace(!b?/&(?!#?\w+;)/g:/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function m(a){var b=":"+a+":";return emoji.emojis_by_name.hasOwnProperty(a)?'<img alt="'+b+'" class="emoji" src="'+emoji.emojis_by_name[a]+'" title="'+b+'">':b}function k(a){var b=people.get_by_name(a);if(void 0!==b)return'<span class="user-mention" data-user-email="'+b.email+'">@'+b.full_name+"</span>";if("all"===a||"everyone"===a)return'<span class="user-mention" data-user-email="*">@'+
a+"</span>"}function l(a,b){var c=q[a],d=1;_.each(b,function(a){c=c.replace("\\"+d,a);d++});return c}function r(a,b){for(var c=/\(?P<([^>]+?)>/g,d=c.exec(a),e=1;d;)d=d[1],a=a.replace("(?P<"+d+">","("),b=b.replace("%("+d+")s","\\"+e),d=c.exec(a),e++;var g="g",c=/\(\?([iLmsux]+)\)/;if(d=c.exec(a))d=d[1].split(""),_.each(d,function(a){-1!=="im".indexOf(a)&&(g+=a)}),a=a.replace(c,"");return[RegExp(a,g),b]}var n={},t={},s={},q={},v=[],p=!1,y=[/[^\s]*(?:\.bmp|\.gif|\.jpg|\.jpeg|\.png|\.webp)\s+/m,/[^\s]*(?:\.bmp|\.gif|\.jpg|\.jpeg|\.png|\.webp)$/m,
/[^\s]*(?:twitter|youtube).com\/[^\s]*/,/!avatar\([^)]+\)/,/!gravatar\([^)]+\)/];n.contains_bugdown=function(a){return void 0!==_.find(y,function(b){return b.test(a)})};n.apply_markdown=function(a){return marked(a+"\n\n").trim()};n._add_subject_links=b;n._add_message_flags=h;n.try_deliver_locally=function(b){var c=a();if(0===c%1)blueslip.error("Incremented local id to next integer---100 local messages queued");else return n.contains_bugdown(b.content)||narrow.active()&&!narrow.filter().can_apply_locally()?
void 0:e(b,c)};n.edit_locally=function(a,b,c){a.raw_content=b;void 0!==c&&(message_store.process_message_for_recent_subjects(a,!0),a.subject=c,message_store.process_message_for_recent_subjects(a));a.content=n.apply_markdown(b);home_msg_list.view.rerender_messages([a]);current_msg_list===narrowed_msg_list&&narrowed_msg_list.view.rerender_messages([a]);stream_list.update_streams_sidebar()};n.reify_message_id=function(a,b){var c=t[a];delete t[a];void 0!==c&&(c.id=b,delete c.local_id,$(document).trigger($.Event("message_id_changed",
{old_id:a,new_id:b})))};n.process_from_server=function(a){var b=!1,c=[],d=[];a=_.filter(a,function(a){n.reify_message_id(a.local_id,a.id);var e=s[a.local_id];if(void 0!==e){e.content!==a.content&&(e.content=a.content,b=!0,compose.mark_rendered_content_disparity(a.id,!0));if("private"===e.type){var g=get_private_message_recipient(a,"full_name","email");e.display_reply_to!==g&&(e.display_reply_to=g,_.each(a.display_recipient,function(a){people.get_by_email(a.email).full_name!==a.full_name&&people.reify(a)}),
b=!0)}d.push(e);c.push(e.id);compose.report_as_received(e);delete s[e.id];return!1}return!0});b?(home_msg_list.view.rerender_messages(d),current_msg_list===narrowed_msg_list&&narrowed_msg_list.view.rerender_messages(d)):_.each(c,function(a){ui.show_local_message_arrived(a)});return a};n.message_send_error=function(a,b){message_store.get(a).failed_request=!0;ui.show_message_failed(a,b)};n.set_realm_filters=function(a){if(feature_flags.local_echo){q={};v=[];var b=[];_.each(a,function(a){a=r(a[0],a[1]);
q[a[0]]=a[1];v.push([a[0],a[1]]);b.push(a[0])});marked.InlineLexer.rules.zulip.realm_filters=b}};$(function(){function a(b,c){b[c]={exec:function(a){return!1}}}function b(a,c){$("#main_div").on("click","."+a+"-failed-message",function(a){a.stopPropagation();popovers.hide_all();a=$(this).closest(".message_row");var b=rows.id(a),d=s[b];void 0===d?blueslip.warn("Got resend or retry on failure request but did not find message in ack list "+b):c(d,a)})}var e=new marked.Renderer;e.code=function(a,b){return"quote"===
b?"<blockquote>\n<p>"+g(a,!0)+"</p>\n</blockquote>\n\n\n":'<div class="codehilite"><pre>'+g(a,!0)+"\n</pre></div>\n\n\n"};e.link=function(a,b,c){return'<a href="'+a+'" target="_blank" title="'+(b||a)+'">'+c+"</a>"};e.br=function(){return"<br>\n"};marked.Lexer.rules.tables.list=/^( *)((?:\*)) [\s\S]+?(?:\n+(?=(?: *[\-*_]){3,} *(?:\n+|$))|\n{2,}(?! )(?!\1(?:\*) )\n*|\s*$)/;a(marked.Lexer.rules.tables,"heading");a(marked.Lexer.rules.tables,"lheading");marked.InlineLexer.rules.zulip.strong=/^\*\*([\s\S]+?)\*\*(?!\*)/;
a(marked.InlineLexer.rules.zulip,"em");a(marked.InlineLexer.rules.zulip,"del");a(marked.InlineLexer.rules.zulip,"autolink");n.set_realm_filters(page_params.realm_filters);fenced_code.set_stash_func(function(a){return marked.stashHtml(a,!0)});fenced_code.set_escape_func(g);marked.setOptions({gfm:!0,tables:!0,breaks:!0,pedantic:!1,sanitize:!0,smartLists:!0,smartypants:!1,zulip:!0,emojiHandler:m,userMentionHandler:k,realmFilterHandler:l,renderer:e,preprocessors:[function(a){return fenced_code.process_fenced_code(a)}]});
b("remove",d);b("refresh",f);b("edit",c);$(document).on("home_view_loaded.zulip",function(){p=!0})});$(document).on("socket_loaded_requests.zulip",function(b,c){function d(){_.each(g,function(a){e(a,a.local_id)})}var g=[],f=a();_.each(c.requests,function(a,b){var c=a.msg;void 0===c.stream||void 0===c.local_id||(c.local_id=f,c.queue_id=page_params.event_queue_id,f=parseFloat((f+0.01).toFixed(3)),g.push(c))});if(p)d();else $(document).on("home_view_loaded.zulip",function(){d()})});return n}();
"undefined"!==typeof module&&(module.exports=echo);var Socket=function(){function f(b){this.url=b;this._is_reconnecting=this._is_authenticated=this._is_open=!1;this._reconnect_initiation_time=null;this._connection_failures=this._next_req_id_counter=0;this._heartbeat_timeout_id=this._reconnect_timeout_id=null;this._localstorage_requests_key="zulip_socket_requests";this._requests=this._localstorage_requests();var a=this;this._is_unloading=!1;$(window).on("unload",function(){a._is_unloading=!0});$(document).on("unsuspend",function(){a._try_to_reconnect({reason:"unsuspend"})});
0!==Object.keys(this._requests).length&&$(document).trigger("socket_loaded_requests.zulip",{requests:this._requests});this._supported_protocols="websocket xdr-streaming xhr-streaming xdr-polling xhr-polling jsonp-polling".split(" ");page_params.test_suite?this._supported_protocols=_.reject(this._supported_protocols,function(a){return"xhr-streaming"===a}):this._create_sockjs_object()}var h={none_given:{code:4E3,msg:"No reason provided"},no_heartbeat:{code:4001,msg:"Missed too many heartbeats"},auth_fail:{code:4002,
msg:"Authentication failed"},ack_timeout:{code:4003,msg:"ACK timeout"},cant_send:{code:4004,msg:"User attempted to send while Socket was not ready"},unsuspend:{code:4005,msg:"Got unsuspend event"}};f.prototype={_create_sockjs_object:function(){this._sockjs=new SockJS(this.url,null,{protocols_whitelist:this._supported_protocols});this._setup_sockjs_callbacks(this._sockjs)},_make_request:function(b){return{req_id:this._get_next_req_id(),type:b,state:"pending"}},send:function(b,a,e){var d=this._make_request("request");
d.msg=b;d.success=a;d.error=e;this._save_request(d);this._can_send()?this._do_send(d):this._try_to_reconnect({reason:"cant_send"})},_get_next_req_id:function(){var b=page_params.event_queue_id+":"+this._next_req_id_counter;this._next_req_id_counter++;return b},_req_id_too_new:function(b){b=b.split(":")[2];return parseInt(b,10)>=this._next_req_id_counter},_req_id_sorter:function(b,a){var e=parseInt(b.split(":")[2],10),d=parseInt(a.split(":")[2],10);return e-d},_do_send:function(b){var a=this;this._requests[b.req_id].ack_timeout_id=
setTimeout(function(){blueslip.info("Timeout on ACK for request "+b.req_id);a._try_to_reconnect({reason:"ack_timeout"})},2E3);try{this._update_request_state(b.req_id,"sent"),this._sockjs.send(JSON.stringify({req_id:b.req_id,type:b.type,request:b.msg}))}catch(e){if(this._update_request_state(b.req_id,"pending"),!(e instanceof Error&&"INVALID_STATE_ERR"===e.message))if(e instanceof Error&&-1!==e.message.indexOf("NS_ERROR_NOT_CONNECTED"))this._sockjs.close();else throw e;}},_can_send:function(){return this._is_open&&
this._is_authenticated},_resend:function(b){b=this._requests[b];null!==b.ack_timeout_id&&(clearTimeout(b.ack_timeout_id),b.ack_timeout_id=null);"request"===b.type&&this._do_send(b)},_process_response:function(b,a){var e=this._requests[b];void 0===e?this._req_id_too_new(b)&&blueslip.error("Got a response for an unknown request",{request_id:b,next_id:this._next_req_id_counter,outstanding_ids:_.keys(this._requests)}):("success"===a.result&&void 0!==e.success?e.success(a):void 0!==e.error&&e.error("response",
a),this._remove_request(b))},_process_ack:function(b){var a=this._requests[b];void 0===a?blueslip.error("Got an ACK for an unknown request",{request_id:b,next_id:this._next_req_id_counter,outstanding_ids:_.keys(this._requests)}):null!==a.ack_timeout_id&&(clearTimeout(a.ack_timeout_id),a.ack_timeout_id=null)},_setup_sockjs_callbacks:function(b){var a=this;b.onopen=function(){blueslip.info("Socket connected [transport="+b.protocol+"]");null!==a._reconnect_initiation_time&&server_events.restart_get_events();
a._is_open=!0;$(document).trigger($.Event("websocket_postopen.zulip",{}));$(function(){var b=a._make_request("auth");b.msg={csrf_token:csrf_token,queue_id:page_params.event_queue_id,status_inquiries:_.keys(a._requests)};b.success=function(b){a._is_authenticated=!0;a._is_reconnecting=!1;a._reconnect_initiation_time=null;a._connection_failures=0;var c=[];_.each(b.status_inquiries,function(b,d){"complete"===b.status?a._process_response(d,b.response):"received"===b.status?a._update_request_state(d,"sent"):
"not_received"===b.status&&c.push(d)});c.sort(a._req_id_sorter);_.each(c,function(b){a._resend(b)})};b.error=function(b,c){blueslip.info("Could not authenticate with server: "+c.msg);a._connection_failures++;a._try_to_reconnect({reason:"auth_fail",wait_time:a._reconnect_wait_time()})};a._save_request(b);a._do_send(b)})};b.onmessage=function(b){"ack"===b.data.type?a._process_ack(b.data.req_id):a._process_response(b.data.req_id,b.data.response)};b.onheartbeat=function(){null!==a._heartbeat_timeout_id&&
(clearTimeout(a._heartbeat_timeout_id),a._heartbeat_timeout_id=null);a._heartbeat_timeout_id=setTimeout(function(){a._heartbeat_timeout_id=null;blueslip.info("Missed too many hearbeats");a._try_to_reconnect({reason:"no_heartbeat"})},6E4)};b.onclose=function(b){a._is_unloading||($(document).trigger($.Event("websocket_postopen.zulip",{})),blueslip.info("SockJS connection lost.  Attempting to reconnect soon. ("+b.code.toString()+", "+b.reason+")"),a._connection_failures++,a._is_reconnecting=!1,a._try_to_reconnect({wait_time:a._reconnect_wait_time()}))}},
_reconnect_wait_time:function(){return 1===this._connection_failures?30:1E3*Math.min(90,Math.exp(this._connection_failures/2))},_try_to_reconnect:function(b){b=_.extend({wait_time:0,reason:"none_given"},b);var a=this,e=(new Date).getTime();this._is_reconnecting&&1E3>e-this._reconnect_initiation_time||(null!==this._reconnect_timeout_id&&(clearTimeout(this._reconnect_timeout_id),this._reconnect_timeout_id=null),null!==this._heartbeat_timeout_id&&(clearTimeout(a._heartbeat_timeout_id),this._heartbeat_timeout_id=
null),_.each(this._requests,function(b,c){null!==b.ack_timeout_id&&(clearTimeout(b.ack_timeout_id),b.ack_timeout_id=null);"auth"===b.type&&a._remove_request(c)}),this._is_authenticated=this._is_open=!1,this._is_reconnecting=!0,this._reconnect_initiation_time=e,void 0!==this._sockjs&&(e=h[b.reason],this._sockjs.close(e.code,e.msg)),this._reconnect_timeout_id=setTimeout(function(){a._reconnect_timeout_id=null;blueslip.info("Attempting socket reconnect.");a._create_sockjs_object()},b.wait_time))},_localstorage_requests:function(){return!localstorage.supported()?
{}:JSON.parse(window.localStorage[this._localstorage_requests_key]||"{}")},_save_localstorage_requests:function(){if(localstorage.supported()){var b={};_.each(this._requests,function(a,d){"auth"!==a.type&&(b[d]=a)});try{window.localStorage[this._localstorage_requests_key]=JSON.stringify(b)}catch(a){blueslip.warn("Failed to save to local storage, caught exception when saving "+a)}}},_save_request:function(b){this._requests[b.req_id]=b;localstorage.supported()&&this._save_localstorage_requests()},_remove_request:function(b){delete this._requests[b];
localstorage.supported()&&this._save_localstorage_requests()},_update_request_state:function(b,a){this._requests[b].state=a;localstorage.supported()&&this._save_localstorage_requests()}};return f}();var compose=function(){function f(){return void 0!==window.bridge&&void 0!==window.bridge.desktopAppVersion?"desktop app "+window.bridge.desktopAppVersion():"website"}function h(){$("#new_message_content").trigger("autosize.resize")}function b(a,b,c){"stream"===a?($("#private-message").hide(),$("#stream-message").show(),$("#stream_toggle").addClass("active"),$("#private_message_toggle").removeClass("active")):($("#private-message").show(),$("#stream-message").hide(),$("#stream_toggle").removeClass("active"),
$("#private_message_toggle").addClass("active"));$("#send-status").removeClass(status_classes).hide();$("#compose").css({visibility:"visible"});$(".new_message_textarea").css("min-height","3em");void 0!==b&&(""===window.getSelection().toString()||"message click"!==c.trigger)&&b.focus().select();-1!==current_msg_list.selected_id()&&(a=current_msg_list.selected_row(),a=a.offset().top+a.height()-$("#compose").offset().top,0<a&&viewport.user_initiated_animate_scroll(a+5))}function a(){$("#compose_invite_users").hide();
$("#compose_invite_users").empty()}function e(){x.snapshot_message();a();$("#compose").find("input[type=text], textarea").val("");h();$("#send-status").hide(0)}function d(){F&&(compose_fade.set_focused_recipient(F),compose_fade.update_faded_messages())}function c(){$("#compose-send-button").removeAttr("disabled");var a=$("#compose").data("filedrop_xhr");void 0!==a&&(a.abort(),$("#compose").removeData("filedrop_xhr"))}function g(){var a=compose.subject();""===a&&(a=compose.empty_subject_placeholder());
var b;b=compose.message_content().replace(G,"]($1)");a={client:f(),type:compose.composing(),subject:a,stream:compose.stream_name(),private_message_recipient:compose.recipient(),content:b,queue_id:page_params.event_queue_id};"private"===a.type?(a.to=compose.recipient().split(/\s*[,;]\s*/),a.reply_to=compose.recipient()):a.to=compose.stream_name();return a}function m(){$("#restore-draft").hide();A=void 0}function k(a,b){$("#send-status").removeClass(status_classes).addClass("alert-error").stop(!0).fadeTo(0,
1);$("#error-msg").html(a);$("#compose-send-button").removeAttr("disabled");$("#sending-indicator").hide();void 0!==b&&b.focus().select()}function l(a,b,c){channel.post({url:"/json/send_message",data:a,success:b,error:function(a,b){if("timeout"!==b&&reload.is_pending())reload.initiate({immediate:!0,send_after_reload:!0});else{var d=channel.xhr_error_message("Error sending message",a);c(d)}}})}function r(a,b,c){u.send(a,b,function(a,b){var d="Error sending message";"response"===a&&(d+=": "+b.msg);
c(d)})}function n(a){a=x.send_times_data[a];if(!(void 0===a.send_finished||void 0===a.received||void 0===a.displayed)){var b=a.locally_echoed,c={time:(a.send_finished-a.start).toString(),received:(a.received-a.start).toString(),displayed:(a.displayed-a.start).toString(),locally_echoed:b};b&&(c.rendered_content_disparity=a.rendered_content_disparity||!1);channel.post({url:"/json/report_send_time",data:c})}}function t(a){void 0===x.send_times_data[a]&&(x.send_times_data[a]={});x.send_times_data[a].received=
new Date;n(a)}function s(a,b,c){var d=new Date,e=d-b;feature_flags.log_send_times&&blueslip.log("send time: "+e);feature_flags.collect_send_times&&x.send_times_log.push(e);void 0===x.send_times_data[a]&&(x.send_times_data[a]={});x.send_times_data[a].start=b;x.send_times_data[a].send_finished=d;x.send_times_data[a].locally_echoed=c;n(a)}function q(){$("#new_message_content").val("").focus();h();$("#send-status").hide(0);m();$("#compose-send-button").removeAttr("disabled");$("#sending-indicator").hide();
resize.resize_bottom_whitespace()}function v(a){void 0===a&&(a=g());x.snapshot_message(a);a.to="private"===a.type?JSON.stringify(a.to):JSON.stringify([a.to]);var b=new Date,c;feature_flags.local_echo&&(c=echo.try_deliver_locally(a),void 0!==c&&(a.local_id=c));var d=void 0!==c;x.transmit_message(a,function(a){x.send_message_success(c,a.id,b,d)},function(b){!feature_flags.local_echo||void 0===a.local_id?k(b,$("#new_message_content")):echo.message_send_error(c,b)});server_events.assert_get_events_running("Restarting get_events because it was not running during send");
feature_flags.local_echo&&d&&q()}function p(a,b){return function(c){var d=$("#"+a),e=d.val();void 0!==c&&d.val(c);return b?e:$.trim(e)}}function y(){var a=x.stream_name();if(""===a)return k("Please specify a stream",$("#stream")),!1;if(page_params.mandatory_topics&&""===x.subject())return k("Please specify a topic",$("#subject")),!1;if(!stream_data.is_subscribed(a)){var b=x.check_stream_existence(a,void 0!==page_params.narrow_stream);"error"===b&&(k("Error checking subscription",$("#stream")),$("#compose-send-button").removeAttr("disabled"),
$("#sending-indicator").hide());switch(b){case "does-not-exist":return a="<p>The stream <b>"+Handlebars.Utils.escapeExpression(a)+"</b> does not exist.</p><p>Manage your subscriptions <a href='#subscriptions'>on your Streams page</a>.</p>",k(a,$("#stream")),!1;case "error":return!1;case "not-subscribed":return a="<p>You're not subscribed to the stream <b>"+Handlebars.Utils.escapeExpression(a)+"</b>.</p><p>Manage your subscriptions <a href='#subscriptions'>on your Streams page</a>.</p>",k(a,$("#stream")),
!1}}return!0}var x={},F=!1,A,D=document.location.protocol+"//"+document.location.host,B="/user_uploads",G=RegExp("\\]\\("+D+"("+B+"[^\\)]+)\\)","g");x.decorate_stream_bar=function(a){var b=stream_data.get_color(a),c=$("#compose-lock-icon"),d=$("#stream");stream_data.get_invite_only(a)?(c.show(),d.addClass("lock-padding")):(c.hide(),d.removeClass("lock-padding"));$("#stream-message .message_header_stream").css("background-color",b).removeClass(stream_color.color_classes).addClass(stream_color.get_color_class(b))};
$(function(){$("#stream,#subject,#private_message_recipient").bind({keyup:d,change:d})});x.start=function(a,c){if(!reload.is_in_progress()){notifications.clear_compose_notifications();$("#compose_close").show();$("#compose_controls").hide();$(".message_comp").show();var d=c,g={message_type:a,stream:"",subject:"",private_message_recipient:"",trigger:"unknown"};narrow.set_compose_defaults(g);c=d=_.extend(g,d);"compose_hotkey"===c.trigger&&(c.subject="",c.private_message_recipient="");compose.composing()&&
!(compose.composing()===a&&("stream"===a&&c.stream===compose.stream_name()&&c.subject===compose.subject()||"private"===a&&c.private_message_recipient===compose.recipient()))&&e();compose.stream_name(c.stream);compose.subject(c.subject);compose.recipient(c.private_message_recipient.replace(/,\s*/g,", "));void 0!==c.content&&compose.message_content(c.content);ui.change_tab_to("#home");F=a;var d=c,f;if("stream"===a&&d.stream&&!d.subject)f="subject";else if("stream"===a&&d.stream||"private"===a&&d.private_message_recipient)f=
"new_message_content";"stream"===a?b("stream",$("#"+(f||"stream")),d):b("private",$("#"+(f||"private_message_recipient")),d);compose_fade.start_compose(a);x.decorate_stream_bar(c.stream);$(document).trigger($.Event("compose_started.zulip",c));resize.resize_bottom_whitespace()}};x.cancel=function(){void 0!==page_params.narrow?(compose_fade.clear_compose(),void 0!==page_params.narrow_topic?compose.subject(page_params.narrow_topic):compose.subject("")):($(".message_comp").find("input, textarea, button").blur(),
$("#stream-message").hide(),$("#private-message").hide(),$(".new_message_textarea").css("min-height",""),compose_fade.clear_compose(),$(".message_comp").hide(),$("#compose_controls").show(),$("#compose_close").hide(),resize.resize_bottom_whitespace(),e(),notifications.clear_compose_notifications(),c(),F=!1,void 0!==A&&$("#restore-draft").show(),$(document).trigger($.Event("compose_canceled.zulip")))};x.empty_subject_placeholder=function(){return"(no topic)"};x.snapshot_message=function(a){x.composing()&&
""!==x.message_content()&&(A=void 0!==a?_.extend({},a):g())};x.restore_message=function(){if(A){var a=_.extend({},A);if("stream"===a.type&&0<a.stream.length&&0<a.subject.length||"private"===a.type&&0<a.reply_to.length)a=_.extend({replying_to_message:a},a);m();compose_fade.clear_compose();compose.start(a.type,a)}};var u;feature_flags.use_socket&&(u=new Socket("/sockjs"));x._socket=u;x.send_times_log=[];x.send_times_data={};x.mark_rendered_content_disparity=function(a,b){void 0===x.send_times_data[a]&&
(x.send_times_data[a]={});x.send_times_data[a].rendered_content_disparity=b};x.report_as_received=function(a){a.sent_by_me&&(t(a.id),setTimeout(function(){var b=a.id;void 0===x.send_times_data[b]&&(x.send_times_data[b]={});x.send_times_data[b].displayed=new Date;n(b)},0))};x.send_message_success=function(a,b,c,d){(!feature_flags.local_echo||!d)&&q();s(b,c,d);feature_flags.local_echo&&echo.reify_message_id(a,b);setTimeout(function(){void 0===x.send_times_data[b].received&&(blueslip.log("Restarting get_events due to delayed receipt of sent message "+
b),server_events.restart_get_events())},5E3)};x.transmit_message=function(a,b,c){delete x.send_times_data[a.id];feature_flags.use_socket?r(a,b,c):l(a,b,c)};x.test_send_many_messages=function(a,b,c){function d(){var g={};e+=1;g.type="stream";g.to=a;g.subject=b;g.content=e.toString();g.client=f();v(g);e!==c&&setTimeout(d,1E3)}var e=0;d()};x.finish=function(){a();if(!compose.validate())return!1;v();$(document).trigger($.Event("compose_finished.zulip"));return!0};$(function(){$("#compose form").on("submit",
function(a){a.preventDefault();compose.finish()})});x.composing=function(){return F};x.stream_name=p("stream");x.subject=p("subject");x.message_content=p("new_message_content",!0);x.recipient=p("private_message_recipient");x.has_message_content=function(){return""!==x.message_content()};x.check_stream_existence=function(a,b){var c="error",d={stream:a};b&&(d.autosubscribe=!0);channel.post({url:"/json/subscriptions/exists",data:d,async:!1,success:function(a){c=a.subscribed?"subscribed":"not-subscribed"},
error:function(a){c=404===a.status?"does-not-exist":"error"}});return c};x.validate=function(){$("#compose-send-button").attr("disabled","disabled").blur();$("#sending-indicator").show();if(/^\s*$/.test(x.message_content()))return k("You have nothing to send!",$("#new_message_content")),!1;if($("#zephyr-mirror-error").is(":visible"))return k("You need to be running Zephyr mirroring in order to send messages!"),!1;if("private"===x.composing()){var a;""===x.recipient()?(k("Please specify at least one recipient",
$("#private_message_recipient")),a=!1):a=!0;return a}return y()};$(function(){function a(b,d,e){$("#compose-send-button").attr("disabled","");$("#send-status").addClass("alert-info").show();$(".send-status-close").one("click",c);$("#error-msg").html($("<p>").text("Uploading\u2026").after('<div class="progress progress-striped active"><div class="bar" id="upload-bar" style="width: 00%;"></div></div>'))}function b(a,c,d){$("#upload-bar").width(d+"%")}function d(a,b){var c;$("#send-status").addClass("alert-error").removeClass("alert-info");
$("#compose-send-button").removeAttr("disabled");switch(a){case "BrowserNotSupported":c="File upload is not yet available for your browser.";break;case "TooManyFiles":c="Unable to upload that many files at once.";break;case "FileTooLarge":c='"'+b.name+'" was too large; the maximum file size is 25MiB.';break;case "REQUEST ENTITY TOO LARGE":c="Sorry, the file was too large.";break;default:c="An unknown error occured."}$("#error-msg").text(c)}function e(a,b,c,d){void 0!==c.uri&&(b=$("#new_message_content"),
d=c.uri.split("/"),d=d[d.length-1],compose.composing()||compose.start("stream"),c=c.uri,c=0===c.indexOf(B)?D+c:c,-1===a?b.val(b.val()+"[pasted image]("+c+") "):b.val(b.val()+"["+d+"]("+c+") "),h(),$("#compose-send-button").removeAttr("disabled"),$("#send-status").removeClass("alert-info").hide(),a=$("#file_input"),c=a.clone(!0),a.replaceWith(c))}$("#new_message_content").autosize();window.XMLHttpRequest&&(new XMLHttpRequest).upload&&$("#compose #attach_files").removeClass("notdisplayed");feature_flags.dropbox_integration&&
LazyLoad.js("https://www.dropbox.com/static/api/1/dropins.js",function(){_.has(window,"Dropbox")?Dropbox.isBrowserSupported()&&(Dropbox.init({appKey:window.dropboxAppKey}),$("#compose #attach_dropbox_files").removeClass("notdisplayed")):blueslip.error("Dropbox script reports loading but window.Dropbox undefined")});$(document).on("usermention_completed.zulip",function(a,b){if(!("stream"!==F||"mit.edu"===page_params.domain)&&void 0!==b&&void 0!==b.mentioned){var c=b.mentioned.email;if(!1===compose_fade.would_receive_message(c)){var d=
templates.render("compose-invite-users",{email:c,name:b.mentioned.full_name}),e=$("#compose_invite_users");-1===_.map($(".compose_invite_user",e),function(a){return $(a).data("useremail")}).indexOf(c)&&e.append(d);e.show()}}});$("#compose_invite_users").on("click",".compose_invite_link",function(a){a.preventDefault();var b=$(a.target).parents(".compose_invite_user"),c=$(b).data("useremail");void 0!==c&&subs.invite_user_to_stream(c,compose.stream_name(),function(){var a=$("#compose_invite_users");
b.remove();0===a.children().length&&a.hide()},function(){b.find(".compose_invite_user_error").show();$(a.target).attr("disabled",!0)})});$("#compose_invite_users").on("click",".compose_invite_close",function(a){a=$(a.target).parents(".compose_invite_user");var b=$("#compose_invite_users");a.remove();0===b.children().length&&b.hide()});$("#compose").on("click","#attach_files",function(a){a.preventDefault();$("#compose #file_input").trigger("click")});$("#compose").on("click","#attach_dropbox_files",
function(a){a.preventDefault();Dropbox.choose({success:function(a){var b=$("#new_message_content");a=_.map(a,function(a){return"["+a.name+"]("+a.link+")"}).join(" ")+" ";b.val(b.val()+a)},multiselect:!0,iframe:!0})});window.bridge&&(x.uploadStarted=a,x.progressUpdated=b,x.uploadError=d,x.uploadFinished=e);$("#compose").filedrop({url:"json/upload_file",fallback_id:"file_input",paramname:"file",maxfilesize:25,data:{csrfmiddlewaretoken:csrf_token},raw_droppable:["text/uri-list","text/plain"],drop:a,
progressUpdated:b,error:d,uploadFinished:e,rawDrop:function(a){var b=$("#new_message_content");compose.composing()||compose.start("stream");b.val(b.val()+a);h()}});void 0!==page_params.narrow&&(void 0!==page_params.narrow_topic?compose.start("stream",{subject:page_params.narrow_topic}):compose.start("stream",{}));$(document).on("message_id_changed",function(a){if(void 0!==x.send_times_data[a.old_id]){var b=x.send_times_data[a.old_id];delete x.send_times_data[a.old_id];x.send_times_data[a.new_id]=
_.extend({},x.send_times_data[a.old_id],b)}})});return x}();var stream_color=function(){function f(a,c,d){var e=b.get_color_class(d);a=$("#floating_recipient_bar").add(a).find(".stream_label");_.each(a,function(a){a=$(a);$.trim(a.text())===c&&(a.closest(".recipient_row").children(".message_row").children(".messagebox").css("box-shadow","inset 2px 0px 0px 0px "+d+", -1px 0px 0px 0px "+d),a.css({background:d,"border-left-color":d}),a.removeClass(b.color_classes),a.addClass(e))})}function h(a){var b=$(this).attr("stream_name");a=a.toHexString();subs.set_color(b,
a)}var b={default_color:"#c2c2c2"},a="#76ce90 #fae589 #a6c7e5 #e79ab5 #bfd56f #f4ae55 #b0a5fd #addfe5 #f5ce6e #c2726a #94c849 #bd86e5 #ee7e4a #a6dcbf #95a5fd #53a063 #9987e1 #e4523d #c2c2c2 #4f8de4 #c6a8ad #e7cc4d #c8bebf #a47462".split(" ");b.color_classes="dark_background";b.pick_color=function(b){var c=_.shuffle(a),d={};_.each(b,function(a){d[a]=!0});return(b=_.find(c,function(a){return!_.has(d,a)}))?b:c[0]};var e=["a47462 c2726a e4523d e7664d ee7e4a f4ae55".split(" "),"76ce90 53a063 94c849 bfd56f fae589 f5ce6e".split(" "),
"a6dcbf addfe5 a6c7e5 4f8de4 95a5fd b0a5fd".split(" "),"c2c2c2 c8bebf c6a8ad e79ab5 bd86e5 9987e1".split(" ")],d={clickoutFiresChange:!0,showPalette:!0,palette:e};b.set_colorpicker_color=function(a,b){a.spectrum(_.extend(d,{color:b}))};b.update_stream_color=function(a,c,d,e){e=_.defaults({},e,{update_historical:!1});a.color=d;a=parseInt(a.stream_id,10);$("#subscription_"+a+" .color_swatch").css("background-color",d);b.set_colorpicker_color($("#subscription_"+a+" .colorpicker"),d);e.update_historical&&
(f($(".focused_table"),c,d),"#zhome"!==$(".focused_table").attr("id")&&f($("#zhome"),c,d));$("#stream_sidebar_swatch_"+a).css("background-color",d);$("#stream_sidebar_privacy_swatch_"+a).css("color",d);tab_bar.colorize_tab_bar()};d.change=h;b.sidebar_popover_colorpicker_options={clickoutFiresChange:!0,showPaletteOnly:!0,showPalette:!0,flat:!0,palette:e,change:h};b.sidebar_popover_colorpicker_options_full={clickoutFiresChange:!0,showPalette:!0,flat:!0,cancelText:"",chooseText:"choose",palette:e,change:h};
var c;$(function(){c=(colorspace.luminance_to_lightness(colorspace.sRGB_to_linear(51))+100)/2});b.get_color_class=_.memoize(function(a){var b,d=[0,0,0],e=1;b=/^#([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})$/.exec(a);if(!b&&(e=17,b=/^#([\da-fA-F])([\da-fA-F])([\da-fA-F])$/.exec(a),!b))return"";for(a=0;3>a;a++)d[a]=colorspace.sRGB_to_linear(e*parseInt(b[a+1],16));return colorspace.luminance_to_lightness(colorspace.rgb_luminance(d))<c?"dark_background":""});return b}();
"undefined"!==typeof module&&(module.exports=stream_color);var admin=function(){function f(a,b){loading.destroy_indicator($("#subs_page_loading_indicator"));ui.report_error("Error listing users or bots",a,$("#administration-status"))}function h(a,b){ui.report_error("Error listing streams",a,$("#administration-status"))}function b(a){var b=$("#admin_users_table"),c=$("#admin_deactivated_users_table"),g=$("#admin_bots_table");b.find("tr.user_row").remove();c.find("tr.user_row").remove();g.find("tr.user_row").remove();var f=[],h=[],l=[];_.each(a.members,function(a){a.is_active_human=
a.is_active&&!a.is_bot;a.is_bot?l.push(a):a.is_active?f.push(a):h.push(a)});f=_.sortBy(f,"full_name");h=_.sortBy(h,"full_name");l=_.sortBy(l,"full_name");_.each(l,function(a){g.append(templates.render("admin_user_list",{user:a}))});_.each(f,function(a){b.append(templates.render("admin_user_list",{user:a}))});_.each(h,function(a){c.append(templates.render("admin_user_list",{user:a}))});loading.destroy_indicator($("#admin_page_users_loading_indicator"));loading.destroy_indicator($("#admin_page_bots_loading_indicator"));
loading.destroy_indicator($("#admin_page_deactivated_users_loading_indicator"))}function a(a){var b=$("#admin_streams_table").expectOne();b.find("tr.stream_row").remove();_.each(a.streams,function(a){b.append(templates.render("admin_streams_list",{stream:a}))});loading.destroy_indicator($("#admin_page_streams_loading_indicator"))}return{show_or_hide_menu_item:function(){var a=$(".admin-menu-item").expectOne();page_params.is_admin?a.show():a.hide()},setup_page:function(){var e=templates.render("admin_tab",
{realm_name:page_params.realm_name,domain:page_params.domain,realm_restricted_to_domain:page_params.realm_restricted_to_domain,realm_invite_required:page_params.realm_invite_required,realm_invite_by_admins_only:page_params.realm_invite_by_admins_only});$("#administration").html(e);$("#administration-status").expectOne().hide();$("#admin-realm-name-status").expectOne().hide();$("#admin-realm-restricted-to-domain-status").expectOne().hide();$("#admin-realm-invite-required-status").expectOne().hide();
$("#admin-realm-invite-by-admins-only-status").expectOne().hide();loading.make_indicator($("#admin_page_users_loading_indicator"));loading.make_indicator($("#admin_page_bots_loading_indicator"));loading.make_indicator($("#admin_page_streams_loading_indicator"));loading.make_indicator($("#admin_page_deactivated_users_loading_indicator"));channel.get({url:"/json/users",idempotent:!0,timeout:1E4,success:b,error:f});channel.get({url:"/json/streams?include_public=true&include_subscribed=true",timeout:1E4,
idempotent:!0,success:a,error:h});$(".admin_user_table").on("click",".deactivate",function(a){a.preventDefault();a.stopPropagation();$(".active_user_row").removeClass("active_user_row");var b=$(a.target).closest(".user_row");b.addClass("active_user_row");a=b.find(".user_name").text();b=b.find(".email").text();$("#deactivation_user_modal .email").text(b);$("#deactivation_user_modal .user_name").text(a);$("#deactivation_user_modal").modal("show")});$(".admin_stream_table").on("click",".deactivate",
function(a){a.preventDefault();a.stopPropagation();$(".active_stream_row").removeClass("active_stream_row");a=$(a.target).closest(".stream_row");a.addClass("active_stream_row");a=a.find(".stream_name").text();$("#deactivation_stream_modal .stream_name").text(a);$("#deactivation_stream_modal").modal("show")});$(".admin_bot_table").on("click",".deactivate",function(a){a.preventDefault();a.stopPropagation();$(".active_user_row").removeClass("active_user_row");var b=$(a.target).closest(".user_row");b.addClass("active_user_row");
b.find(".user_name").text();a=b.find(".email").text();channel.del({url:"/json/bots/"+a,error:function(a,d){"4"===a.status.toString().charAt(0)?b.find("button").closest("td").html($("<p>").addClass("text-error").text($.parseJSON(a.responseText).msg)):b.find("button").text("Failed!")},success:function(){var a=b.find("button.deactivate");a.addClass("btn-warning");a.removeClass("btn-danger");a.addClass("reactivate");a.removeClass("deactivate");a.text("Reactivate");b.addClass("deactivated_user")}})});
$(".admin_user_table, .admin_bot_table").on("click",".reactivate",function(a){a.preventDefault();a.stopPropagation();$(".active_user_row").removeClass("active_user_row");var b=$(a.target).closest(".user_row");b.addClass("active_user_row");a=b.find(".email").text();channel.post({url:"/json/users/"+a+"/reactivate",error:function(a,d){var e=b.find("button");"4"===a.status.toString().charAt(0)?e.closest("td").html($("<p>").addClass("text-error").text($.parseJSON(a.responseText).msg)):e.text("Failed!")},
success:function(){var a=b.find("button.reactivate");a.addClass("btn-danger");a.removeClass("btn-warning");a.addClass("deactivate");a.removeClass("reactivate");a.text("Deactivate");b.removeClass("deactivated_user")}})});$("#id_realm_invite_required").change(function(){this.checked?($("#id_realm_invite_by_admins_only").removeAttr("disabled"),$("#id_realm_invite_by_admins_only_label").removeClass("control-label-disabled")):($("#id_realm_invite_by_admins_only").attr("disabled",!0),$("#id_realm_invite_by_admins_only_label").addClass("control-label-disabled"))});
$(".administration").on("submit","form.admin-realm",function(a){var b=$("#admin-realm-name-status").expectOne(),e=$("#admin-realm-restricted-to-domain-status").expectOne(),f=$("#admin-realm-invite-required-status").expectOne(),h=$("#admin-realm-invite-by-admins-only-status").expectOne();b.hide();e.hide();f.hide();h.hide();a.preventDefault();a.stopPropagation();a=$("#id_realm_name").val();var l=$("#id_realm_restricted_to_domain").prop("checked"),r=$("#id_realm_invite_required").prop("checked"),n=$("#id_realm_invite_by_admins_only").prop("checked");
a={name:JSON.stringify(a),restricted_to_domain:JSON.stringify(l),invite_required:JSON.stringify(r),invite_by_admins_only:JSON.stringify(n)};channel.patch({url:"/json/realm",data:a,success:function(a){void 0!==a.name&&ui.report_success("Name changed!",b);void 0!==a.restricted_to_domain&&(a.restricted_to_domain?ui.report_success("New users must have @"+page_params.domain+" e-mails!",e):ui.report_success("New users may have arbitrary e-mails!",e));void 0!==a.invite_required&&(a.invite_required?ui.report_success("New users must be invited by e-mail!",
f):ui.report_success("New users may sign up online!",f));void 0!==a.invite_by_admins_only&&(a.invite_by_admins_only?ui.report_success("New users must be invited by an admin!",h):ui.report_success("Any user may now invite new users!",h))},error:function(a,d){ui.report_error("Failed!",a,b)}})});$(".admin_user_table").on("click",".make-admin",function(a){a.preventDefault();a.stopPropagation();$(".active_user_row").removeClass("active_user_row");var b=$(a.target).closest(".user_row");b.addClass("active_user_row");
a="/json/users/"+b.find(".email").text();var e={is_admin:JSON.stringify(!0)};channel.patch({url:a,data:e,success:function(){var a=b.find("button.make-admin");a.addClass("btn-danger");a.removeClass("btn-warning");a.addClass("remove-admin");a.removeClass("make-admin");a.text("Remove admin")},error:function(a,d){var e=b.find(".admin-user-status");ui.report_error("Failed!",a,e)}})});$(".admin_user_table").on("click",".remove-admin",function(a){a.preventDefault();a.stopPropagation();$(".active_user_row").removeClass("active_user_row");
var b=$(a.target).closest(".user_row");b.addClass("active_user_row");a="/json/users/"+b.find(".email").text();var e={is_admin:JSON.stringify(!1)};channel.patch({url:a,data:e,success:function(){var a=b.find("button.remove-admin");a.addClass("btn-warning");a.removeClass("btn-danger");a.addClass("make-admin");a.removeClass("remove-admin");a.text("Make admin")},error:function(a,d){var e=b.find(".admin-user-status");ui.report_error("Failed!",a,e)}})});$("#do_deactivate_user_button").click(function(a){var b=
$(".active_user_row");a=b.find(".email").text();$("#deactivation_user_modal .email").html()!==a&&(blueslip.error("User deactivation canceled due to non-matching fields."),ui.report_message("Deactivation encountered an error. Please reload and try again.",$("#home-error"),"alert-error"));$("#deactivation_user_modal").modal("hide");b.find("button").prop("disabled",!0).text("Working\u2026");channel.del({url:"/json/users/"+a,error:function(a,d){"4"===a.status.toString().charAt(0)?b.find("button").closest("td").html($("<p>").addClass("text-error").text($.parseJSON(a.responseText).msg)):
b.find("button").text("Failed!")},success:function(){var a=b.find("button.deactivate");a.prop("disabled",!1);a.addClass("btn-warning");a.removeClass("btn-danger");a.addClass("reactivate");a.removeClass("deactivate");a.text("Reactivate");b.addClass("deactivated_user");b.find(".user-admin-settings").hide()}})});$("#do_deactivate_stream_button").click(function(a){$("#deactivation_stream_modal .stream_name").text()!==$(".active_stream_row").find(".stream_name").text()&&(blueslip.error("Stream deactivation canceled due to non-matching fields."),
ui.report_message("Deactivation encountered an error. Please reload and try again.",$("#home-error"),"alert-error"));$("#deactivation_stream_modal").modal("hide");$(".active_stream_row button").prop("disabled",!0).text("Working\u2026");channel.del({url:"/json/streams/"+encodeURIComponent($(".active_stream_row").find(".stream_name").text()),error:function(a,b){"4"===a.status.toString().charAt(0)?$(".active_stream_row button").closest("td").html($("<p>").addClass("text-error").text($.parseJSON(a.responseText).msg)):
$(".active_stream_row button").text("Failed!")},success:function(){$(".active_stream_row").remove()}})})}}}();var stream_data=function(){var f={},h,b;f.clear_subscriptions=function(){h=new Dict({fold_case:!0});b=new Dict};f.clear_subscriptions();f.add_sub=function(a,e){h.set(a,e);b.set(e.stream_id,e)};f.get_sub=function(a){return h.get(a)};f.get_sub_by_id=function(a){return b.get(a)};f.delete_sub=function(a){h.del(a)};f.subscribed_subs=function(){return _.where(h.values(),{subscribed:!0})};f.subscribed_streams=function(){return _.pluck(f.subscribed_subs(),"name")};f.get_colors=function(){return _.pluck(f.subscribed_subs(),
"color")};f.all_subscribed_streams_are_in_home_view=function(){return _.every(f.subscribed_subs(),function(a){return a.in_home_view})};f.home_view_stream_names=function(){var a=_.filter(f.subscribed_subs(),function(a){return a.in_home_view});return _.map(a,function(a){return a.name})};f.canonicalized_name=function(a){return a.toString().toLowerCase()};f.get_color=function(a){a=f.get_sub(a);return void 0===a?stream_color.default_color:a.color};f.in_home_view=function(a){a=f.get_sub(a);return void 0!==
a&&a.in_home_view};f.is_subscribed=function(a){a=f.get_sub(a);return void 0!==a&&a.subscribed};f.get_invite_only=function(a){a=f.get_sub(a);return void 0===a?!1:a.invite_only};f.get_name=function(a){var b=f.get_sub(a);return void 0===b?a:b.name};f.set_subscribers=function(a,b){a.subscribers=Dict.from_array(b||[],{fold_case:!0})};f.add_subscriber=function(a,b){var d=f.get_sub(a);"undefined"===typeof d||!d.subscribed?blueslip.warn("We got an add_subscriber call for a non-existent or unsubscribed stream."):
d.subscribers.set(b,!0)};f.remove_subscriber=function(a,b){var d=f.get_sub(a);"undefined"===typeof d||!d.subscribed?blueslip.warn("We got a remove_subscriber call for a non-existent or unsubscribed stream."):d.subscribers.del(b)};f.user_is_subscribed=function(a,b){var d=f.get_sub(a);if("undefined"===typeof d||!d.subscribed)blueslip.warn("We got a user_is_subscribed call for a non-existent or unsubscribed stream.");else return d.subscribers.has(b)};return f}();
"undefined"!==typeof module&&(module.exports=stream_data);var subs=function(){function f(a){return _.extend(a,{is_admin:page_params.is_admin,can_make_public:page_params.is_admin&&a.invite_only&&stream_data.is_subscribed(a.name),can_make_private:page_params.is_admin&&!a.invite_only})}function h(){var a=stream_data.get_colors();return stream_color.pick_color(a)}function b(a,b,c){return channel.post({url:"/json/subscriptions/property",data:{subscription_data:JSON.stringify([{stream:a,property:b,value:c}])},timeout:1E4})}function a(a,c){_.each(stream_data.subscribed_subs(),
function(d){d[a]!==c&&b(d.name,a,c)})}function e(a){a=$(a.target).closest(".subscription_row");var b=a.find(".subscription_name").text(),c=stream_data.get_sub(b),d=a.find(".sub_notification_setting");subs.toggle_home(b);c.in_home_view?(a.find(".mute-note").addClass("hide-mute-note"),d.removeClass("muted-sub"),d.find("input[type='checkbox']").removeAttr("disabled")):(a.find(".mute-note").removeClass("hide-mute-note"),d.addClass("muted-sub"),d.find("input[type='checkbox']").attr("disabled",!0))}function d(a,
b){a.in_home_view=b;setTimeout(function(){var a,b;ui.home_tab_obscured()?b=viewport.scrollTop():home_msg_list===current_msg_list&&null!==current_msg_list.selected_row().offset()&&(a=current_msg_list.selected_row().offset().top);home_msg_list.clear({clear_selected_id:!1});message_store.add_messages(all_msg_list.all(),home_msg_list);ui.home_tab_obscured()?viewport.scrollTop(b):home_msg_list===current_msg_list&&(home_msg_list.select_id(home_msg_list.selected_id(),{use_closest:!0,empty_ok:!0}),-1!==current_msg_list.selected_id()&&
viewport.set_message_offset(a));suppress_scroll_pointer_update=recenter_pointer_on_display=!0;home_msg_list.empty()||process_loaded_for_unread(home_msg_list.all())},0);stream_list.set_in_home_view(a.name,a.in_home_view);$("#subscription_"+a.stream_id+" #sub_setting_not_in_home_view .sub_setting_control").attr("checked",!b)}function c(a,b){var c=a.name;stream_data.delete_sub(c);a.name=b;stream_data.add_sub(b,a);stream_list.rename_stream(a);_.each([home_msg_list,current_msg_list,all_msg_list],function(a){a.change_display_recipient(c,
b)})}function g(a){a=$(a.target).closest(".subscription_row").find(".subscription_name").text();var c=stream_data.get_sub(a);c.desktop_notifications=!c.desktop_notifications;b(a,"desktop_notifications",c.desktop_notifications)}function m(a){a=$(a.target).closest(".subscription_row").find(".subscription_name").text();var c=stream_data.get_sub(a);c.audible_notifications=!c.audible_notifications;b(a,"audible_notifications",c.audible_notifications)}function k(a,b){var c=stream_data.get_sub(a);if(void 0!==
c)return c;if(b.stream_id){var d=b.subscribers,c=_.omit(b,"subscribers"),c=_.defaults(c,{name:a,render_subscribers:"mit.edu"!==page_params.domain||!0===b.invite_only,subscribed:!0,in_home_view:!0,invite_only:!1,desktop_notifications:page_params.stream_desktop_notifications_enabled,audible_notifications:page_params.stream_sounds_enabled,description:""});stream_data.set_subscribers(c,d);c.color||(c.color=h());stream_data.add_sub(a,c);$(document).trigger($.Event("sub_obj_created.zulip",{sub:c}));return c}blueslip.fatal("We cannot create a sub without a stream_id")}
function l(a){a=parseInt(a.stream_id,10);return $("#subscription_"+a+" .sub_unsub_button")}function r(a){a=parseInt(a.stream_id,10);return $("#subscription_settings_"+a)}function n(a){a="#email-address-hint-"+a.stream_id;var b=$(a);b.popover({placement:"bottom",title:"Email integration",content:templates.render("email_address_hint",{page_params:page_params}),trigger:"manual"});$("body").on("mouseover",a,function(a){b.popover("show");a.stopPropagation()});$("body").on("mouseout",a,function(a){b.popover("hide");
a.stopPropagation()})}function t(a){a=f(a);var b=templates.render("subscription",a);$("#create_stream_row").after(b);r(a).collapse("show");n(a)}function s(a,b){return templates.render("stream_member_list_entry",{name:a,email:b,displaying_for_admin:page_params.is_admin})}function q(a,b){var c=[];a.sort(function(a,b){return util.strcmp(a.name,b.name)});a.forEach(function(a){a=k(a.name,{color:a.color,in_home_view:a.in_home_view,invite_only:a.invite_only,desktop_notifications:a.desktop_notifications,
audible_notifications:a.audible_notifications,subscribed:b,email_address:a.email_address,stream_id:a.stream_id,subscribers:a.subscribers,description:a.description});c.push(a)});return c}function v(a){var b;return channel.post({url:"/json/subscriptions/add",data:{subscriptions:JSON.stringify([{name:a}])},success:function(a,c,d,e){$("#create_stream_name").val("");a=$.parseJSON(d.responseText);$.isEmptyObject(a.already_subscribed)||(b=a.already_subscribed[page_params.email][0],ui.report_success("Already subscribed to "+
b,$("#subscriptions-status")))},error:function(a){ui.report_error("Error adding subscription",a,$("#subscriptions-status"));$("#create_stream_name").focus()}})}function p(a){return channel.post({url:"/json/subscriptions/remove",data:{subscriptions:JSON.stringify([a])},success:function(a,b,c,d){$.parseJSON(c.responseText);$("#subscriptions-status").hide()},error:function(a){ui.report_error("Error removing subscription",a,$("#subscriptions-status"));$("#create_stream_name").focus()}})}function y(a,
b,c,d){return channel.post({url:"/json/subscriptions/add",data:{subscriptions:JSON.stringify([{name:a}]),principals:JSON.stringify(b),invite_only:JSON.stringify(c),announce:JSON.stringify(d)},success:function(a){$("#create_stream_name").val("");$("#subscriptions-status").hide();$("#stream-creation").modal("hide")},error:function(a){ui.report_error("Error creating stream",a,$("#subscriptions-status"));$("#stream-creation").modal("hide")}})}function x(){var a=$("#announce-new-stream input"),b=!1;"invite-only"===
$("input:radio[name=privacy]:checked").val()?(b=!0,a.prop("checked",!1)):b=$("#user-checkboxes input").length===$("#user-checkboxes input:checked").length;a.prop("disabled",b)}function F(a,b){_.each(a,function(a){a.subscribers&&(a.subscribers=_.map(a.subscribers,function(a){return b[a]}))})}function A(){var a=narrow.stream();if(void 0!==a){var b=stream_data.get_sub(a);void 0!==b?$("html, body").animate({scrollTop:r(b).offset().top}):$("#create_stream_name").val(a)}}var D={stream_id:function(a){a=
stream_data.get_sub(a);return void 0===a?(blueslip.error("Tried to get subs.stream_id for a stream user is not subscribed to!"),0):parseInt(a.stream_id,10)},set_all_stream_desktop_notifications_to:function(b){a("desktop_notifications",b)},set_all_stream_audible_notifications_to:function(b){a("audible_notifications",b)},toggle_home:function(a){var c=stream_data.get_sub(a);d(c,!c.in_home_view);b(a,"in_home_view",c.in_home_view)},set_color:function(a,c){var d=stream_data.get_sub(a);stream_color.update_stream_color(d,
a,c,{update_historical:!0});b(a,"color",c)},show_settings_for:function(a){r(stream_data.get_sub(a)).collapse("show")},mark_subscribed:function(a,b){var c=stream_data.get_sub(a);if(void 0===c)c=k(a,b),t(c);else{if(c.subscribed)return;var d=h();D.set_color(a,d);c.subscribed=!0;c.subscribers=Dict.from_array(b.subscribers);var d=r(c),e=l(c);0!==e.length?(e.text("Subscribed").addClass("subscribed-button").addClass("btn-success"),c.render_subscribers&&d.hasClass("in")&&d.find(".subscriber_list_container .subscriber-list").prepend(s(page_params.fullname,
page_params.email))):t(c);d=d.closest(".subscription_row");d.find(".color_swatch").addClass("in");d.find(".regular_subscription_settings").collapse("show")}current_msg_list.narrowed&&current_msg_list.update_trailing_bookend();process_loaded_for_unread(all_msg_list.all());$(document).trigger($.Event("subscription_add_done.zulip",{sub:c}))},mark_unsubscribed:function(a){a=stream_data.get_sub(a);D.mark_sub_unsubscribed(a)},mark_sub_unsubscribed:function(a){if(void 0!==a&&a.subscribed){stream_list.remove_narrow_filter(a.name,
"stream");a.subscribed=!1;l(a).removeClass("subscribed-button").removeClass("btn-success").removeClass("btn-danger").text("Subscribe");var b=r(a);b.hasClass("in")&&b.collapse("hide");b=b.closest(".subscription_row");b.find(".color_swatch").removeClass("in");a.render_subscribers&&b.find(".regular_subscription_settings").collapse("hide");current_msg_list.narrowed&&current_msg_list.update_trailing_bookend();$(document).trigger($.Event("subscription_remove_done.zulip",{sub:a}))}},receives_desktop_notifications:function(a){a=
stream_data.get_sub(a);return void 0===a?!1:a.desktop_notifications},receives_audible_notifications:function(a){a=stream_data.get_sub(a);return void 0===a?!1:a.audible_notifications},setup_page:function(){function a(b){function c(a,b){return util.strcmp(a.name,b.name)}var d=stream_data.subscribed_subs(),e=new Dict({fold_case:!0});_.each(d,function(a){e.set(a.name,!0)});b=_.reject(b.streams,function(a){return e.has(a.name)});var g=[];_.each(b,function(a){var b=stream_data.get_sub(a.name);b||(b=k(a.name,
_.extend({subscribed:!1},a)));g.push(b)});d.sort(c);g.sort(c);var d=d.concat(g),h=[];_.each(d,function(a){a=f(a);h.push(a)});$("#subscriptions_table").empty();d=templates.render("subscription_table_body",{can_create_streams:page_params.can_create_streams,subscriptions:h});$("#subscriptions_table").append(d);_.each(h,function(a){n(a)});loading.destroy_indicator($("#subs_page_loading_indicator"));$(document).trigger($.Event("subs_page_loaded.zulip"))}function b(a,c){loading.destroy_indicator($("#subs_page_loading_indicator"));
ui.report_error("Error listing streams or subscriptions",a,$("#subscriptions-status"))}loading.make_indicator($("#subs_page_loading_indicator"));"mit.edu"!==page_params.domain?channel.post({url:"/json/get_public_streams",idempotent:!0,timeout:1E4,success:a,error:b}):(a({streams:[]}),$("#create_stream_button").val("Subscribe"))},update_subscription_properties:function(a,b,e){var g=stream_data.get_sub(a);if(void 0===g)blueslip.warn("Update for an unknown subscription",{stream_name:a,property:b,value:e});
else switch(b){case "color":stream_color.update_stream_color(g,a,e,{update_historical:!0});break;case "in_home_view":d(g,e);break;case "desktop_notifications":$("#subscription_"+g.stream_id+" #sub_desktop_notifications_setting .sub_setting_control").attr("checked",e);g.desktop_notifications=e;break;case "audible_notifications":$("#subscription_"+g.stream_id+" #sub_audible_notifications_setting .sub_setting_control").attr("checked",e);g.audible_notifications=e;break;case "name":c(g,e);break;case "description":g.description=
e;a=".subscription_row[data-subscription-id="+g.stream_id+"]";$(a+" .subscription_description").text(e);$(a+" input.description").val(e);break;case "email_address":g.email_address=e;break;default:blueslip.warn("Unexpected subscription property type",{property:b,value:e})}},invite_user_to_stream:function(a,b,c,d){return channel.post({url:"/json/subscriptions/add",data:{subscriptions:JSON.stringify([{name:b}]),principals:JSON.stringify([a])},success:c,error:d})},remove_user_from_stream:function(a,b,
c,d){return channel.post({url:"/json/subscriptions/remove",data:{subscriptions:JSON.stringify([b]),principals:JSON.stringify([a])},success:c,error:d})}};$(function(){function a(b,c,d,e,g){b.preventDefault();var h=$(b.target).attr("data-stream-name"),k=$(b.target).closest(".subscription_row");$("#subscriptions-status").hide();channel.post({url:c,data:{stream_name:h},success:function(a){a=stream_data.get_sub(h);a.invite_only=g;var b;a=f(a);b=templates.render("subscription_setting_icon",a);k.find(".subscription-setting-icon").expectOne().html(b);
b=templates.render("subscription_type",a);k.find(".subscription-type").expectOne().html(b);b=templates.render("change_stream_privacy",a);k.find(".change-stream-privacy").expectOne().html(b);stream_list.redraw_stream_privacy(a.name);a=k.find(".change-stream-privacy-feedback").expectOne();ui.report_success(d,a)},error:function(a){var b=k.find(".change-stream-privacy-feedback").expectOne();ui.report_error(e,a,b)}})}F(page_params.subbed_info,page_params.email_dict);F(page_params.unsubbed_info,page_params.email_dict);
q(page_params.subbed_info,!0);q(page_params.unsubbed_info,!1);delete page_params.subbed_info;delete page_params.unsubbed_info;stream_list.build_stream_list();$("#subscriptions_table").on("submit","#add_new_subscription",function(a){a.preventDefault();"mit.edu"===page_params.domain?v($("#create_stream_name").val()):(a=$.trim($("#create_stream_name").val()),"does-not-exist"===compose.check_stream_existence(a)?($("#stream_name").text(a),$("#people_to_add").html(templates.render("new_stream_users",{users:people.get_rest_of_realm()})),
$("#make-invite-only input:radio[value=public]").prop("checked",!0),$("#announce-new-stream input").prop("disabled",!1),$("#announce-new-stream input").prop("checked",!0),$("#stream-creation").modal("show")):v(a))});$("#stream_creation_form").on("change","#user-checkboxes input, #make-invite-only input",x);$(document).on("click",".subs_set_all_users",function(a){$("#people_to_add :checkbox").attr("checked",!0);a.preventDefault();x()});$(document).on("click",".subs_unset_all_users",function(a){$("#people_to_add :checkbox").attr("checked",
!1);a.preventDefault();x()});var b=$("#announce-stream-docs");b.popover({placement:"right",content:templates.render("announce_stream_docs"),trigger:"manual"});$("body").on("mouseover","#announce-stream-docs",function(a){b.popover("show");b.data("popover").tip().css("z-index",2E3);a.stopPropagation()});$("body").on("mouseout","#announce-stream-docs",function(a){b.popover("hide");a.stopPropagation()});$("#stream_creation_form").on("submit",function(a){a.preventDefault();a=$.trim($("#create_stream_name").val());
var b=_.map($("#stream_creation_form input:checkbox[name=user]:checked"),function(a){return $(a).val()});b.push(page_params.email);y(a,b,"invite-only"===$("#stream_creation_form input[name=privacy]:checked").val(),$("#announce-new-stream input").prop("checked"))});$("body").on("mouseover",".subscribed-button",function(a){$(a.target).addClass("btn-danger").text("Unsubscribe")}).on("mouseout",".subscribed-button",function(a){$(a.target).removeClass("btn-danger").text("Subscribed")});$("#subscriptions_table").on("click",
".email-address",function(a){var b;window.getSelection?(b=window.getSelection(),a=document.createRange(),a.selectNodeContents(this),b.removeAllRanges(),b.addRange(a)):document.body.createTextRange&&(a=document.body.createTextRange(),a.moveToElementText(this),a.select())});$("#subscriptions_table").on("click",".sub_unsub_button",function(a){a.preventDefault();a.stopPropagation();a=$(a.target).closest(".subscription_row").find(".subscription_name").text();stream_data.get_sub(a).subscribed?p(a):v(a)});
$("#subscriptions_table").on("show",".subscription_settings",function(a){a=$(a.target).closest(".subscription_row");var b=a.find(".colorpicker"),c=stream_data.get_color(a.find(".subscription_name").text());stream_color.set_colorpicker_color(b,c);b=a.offset().top+365-viewport.height()+viewport.scrollTop();0<b&&$(".app").animate({scrollTop:viewport.scrollTop()+b+5});a.find(".subscription_settings :input").removeAttr("tabindex")});$("#subscriptions_table").on("hide",".subscription_settings",function(a){$(a.target).closest(".subscription_row").find(".subscription_settings :input").attr("tabindex",
"-1")});$("#subscriptions_table").on("click",".sub_setting_checkbox",function(a){var b=$(a.target).closest(".sub_setting_checkbox").find(".sub_setting_control");b[0]!==a.target&&b.prop("checked",!b.prop("checked"))});$("#subscriptions_table").on("click","#sub_setting_not_in_home_view",e);$("#subscriptions_table").on("click","#sub_desktop_notifications_setting",g);$("#subscriptions_table").on("click","#sub_audible_notifications_setting",m);$("#subscriptions_table").on("submit",".subscriber_list_add form",
function(a){a.preventDefault();a=$(a.target).closest(".subscription_row");var b=a.find(".subscription_name").text(),c=a.find('input[name="principal"]'),d=$.trim(c.val()),e=a.find(".subscriber_list_container .alert-error"),g=a.find(".subscriber_list_container .alert-warning"),f=a.find(".subscriber_list_container .subscriber-list");D.invite_user_to_stream(d,b,function(a){c.val("");a.subscribed.hasOwnProperty(d)?(e.addClass("hide"),g.addClass("hide"),d===page_params.email?D.mark_subscribed(b):(a=people.get_by_email(d).full_name,
f.prepend(s(a,d)))):(e.addClass("hide"),g.removeClass("hide").text("User already subscribed"))},function(a){g.addClass("hide");e.removeClass("hide").text("Could not add user to this stream")})});$("#subscriptions_table").on("submit",".subscriber_list_remove form",function(a){a.preventDefault();var b=$(a.target).closest("tr"),c=b.children(".subscriber-email").text();a=$(a.target).closest(".subscription_row");var d=a.find(".subscription_name").text(),e=a.find(".subscriber_list_container .alert-error"),
g=a.find(".subscriber_list_container .alert-warning");D.remove_user_from_stream(c,d,function(a){0<a.removed.length?(e.addClass("hide"),g.addClass("hide"),b.remove(),c===page_params.email&&D.mark_unsubscribed(d)):(e.addClass("hide"),g.removeClass("hide").text("User already not subscribed"))},function(a){g.addClass("hide");e.removeClass("hide").text("Could not remove user from this stream")})});$("#subscriptions_table").on("submit",".rename-stream form",function(a){a.preventDefault();var b=$(a.target).closest(".subscription_row"),
c=b.find(".subscription_name");a=c.text();var d=b.find('input[name="new-name"]'),e=$.trim(d.val());$("#subscriptions-status").hide();channel.post({url:"/json/rename_stream",data:{old_name:a,new_name:e},success:function(a){d.val("");c.text(e);b.find(".email-address").text(a.email_address);ui.report_success("The stream has been renamed!",$("#subscriptions-status"))},error:function(a){ui.report_error("Error renaming stream",a,$("#subscriptions-status"))}})});$("#subscriptions_table").on("submit",".change-stream-description form",
function(a){a.preventDefault();$(a.target);var b=$(a.target).closest(".subscription_row");a=b.find(".subscription_name").text();b=b.find('input[name="description"]').val();$("#subscription_status").hide();channel.patch({url:"/json/streams/"+a,data:{description:JSON.stringify(b)},success:function(){ui.report_success("The stream description has been updated!",$("#subscriptions-status"))},error:function(a){ui.report_error("Error updating the stream description",a,$("#subscriptions-status"))}})});$("#subscriptions_table").on("click",
".make-stream-public-button",function(b){a(b,"/json/make_stream_public","The stream has been made public!","Error making stream public",!1)});$("#subscriptions_table").on("click",".make-stream-private-button",function(b){a(b,"/json/make_stream_private","The stream has been made private!","Error making stream private",!0)});$("#subscriptions_table").on("show",".regular_subscription_settings",function(a){a.stopPropagation()});$("#subscriptions_table").on("show",".subscription_settings",function(a){a=
$(a.target).closest(".subscription_row");var b=a.find(".subscription_name").text(),c=a.find(".subscriber_list_container .alert-warning"),d=a.find(".subscriber_list_container .alert-error"),e=a.find(".subscriber_list_container .subscriber-list"),g=a.find(".subscriber_list_loading_indicator");stream_data.get_sub(b).render_subscribers&&(c.addClass("hide"),d.addClass("hide"),e.empty(),loading.make_indicator(g),channel.post({url:"/json/get_subscribers",idempotent:!0,data:{stream:b},success:function(a){loading.destroy_indicator(g);
a=_.map(a.subscribers,function(a){return void 0===people.get_by_email(a)?a:s(people.get_by_email(a).full_name,a)});_.each(a.sort().reverse(),function(a){e.prepend(a)})},error:function(a){loading.destroy_indicator(g);d.removeClass("hide").text("Could not fetch subscriber list")}}),a.find('input[name="principal"]').typeahead({source:page_params.people_list,items:5,highlighter:function(a){a=typeahead_helper.render_person(a);return typeahead_helper.highlight_with_escaping(this.query,a)},matcher:function(a){var b=
$.trim(this.query.toLowerCase());return""===b||b===a.email?!1:-1!==a.email.toLowerCase().indexOf(b)||-1!==a.full_name.toLowerCase().indexOf(b)},sorter:typeahead_helper.sort_recipientbox_typeahead,updater:function(a){return a.email}}))});$("#subscriptions_table").on("show",".subscription_settings",function(a){a=$(a.target).closest(".subscription_row").find(".sub_arrow i");a.removeClass("icon-vector-chevron-down");a.addClass("icon-vector-chevron-up")});$("#subscriptions_table").on("hide",".subscription_settings",
function(a){a=$(a.target).closest(".subscription_row").find(".sub_arrow i");a.removeClass("icon-vector-chevron-up");a.addClass("icon-vector-chevron-down")})});D.show_and_focus_on_narrow=function(){$(document).one("subs_page_loaded.zulip",A);ui.change_tab_to("#subscriptions")};return D}();"undefined"!==typeof module&&(module.exports=subs);var message_edit=function(){function f(a){var b=a.keyCode||a.which;"message_edit_content"===a.target.id&&13===b&&(a.metaKey||a.ctrlKey)?(a=$(".message_edit_content").filter(":focus").closest(".message_row"),!0===message_edit.save(a)&&message_edit.end(a)):"message_edit_topic"===a.target.id&&13===b&&(a.stopPropagation(),a.preventDefault())}function h(a,b){var g=a.find(".message_content")[0].getBoundingClientRect().top,h=current_msg_list.get(rows.id(a)),k=a.find(".message_edit"),l=$(templates.render("message_edit_form",
{is_stream:h.is_stream,topic:h.subject,content:b})),r={form:l,raw_content:b},n=h.subject;current_msg_list.show_edit_message(a,r);l.keydown(f);e[h.id]=r;"stream"===h.type&&h.subject===compose.empty_subject_placeholder()?k.find(".message_edit_topic").focus():k.find(".message_edit_content").focus();g=k.find(".message_edit_content")[0].getBoundingClientRect().top-g+5;r.scrolled_by=g;viewport.scrollTop(viewport.scrollTop()+g);if(feature_flags.propagate_topic_edits&&void 0===h.local_id){var t=k.find(".message_edit_topic");
t.keyup(function(){var b=t.val();a.find(".message_edit_topic_propagate").toggle(b!==n)})}composebox_typeahead.initialize_compose_typeahead("#message_edit_content",{emoji:!0})}function b(a,b){h(a,b);var e=a.height()+a.offset().top,f=$("#compose").offset().top;e>f&&viewport.scrollTop(viewport.scrollTop()+e-f)}var a={},e={};a.save=function(a){var b=current_msg_list,e;e=a.hasClass("recipient_row")?rows.id_for_recipient_row(a):rows.id(a);e=current_msg_list.get(e);var f=!1,h=a.find(".message_edit_content").val(),
l=!1,r;"stream"===e.type&&(r=a.find(".message_edit_topic").val(),l=r!==e.subject&&""!==r.trim());if(void 0!==e.local_id){if(h===e.raw_content&&!l)return!0;echo.edit_locally(e,h,l?r:void 0);return!0}var n={message_id:e.id};l&&(n.subject=r,feature_flags.propagate_topic_edits&&(r=a.find("select.message_edit_topic_propagate").val()||"change_later",n.propagate_mode=r),f=!0);h!==e.raw_content&&(n.content=h,f=!0);if(!f)return!0;channel.post({url:"/json/update_message",data:n,success:function(a){if(b===current_msg_list)return!0},
error:function(b,c,e){b=channel.xhr_error_message("Error saving edit",b);a.find(".edit_error").text(b).show()}})};a.start=function(a){var c=current_msg_list.get(rows.id(a)),e=current_msg_list;channel.post({url:"/json/fetch_raw_message",idempotent:!0,data:{message_id:c.id},success:function(f){current_msg_list===e&&(c.raw_content=f.raw_content,b(a,f.raw_content))}})};a.start_local_failed_edit=function(a,c){b(a,c.raw_content)};a.start_topic_edit=function(a){var b=$(templates.render("topic_edit_form"));
current_msg_list.show_edit_topic(a,b);b.keydown(f);a=rows.id_for_recipient_row(a);a=current_msg_list.get(a).subject;a===compose.empty_subject_placeholder()&&(a="");b.find(".message_edit_topic").val(a).select().focus()};a.is_editing=function(a){return void 0!==e[a]};a.end=function(a){var b=current_msg_list.get(rows.id(a));if(void 0!==b&&void 0!==e[b.id]){var g=e[b.id].scrolled_by;viewport.scrollTop(viewport.scrollTop()-g);delete e[b.id];current_msg_list.hide_edit_message(a)}};a.maybe_show_edit=function(a,
b){void 0!==e[b]&&current_msg_list.show_edit_message(a,e[b])};$(document).on("narrow_deactivated.zulip",function(a){_.each(e,function(a,b){if(void 0!==current_msg_list.get(b)){var d=current_msg_list.get_row(b);current_msg_list.show_edit_message(d,a)}})});return a}();var condense=function(){function f(a){a.find(".message_condenser").hide();a.find(".message_expander").show()}function h(a){a.find(".message_content").addClass("condensed");f(a)}function b(a){a.find(".message_content").removeClass("condensed");a.find(".message_expander").hide();a.find(".message_condenser").show()}var a={},e=new Dict;a.uncollapse=function(a){var c=current_msg_list.get(rows.id(a)),e=a.find(".message_content");c.collapsed=!1;e.removeClass("collapsed");message_flags.send_collapsed([c],
!1);!0===c.condensed?h(a):!1===c.condensed?b(a):e.hasClass("could-be-condensed")?h(a):a.find(".message_expander").hide()};a.collapse=function(a){var b=current_msg_list.get(rows.id(a));b.collapsed=!0;message_flags.send_collapsed([b],!0);a.find(".message_content").addClass("collapsed");f(a)};a.clear_message_content_height_cache=function(){e=new Dict};a.un_cache_message_content_height=function(a){e.del(a)};a.condense_and_collapse=function(a){var c=0.65*viewport.height();_.each(a,function(a){var d=$(a).find(".message_content"),
f=current_msg_list.get(rows.id($(a)));if(void 0!==d&&void 0!==f){var l;l=f.id;if(e.has(l))l=e.get(l);else{var r=a.getBoundingClientRect().height;e.set(l,r);l=r}(l=l>c)?d.addClass("could-be-condensed"):d.removeClass("could-be-condensed");!0===f.condensed?h($(a)):!1===f.condensed?b($(a)):(l?h($(a)):(d.removeClass("condensed"),$(a).find(".message_expander").hide()),f.collapsed&&(d.addClass("collapsed"),$(a).find(".message_expander").show()))}})};$(function(){$("#home").on("click",".message_expander",
function(b){b=$(this).closest(".message_row");var c=current_msg_list.get(rows.id(b)),e=b.find(".message_content");c.collapsed?a.uncollapse(b):e.hasClass("condensed")&&(c.condensed=!1,e.removeClass("condensed"),$(this).hide(),b.find(".message_condenser").show())});$("#home").on("click",".message_condenser",function(a){a=$(this).closest(".message_row");current_msg_list.get(rows.id(a)).condensed=!0;h(a)})});return a}();var resize=function(){function f(a,b){var c=0;_.each(a,function(a){c+=a.real_height});_.each(a,function(a){var e=a.real_height/c,e=0.05>e?0.05:0.85<e?0.85:e;a.max_height=40>b*e?40:b*e>1.2*a.real_height?1.2*a.real_height:b*e})}var h={},b=!1;h.resize_bottom_whitespace=function(a){page_params.autoscroll_forever?$("#bottom_whitespace").height($("#compose-container")[0].offsetHeight):void 0!==a&&$("#bottom_whitespace").height(a.bottom_whitespace_height)};h.resize_page_components=function(){$("#compose");
$("#floating_recipient_bar");"other_tab"===ui.home_tab_obscured()?$("div.tab-pane.active").outerWidth():$("#main_div").outerWidth();var a;page_params.left_side_userlist&&(a=viewport.is_narrow(),$("#top_navbar").removeClass("rightside-userlist"),a&&!b?(b=!0,popovers.set_userlist_placement("left"),a=$(".bottom_sidebar").expectOne(),a.append($("#user-list").expectOne()),a.append($("#group-pm-list").expectOne()),a.append($("#share-the-love").expectOne()),$("#user_presences").css("margin","0px"),$("#group-pms").css("margin",
"0px"),$("#userlist-toggle").css("display","none"),$("#invite-user-link").hide()):!a&&b&&(b=!1,popovers.set_userlist_placement("right"),a=$("#right-sidebar").expectOne(),a.append($("#user-list").expectOne()),a.append($("#group-pm-list").expectOne()),$("#user_presences").css("margin",""),$("#group-pms").css("margin",""),$("#userlist-toggle").css("display",""),$("#invite-user-link").show()));if(b){a={};var d=viewport.height(),c=viewport.width(),g=$(".header").outerHeight(!0),m=$("#stream_filters").expectOne(),
k=$("#user_presences").expectOne(),l=$("#group-pms").expectOne(),r=m.prop("scrollHeight"),n=k.prop("scrollHeight"),t=l.prop("scrollHeight");a.bottom_whitespace_height=0.4*d;a.main_div_min_height=d-g;a.bottom_sidebar_height=d-parseInt($("#left-sidebar").css("marginTop"),10)-parseInt($(".bottom_sidebar").css("marginTop"),10);a.total_leftlist_height=a.bottom_sidebar_height-$("#global_filters").outerHeight(!0)-$("#streams_header").outerHeight(!0)-$("#userlist-header").outerHeight(!0)-$(".user-list-filter").outerHeight(!0)-
$("#group-pm-header").outerHeight(!0)-parseInt(m.css("marginBottom"),10)-parseInt(k.css("marginTop"),10)-parseInt(k.css("marginBottom"),10)-parseInt(l.css("marginTop"),10)-parseInt(l.css("marginBottom"),10)-15;g=[{real_height:r},{real_height:n},{real_height:t}];f(g,a.total_leftlist_height);a.stream_filters_max_height=g[0].max_height;a.user_presences_max_height=g[1].max_height;a.group_pms_max_height=g[2].max_height;a.viewport_height=d;a.viewport_width=c}else a={},c=viewport.height(),g=$("#top_navbar").outerHeight(!0),
d=$("#invite-user-link").outerHeight(!0)||0,a.bottom_whitespace_height=0.4*c,a.main_div_min_height=c-g,a.bottom_sidebar_height=c-g-40,a.right_sidebar_height=c-parseInt($("#right-sidebar").css("marginTop"),10),a.stream_filters_max_height=a.bottom_sidebar_height-$("#global_filters").outerHeight(!0)-$("#streams_header").outerHeight(!0)-10,$("#share-the-love").is(":visible")&&(a.stream_filters_max_height-=$("#share-the-love").outerHeight(!0)+20),a.stream_filters_max_height=Math.max(40,a.stream_filters_max_height),
c=$("#user_presences").expectOne(),g=$("#group-pms").expectOne(),d=a.right_sidebar_height-$("#feedback_section").outerHeight(!0)-parseInt(c.css("marginTop"),10)-parseInt(c.css("marginBottom"),10)-$("#userlist-header").outerHeight(!0)-$(".user-list-filter").outerHeight(!0)-d-parseInt(g.css("marginTop"),10)-parseInt(g.css("marginBottom"),10)-$("#group-pm-header").outerHeight(!0),c=[{real_height:c.prop("scrollHeight")},{real_height:g.prop("scrollHeight")}],f(c,d),a.user_presences_max_height=c[0].max_height,
a.group_pms_max_height=c[1].max_height;h.resize_bottom_whitespace(a);$("#stream-filters-container").css("max-height",a.stream_filters_max_height);$("#user_presences").css("max-height",a.user_presences_max_height);$("#group-pms").css("max-height",a.group_pms_max_height);$("#stream-filters-container").perfectScrollbar("update")};var a=$(window).width();h.handler=function(b){b=$(window).width();b!==a&&(a=b,condense.clear_message_content_height_cache());popovers.hide_all();h.resize_page_components();
-1!==current_msg_list.selected_id()&&scroll_to_selected()};return h}();var floating_recipient_bar=function(){var f={},h=!1,b;f.hide=function(){h&&($("#floating_recipient_bar").css("visibility","hidden"),h=!1)};f.update=function(){var a=$("#floating_recipient_bar"),e=a.offset().top+a.outerHeight(),a=current_msg_list.selected_row();if(!(void 0===a||0===a.length))if(a=rows.get_message_recipient_row(a),void 0!==a){for(;;){if(0===a.length){f.hide();return}if(a.is(".recipient_row")&&a.offset().top<e)break;a=a.prev()}var d=$(a).find(".message_header").outerHeight();if(e<=a.offset().top+
d)f.hide();else{var c;a!==b&&(0!==a.children(".message_header_stream").length?(e=$("#current_label_stream"),d=$("#current_label_private_message"),c=a.children(".message_header_stream")):(e=$("#current_label_private_message"),d=$("#current_label_stream"),c=a.children(".message_header_private_message")),e.find(".message_header").replaceWith(c.clone()),d.css("display","none"),e.css("display","block"),e.attr("zid",rows.id(rows.first_message_in_group(a))),e.toggleClass("faded",a.hasClass("faded")),b=a);
h||($("#floating_recipient_bar").css("visibility","visible"),h=!0)}}};return f}();var ui=function(){function f(){var a=viewport.message_viewport_info().visible_height-55;1>a&&(a=1);return a}function h(){var a;void 0!==c&&((a=current_msg_list.get(rows.id(c)))&&a.sent_by_me&&c.find(".message_content").find("span.edit_content").remove(),c.removeClass("message_hovered"),c=void 0)}function b(a,b){_.each([all_msg_list,home_msg_list,narrowed_msg_list],function(c){void 0!==c&&(c=c.get_row(a),void 0!==c&&b(c))})}function a(){d=!1;$("#home").hasClass("active")&&(suppress_scroll_pointer_update?
suppress_scroll_pointer_update=!1:keep_pointer_in_view(),floating_recipient_bar.update(),0===viewport.scrollTop()&&have_scrolled_away_from_top?(have_scrolled_away_from_top=!1,message_store.load_more_messages(current_msg_list)):have_scrolled_away_from_top||(have_scrolled_away_from_top=!0),setTimeout(unread.process_visible,0))}var e={},d=!1;e.actively_scrolling=function(){return d};e.home_tab_obscured=function(){return 0<$(".modal:visible").length?"modal":!$("#home").hasClass("active")?"other_tab":
!1};e.change_tab_to=function(a){$('#gear-menu a[href="'+a+'"]').tab("show")};e.focus_on=function(a){$("#"+a).focus()};e.page_up_the_right_amount=function(){var a=f();viewport.scrollTop(viewport.scrollTop()-a)};e.page_down_the_right_amount=function(){var a=f();viewport.scrollTop(viewport.scrollTop()+a)};e.replace_emoji_with_text=function(a){a.find(".emoji").replaceWith(function(){return $(this).attr("alt")})};var c;e.report_message=function(a,b,c){void 0===c&&(c="alert");b.removeClass(status_classes).addClass(c).text(a).stop(!0).fadeTo(0,
1);b.show()};e.report_error=function(a,b,c){b&&"4"===b.status.toString().charAt(0)&&(a+=": "+$.parseJSON(b.responseText).msg);ui.report_message(a,c,"alert-error")};e.report_success=function(a,b){ui.report_message(a,b,"alert-success")};e.find_message=function(a){var b;_.each([all_msg_list,home_msg_list,narrowed_msg_list],function(c){void 0!==c&&void 0===b&&(b=c.get(a))});return b};e.update_starred=function(a,c){var d=e.find_message(a);unread.mark_message_as_read(d);d.starred=c;b(a,function(a){a=a.find(".message_star");
c?a.addClass("icon-vector-star").removeClass("icon-vector-star-empty").removeClass("empty-star"):a.removeClass("icon-vector-star").addClass("icon-vector-star-empty").addClass("empty-star");a.attr("title",(d.starred?"Unstar":"Star")+" this message")})};var g=[],m=_.throttle(function(){_.each(g,function(a){b(a,function(a){a.find(".message_time").toggleClass("notvisible",!1)})});g=[]},100);e.show_local_message_arrived=function(a){g.push(a);m()};e.show_message_failed=function(a,c){b(a,function(a){a=a.find(".message_failed");
a.toggleClass("notvisible",!1);a.find(".failed_text").attr("title",c)})};e.show_failed_message_success=function(a){b(a,function(a){a.find(".message_failed").toggleClass("notvisible",!0)})};e.small_avatar_url=function(a){if(a.avatar_url){var b=a.avatar_url+"&s=50";a.sent_by_me&&(b+="&stamp="+settings.avatar_stamp);return b}return""};var k=!1;e.show_loading_more_messages_indicator=function(){k||(loading.make_indicator($("#loading_more_messages_indicator"),{abs_positioned:!0}),k=!0,floating_recipient_bar.hide())};
e.hide_loading_more_messages_indicator=function(){k&&(loading.destroy_indicator($("#loading_more_messages_indicator")),k=!1)};e.switchToFullWidth=function(){$("#full-width-style").remove();$("head").append('<style id="full-width-style" type="text/css">#home .alert-bar, .recipient-bar-content, #compose-container, .app-main, .header-main { max-width: none; }</style>');return"Switched to full width"};$(function(){var a=$.throttle(50,function(a,b){0<b?viewport.at_top()&&navigate.up():0>b&&viewport.at_bottom()&&
navigate.down();last_viewport_movement_direction=b});viewport.message_pane.mousewheel(function(b,c){var d=e.home_tab_obscured();d?"modal"===d&&b.preventDefault():a(b,c)});$(window).resize($.throttle(50,resize.handler));$(".modal-body, .scrolling_list, input, textarea").mousewheel(function(a,b){var c=$(this),d=c.scrollTop(),c=this.scrollHeight-c.innerHeight()-1;a.stopPropagation();(0<b&&0>=d||0>b&&d>=c)&&a.preventDefault()});$("#compose").mousewheel(function(a){a.stopPropagation();a.preventDefault()});
resize.handler();page_params.left_side_userlist||$("#navbar-buttons").addClass("right-userlist");$("#main_div").on("mouseover",".message_row",function(a){a=$(this).closest(".message_row");var b;if((!c||!(a&&c.attr("zid")===a.attr("zid")))&&!a.hasClass("local"))b=current_msg_list.get(rows.id(a)),h(),a.addClass("message_hovered"),b&&(b.sent_by_me&&!b.status_message&&!feature_flags.disable_message_editing)&&a.find(".message_content").find("p:last").append('<span class="edit_content"><i class="icon-vector-pencil edit_content_button"></i></span>'),
c=a});$("#main_div").on("mouseleave",".message_row",function(a){h()});$("#main_div").on("mouseover",".message_sender",function(a){$(this).closest(".message_row").addClass("sender_name_hovered")});$("#main_div").on("mouseout",".message_sender",function(a){$(this).closest(".message_row").removeClass("sender_name_hovered")});$("#subscriptions_table").on("mouseover",".subscription_header",function(a){$(this).addClass("active")});$("#subscriptions_table").on("mouseout",".subscription_header",function(a){$(this).removeClass("active")});
$("#stream").on("blur",function(){compose.decorate_stream_bar(this.value)});$(window).on("blur",function(){$(document.body).addClass("window_blurred")});$(window).on("focus",function(){$(document.body).removeClass("window_blurred")});$(document).on("message_selected.zulip",function(a){if(current_msg_list===a.msg_list&&-1!==a.id){var b=a.msg_list.get_row(a.id);$(".selected_message").removeClass("selected_message");b.addClass("selected_message");if(a.then_scroll){if(0===b.length){var c=current_msg_list.get_row(a.id);
blueslip.debug("message_selected missing selected row",{previously_selected:a.previously_selected,selected_id:a.id,selected_idx:a.msg_list.selected_idx(),selected_idx_exact:a.msg_list._items.indexOf(a.msg_list.get(a.id)),render_start:a.msg_list.view._render_win_start,render_end:a.msg_list.view._render_win_end,selected_id_from_idx:a.msg_list._items[a.msg_list.selected_idx()].id,msg_list_sorted:_.isEqual(_.pluck(a.msg_list._items,"id"),_.chain(current_msg_list._items).pluck("id").clone().value().sort()),
found_in_dom:c.length})}void 0!==a.target_scroll_offset?viewport.set_message_offset(a.target_scroll_offset):recenter_view(b,{from_scroll:a.from_scroll,force_center:-1===a.previously_selected})}}});$("#main_div").on("mouseenter",".message_time",function(a){a=$(a.target);var b=a.closest(".message_row"),b=current_msg_list.get(rows.id(b));timerender.set_full_datetime(b,a)});$("#streams_inline_cog").tooltip({placement:"left",animation:!1});feature_flags.disable_message_editing&&$("#edit-message-hotkey-help").hide();
"mit.edu"===page_params.domain&&($("#user-list").hide(),$("#group-pm-list").hide());feature_flags.full_width&&e.switchToFullWidth();reload.initialize();composebox_typeahead.initialize();search.initialize();tutorial.initialize();notifications.initialize();gear_menu.initialize();hashchange.initialize();invite.initialize();activity.initialize()});var l,r=0;$(function(){viewport.message_pane.scroll($.throttle(50,function(b){unread.process_visible();d=!0;clearTimeout(l);l=setTimeout(a,100)}));$("#new_message_content").blur(function(){r=
$(this).caret().start})});e.restore_compose_cursor=function(){$("#new_message_content").focus().caret(r,r)};$(function(){void 0!==window.bridge&&($("#new_message_content").attr("spellcheck","false"),$("#webathena_login_menu").hide(),$("#normal-zephyr-mirror-error-text").addClass("notdisplayed"),$("#desktop-zephyr-mirror-error-text").removeClass("notdisplayed"))});return e}();var click_handlers=function(){$(function(){function f(a){a=rows.get_closest_group(a);a=rows.id_for_recipient_row(a);a=current_msg_list.get(a);var b=current_msg_list.selected_message();return util.same_recipient(a,b)?b.id:a.id}function h(a){$(a.target).is("a")||a.stopPropagation();popovers.hide_all()}var b=!1,a=!1;$("#main_div").on("mousedown",".messagebox",function(){a=!1;b=!0});$("#main_div").on("mousemove",".messagebox",function(){b&&(a=!0)});$("#main_div").on("click",".messagebox",function(e){var d=
$(e.target);if(!d.is("a")&&!d.is("img.message_inline_image")&&!d.is("img.twitter-avatar")&&!d.is("div.message_length_controller")&&!d.is("textarea")&&!d.is("input")&&!d.is("i.edit_content_button")){if(!b||!a){d=$(this).closest(".message_row");d=rows.id(d);if(message_edit.is_editing(d))return;current_msg_list.select_id(d);respond_to_message({trigger:"message click"});e.stopPropagation();popovers.hide_all()}b=a=!1}});$("#main_div").on("click",".star",function(a){a.stopPropagation();popovers.hide_all();
a=rows.id($(this).closest(".message_row"));a=ui.find_message(a);unread.mark_message_as_read(a);ui.update_starred(a.id,!0!==a.starred);message_flags.send_starred([a],a.starred)});$("body").on("click",".edit_content_button",function(a){var b=current_msg_list.get_row(rows.id($(this).closest(".message_row")));current_msg_list.select_id(rows.id(b));message_edit.start(b);a.stopPropagation();popovers.hide_all()});$("body").on("click",".always_visible_topic_edit,.on_hover_topic_edit",function(a){var b=$(this).closest(".recipient_row");
message_edit.start_topic_edit(b);a.stopPropagation();popovers.hide_all()});$("body").on("click",".topic_edit_save",function(a){var b=$(this).closest(".recipient_row");!0===message_edit.save(b)&&current_msg_list.hide_edit_topic(b);a.stopPropagation();popovers.hide_all()});$("body").on("click",".topic_edit_cancel",function(a){var b=$(this).closest(".recipient_row");current_msg_list.hide_edit_topic(b);a.stopPropagation();popovers.hide_all()});$("body").on("click",".message_edit_save",function(a){var b=
$(this).closest(".message_row");!0===message_edit.save(b)&&message_edit.end($(this).closest(".message_row"));a.stopPropagation();popovers.hide_all()});$("body").on("click",".message_edit_cancel",function(a){var b=$(this).closest(".message_row");message_edit.end(b);a.stopPropagation();popovers.hide_all()});$("#home").on("click",".narrows_by_recipient",function(a){!a.metaKey&&!a.ctrlKey&&(a.preventDefault(),a=f(this),narrow.by_recipient(a,{trigger:"message header"}))});$("#home").on("click",".narrows_by_subject",
function(a){!a.metaKey&&!a.ctrlKey&&(a.preventDefault(),a=f(this),narrow.by_subject(a,{trigger:"message header"}))});$("#userlist-toggle-button").on("click",function(a){a.preventDefault();a.stopPropagation();a=!$(".app-main .column-right").hasClass("expanded");popovers.hide_all();a&&popovers.show_userlist_sidebar()});$("#streamlist-toggle-button").on("click",function(a){a.preventDefault();a.stopPropagation();a=!$(".app-main .column-left").hasClass("expanded");popovers.hide_all();a&&popovers.show_streamlist_sidebar()});
$("#user_presences").expectOne().on("click",".selectable_sidebar_block",function(a){var b=$(a.target).parents("li").attr("data-email");narrow.by("pm-with",b,{select_first_unread:!0,trigger:"sidebar"});a.preventDefault();a.stopPropagation();popovers.hide_all()});$("#group-pms").expectOne().on("click",".selectable_sidebar_block",function(a){var b=$(a.target).parents("li").attr("data-emails");narrow.by("pm-with",b,{select_first_unread:!0,trigger:"sidebar"});a.preventDefault();a.stopPropagation();popovers.hide_all()});
$(document).on("click","li[data-name='home']",function(a){ui.change_tab_to("#home");narrow.deactivate();setTimeout(maybe_scroll_to_selected,0);a.preventDefault()});$(".brand").on("click",function(a){ui.home_tab_obscured()?ui.change_tab_to("#home"):narrow.restore_home_state();maybe_scroll_to_selected();a.preventDefault()});$("#streams_header a").click(function(a){ui.change_tab_to("#subscriptions");a.preventDefault()});popovers.register_click_handlers();notifications.register_click_handlers();$(".logout_button").click(function(a){$("#logout_form").submit()});
$(".restart_get_events_button").click(function(a){server_events.restart_get_events({dont_block:!0})});$("#send-status .send-status-close").click(function(){$("#send-status").stop(!0).fadeOut(500)});$(".compose_stream_button").click(function(a){compose.start("stream")});$(".compose_private_button").click(function(a){compose.start("private")});$(".empty_feed_compose_stream").click(function(a){compose.start("stream",{trigger:"empty feed message"});a.preventDefault()});$(".empty_feed_compose_private").click(function(a){compose.start("private",
{trigger:"empty feed message"});a.preventDefault()});$(".empty_feed_join").click(function(a){subs.show_and_focus_on_narrow();a.preventDefault()});$("#compose_buttons").click(h);$(".compose-content").click(h);$("#compose_close").click(function(a){compose.cancel()});$(".feedback").click(function(a){compose.start("private",{private_message_recipient:"feedback@zulip.com",trigger:"feedback menu item"})});$("#feedback_button").click(function(a){a.stopPropagation();popovers.hide_all();compose.start("private",
{private_message_recipient:"feedback@zulip.com",trigger:"feedback button"})});$("#right-sidebar, #top_navbar").on("click",".webathena_login",function(a){$("#zephyr-mirror-error").hide();WinChan.open({url:"https://webathena.mit.edu/#!request_ticket_v1",relay_url:"https://webathena.mit.edu/relay.html",params:{realm:"ATHENA.MIT.EDU",principal:["zephyr","zephyr"]}},function(a,b){a?blueslip.warn(a):"OK"!==b.status?blueslip.warn(b):channel.post({url:"/accounts/webathena_kerberos_login/",data:{cred:JSON.stringify(b.session)},
success:function(a,b){$("#zephyr-mirror-error").hide()},error:function(a,b){$("#zephyr-mirror-error").show()}})});$("#settings-dropdown").dropdown("toggle");a.preventDefault();a.stopPropagation()});$(".bankruptcy_button").click(function(a){unread.enable()});$("#yes-bankrupt").click(function(a){fast_forward_pointer();$("#yes-bankrupt").hide();$("#no-bankrupt").hide();$(this).after($("<div>").addClass("alert alert-info settings_committed").text("Bringing you to your latest messages\u2026"))});$(document).on("click",
function(a){0===a.button&&(0===$(".popover-inner").has(a.target).length&&popovers.hide_all(),compose.composing()&&(!$(a.target).is("a")&&0===$(a.target).closest(".modal").length&&""===window.getSelection().toString())&&compose.cancel())});$("a.dropdown-toggle, .dropdown-menu a").on("touchstart",function(a){a.stopPropagation()})});return{}}();$(function(){$("#stream-filters-container").perfectScrollbar({suppressScrollX:!0,useKeyboard:!1,wheelSpeed:20})});
function scrollbarWidth(){$("body").prepend('<div id="outertest" style="width:200px; height:150px; position: absolute; top: 0; left: 0; overflow-x:hidden; overflow-y:scroll; background: #ff0000; visibility: hidden;"><div id="innertest" style="width:100%; height: 200px; overflow-y: visible;">&nbsp;</div></div>');var f=$("#outertest").outerWidth()-$("#innertest").outerWidth();$("#outertest").remove();return f}
$(function(){var f=scrollbarWidth();0<f&&($(".header").css("left","-"+f+"px"),$(".header-main").css("left",f+"px"),$(".header-main").css("max-width",1400+f+"px"),$(".header-main .column-middle").css("margin-right",250+f+"px"),$(".fixed-app").css("left","-"+f+"px"),$(".fixed-app .app-main").css("max-width",1400+f+"px"),$(".fixed-app .column-middle").css("margin-left",250+f+"px"),$(".column-right").css("right",f+"px"),$(".app-main .right-sidebar").css({"margin-left":f+"px",width:250-f+"px"}),$("#compose").css("left",
"-"+f+"px"),$(".compose-content").css({left:f+"px","margin-right":250+f+"px"}),$("#compose-container").css("max-width",1400+f+"px"),$("head").append("<style> @media (max-width: 975px) { .compose-content, .header-main .column-middle { margin-right: "+(7+f)+"px !important; } } @media (max-width: 775px) { .fixed-app .column-middle { margin-left: "+(7+f)+"px !important; } } </style>"))});var gear_menu=function(){var f={},h={};f.initialize=function(){admin.show_or_hide_menu_item();$('#gear-menu a[data-toggle="tab"]').on("show",function(a){a=$(a.relatedTarget).attr("href");h[a]=viewport.scrollTop()});$('#gear-menu a[data-toggle="tab"]').on("shown",function(a){a=$(a.target).attr("href");resize.resize_bottom_whitespace();$(".alert-error").hide();$(".alert-success").hide();$(".alert-info").hide();$(".alert").hide();var b=a;"#home"===b&&(b="");hashchange.changehash(b);h.hasOwnProperty(a)?
viewport.scrollTop(h[a]):"#home"===a?scroll_to_selected():viewport.scrollTop(0)});var b=$('#gear-menu a[href="#subscriptions"]');b.on("click",function(a){$(document).one("subs_page_loaded.zulip",function(a){$("#create_stream_name").focus().select()})});b.on("shown",subs.setup_page);$('#gear-menu a[href="#administration"]').on("shown",admin.setup_page);$('#gear-menu a[href="#settings"]').on("shown",settings.setup_page)};return f}();var copy_and_paste=function(){function f(b,a){var e,d=!1,c=b;if(0!==c.length){for(e=0;!c.is(".message_row")&&10>e;e++)c=a(c);if(10!==e)return 0!==e&&(d=!0),[rows.id(c),d]}}function h(b){var a=window.getSelection(),e,d=[],c,g,h,k,l,r=!1,n=$("<div>");for(b=0;b<a.rangeCount;b++){e=a.getRangeAt(b);d.push(e);c=$(e.startContainer);k=f($(c.parents(".selectable_row, .message_header")[0]),function(a){return a.next()});if(void 0===k)return;h=k[0];g=$(e.endContainer);"bottom_whitespace"===g.attr("id")||"compose_close"===
g.attr("id")?(e=$(".message_row:last"),r=!0):e=$(g.parents(".selectable_row")[0]);l=f(e,function(a){return a.prev()});if(void 0===l)return;e=l[0];if(k[1]||l[1])r=!0;if(!r&&c.parents(".selectable_row>div")[0]===g.parents(".selectable_row>div")[0])return;for(c=current_msg_list.get_row(h);rows.id(c)<=e;c=rows.next_visible(c))c.prev().hasClass("message_header")&&(h=$("<div>").text(c.prev().text().replace(/\s+/g," ").replace(/^\s/,"").replace(/\s$/,"")),n.append($("<p>").append($("<strong>").text(h.text())))),
h=current_msg_list.get(rows.id(c)),k=$(h.content).slice(0,1),k.prepend(h.sender_full_name+": "),n.append(k),n.append($(h.content).slice(1))}void 0!==window.bridge&&ui.replace_emoji_with_text(n);n.css({position:"absolute",left:"-99999px"}).attr("id","copytempdiv");$("body").append(n);a.selectAllChildren(n[0]);window.setTimeout(function(){a=window.getSelection();a.removeAllRanges();_.each(d,function(b){a.addRange(b)});$("#copytempdiv").remove()},0)}$(function(){$(document).bind("copy",h)});return{}}();var popovers=function(){function f(){return $("li:not(.divider):visible a",b.data("popover").$tip)}var h={},b,a,e="right";h.toggle_actions_popover=function(a,c){var d=b;popovers.hide_all();if(!(void 0!==d&&d.get()[0]===a)&&(current_msg_list.select_id(c),d=$(a),void 0===d.data("popover"))){var e=current_msg_list.get(c),g=e.sent_by_me&&void 0===e.local_id&&!feature_flags.disable_message_editing,f=e.stream&&e.subject&&!muting.is_topic_muted(e.stream,e.subject),h=e.stream&&e.subject&&muting.is_topic_muted(e.stream,
e.subject),e={message:e,can_edit_message:g,can_mute_topic:f,can_unmute_topic:h,conversation_time_uri:narrow.by_conversation_and_time_uri(e),narrowed:narrow.active()},g=d.offset().top-viewport.scrollTop();d.popover({placement:g>viewport.height()-300?"top":"bottom",title:"",content:templates.render("actions_popover_content",e),trigger:"manual"});d.popover("show");b=d}};h.open_message_menu=function(){var a=current_msg_list.selected_id();popovers.toggle_actions_popover($(".selected_message .actions_hover")[0],
a);b&&f().eq(0).expectOne().focus();return!0};h.actions_menu_handle_keyboard=function(a){var b=f(),c=b.index(b.filter(":focus"));if("enter"===a&&0<=c&&c<b.length)return b.eq(c).trigger("click");-1===c?c=0:("down_arrow"===a||"vim_down"===a)&&c<b.length-1?++c:("up_arrow"===a||"vim_up"===a)&&0<c&&--c;b.eq(c).focus()};h.actions_popped=function(){return void 0!==b};h.hide_actions_popover=function(){popovers.actions_popped()&&(b.popover("destroy"),b=void 0)};h.hide_message_info_popover=function(){void 0!==
a&&(a.popover("destroy"),a=void 0)};h.hide_userlist_sidebar=function(){$(".app-main .column-right").removeClass("expanded")};h.hide_streamlist_sidebar=function(){$(".app-main .column-left").removeClass("expanded")};h.show_userlist_sidebar=function(){$(".app-main .column-right").addClass("expanded");resize.resize_page_components()};h.show_streamlist_sidebar=function(){$(".app-main .column-left").addClass("expanded");resize.resize_page_components()};var d,c,g,m;h.hide_stream_sidebar_popover=function(){void 0!==
d&&($(d).popover("destroy"),d=void 0)};h.hide_topic_sidebar_popover=function(){void 0!==c&&($(c).popover("destroy"),c=void 0)};h.hide_user_sidebar_popover=function(){void 0!==m&&($("#user_presences").data("popover",m),$("#user_presences").popover("destroy"),m=g=void 0)};h.register_click_handlers=function(){$("#main_div").on("click",".actions_hover",function(a){var b=$(this).closest(".message_row");a.stopPropagation();popovers.toggle_actions_popover(this,rows.id(b))});$("#main_div").on("click",".sender_info_hover",
function(b){var c=$(this).closest(".message_row");b.stopPropagation();c=rows.id(c);b=a;popovers.hide_all();if(!(void 0!==b&&b.get()[0]===this)&&(current_msg_list.select_id(c),b=$(this),void 0===b.data("popover"))){timerender.set_full_datetime(current_msg_list.get(c),b.closest(".message_row").find(".message_time"));var c=current_msg_list.get(c),c={message:c,pm_with_uri:narrow.pm_with_uri(c.sender_email),sent_by_uri:narrow.by_sender_uri(c.sender_email),narrowed:narrow.active()},d=b.offset().top-viewport.scrollTop();
b.popover({placement:d>viewport.height()-300?"top":"bottom",title:templates.render("message_info_popover_title",c),content:templates.render("message_info_popover_content",c),trigger:"manual"});b.popover("show");a=b}});$("body").on("click",".user_popover .narrow_to_private_messages",function(a){var b=$(a.target).parents("ul").attr("data-email");popovers.hide_user_sidebar_popover();narrow.by("pm-with",b,{select_first_unread:!0,trigger:"user sidebar popover"});a.stopPropagation()});$("body").on("click",
".user_popover .narrow_to_messages_sent",function(a){var b=$(a.target).parents("ul").attr("data-email");popovers.hide_user_sidebar_popover();narrow.by("sender",b,{select_first_unread:!0,trigger:"user sidebar popover"});a.stopPropagation()});$("body").on("click",".user_popover .compose_private_message",function(a){var b=$(a.target).parents("ul").attr("data-email");popovers.hide_user_sidebar_popover();compose.start("private",{private_message_recipient:b,trigger:"sidebar user actions"});a.stopPropagation()});
$("body").on("click",".sender_info_popover .narrow_to_private_messages",function(a){var b=$(a.target).parents("ul").attr("data-email");narrow.by("pm-with",b,{select_first_unread:!0,trigger:"user sidebar popover"});popovers.hide_message_info_popover();a.stopPropagation();a.preventDefault()});$("body").on("click",".sender_info_popover .narrow_to_messages_sent",function(a){var b=$(a.target).parents("ul").attr("data-email");narrow.by("sender",b,{select_first_unread:!0,trigger:"user sidebar popover"});
popovers.hide_message_info_popover();a.stopPropagation();a.preventDefault()});$("#user_presences").on("click","span.arrow",function(a){a.stopPropagation();a=$(this).closest("li");var b=a.find("a").attr("data-email"),c=a.find("a").attr("data-name");g===b?popovers.hide_all():(popovers.hide_all(),"right"===e&&popovers.show_userlist_sidebar(),c=templates.render("user_sidebar_actions",{email:b,name:c}),a.popover({content:c,placement:"left"===e?"right":"left",trigger:"manual",fixed:!0}),a.popover("show"),
g=b,m=a.data("popover"))});$("#stream_filters").on("click",".topic-sidebar-arrow",function(a){var b=a.target;if(void 0!==c&&c===b)popovers.hide_topic_sidebar_popover();else{popovers.hide_all();popovers.show_streamlist_sidebar();var d=$(b).closest(".expanded_subjects").expectOne().attr("data-stream"),e=$(b).closest("li").expectOne().attr("data-name"),g=muting.is_topic_muted(d,e),d=templates.render("topic_sidebar_actions",{stream_name:d,topic_name:e,can_mute_topic:!g,can_unmute_topic:g});$(b).popover({content:d,
trigger:"manual",fixed:!0});$(b).popover("show");c=b}a.stopPropagation()});$("body").on("click",".narrow_to_topic",function(a){popovers.hide_topic_sidebar_popover();var b=$(a.currentTarget).closest(".narrow_to_topic").expectOne(),c=b.attr("data-stream-name"),b=b.attr("data-topic-name");narrow.activate([{operator:"stream",operand:c},{operator:"topic",operand:b}],{select_first_unread:!0,trigger:"sidebar"});a.stopPropagation()});$("body").on("click",".sidebar-popover-mute-topic",function(a){var b=$(a.currentTarget).attr("data-stream-name"),
c=$(a.currentTarget).attr("data-topic-name");popovers.hide_topic_sidebar_popover();muting.mute_topic(b,c);muting_ui.persist_and_rerender();a.stopPropagation();a.preventDefault()});$("body").on("click",".sidebar-popover-unmute-topic",function(a){var b=$(a.currentTarget).attr("data-stream-name"),c=$(a.currentTarget).attr("data-topic-name");popovers.hide_topic_sidebar_popover();muting.unmute_topic(b,c);muting_ui.persist_and_rerender();a.stopPropagation();a.preventDefault()});$("#stream_filters").on("click",
".stream-sidebar-arrow",function(a){function b(a,c){var d=a[0].offsetHeight,e=a.find(".colorpicker-container").find(".colorpicker");c(e);var e=a[0].offsetHeight,g=a.closest(".popover"),f=parseFloat(g.css("top").replace("px",""));g.css("top",f+0.5*-(e-d)+"px")}var c=a.target;if(void 0!==d&&d===c)popovers.hide_stream_sidebar_popover();else{popovers.hide_all();popovers.show_streamlist_sidebar();var e=$(c).parents("li").attr("data-name");$(c).offset();viewport.scrollTop();$(c).popover({content:templates.render("stream_sidebar_actions",
{stream:stream_data.get_sub(e)}),trigger:"manual",fixed:!0});$(c).popover("show");e=stream_data.get_sub(e).stream_id;e=$(".streams_popover[data-id="+e+"]");b(e,function(a){a.spectrum(stream_color.sidebar_popover_colorpicker_options)});$(".streams_popover").on("click",".custom_color",function(a){b($(a.target).closest(".streams_popover"),function(b){b.spectrum("destroy");b.spectrum(stream_color.sidebar_popover_colorpicker_options_full);b.parent().find(".sp-container").removeClass("sp-buttons-disabled");
$(a.target).hide()});$(".streams_popover").on("click","a.sp-cancel",function(a){popovers.hide_stream_sidebar_popover()})});d=c}a.stopPropagation()});$("body").on("click",".respond_button",function(a){respond_to_message({trigger:"popover respond"});popovers.hide_actions_popover();a.stopPropagation();a.preventDefault()});$("body").on("click",".respond_personal_button",function(a){respond_to_message({reply_type:"personal",trigger:"popover respond pm"});popovers.hide_all();a.stopPropagation();a.preventDefault()});
$("body").on("click",".popover_narrow_by_id",function(a){var b=$(a.currentTarget).data("msgid");popovers.hide_actions_popover();narrow.by_id(b,{trigger:"popover"});a.stopPropagation();a.preventDefault()});$("body").on("click",".popover_narrow_by_conversation_and_time",function(a){var b=$(a.currentTarget).data("msgid");popovers.hide_actions_popover();narrow.by_conversation_and_time(b,{trigger:"popover"});a.stopPropagation();a.preventDefault()});$("body").on("click",".popover_toggle_collapse",function(a){var b,
c=$(a.currentTarget).data("msgid"),d=current_msg_list.get_row(c),e=current_msg_list.get(rows.id(d));current_msg_list===narrowed_msg_list&&(b=home_msg_list.get_row(c));c=function(a){a&&(e.collapsed?condense.uncollapse(a):condense.collapse(a))};popovers.hide_actions_popover();c(d);c(b);a.stopPropagation();a.preventDefault()});$("body").on("click",".popover_edit_message",function(a){var b=$(a.currentTarget).data("msgid"),b=current_msg_list.get_row(b);popovers.hide_actions_popover();message_edit.start(b);
a.stopPropagation();a.preventDefault()});$("body").on("click",".popover_mute_topic",function(a){var b=$(a.currentTarget).data("msg-stream"),c=$(a.currentTarget).data("msg-topic");popovers.hide_actions_popover();muting.mute_topic(b,c);muting_ui.persist_and_rerender();a.stopPropagation();a.preventDefault()});$("body").on("click",".popover_unmute_topic",function(a){var b=$(a.currentTarget).data("msg-stream"),c=$(a.currentTarget).data("msg-topic");popovers.hide_actions_popover();muting.unmute_topic(b,
c);muting_ui.persist_and_rerender();a.stopPropagation();a.preventDefault()});$("body").on("click",".toggle_home",function(a){var b=$(a.currentTarget).parents("ul").attr("data-name");popovers.hide_stream_sidebar_popover();subs.toggle_home(b);a.stopPropagation()});$("body").on("click",".narrow_to_stream",function(a){var b=$(a.currentTarget).parents("ul").attr("data-name");popovers.hide_stream_sidebar_popover();narrow.by("stream",b,{select_first_unread:!0,trigger:"sidebar popover"});a.stopPropagation()});
$("body").on("click",".compose_to_stream",function(a){var b=$(a.currentTarget).parents("ul").attr("data-name");popovers.hide_stream_sidebar_popover();compose.start("stream",{stream:b,trigger:"sidebar stream actions"});a.stopPropagation()});$("body").on("click",".open_stream_settings",function(a){var b=$(a.currentTarget).parents("ul").attr("data-name");popovers.hide_stream_sidebar_popover();$("#subscriptions").hasClass("active")?subs.show_settings_for(b):($(document).one("subs_page_loaded.zulip",function(a){subs.show_settings_for(b)}),
ui.change_tab_to("#subscriptions"))})};h.any_active=function(){return popovers.actions_popped()||void 0!==m||void 0!==d||void 0!==c||void 0!==a};h.hide_all=function(){popovers.hide_actions_popover();popovers.hide_message_info_popover();popovers.hide_stream_sidebar_popover();popovers.hide_topic_sidebar_popover();popovers.hide_user_sidebar_popover();popovers.hide_userlist_sidebar();popovers.hide_streamlist_sidebar()};h.set_userlist_placement=function(a){e=a||"right"};return h}();var typeahead_helper=function(){function f(b,a,e){for(var d=[],c=[],g=[],f=a.shift();f;){var h;h=e?e(f):f;0===h.indexOf(b)?d.push(f):0===h.toLowerCase().indexOf(b.toLowerCase())?c.push(f):g.push(f);f=a.shift()}return{matches:d.concat(c),rest:g}}var h={highlight_with_escaping:function(b,a){b=b.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&");var e=RegExp("("+b+")","ig"),d=a.split(e),c="";_.each(d,function(a){c=a.match(e)?c+("<strong>"+Handlebars.Utils.escapeExpression(a)+"</strong>"):c+Handlebars.Utils.escapeExpression(a)});
return c},highlight_with_escaping_and_regex:function(b,a){var e=a.split(b),d="";_.each(e,function(a){d=a.match(b)?d+("<strong>"+Handlebars.Utils.escapeExpression(a)+"</strong>"):d+Handlebars.Utils.escapeExpression(a)});return d},highlight_query_in_phrase:function(b,a){var e;b=b.toLowerCase();b=b.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&");var d=RegExp("(^"+b+")","ig"),c="",g=a.split(" ");for(e=0;e<g.length;e++)0<e&&(c+=" "),c+=h.highlight_with_escaping_and_regex(d,g[e]);return c},render_person:function(b){return b.special_item_text?
b.special_item_text:b.full_name+" <"+b.email+">"},sorter:function(b,a,e){b=f(b,a,e);return b.matches.concat(b.rest)},compare_by_pms:function(b,a){return b.pm_recipient_count>a.pm_recipient_count?-1:b.pm_recipient_count<a.pm_recipient_count?1:!b.is_bot&&a.is_bot?-1:b.is_bot&&!a.is_bot?1:b.full_name<a.full_name?-1:b===a?0:1},sort_by_pms:function(b){b.sort(h.compare_by_pms);return b},sort_recipients:function(b,a){var e=f(a,b,function(a){return a.full_name}),d=f(a,e.rest,function(a){return a.email}),
e=h.sort_by_pms(e.matches.concat(d.matches)),d=h.sort_by_pms(d.rest);return e.concat(d)},sort_emojis:function(b,a){var e=f(a,b,function(a){return a.emoji_name});return e.matches.concat(e.rest)},sort_recipientbox_typeahead:function(b){var a=composebox_typeahead.get_cleaned_pm_recipients(this.query);return h.sort_recipients(b,a[a.length-1])}};return h}();"undefined"!==typeof module&&(module.exports=typeahead_helper);var search_suggestion=function(){function f(a,b){var c;b=b.toLowerCase();a=a.toLowerCase();if(0===a.indexOf(b))return!0;var d=a.split(" ");for(c=0;c<d.length;c++)if(0===d[c].indexOf(b))return!0;return!1}function h(a,b){var c=typeahead_helper.highlight_query_in_phrase;return c(a,b.full_name)+" &lt;"+c(a,b.email)+"&gt;"}function b(a){var b;switch(a.length){case 0:b="";break;case 1:var c=a[0].operator;b=a[0].operand;if(!("stream"===c||"search"===c))return[];break;default:return[]}a=stream_data.subscribed_streams();
a=_.filter(a,function(a){return f(a,b)});a=typeahead_helper.sorter(b,a);return _.map(a,function(a){var c="Narrow to stream "+typeahead_helper.highlight_query_in_phrase(b,a);a=Filter.unparse([{operator:"stream",operand:a}]);return{description:c,search_string:a}})}function a(a,b,c){if(0===b.length)return[];var d=!1;"is"===b[0].operator&&"private"===b[0].operand?(b=b.slice(1),d=!0):_.each(c,function(a){b[0].operator===a&&(d=!0)});if(!d)return[];var e,g,m=!1;if(0===b.length)e="",g=c[0];else if(1===b.length){var v=
b[0].operator;"search"===v?(e=b[0].operand,g=c[0]):_.each(c,function(a){v===a&&(e=b[0].operand,g=a,m=b[0].negated)});if(void 0===e)return[]}else return[];a=_.filter(a,function(a){return""===e||f(a.full_name,e)||f(a.email,e)});a.sort(typeahead_helper.compare_by_pms);a=a.slice(0,15);var p=Filter.operator_to_prefix(g,m);a=_.map(a,function(a){var b={operator:g,operand:a.email,negated:m};a=h(e,a);a=p+" "+a;var c=[b];m&&(c=[{operator:"is",operand:"private"},b]);b=Filter.unparse(c);return{description:a,
search_string:b}});a.push({search_string:"is:private",description:"Private messages"});return a}function e(a,b,c){if(""===b)return[];a=_.filter(a,function(a){return f(a.full_name,b)||f(a.email,b)});a.sort(typeahead_helper.compare_by_pms);var d=Filter.operator_to_prefix(c);return _.map(a,function(a){var e=h(b,a);return{description:d+" "+e,search_string:c+":"+a.email}})}function d(a){var b=Filter.unparse(a);a=Filter.describe(a);a=Handlebars.Utils.escapeExpression(a);return{description:a,search_string:b}}
function c(a){if(0===a.length)return[];var b=a.slice(-1)[0],c=Filter.canonicalize_operator(b.operator),d=b.operand,e="topic"===c&&b.negated,g;switch(c){case "stream":b=new Filter(a);if(b.has_operator("topic"))return[];g="";break;case "topic":case "search":g=d;a=a.slice(0,-1);b=new Filter(a);if(b.has_operator("topic"))return[];b.has_operator("stream")?d=b.operands("stream")[0]:(d=narrow.stream(),a.push({operator:"stream",operand:d}));break;default:return[]}if(!d)return[];b=recent_subjects.get(d);d=
stream_data.get_name(d);if(!b)return[];b=b.slice(0,300);b=_.map(b,function(a){return a.subject});""!==g&&(b=_.filter(b,function(a){return f(a,g)}));b=b.slice(0,10);b.sort();return _.map(b,function(b){b=a.concat([{operator:"topic",operand:b,negated:e}]);var c=Filter.unparse(b);return{description:Filter.describe(b),search_string:c}})}function g(a,b){if(1>b.length)return[];var c,d=[];for(c=b.length-1;1<=c;--c){var e=b.slice(0,c),g=Filter.unparse(e),e={description:Filter.describe(e),search_string:g};
d.push(e)}return d}function m(a,b){if(2<=b.length)return[];var c=[{search_string:"",description:"Home"},{search_string:"in:all",description:"All messages"},{search_string:"is:private",description:"Private messages"},{search_string:"is:starred",description:"Starred messages"},{search_string:"is:mentioned",description:"@-mentions"},{search_string:"is:alerted",description:"Alerted messages"},{search_string:"sender:"+page_params.email,description:"Sent by me"}];a=a.toLowerCase();return c=_.filter(c,function(b){return b.search_string.toLowerCase()===
a?!1:""===a?!0:0===b.search_string.toLowerCase().indexOf(a)||0===b.description.toLowerCase().indexOf(a)})}return{get_suggestions:function(f){var h=[],r,n=Filter.parse(f),h=[d(n)];r=m(f,n);h=h.concat(r);r=b(n);var h=h.concat(r),t=page_params.people_list;r=e(t,f,"pm-with");h=h.concat(r);r=e(t,f,"sender");h=h.concat(r);r=a(t,n,["pm-with","sender"]);h=h.concat(r);r=c(n);h=h.concat(r);r=g(f,n);var h=h.concat(r),s={},q=[];_.each(h,function(a){s[a.search_string]||(s[a.search_string]=a,q.push(a))});return{strings:_.map(q,
function(a){return a.search_string}),lookup_table:s}}}}();"undefined"!==typeof module&&(module.exports=search_suggestion);var search=function(){function f(a){var b=$("#search_query");ui.change_tab_to("#home");a=Filter.parse(a);narrow.activate(a,{trigger:"search"});b.blur();return b.val()}function h(a){var b=$("#search_query");a||b.val()||narrow.active()?$(".search_button").removeAttr("disabled"):$(".search_button").attr("disabled","disabled")}var b={update_button_visibility:function(){h($("#search_query").is(":focus"))},initialize:function(){var a={};$("#search_query").typeahead({source:function(b){b=search_suggestion.get_suggestions(b);
a=b.lookup_table;return b.strings},fixed:!0,items:30,helpOnEmptyStrings:!0,naturalSearch:!0,highlighter:function(b){return a[b].description},matcher:function(a){return!0},updater:f,sorter:function(a){return a}});$("#searchbox_form").keydown(function(a){b.update_button_visibility();var c=a.which,e=$("#search_query");if(13===c&&e.is(":focus"))return a.preventDefault(),!1}).keyup(function(a){a=a.which;var b=$("#search_query");13===a&&b.is(":focus")&&(narrow.activate(Filter.parse(b.val()),{trigger:"search"}),
b.blur(),h(!1))});$("#search_exit").on("click",b.clear_search);var e=$("#search_query");e.on("focus",b.focus_search).on("blur",function(){setTimeout(function(){var a=narrow.search_string();e.val(a);b.update_button_visibility()},100)})},focus_search:function(){h(!0)},initiate_search:function(){$("#search_query").select()},clear_search:function(){narrow.deactivate();$("#search_query").blur();b.update_button_visibility()}};return b}();"undefined"!==typeof module&&(module.exports=search);var composebox_typeahead=function(){function f(a){a=a.split(/\s*[,;]\s*/);return a[a.length-1]}function h(a){return typeahead_helper.highlight_with_escaping(this.query,a)}function b(a,b){a=a.toLowerCase();return-1!==b.email.toLowerCase().indexOf(a)||-1!==b.full_name.toLowerCase().indexOf(a)}function a(a){var b=a.keyCode||a.which;if(13===b||9===b&&!a.shiftKey)if(("stream"===a.target.id||"subject"===a.target.id||"private_message_recipient"===a.target.id)&&a.preventDefault(),"new_message_content"===
a.target.id&&13!==b&&a.preventDefault(),"stream"===a.target.id?m="subject":"subject"===a.target.id?(13===b&&a.preventDefault(),m="new_message_content"):m="private_message_recipient"===a.target.id?"new_message_content":"new_message_content"===a.target.id?13===b?!1:"compose-send-button":!1,!$("#subject").data().typeahead.shown&&!$("#stream").data().typeahead.shown&&!$("#private_message_recipient").data().typeahead.shown&&!$("#new_message_content").data().typeahead.shown){if("zulip.com"===page_params.domain&&
"compose-send-button"===m||"zulip.com"!==page_params.domain&&m)ui.focus_on(m),m=!1;if("new_message_content"===a.target.id&&13===b&&(a.metaKey||a.ctrlKey||page_params.enter_sends&&!a.shiftKey))a.preventDefault(),"disabled"!==$("#compose-send-button").attr("disabled")&&($("#compose-send-button").attr("disabled","disabled"),compose.finish())}}function e(a){var b=a.keyCode||a.which;if((13===b||9===b&&!a.shiftKey)&&m)ui.focus_on(m),m=!1}function d(a){var b=!1;$("#"+a).focus(function(c){b||(b=!0,$("#"+
a).select().one("mouseup",function(a){a.preventDefault()}),b=!1)})}var c={get_cleaned_pm_recipients:function(a){a=a.split(/\s*[,;]\s*/);return a=_.filter(a,function(a){return a.match(/\S/)})}},g=new Dict;c.add_topic=function(a,b){var c=a.toLowerCase(),d=b.toLowerCase();g.has(c)||g.set(c,new Dict);c=g.get(c);c.has(d)||c.set(d,b)};c.topics_seen_for=function(a){a=a.toLowerCase();return g.has(a)?g.get(a).values().sort():[]};var m=!1;c.split_at_cursor=function(a,b){var c=b.caret().start;return[a.slice(0,
c),a.slice(c)]};c.compose_content_begins_typeahead=function(a){a=c.split_at_cursor(a,this.$element)[0];var b=a.split(/[\s*(){}\[\]]/);if(1>b.length)return!1;b=b[b.length-1];if(this.options.completions.emoji&&":"===b[0]){if(/^:-?.?$/.test(b))return!1;this.completing="emoji";this.token=b.substring(1);return emoji.emojis}if(!this.options.completions.mention)return!1;b=a.lastIndexOf("@");if(-1===b||b<a.length-1-30||0<b&&-1==="\n\t \"'(){}[]".indexOf(a[b-1]))return!1;b=a.substring(b+1);if(1>b.length||
-1!==b.lastIndexOf("*"))return!1;this.completing="mention";this.token=b.substring(b.indexOf("@")+1);return page_params.people_list.concat([{special_item_text:"all (Notify everyone)",email:"all",pm_recipient_count:Infinity,full_name:"all"},{special_item_text:"everyone (Notify everyone)",email:"everyone",full_name:"everyone"}])};c.content_highlighter=function(a){if("emoji"===this.completing)return"<img class='emoji' src='"+a.emoji_url+"' /> "+a.emoji_name;if("mention"===this.completing)return a=typeahead_helper.render_person(a),
typeahead_helper.highlight_with_escaping(this.token,a)};c.content_typeahead_selected=function(a){var b=c.split_at_cursor(this.query,this.$element),d=b[0],b=b[1];"emoji"===this.completing?d=0===d.lastIndexOf(":")||" "===d.charAt(d.lastIndexOf(":")-1)?d.replace(/:\S+$/,"")+":"+a.emoji_name+": ":d.replace(/:\S+$/,"")+" :"+a.emoji_name+": ":"mention"===this.completing&&(d=d.substring(0,d.length-this.token.length-1)+"@**"+a.full_name+"** ","all"!==a.email&&"everyone"!==a.email&&$(document).trigger("usermention_completed.zulip",
{mentioned:a}));setTimeout(function(){$("#new_message_content").caret(d.length,d.length)},0);return d+b};c.initialize_compose_typeahead=function(a,d){d=$.extend({mention:!1,emoji:!1},d);$(a).typeahead({items:5,dropup:!0,fixed:!0,source:c.compose_content_begins_typeahead,highlighter:c.content_highlighter,matcher:function(a){if("emoji"===this.completing)return-1!==a.emoji_name.indexOf(this.token.toLowerCase());if("mention"===this.completing)return b(this.token,a)},sorter:function(a){if("emoji"===this.completing)return typeahead_helper.sort_emojis(a,
this.token);if("mention"===this.completing)return typeahead_helper.sort_recipients(a,this.token)},updater:c.content_typeahead_selected,stopAdvance:!0,completions:d})};c.initialize=function(){d("stream");d("subject");d("private_message_recipient");$("form#send_message_form").keydown(a);$("form#send_message_form").keyup(e);$("#enter_sends").click(function(){var a=$("#compose-send-button");page_params.enter_sends=$("#enter_sends").is(":checked");page_params.enter_sends?a.fadeOut():a.fadeIn();$("#new_message_content").focus();
return channel.post({url:"/json/change_enter_sends",idempotent:!0,data:{enter_sends:page_params.enter_sends}})});$("#enter_sends").prop("checked",page_params.enter_sends);page_params.enter_sends&&$("#compose-send-button").hide();$("#stream").typeahead({source:function(a,b){return stream_data.subscribed_streams()},items:3,fixed:!0,highlighter:function(a){return typeahead_helper.highlight_query_in_phrase(this.query,a)},matcher:function(a){var b=this.query.trim().toLowerCase();return 0===a.toLowerCase().indexOf(b)}});
$("#subject").typeahead({source:function(a,b){var d=$("#stream").val();return c.topics_seen_for(d)},items:3,fixed:!0,highlighter:h,sorter:function(a){a=typeahead_helper.sorter(this.query,a,function(a){return a});0<a.length&&-1===a.indexOf(this.query)&&a.unshift(this.query);return a}});$("#private_message_recipient").typeahead({source:page_params.people_list,items:5,dropup:!0,fixed:!0,highlighter:function(a){var b=f(this.query);a=typeahead_helper.render_person(a);return typeahead_helper.highlight_with_escaping(b,
a)},matcher:function(a){var c=f(this.query);return!c.match(/\S/)?!1:b(c,a)},sorter:typeahead_helper.sort_recipientbox_typeahead,updater:function(a){var b=c.get_cleaned_pm_recipients(this.query);b.pop();b=b.join(", ");0!==b.length&&(b+=", ");return b+a.email+", "},stopAdvance:!0});c.initialize_compose_typeahead("#new_message_content",{mention:!0,emoji:!0});$("#private_message_recipient").blur(function(a){a=$(this).val();a=c.get_cleaned_pm_recipients(a);$(this).val(a.join(", "))})};return c}();
"undefined"!==typeof module&&(module.exports=composebox_typeahead);var navigate=function(){function f(f){current_msg_list.select_id(rows.id(f),{then_scroll:!0,from_scroll:!0})}return{up:function(){last_viewport_movement_direction=-1;var h=rows.prev_visible(current_msg_list.selected_row());0!==h.length&&f(h)},down:function(h){last_viewport_movement_direction=1;var b=rows.next_visible(current_msg_list.selected_row());0!==b.length&&f(b);h&&0===b.length&&(h=rows.get_table(current_msg_list.table_name),viewport.scrollTop(h.outerHeight(!0)-0.1*viewport.height()),unread.mark_current_list_as_read())},
to_home:function(){last_viewport_movement_direction=-1;var h=rows.first_visible(current_msg_list.selected_row());0!==h.length&&f(h)},to_end:function(){var f=current_msg_list.last().id;last_viewport_movement_direction=1;current_msg_list.select_id(f,{then_scroll:!0,from_scroll:!0});unread.mark_current_list_as_read()},page_up:function(){viewport.at_top()&&!current_msg_list.empty()?current_msg_list.select_id(current_msg_list.first().id,{then_scroll:!1}):ui.page_up_the_right_amount()},page_down:function(){viewport.at_bottom()&&
!current_msg_list.empty()?(current_msg_list.select_id(current_msg_list.last().id,{then_scroll:!1}),unread.mark_current_list_as_read()):ui.page_down_the_right_amount()},cycle_stream:function(f){var b,a;void 0!==narrow.stream()&&(b=stream_list.get_stream_li(narrow.stream()));switch(f){case "forward":void 0===narrow.stream()?a=$("#stream_filters").children(".narrow-filter").first():(a=b.next(".narrow-filter"),0===a.length&&(a=$("#stream_filters").children(".narrow-filter").first()));break;case "backward":void 0===
narrow.stream()?a=$("#stream_filters").children(".narrow-filter").last():(a=b.prev(".narrow-filter"),0===a.length&&(a=$("#stream_filters").children(".narrow-filter").last()));break;default:blueslip.error("Invalid parameter to cycle_stream",{value:f})}narrow.by("stream",a.data("name"))}}}();var hotkeys=function(){function f(a){a(current_msg_list.selected_id(),{trigger:"hotkey"});return!0}function h(a){if(9===a.which&&a.shiftKey)return"shift_tab";if(a.metaKey||a.ctrlKey)return"ignore";if(!a.shiftKey)switch(a.keyCode){case 33:return"page_up";case 34:return"page_down";case 35:return"end";case 36:return"home";case 38:return"up_arrow";case 40:return"down_arrow"}switch(a.which){case 8:return"backspace";case 9:return"tab";case 13:return"enter";case 27:return"escape";case 32:return a.shiftKey?
"page_up":"page_down";case 47:return"search";case 63:return"show_shortcuts";case 65:return"stream_cycle_backward";case 67:return"compose_private_message";case 68:return"stream_cycle_forward";case 74:return"page_down";case 75:return"page_up";case 82:return"respond_to_author";case 83:return"narrow_by_subject";case 99:return"compose";case 105:return"message_actions";case 106:return"vim_down";case 107:return"vim_up";case 113:return"query_users";case 114:return"reply_message";case 115:return"narrow_by_recipient";
case 118:return"narrow_private"}return"ignore"}function b(b){var d;b=h(b);activity.new_user_input=!0;if("tab"===b&&(d=$(".edit-alert-word").filter(":focus"),0<d.length))return d.closest(".alert-word-item").find(".add-alert-word").focus(),!0;if(ui.home_tab_obscured()&&"search"!==b&&"query_users"!==b||"ignore"===b)return!1;if(popovers.actions_popped()&&-1!==a.indexOf(b))return popovers.actions_menu_handle_keyboard(b),!0;if($("#compose-send-button").is(":focus")){if("backspace"===b)return!0;if("shift_tab"===
b)return ui.restore_compose_cursor(),!0}if("tab"===b){d=$(".message_edit_content").filter(":focus");if(0<d.length)return b=d.closest(".message_edit_form"),b.find(".message_edit_save").focus(),!0;d=$(".message_edit_save").filter(":focus");if(0<d.length)return b=d.closest(".message_edit_form"),b.find(".message_edit_cancel").focus(),!0}if("shift_tab"===b){if(0<$(".message_edit_cancel").filter(":focus").length)return $(".message_edit_save").focus(),!0;d=$(".message_edit_save").filter(":focus");if(0<d.length)return d.closest(".message_edit_form").find(".message_edit_content").focus(),
!0}if(0<$("input:focus,select:focus,textarea:focus,#compose-send-button:focus").length){if("escape"===b){if($("#subject").data().typeahead.shown||$("#stream").data().typeahead.shown||$("#private_message_recipient").data().typeahead.shown||$("#new_message_content").data().typeahead.shown||$("#search_query").data().typeahead.shown)return!0;if(0<$(".message_edit_content").filter(":focus").length)d=$(".message_edit_content").filter(":focus").closest(".message_row"),message_edit.end(d);else return activity.searching()?
activity.escape_search():compose.composing()?compose.cancel():$("input:focus,textarea:focus").blur(),!0}if("enter"===b&&activity.searching())return activity.blur_search(),!0;if(("up_arrow"===b||"down_arrow"===b)&&compose.composing()&&""===compose.message_content()&&$("#new_message_content").is(":focus"))compose.cancel();else return!1}if(0<$("a:focus,button:focus").length&&"enter"===b)return!1;switch(b){case "narrow_private":return f(function(a,b){narrow.by("is","private",b)});case "escape":return popovers.any_active()?
popovers.hide_all():compose.composing()?compose.cancel():search.clear_search(),!0;case "compose":return compose.start("stream",{trigger:"compose_hotkey"}),!0;case "compose_private_message":return compose.start("private",{trigger:"compose_hotkey"}),!0;case "query_users":return activity.initiate_search(),!0;case "search":return search.initiate_search(),!0;case "show_shortcuts":return $("#keyboard-shortcuts").modal("show"),!0;case "stream_cycle_backward":return navigate.cycle_stream("backward"),!0;case "stream_cycle_forward":return navigate.cycle_stream("forward"),
!0}if(current_msg_list.empty())return!1;switch(b){case "down_arrow":case "vim_down":return navigate.down(!0),!0;case "up_arrow":case "vim_up":return navigate.up(),!0;case "home":return navigate.to_home(),!0;case "end":return navigate.to_end(),!0;case "page_up":return navigate.page_up(),!0;case "page_down":return navigate.page_down(),!0}switch(b){case "message_actions":return popovers.open_message_menu();case "narrow_by_recipient":return f(narrow.by_recipient);case "narrow_by_subject":return f(narrow.by_subject);
case "enter":return respond_to_message({trigger:"hotkey enter"}),!0;case "reply_message":return respond_to_message({trigger:"hotkey"}),!0;case "respond_to_author":return respond_to_message({reply_type:"personal",trigger:"hotkey pm"}),!0}return!1}var a=["down_arrow","up_arrow","vim_up","vim_down","enter"];$(document).keydown(function(a){(48>a.which||90<a.which)&&b(a)&&a.preventDefault();resize.resize_bottom_whitespace()});$(document).keypress(function(a){0!==a.which&&0!==a.charCode&&b(a)&&a.preventDefault()});
return{}}();var favicon=function(){return{reset:function(){$('link[rel="shortcut icon"]').detach().appendTo("head")},set:function(f){$.browser.webkit?$('link[rel="shortcut icon"]').attr("href",f):($('link[rel="shortcut icon"]').remove(),$("head").append($("<link>").attr("rel","shortcut icon").attr("href",f)))}}}();"undefined"!==typeof module&&(module.exports=favicon);var notifications=function(){function f(a){a.onclose=function(){};a.onclick=function(){};a.cancel()}function h(){0<unread.get_counts().private_message_count?(r===l?(favicon.set(n),r=n,n=l):(favicon.set(l),n=r,r=l),setTimeout(h,2E3)):(t=!1,favicon.set(r))}function b(a,b,c){a=$(templates.render("notification",{gravatar_url:ui.small_avatar_url(a),title:b,content:c}));$(".top-right").notify({message:{html:a},fadeOut:{enabled:!0,delay:4E3}}).show()}function a(a){var d,e,g,h,k,l=a.message,m=l.sender_full_name,
r=1,q;h=$("<div/>").html(l.content);ui.replace_emoji_with_text(h);h=h.text();l.is_me_message&&(h=l.sender_full_name+h.slice(3));"private"===l.type?(k=g=l.display_reply_to,k=k.replace(", "+l.sender_full_name,""),k=k.replace(l.sender_full_name+", ",""),q="pm"):(g=l.sender_full_name+" to "+l.stream+" > "+l.subject,q=l.mentioned?"mention":l.alerted?"alert":"stream");if(150<h.length){for(d=150;0<d&&" "!==h[d];d--);h=h.substring(0,d);h+=" [...]"}void 0===window.bridge&&void 0!==c[g]&&(r=c[g].msg_count+
1,m=r+" messages from "+m,e=c[g].obj,f(e));"private"===l.type&&2<l.display_recipient.length&&(230<h.length+m.length+k.length&&(k=k.replace(/[^,]/g,"").length+" other people"),m+=" (to you and "+k+")");"stream"===l.type&&(m+=" (to "+l.stream+" > "+l.subject+")");void 0===window.bridge&&!0===a.webkit_notify?(a=ui.small_avatar_url(l),c[g]={obj:s.createNotification(a,m,h),msg_count:r,message_id:l.id},e=c[g].obj,e.onclick=function(){e.cancel();feature_flags.clicking_notification_causes_narrow&&narrow.by_subject(l.id,
{trigger:"notification"});window.focus()},e.onclose=function(){delete c[g]},e.show()):!1===a.webkit_notify&&"undefined"!==typeof Notification&&!0===$.browser.mozilla?Notification.requestPermission(function(a){"granted"===a?e=new Notification(m,{body:h,iconUrl:ui.small_avatar_url(l)}):b(l,m,h)}):!1===a.webkit_notify?b(l,m,h):window.bridge.desktopNotification(m,h,q)}function e(a){return"stream"===a.type?a.stream+">"+a.subject:2<a.display_recipient.length?"group PM with "+a.display_reply_to:a.reply_to===
page_params.email?"PM with yourself":"PM with "+a.display_reply_to}var d={},c={},g=document.hasFocus&&document.hasFocus(),m=!1,k,l="/static/images/favicon/favicon-pms.png",r,n,t=!1,s;window.webkitNotifications?s=window.webkitNotifications:window.Notification&&(s={checkPermission:function(){return"granted"===window.Notification.permission?0:2},requestPermission:window.Notification.requestPermission,createNotification:function(a,b,c){var d=new window.Notification(b,{icon:a,body:c});d.show=function(){};
d.cancel=function(){d.close()};return d}});d.initialize=function(){$(window).focus(function(){g=!0;_.each(c,function(a){f(a.obj)});c={};unread.process_visible()}).blur(function(){g=!1});if(void 0!==window.bridge)k=!0;else{var a=$("<audio>");void 0===a[0].canPlayType?k=!1:(k=!0,$("#notifications-area").append(a),a[0].canPlayType('audio/ogg; codecs="vorbis"')?a.append($("<source>").attr("type","audio/ogg").attr("loop","yes").attr("src","/static/audio/zulip.ogg")):a.append($("<source>").attr("type",
"audio/mpeg").attr("loop","yes").attr("src","/static/audio/zulip.mp3")));s&&$(document).click(function(){page_params.desktop_notifications_enabled&&!m&&0!==s.checkPermission()&&(tutorial.is_running()?tutorial.defer(function(){s.requestPermission(function(){m=!0})}):s.requestPermission(function(){m=!0}))})}};void 0!==window.bridge&&window.bridge.updateCount(0);var q;d.update_title_count=function(a){q=a;d.redraw_title()};d.redraw_title=function(){var a;a=(q?"("+q+") ":"")+page_params.realm_name+" - "+
page_params.product_name;document.title!==a&&(document.title=a,$.browser.msie||(q?(a=+q,99<a&&(a="infinite"),r=n="/static/images/favicon/favicon-"+a+".png"):r=n="/static/favicon.ico?v=2",favicon.set(r)),void 0!==window.bridge&&window.bridge.updateCount(q))};d.update_pm_count=function(a){void 0!==window.bridge&&void 0!==window.bridge.updatePMCount&&window.bridge.updatePMCount(a);t||(t=!0,h())};d.window_has_focus=function(){return g};d.notify_above_composebox=function(a,b,c,e){a=$(templates.render("compose_notification",
{note:a,link_class:b,link_msg_id:c,link_text:e}));d.clear_compose_notifications();$("#out-of-view-notification").append(a);$("#out-of-view-notification").show()};d.close_notification=function(a){_.each(Object.keys(c),function(b){c[b].message_id===a.id&&(f(c[b].obj),delete c[b])})};d.speaking_at_me=function(a){return void 0===a?!1:a.mentioned};d.received_messages=function(b){_.each(b,function(b){if((b.sent_by_me||b.notification_sent?0:d.speaking_at_me(b)||!("stream"===b.type&&!stream_data.in_home_view(b.stream)||
"stream"===b.type&&muting.is_topic_muted(b.stream,b.subject)))&&(unread.message_unread(b)||page_params.autoscroll_forever))b.notification_sent=!0,("stream"===b.type&&subs.receives_desktop_notifications(b.stream)||"private"===b.type&&page_params.desktop_notifications_enabled||alert_words.notifies(b)&&page_params.desktop_notifications_enabled||d.speaking_at_me(b)&&page_params.desktop_notifications_enabled)&&(s&&$.browser.webkit&&0===s.checkPermission()||void 0!==window.bridge?a({message:b,webkit_notify:!0}):
a({message:b,webkit_notify:!1})),("stream"===b.type&&subs.receives_audible_notifications(b.stream)||"private"===b.type&&page_params.sounds_enabled||alert_words.notifies(b)&&page_params.sounds_enabled||d.speaking_at_me(b)&&page_params.sounds_enabled)&&k&&(void 0!==window.bridge?window.bridge.bell():$("#notifications-area").find("audio")[0].play())})};d.possibly_notify_new_messages_outside_viewport=function(a){_.each(a,function(a){if(a.sender_email===page_params.email){var b,c=a.id;0===current_msg_list.get_row(a.id).length&&
(b="stream"===a.type&&muting.is_topic_muted(a.stream,a.subject)?"Sent! Your message was sent to a topic you have muted.":"stream"===a.type&&!stream_data.in_home_view(a.stream)?"Sent! Your message was sent to a stream you have muted.":"Sent! Your message is outside your current narrow.",a="Narrow to "+e(a),d.notify_above_composebox(b,"compose_notification_narrow_by_subject",c,a))}})};d.notify_messages_outside_current_search=function(a){_.each(a,function(a){a.sender_email===page_params.email&&d.notify_above_composebox("Sent! Your recent message is outside the current search.",
"compose_notification_narrow_by_subject",a.id,"Narrow to "+e(a))})};d.clear_compose_notifications=function(){$("#out-of-view-notification").empty();$("#out-of-view-notification").stop(!0,!0);$("#out-of-view-notification").hide()};$(function(){"undefined"!==typeof bridge&&void 0===window.bridge&&(window.bridge=bridge);$(document).on("message_id_changed",function(a){var b=a.old_id,c=a.new_id;_.each($("#out-of-view-notification a"),function(a){a=$(a);a.data("msgid")===b&&a.data("msgid",c)})})});d.register_click_handlers=
function(){$("#out-of-view-notification").on("click",".compose_notification_narrow_by_subject",function(a){var b=$(a.currentTarget).data("msgid");narrow.by_subject(b,{trigger:"compose_notification"});a.stopPropagation();a.preventDefault()});$("#out-of-view-notification").on("click",".compose_notification_scroll_to_message",function(a){var b=$(a.currentTarget).data("msgid");current_msg_list.select_id(b);scroll_to_selected();a.stopPropagation();a.preventDefault()});$("#out-of-view-notification").on("click",
".out-of-view-notification-close",function(a){d.clear_compose_notifications();a.stopPropagation();a.preventDefault()})};d.handle_global_notification_updates=function(a,b){"enable_stream_desktop_notifications"===a?page_params.stream_desktop_notifications_enabled=b:"enable_stream_sounds"===a?page_params.stream_sounds_enabled=b:"enable_desktop_notifications"===a?page_params.desktop_notifications_enabled=b:"enable_sounds"===a?page_params.sounds_enabled=b:"enable_offline_email_notifications"===a?page_params.enable_offline_email_notifications=
b:"enable_offline_push_notifications"===a?page_params.enable_offline_push_notifications=b:"enable_digest_emails"===a&&(page_params.enable_digest_emails=b)};return d}();var hashchange=function(){function f(a){var b=window.location;if(history.pushState){if(""===a||"#"!==a.charAt(0))a="#"+a;var d=b.pathname;if(void 0===d)d="/";else if(""===d||"/"!==d.charAt(0))d="/"+d;history.pushState(null,null,b.protocol+"//"+b.host+d+a)}else b.hash=a}function h(){ui.change_tab_to("#home");narrow.deactivate();floating_recipient_bar.update()}function b(a){d=!0;a:{if(!(window.location.hash===e||void 0!==e&&""===window.location.hash.replace(/^#/,"")&&""===e.replace(/^#/,""))){$(document).trigger($.Event("hashchange.zulip"));
var b=window.location.hash.split("/");switch(b[0]){case "#narrow":ui.change_tab_to("#home");b:{var m,k=[];for(m=1;m<b.length;m+=2)try{var l=decodeURIComponent(b[m].replace(/\./g,"%")),r=decodeURIComponent((b[m+1]||"").replace(/\./g,"%")),n=!1;"-"===l[0]&&(n=!0,l=l.slice(1));k.push({negated:n,operator:l,operand:r})}catch(t){b=void 0;break b}b=k}if(void 0===b){f("");h();break}m={select_first_unread:!0,change_hash:!1,trigger:"hash change"};void 0!==a&&void 0!==page_params.initial_narrow_pointer&&(m.from_reload=
!0,m.first_unread_from_server=!0);narrow.activate(b,m);floating_recipient_bar.update();a=!0;break a;case "":case "#":h();break;case "#subscriptions":ui.change_tab_to("#subscriptions");break;case "#administration":ui.change_tab_to("#administration");break;case "#settings":ui.change_tab_to("#settings")}}a=!1}d=!1;return a}var a={},e,d=!1;a.encodeHashComponent=function(a){return encodeURIComponent(a).replace(/\./g,"%2E").replace(/%/g,".")};a.changehash=function(a){d||($(document).trigger($.Event("hashchange.zulip")),
f(a),favicon.reset())};a.operators_to_hash=function(a){var b="#";void 0!==a&&(b="#narrow",_.each(a,function(a){var c=a.operand;b+="/"+(a.negated?"-":"")+hashchange.encodeHashComponent(a.operator)+"/"+hashchange.encodeHashComponent(c)}));return b};a.save_narrow=function(b){d||(b=a.operators_to_hash(b),a.changehash(b))};a.initialize=function(){window.onhashchange=blueslip.wrap_function(b);b(!0)};return a}();"undefined"!==typeof module&&(module.exports=hashchange);var invite=function(){function f(){var a=[];_.each(stream_data.subscribed_streams(),function(b){var d=b===page_params.notifications_stream;(1===stream_data.subscribed_streams().length||!d||d&&stream_data.get_invite_only(b))&&a.push({name:b,invite_only:stream_data.get_invite_only(b)})});$("#streams_to_add").html(templates.render("invite_subscription",{streams:a}))}function h(){var a=$("#invite_status"),b=$("#invitee_emails").closest(".control-group");a.hide().text("").removeClass("alert-error alert-warning alert-success");
b.removeClass("warning error")}function b(){$("#invitee_emails").val("");f();h()}return{initialize:function(){var a=$("#invite_status"),e=$("#invitee_emails"),d=e.closest(".control-group");$("#submit-invitation").button();$("#invite-user").on("show",b);$("#invite-user").on("shown",function(){e.focus().autosize()});$("#invite_user_form").ajaxForm({dataType:"json",beforeSubmit:function(a,b,d){h();$("#submit-invitation").button("loading");return!0},success:function(b,d,e,f){$("#submit-invitation").button("reset");
$("#invitee_emails").val("");a.text("Users invited successfully.").addClass("alert-success").show()},error:function(b,e,f){$("#submit-invitation").button("reset");b=$.parseJSON(b.responseText);if(void 0===b.errors)a.text(b.msg).addClass("alert-error").show();else{var h=$("<ul>");_.each(b.errors,function(a){h.append($("<li>").text(a.join(": ")))});a.addClass("alert-warning").empty().append($("<p>").text(b.msg)).append(h).show();d.addClass("warning")}}});$(document).on("click",".invite_check_all_button",
function(a){$("#streams_to_add :checkbox").attr("checked",!0);a.preventDefault()});$(document).on("click",".invite_uncheck_all_button",function(a){$("#streams_to_add :checkbox").attr("checked",!1);a.preventDefault()})}}}();function MessageListView(f,h,b){this.list=f;this.collapse_messages=b;this._rows={};this.message_containers={};(this.table_name=h)&&this.clear_table();this._message_groups=[];this._render_win_end=this._render_win_start=0}
(function(){function f(a){return page_params.twenty_four_hour_time?a.toString("HH:mm"):a.toString("h:mm TT")}function h(a,b){if(void 0===a||void 0===b)return!1;var d=new XDate(1E3*a.msg.timestamp),e=new XDate(1E3*b.msg.timestamp);return d.toDateString()===e.toDateString()}function b(a,b){return void 0===a||void 0===b?!1:util.same_sender(a.msg,b.msg)}function a(a,b){return void 0===a||void 0===b?!1:util.same_recipient(a.msg,b.msg)}function e(a,b,d){var e=new XDate(1E3*b.msg.timestamp);void 0!==d?(d=
new XDate(1E3*d.msg.timestamp),e.toDateString()!==d.toDateString()&&(a.show_date=timerender.render_date(e,d)[0].outerHTML)):a.show_date=timerender.render_date(e)[0].outerHTML;void 0===b.timestr&&(b.timestr=f(e))}function d(a,b){a.is_stream=b.msg.is_stream;a.is_private=b.msg.is_private;a.is_stream?(a.background_color=stream_data.get_color(b.msg.stream),a.color_class=stream_color.get_color_class(a.background_color),a.invite_only=stream_data.get_invite_only(b.msg.stream),a.subject=b.msg.subject,a.match_subject=
b.msg.match_subject,a.stream_url=b.stream_url,a.topic_url=b.topic_url):a.is_private&&(a.pm_with_url=b.pm_with_url,a.display_reply_to=b.msg.display_reply_to);a.display_recipient=b.msg.display_recipient;a.always_visible_topic_edit=b.msg.always_visible_topic_edit;a.on_hover_topic_edit=b.msg.on_hover_topic_edit;a.subject_links=b.msg.subject_links}MessageListView.prototype={_RENDER_WINDOW_SIZE:400,_RENDER_THRESHOLD:50,_add_msg_timestring:function(a){if(void 0!==a.msg.last_edit_timestamp){var b=new XDate(1E3*
a.msg.last_edit_timestamp);a.last_edit_timestr=timerender.render_date(b)[0].textContent+" at "+f(b)}},add_subscription_marker:function(a,b,d){void 0!==b&&d.msg.historical!==b.msg.historical&&(a.bookend_top=!0,d.msg.historical?(a.unsubscribed=d.msg.stream,a.bookend_content=this.list.unsubscribed_bookend_content(d.msg.stream)):(a.subscribed=d.msg.stream,a.bookend_content=this.list.subscribed_bookend_content(d.msg.stream)))},build_message_groups:function(c,g){function f(){return{message_containers:[],
message_group_id:_.uniqueId("message_group_")}}function k(a){b(s,a)&&(s.next_is_same_sender=!0);n.message_containers.push(a)}function l(){0<n.message_containers.length&&(d(n,n.message_containers[0]),n.message_containers[n.message_containers.length-1].include_footer=!0,t.push(n))}var r=this,n=f(),t=[],s;_.each(c,function(c){c.include_recipient=!1;c.include_footer=!1;a(s,c)&&r.collapse_messages&&s.msg.historical===c.msg.historical&&h(s,c)?k(c):(l(),n=f(),k(c),c.include_recipient=!0,c.subscribed=!1,
c.unsubscribed=!1,r.list!==home_msg_list&&r.add_subscription_marker(n,s,c),c.msg.stream?(c.stream_url=narrow.by_stream_uri(c.msg.stream),c.topic_url=narrow.by_stream_subject_uri(c.msg.stream,c.msg.subject)):c.pm_with_url=narrow.pm_with_uri(c.msg.reply_to));e(n,c,s);c.include_sender=!0;!c.include_recipient&&(!s.status_message&&b(s,c))&&(c.include_sender=!1);r._add_msg_timestring(c);c.small_avatar_url=ui.small_avatar_url(c.msg);void 0!==c.msg.stream&&(c.background_color=stream_data.get_color(c.msg.stream));
c.contains_mention=notifications.speaking_at_me(c.msg);c.msg.unread=unread.message_unread(c.msg);c.msg.is_me_message?(c.status_message=c.msg.content.slice(7,-4),c.include_sender=!0):c.status_message=!1;s=c});l();return t},join_message_groups:function(c,d){if(void 0===c||void 0===d)return!1;var e=_.last(c.message_containers),f=_.first(d.message_containers);if(this.collapse_messages&&a(e,f)&&h(e,f)&&e.msg.historical===f.msg.historical)return!e.status_message&&(!f.msg.is_me_message&&b(e,f))&&(f.include_sender=
!1),b(e,f)&&(e.next_is_same_sender=!0),c.message_containers=c.message_containers.concat(d.message_containers),!0;this.list!==home_msg_list&&e.msg.historical!==f.msg.historical&&(c.bookend_bottom=!0,this.add_subscription_marker(c,e,f));return!1},merge_message_groups:function(a,b){var d={append_groups:[],prepend_groups:[],rerender_groups:[],append_messages:[],rerender_messages:[]},f,l;if("top"===b)f=_.last(a),l=_.first(this._message_groups),this.join_message_groups(f,l)?(f.message_group_id=l.message_group_id,
d.rerender_groups.push(f),this._message_groups.shift(),this._message_groups.unshift(f),a=_.initial(a)):h(l.message_containers[0],f.message_containers[0])||(e(l,_.first(l.message_containers),_.last(f.message_containers)),d.rerender_groups.push(l)),d.prepend_groups=a,this._message_groups=a.concat(this._message_groups);else{f=_.last(this._message_groups);l=_.first(a);if(this.join_message_groups(f,l))d.rerender_messages.push(f.message_containers[f.message_containers.length-l.message_containers.length-
1]),d.append_messages=_.first(a).message_containers,a=_.rest(a);else if(void 0!==f&&void 0!==l){f=_.last(f.message_containers);var r=_.first(l.message_containers);h(f,r)&&(l.show_date=void 0)}d.append_groups=a;this._message_groups=this._message_groups.concat(a)}return d},_post_process_dom_messages:function(a){var b=this;_.each(a,function(a){_.isElement(a)||blueslip.warn("Only DOM nodes can be passed to _post_process_messages");var c=$(a);c.hasClass("message_row")&&(b._rows[c.attr("zid")]=a);c.hasClass("mention")&&
c.find(".user-mention").each(function(){var a=$(this).attr("data-user-email");("*"===a||a===page_params.email)&&$(this).addClass("user-mention-me")});a=rows.id(c);message_edit.maybe_show_edit(c,a);a=$.Event("message_rendered.zulip",{target:c});try{$(document).trigger(a)}catch(d){blueslip.error("Problem with message rendering",{message_id:rows.id($(c))},d.stack)}})},render:function(a,b,d){function e(){void 0===t&&0<q.selected_row().length&&(t=q.selected_row().offset().top)}if(!(0===a.length||void 0===
this.table_name)){var f=this.list,h=rows.get_table(this.table_name),n=rows.id(rows.last_visible())===f.selected_id(),t,s,q=this;s=_.map(a,function(a){return{msg:a}});if(!(0===s.length||void 0===this.table_name)){a=this.build_message_groups(s,this.table_name);var v=this.merge_message_groups(a,b);b=[];var p,y;_.each(s,function(a){q.message_containers[a.msg.id]=a});0<v.prepend_groups.length&&(e(),p=$(templates.render("message_group",{message_groups:v.prepend_groups,use_match_properties:q.list.filter.is_search(),
table_name:q.table_name})),y=p.find(".message_row"),b=b.concat(p),q._post_process_dom_messages(y.get()),h.find(".recipient_row").first().prev(".date_row").remove(),h.prepend(p),condense.condense_and_collapse(y));0<v.rerender_groups.length&&(e(),_.each(v.rerender_groups,function(a){var b=$("#"+a.message_group_id);b.prev(".date_row").remove();p=$(templates.render("message_group",{message_groups:[a],use_match_properties:q.list.filter.is_search(),table_name:q.table_name}));y=p.find(".message_row");q._post_process_dom_messages(y.get());
b.replaceWith(p);condense.condense_and_collapse(y)}));0<v.rerender_messages.length&&_.each(v.rerender_messages,function(a){var b=q.get_row(a.msg.id);a=_.extend(a,{table_name:this.table_name});a=$(templates.render("single_message",a));q._post_process_dom_messages(a.get());b.replaceWith(a);condense.condense_and_collapse(a);f.reselect_selected_id()});0<v.append_messages.length&&(s=h.find(".message_row:last").expectOne(),s=rows.get_message_recipient_row(s),y=$(_.map(v.append_messages,function(a){a=_.extend(a,
{table_name:this.table_name});return templates.render("single_message",a)}).join("")).filter(".message_row"),q._post_process_dom_messages(y.get()),s.append(y),b=b.concat(y));0<v.append_groups.length&&(q.clear_trailing_bookend(),p=$(templates.render("message_group",{message_groups:v.append_groups,use_match_properties:q.list.filter.is_search(),table_name:q.table_name})),y=p.find(".message_row"),b=b.concat(p),q._post_process_dom_messages(y.get()),h.append(p),condense.condense_and_collapse(y));f===current_msg_list&&
void 0!==t&&(viewport.set_message_offset(t),f.reselect_selected_id());h=_.last(q._message_groups);void 0!==h&&(f.last_message_historical=_.last(h.message_containers).msg.historical);f.update_trailing_bookend();f===current_msg_list&&compose_fade.update_rendered_message_groups(a,function(a){a=q.get_row(a.message_containers[0].msg.id);return rows.get_message_recipient_row(a)});f===current_msg_list&&d&&q._maybe_autoscroll(b,n)}}},_maybe_autoscroll:function(a,b){var d=0,e=0,f=-1;_.each(a.reverse(),function(a){if(a.is("div"))if(d+=
a.height(),-1<f)e+=a.height();else{var b=rows.id(a);-1<b&&this.get_message(b).sender_email===page_params.email&&(e+=a.height(),f=rows.id(a))}},this);if(b&&page_params.autoscroll_forever)this.list.select_id(this.list.last().id,{from_rendering:!0}),scroll_to_selected(),this.list.reselect_selected_id();else{var h=this.selected_row(),n=rows.last_visible();if(h&&0<h.length&&n){var t=h.offset().top,h=viewport.message_viewport_info(),t=t-h.visible_top;if(page_params.autoscroll_forever&&-1<f&&rows.last_visible().offset().top-
this.list.selected_row().offset().top<viewport.height())this.list.select_id(f,{from_rendering:!0}),scroll_to_selected();else if(!(0>=t)&&!(0>=d)){var s=d;s>t&&(s=t);n.offset().top+n.height()-d>h.visible_top+h.visible_height||viewport.system_initiated_animate_scroll(s)}}}},clear_rendering_state:function(a){a&&this.clear_table();this.list.last_message_historical=!1;this._render_win_end=this._render_win_start=0},update_render_window:function(a,b){var d=Math.max(a-this._RENDER_WINDOW_SIZE/2,0);if(b&&
d===this._render_win_start)return!1;this._render_win_start=d;this._render_win_end=Math.min(this._render_win_start+this._RENDER_WINDOW_SIZE,this.list.num_items());return!0},maybe_rerender:function(){if(void 0===this.table_name)return!1;var a=this.list.selected_idx();if(!(a-this._render_win_start<this._RENDER_THRESHOLD&&0!==this._render_win_start||this._render_win_end-a<=this._RENDER_THRESHOLD&&this._render_win_end!==this.list.num_items())||!this.update_render_window(a,!0))return!1;this.rerender_preserving_scrolltop();
return!0},rerender_preserving_scrolltop:function(){var a,b=this.selected_row(),d=0<b.length;d&&(a=b.offset().top);this.clear_table();this.render(this.list.all().slice(this._render_win_start,this._render_win_end),"bottom");d&&(0===this.selected_row().length&&-1<this.list.selected_id()&&this.list.select_id(this.list.selected_id(),{use_closest:!0}),viewport.scrollTop(viewport.scrollTop()+this.selected_row().offset().top-a))},_rerender_header:function(a){if(0!==a.length){var b=this.get_row(a[0].msg.id);
if(0!==b.length){var b=rows.get_message_recipient_row(b).find(".message_header"),e={message_containers:a};d(e,a[0]);a=$(templates.render("recipient_row",e));b.replaceWith(a)}}},_rerender_message:function(a){var b=this.get_row(a.msg.id),d=this.list.selected_message()===a.msg;this._add_msg_timestring(a);var e=_.extend(a,{table_name:this.table_name}),e=$(templates.render("single_message",e));this._post_process_dom_messages(e.get());b.replaceWith(e);d&&this.list.select_id(a.msg.id)},rerender_messages:function(b){var d=
this,e=_.map(b,function(a){return d.list.get(a.id)}),e=_.reject(e,function(a){return void 0===a});b=_.map(b,function(a){return d.message_containers[a.id]});b=_.reject(b,function(a){return void 0===a});var f=[],h=[];_.each(b,function(b){0===h.length||a(h[h.length-1],b)?h.push(b):(f.push(h),h=[]);d._rerender_message(b)});0!==h.length&&f.push(h);_.each(f,function(a){d._rerender_header(a)})},append:function(a,b){var d=this._render_win_end-this._render_win_start;d<this._RENDER_WINDOW_SIZE&&(d=a.slice(0,
this._RENDER_WINDOW_SIZE-d),this.render(d,"bottom",b),this._render_win_end+=d.length);this.maybe_rerender()},prepend:function(a){this._render_win_start+=a.length;this._render_win_end+=a.length;var b=this._render_win_end-this._render_win_start;b<this._RENDER_WINDOW_SIZE&&(a=a.slice(a.length-(this._RENDER_WINDOW_SIZE-b)),this.render(a,"top",!1),this._render_win_start-=a.length)},rerender_the_whole_thing:function(a){this.clear_rendering_state(!0);this.update_render_window(this.list.selected_idx(),!1);
this.render(this.list.all().slice(this._render_win_start,this._render_win_end),"bottom")},clear_table:function(){rows.get_table(this.table_name).children().detach();this._rows={};this._message_groups=[];this.message_containers={}},get_row:function(a){return $(this._rows[a])},clear_trailing_bookend:function(){rows.get_table(this.table_name).find(".trailing_bookend").remove()},render_trailing_bookend:function(a){a=$(templates.render("bookend",{bookend_content:a,trailing:!0}));rows.get_table(this.table_name).append(a)},
selected_row:function(){return this.get_row(this.list.selected_id())},get_message:function(a){return this.list.get(a)},change_message_id:function(a,b){if(void 0!==this._rows[a]){var d=this._rows[a];delete this._rows[a];d.setAttribute("zid",b);d.setAttribute("id",this.table_name+b);$(d).removeClass("local");this._rows[b]=d}void 0!==this.message_containers[a]&&(d=this.message_containers[a],delete this.message_containers[a],this.message_containers[b]=d)}}})();
"undefined"!==typeof module&&(module.exports=MessageListView);function MessageList(f,h,b){_.extend(this,{collapse_messages:!0,muting_enabled:!0},b);this.view=new MessageListView(this,f,this.collapse_messages);this.muting_enabled&&(this._all_items=[]);this._items=[];this._hash={};this._local_only={};this.table_name=f;this.filter=h;this._selected_id=-1;void 0===this.filter&&(this.filter=new Filter);this.narrowed="zfilt"===this.table_name;this.num_appends=0;return this}
(function(){MessageList.prototype={add_messages:function(f,h){var b=this,a=b.filter.predicate(),e=[],d=[],c=[];if(-1===b.selected_id()&&b.empty())var g=_.filter(f,a),d=_.reject(g,function(a){return b.get(a.id)});else _.each(f,function(f){void 0===b.get(f.id)&&a(f)&&(b.empty()||f.id>b.last().id?d.push(f):f.id<b.first().id?e.push(f):c.push(f))});if(0<c.length)return b.add_and_rerender(e.concat(c).concat(d)),!0;0<e.length&&b.prepend(e);0<d.length&&b.append(d,h);b===narrowed_msg_list&&!b.empty()&&narrow.hide_empty_narrow_message();
b===narrowed_msg_list&&(!b.empty()&&-1===b.selected_id()&&!h.delay_render)&&b.select_id(b.selected_id(),{then_scroll:!0,use_closest:!0})},get:function(f){f=parseFloat(f);return isNaN(f)?void 0:this._hash[f]},num_items:function(){return this._items.length},empty:function(){return 0===this._items.length},first:function(){return this._items[0]},last:function(){return this._items[this._items.length-1]},nth_most_recent_id:function(f){f=this._items.length-f;return 0>f?-1:this._items[f].id},clear:function(f){f=
_.extend({clear_selected_id:!0},f);this.muting_enabled&&(this._all_items=[]);this._items=[];this._hash={};this.view.clear_rendering_state(!0);f.clear_selected_id&&(this._selected_id=-1)},selected_id:function(){return this._selected_id},select_id:function(f,h){h=_.extend({then_scroll:!1,target_scroll_offset:void 0,use_closest:!1,empty_ok:!1,mark_read:!0,force_rerender:!1},h,{id:f,msg_list:this,previously_selected:this._selected_id});f=parseFloat(f);isNaN(f)&&blueslip.fatal("Bad message id");var b=
this.closest_id(f);!h.use_closest&&b!==f&&blueslip.error("Selected message id not in MessageList",{table_name:this.table_name,id:f});-1===b&&!h.empty_ok&&blueslip.fatal("Cannot select id -1",{table_name:this.table_name,id:f,items_length:this._items.length});f=b;this._selected_id=h.id=f;h.force_rerender?this.rerender():h.from_rendering||this.view.maybe_rerender();$(document).trigger($.Event("message_selected.zulip",h))},reselect_selected_id:function(){this.select_id(this._selected_id,{from_rendering:!0})},
selected_message:function(){return this.get(this._selected_id)},selected_row:function(){return this.get_row(this._selected_id)},_lower_bound:function(f){var h=this;return util.lower_bound(h._items,f,function(b,a,e){return h._is_localonly_id(b.id)&&(e=h._next_nonlocal_message(h._items,e,function(a){return a-1}))?(b=parseFloat((b.id%1).toFixed(0.02)),e.id+b<a):b.id<a})},closest_id:function(f){if(this._local_only.hasOwnProperty(f))return f;var h=this._items;if(0===h.length)return-1;var b=this._lower_bound(f);
if(b<h.length&&f===h[b].id)return h[b].id;var a=[];if(0<b&&this._is_localonly_id(h[b-1].id)){do a.push(b),b--;while(0<b&&this._is_localonly_id(h[b-1].id))}a.push(b);if(b===h.length)b-=1;else{a.unshift(_.last(a)-1);var e=h[b].id;_.each(a,function(a){if(!(0>a)){var c=h[a].id;Math.abs(f-c)<Math.abs(e-f)&&(e=c,b=a)}})}return h[b].id},advance_past_messages:function(f){var h=0,b={};_.each(f,function(a){b[a]=!0});for(f=this.selected_idx()+1;f<this._items.length;){var a=this._items[f].id;if(!b[a])break;h=
a;++f}0<h&&(this._selected_id=h)},_add_to_hash:function(f){var h=this;f.forEach(function(b){var a=parseFloat(b.id);isNaN(a)&&blueslip.fatal("Bad message id");h._is_localonly_id(a)&&(h._local_only[a]=b);void 0!==h._hash[a]?blueslip.error("Duplicate message added to MessageList"):h._hash[a]=b})},selected_idx:function(){return this._lower_bound(this._selected_id)},subscribed_bookend_content:function(f){return"--- Subscribed to stream "+f+" ---"},unsubscribed_bookend_content:function(f){return"--- Unsubscribed from stream "+
f+" ---"},not_subscribed_bookend_content:function(f){return"--- Not subscribed to stream "+f+" ---"},update_trailing_bookend:function(){this.view.clear_trailing_bookend();if(this.narrowed){var f=narrow.stream();if(void 0!==f){var h;stream_data.is_subscribed(f)?this.last_message_historical&&(h=this.subscribed_bookend_content(f)):h=this.last_message_historical?this.not_subscribed_bookend_content(f):this.unsubscribed_bookend_content(f);void 0!==h&&this.view.render_trailing_bookend(h)}}},unmuted_messages:function(f){return _.reject(f,
function(f){return muting.is_topic_muted(f.stream,f.subject)&&!f.mentioned})},append:function(f,h){h=_.extend({delay_render:!1,messages_are_new:!1},h);var b;this.muting_enabled?(this._all_items=this._all_items.concat(f),b=this.unmuted_messages(f)):b=f;this._items=this._items.concat(b);this.num_appends+=1;this._add_to_hash(f);h.delay_render||this.view.append(b,h.messages_are_new)},prepend:function(f){var h;this.muting_enabled?(this._all_items=f.concat(this._all_items),h=this.unmuted_messages(f)):h=
f;this._items=h.concat(this._items);this._add_to_hash(f);this.view.prepend(h)},add_and_rerender:function(f){var h;this.muting_enabled?(this._all_items=f.concat(this._all_items),this._all_items.sort(function(b,a){return b.id-a.id}),h=this.unmuted_messages(f),this._items=h.concat(this._items)):this._items=f.concat(this._items);this._items.sort(function(b,a){return b.id-a.id});this._add_to_hash(f);this.view.rerender_the_whole_thing()},remove_and_rerender:function(f){var h=this;_.each(f,function(a){var b=
h._hash[a.id];void 0!==b&&delete h._hash[b];delete h._local_only[a.id]});var b={};_.each(f,function(a){b[a.id]=!0});this._items=_.filter(this._items,function(a){return!b.hasOwnProperty(a.id)});this.muting_enabled&&(this._all_items=_.filter(this._all_items,function(a){return!b.hasOwnProperty(a.id)}));this.rerender()},show_edit_message:function(f,h){f.find(".message_edit_form").empty().append(h.form);f.find(".message_content").hide();f.find(".message_edit").show();f.find(".message_edit_content").autosize()},
hide_edit_message:function(f){f.find(".message_content").show();f.find(".message_edit").hide()},show_edit_topic:function(f,h){f.find(".topic_edit_form").empty().append(h);f.find(".stream_topic").hide();f.find(".topic_edit").show()},hide_edit_topic:function(f){f.find(".stream_topic").show();f.find(".topic_edit").hide()},show_message_as_read:function(f,h){var b=this.get_row(f.id);"pointer"===h.from&&feature_flags.mark_read_at_bottom||"server"===h.from?b.find(".unread_marker").addClass("fast_fade"):
b.find(".unread_marker").addClass("slow_fade");b.removeClass("unread")},rerender:function(){this._selected_id=this.closest_id(this._selected_id);this.view.clear_rendering_state(!1);this.view.update_render_window(this.selected_idx(),!1);this.view.rerender_preserving_scrolltop();-1!==this._selected_id&&this.select_id(this._selected_id)},rerender_after_muting_changes:function(){this.muting_enabled&&(this._items=this.unmuted_messages(this._all_items),this.rerender())},all:function(){return this._items},
message_range:function(f,h){-1===f&&blueslip.error("message_range given a start of -1");var b=this._lower_bound(f),a=this._lower_bound(h);return this._items.slice(b,a+1)},get_row:function(f){return this.view.get_row(f)},_is_localonly_id:function(f){return 0!==f%1},_next_nonlocal_message:function(f,h,b){do h=b(h);while(void 0!==f[h]&&this._is_localonly_id(f[h].id));return f[h]},change_display_recipient:function(f,h){_.each(this._items,function(b){b.display_recipient===f&&(b.display_recipient=h,b.stream=
h)});this.view.rerender_the_whole_thing()},change_message_id:function(f,h){function b(a,b){return a.id-b.id}if(this._hash.hasOwnProperty(f)){var a=this._hash[f];delete this._hash[f];this._hash[h]=a;this._local_only.hasOwnProperty(f)&&(this._is_localonly_id(h)&&(this._local_only[h]=this._local_only[f]),delete this._local_only[f]);this._selected_id===f&&(this._selected_id=h);var e=this;setTimeout(function(){var a=e._hash[h],c=e._items.indexOf(a);if(-1===c)!e.muting_enabled&&current_msg_list===e&&blueslip.error("Trying to re-order message but can't find message with new_id in _items!");
else{var f=e._next_nonlocal_message(e._items,c,function(a){return a+1}),c=e._next_nonlocal_message(e._items,c,function(a){return a-1});if(void 0!==f&&a.id>f.id||void 0!==c&&a.id<c.id)blueslip.debug("Changed message ID from server caused out-of-order list, reordering"),e._items.sort(b),e.muting_enabled&&e._all_items.sort(b),e.view.rerender_preserving_scrolltop(),-1!==e._selected_id&&e.select_id(e._selected_id)}},0)}}};$(document).on("message_selected.zulip hashchange.zulip mousewheel",function(f){viewport.stop_auto_scrolling()})})();
"undefined"!==typeof module&&(module.exports=MessageList);var message_flags=function(){function f(a,b,c){function f(){var c=_.filter(h,function(a){return void 0===a.local_id}),c=_.map(c,function(a){return a.id});0===c.length?setTimeout(l,100):channel.post({url:"/json/update_message_flags",idempotent:!0,data:{messages:JSON.stringify(c),op:b,flag:a},success:k})}var h=[],k,l;l=c?f:_.debounce(f,1E3);k=function(a,b,c){void 0===a||void 0===a.messages||(h=_.filter(h,function(b){return-1===a.messages.indexOf(b.id)}),0<h.length&&l())};return function(c){void 0===
c.flags&&(c.flags=[]);"add"===b?c.flags.push(a):c.flags=_.without(c.flags,a);h.push(c);l()}}function h(b,d,c){c=c?"add":"remove";var g=d+"_"+c,h;a.hasOwnProperty(g)?h=a[g]:(h=f(d,c,!0),a[g]=h);_.each(b,function(a){h(a)})}var b={},a={};b.send_read=f("read","add");b.send_collapsed=function(a,b){h(a,"collapsed",b)};b.send_starred=function(a,b){h(a,"starred",b)};b.send_force_expand=function(a,b){h(a,"force_expand",b)};b.send_force_collapse=function(a,b){h(a,"force_collapse",b)};return b}();var alert_words=function(){var f={};f.words=page_params.alert_words;var h=/href=['"][\w:\/\.]+$/,b=/title=['"][\w:\/\.]+$/;f.process_message=function(a){f.notifies(a)&&_.each(f.words,function(e){e=e.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&");a.content=a.content.replace(RegExp("(\\s|^|>|[\\(\\\".,';\\[])("+e+")(\\s|$|<|[\\)\\\"\\?!:.,';\\]!])","ig"),function(a,c,e,f,k,l){a=l.substring(0,k);return h.exec(a)||b.exec(a)?c+e+f:c+"<span class='alert-word'>"+e+"</span>"+f})})};f.notifies=function(a){return a.sender_email!==
page_params.email&&a.alerted};return f}();"undefined"!==typeof module&&(module.exports=alert_words);var alert_words_ui=function(){function f(){var b=_.map($(".alert-word-item"),function(a){return $(a).data("word")}),b=_.filter(b,function(a){return""!==a});channel.post({url:"/json/set_alert_words",idempotent:!0,data:{alert_words:JSON.stringify(b)}})}function h(b,a){if(""!==b){var e=templates.render("alert_word_settings_item",{word:b,editing:!1});$(a.target).parent().replaceWith(e);var e=templates.render("alert_word_settings_item",{word:"",editing:!0}),d=$("#word-alerts");d.append(e);0<d.find("input").length&&
d.find("input").focus();f()}}return{set_up_alert_words:function(){var b=$("#word-alerts");_.each(alert_words.words,function(a){a=templates.render("alert_word_settings_item",{word:a});b.append(a)});var a=templates.render("alert_word_settings_item",{word:"",editing:!0});b.append(a);$("#word-alerts").on("click",".add-alert-word",function(a){var b=$(a.target).siblings("input").val();h(b,a)});$("#word-alerts").on("click",".remove-alert-word",function(a){$(a.currentTarget).parent().remove();f()});$("#word-alerts").on("keypress",
".edit-alert-word",function(a){if(13===a.which){a.preventDefault();var b=$(a.target).val();h(b,a)}})}}}();var people=function(){function f(a,b){var e=util.strcmp(a.full_name,b.full_name);return 0>e?-1:0<e?1:util.strcmp(a.email,b.email)}var h={},b=new Dict({fold_case:!0}),a=new Dict({fold_case:!0}),e=new Dict({fold_case:!0});h.get_by_email=function(a){return b.get(a)};h.realm_get=function(a){return e.get(a)};h.get_by_name=function(b){return a.get(b)};h.test_set_people_dict=function(a){b=new Dict.from(a)};h.test_set_people_name_dict=function(b){a=new Dict.from(b)};h.get_rest_of_realm=function(){var a=[];
e.each(function(b){b.email!==page_params.email&&a.push({email:b.email,full_name:b.full_name})});return a.sort(f)};h.add=function(d){page_params.people_list.push(d);b.set(d.email,d);a.set(d.full_name,d);d.pm_recipient_count=0};h.add_in_realm=function(a){e.set(a.email,a);h.add(a)};h.remove=function(d){var c;for(c=0;c<page_params.people_list.length;c++)if(page_params.people_list[c].email===d.email){page_params.people_list.splice(c,1);break}b.del(d.email);a.del(d.full_name);e.del(d.email)};h.reify=function(d){if(b.has(d.email)){var c=
b.get(d.email);if(c.skeleton){var e=page_params.people_list.indexOf(c),c=_.extend({},c,d);c.skeleton=!1;b.set(d.email,d);a.set(d.full_name,d);page_params.people_list[e]=c;a.has(d.email)&&a.del(d.email)}}};h.update=function(d){if(b.has(d.email)){var c=b.get(d.email);_.has(d,"full_name")&&(a.has(c.full_name)&&(a.set(d.full_name,c),a.del(c.full_name)),c.full_name=d.full_name,d.email===page_params.email&&(page_params.fullname=d.full_name));_.has(d,"is_admin")&&(c.is_admin=d.is_admin,d.email===page_params.email&&
(page_params.is_admin=d.is_admin,admin.show_or_hide_menu_item()));activity.set_user_statuses([])}else blueslip.error("Got update_person event for unexpected user",{email:d.email})};$(function(){_.each(page_params.people_list,function(d){b.set(d.email,d);a.set(d.full_name,d);e.set(d.email,d);d.pm_recipient_count=0});people.get_by_email("feedback@zulip.com")||h.add({email:"feedback@zulip.com",full_name:"Zulip Feedback Bot"})});return h}();"undefined"!==typeof module&&(module.exports=people);var message_store=function(){function f(a){a.always_visible_topic_edit=!1;a.on_hover_topic_edit=!1;feature_flags.disable_message_editing||(a.subject===compose.empty_subject_placeholder()?a.always_visible_topic_edit=!0:page_params.is_admin&&(a.on_hover_topic_edit=!0))}function h(a){var b=c[a.id];if(void 0!==b)return void 0!==a.match_subject&&(b.match_subject=a.match_subject,b.match_content=a.match_content),b;var e;a.sent_by_me=a.sender_email===page_params.email;a.flags=a.flags||[];a.historical=void 0!==
a.flags&&-1!==a.flags.indexOf("historical");a.starred=-1!==a.flags.indexOf("starred");a.mentioned=-1!==a.flags.indexOf("mentioned")||-1!==a.flags.indexOf("wildcard_mentioned");a.collapsed=-1!==a.flags.indexOf("collapsed");a.alerted=-1!==a.flags.indexOf("has_alert_word");a.is_me_message=-1!==a.flags.indexOf("is_me_message");switch(a.type){case "stream":a.is_stream=!0;a.stream=a.display_recipient;composebox_typeahead.add_topic(a.stream,a.subject);a.reply_to=a.sender_email;d.process_message_for_recent_subjects(a);
e=[{full_name:a.sender_full_name,email:a.sender_email}];f(a);break;case "private":a.is_private=!0,a.reply_to=util.normalize_recipients(get_private_message_recipient(a,"email")),a.display_reply_to=get_private_message_recipient(a,"full_name","email"),e=a.display_recipient}_.each(e,function(b){people.get_by_email(b.email)||people.add(b);people.get_by_email(b.email).full_name!==b.full_name&&people.reify(b);"private"===a.type&&a.sent_by_me&&(people.get_by_email(b.email).pm_recipient_count+=1)});alert_words.process_message(a);
return c[a.id]=a}function b(a,c,e){var f=[];_.each(a,function(a){f.push(a.id)});channel.post({url:"/json/messages_in_narrow",idempotent:!0,data:{msg_ids:JSON.stringify(f),narrow:JSON.stringify(narrow.public_operators())},timeout:5E3,success:function(b){if(c===current_msg_list){var f=[],g=[];_.each(a,function(a){b.messages.hasOwnProperty(a.id)?(a.match_subject=b.messages[a.id].match_subject,a.match_content=b.messages[a.id].match_content,f.push(a)):g.push(a)});f=_.map(f,h);d.add_messages(f,c,{messages_are_new:e});
unread.process_visible();notifications.possibly_notify_new_messages_outside_viewport(f);notifications.notify_messages_outside_current_search(g)}},error:function(d){setTimeout(function(){c===current_msg_list&&b(a,c,e)},5E3)}})}function a(a,b){$("#get_old_messages_error").hide();0===a.length&&(current_msg_list===narrowed_msg_list&&narrowed_msg_list.empty())&&narrow.show_empty_narrow_message();a=_.map(a,h);b.msg_list===home_msg_list&&(process_loaded_for_unread(a),d.add_messages(a,all_msg_list,{messages_are_new:!1}));
0!==a.length&&!b.cont_will_add_messages&&d.add_messages(a,b.msg_list,{messages_are_new:!1});stream_list.update_streams_sidebar();void 0!==b.cont&&b.cont(a)}function e(b,c){tutorial.is_running()?(loading.destroy_indicator($("#page_loading_indicator")),tutorial.defer(function(){e(b,c)})):c.msg_list.narrowed&&c.msg_list!==current_msg_list||(b?(a(b.messages,c),resize.resize_bottom_whitespace()):setTimeout(function(){d.load_old_messages(c)},0))}var d={},c={},g=!0,m=/https:\/\/humbug-user-uploads.s3.amazonaws.com\/([^"]+)/g;
d.get=function(a){return c[a]};d.process_message_for_recent_subjects=function(a,b){var c=0,d=0,e=a.stream,f=stream_data.canonicalized_name(a.subject);recent_subjects.has(e)?recent_subjects.set(e,_.filter(recent_subjects.get(e),function(a){var b=a.canon_subject.toLowerCase()===f.toLowerCase();b&&(c=a.timestamp,d=a.count);return!b})):recent_subjects.set(e,[]);var g=recent_subjects.get(e),d=void 0!==b?d-1:d+1;0!==d&&g.push({subject:a.subject,canon_subject:f,count:d,timestamp:Math.max(a.timestamp,c)});
g.sort(function(a,b){return b.timestamp-a.timestamp});recent_subjects.set(e,g)};d.add_messages=function(a,b,c){a&&(c=_.extend({messages_are_new:!1,delay_render:!1},c),_.each(a,function(a){a.content=a.content.replace(m,"/user_uploads/unk/$1")}),loading.destroy_indicator($("#page_loading_indicator")),$("#first_run_message").remove(),b.add_messages(a,c),b===home_msg_list&&c.messages_are_new&&_.each(a,function(a){void 0===a.local_id&&compose.report_as_received(a)}))};d.update_messages=function(a){var b=
[],e=!1,g=!1;_.each(a,function(a){var h=c[a.message_id];if(void 0!==h){b.push(h);h.alerted=-1!==a.flags.indexOf("has_alert_word");h.mentioned=-1!==a.flags.indexOf("mentioned")||-1!==a.flags.indexOf("wildcard_mentioned");condense.un_cache_message_content_height(h.id);void 0!==a.rendered_content&&(h.content=a.rendered_content);var k=current_msg_list.get_row(a.message_id);0<k.length&&message_edit.end(k);if(void 0!==a.subject){e=!0;var m=0<=_.indexOf(["change_later","change_all"],a.propagate_mode),k=
stream_data.get_sub_by_id(a.stream_id).name,p=compose.stream_name();m&&k&&p&&k.toLowerCase()===p.toLowerCase()&&a.orig_subject===compose.subject()&&compose.subject(a.subject);if(m&&(m=current_msg_list.selected_id(),0<=_.indexOf(a.message_ids,m)&&(p=narrow.filter())&&k&&p.has_topic(k,a.orig_subject)))k=p.filter_with_new_topic(a.subject).operators(),narrow.activate(k,{trigger:"topic change",then_select_id:m}),g=!0;_.each(a.message_ids,function(b){b=message_store.get(b);void 0!==b&&(d.process_message_for_recent_subjects(b,
!0),unread.update_unread_subjects(b,a),b.subject=a.subject,b.subject_links=a.subject_links,f(b),d.process_message_for_recent_subjects(b))})}h.last_edit_timestamp=a.edit_timestamp;delete h.last_edit_timestr;notifications.received_messages([h]);alert_words.process_message(h)}});e?g||(home_msg_list.rerender(),current_msg_list===narrowed_msg_list&&narrowed_msg_list.rerender()):(home_msg_list.view.rerender_messages(b),current_msg_list===narrowed_msg_list&&narrowed_msg_list.view.rerender_messages(b));unread.update_unread_counts();
stream_list.update_streams_sidebar()};d.insert_new_messages=function(a){a=_.map(a,h);d.add_messages(a,home_msg_list,{messages_are_new:!0});d.add_messages(a,all_msg_list,{messages_are_new:!0});narrow.active()?narrow.filter().can_apply_locally()?(d.add_messages(a,narrowed_msg_list,{messages_are_new:!0}),notifications.possibly_notify_new_messages_outside_viewport(a)):b(a,narrowed_msg_list,!0):notifications.possibly_notify_new_messages_outside_viewport(a);process_loaded_for_unread(a);if(narrow.narrowed_by_reply()){var c,
e=current_msg_list.selected_id();for(c=a.length-1;0<=c;c--){var f=a[c].id;if(f<=e)break;if(a[c].sent_by_me&&void 0!==current_msg_list.get(f)){current_msg_list.select_id(a[c].id,{then_scroll:!0,from_scroll:!0});break}}}unread.process_visible();notifications.received_messages(a);stream_list.update_streams_sidebar()};d.load_old_messages=function(b){b=_.extend({cont_will_add_messages:!1},b);var c={anchor:b.anchor,num_before:b.num_before,num_after:b.num_after};if(b.msg_list.narrowed&&narrow.active()){var f=
narrow.public_operators();void 0!==page_params.narrow&&(f=f.concat(page_params.narrow));c.narrow=JSON.stringify(f)}b.msg_list===home_msg_list&&void 0!==page_params.narrow_stream&&(c.narrow=JSON.stringify(page_params.narrow));b.use_first_unread_anchor&&(c.use_first_unread_anchor=!0);channel.post({url:"/json/get_old_messages",data:c,idempotent:!0,success:function(a){e(a,b)},error:function(c,e,f){b.msg_list.narrowed&&b.msg_list!==current_msg_list||(400===c.status?a([],b):($("#get_old_messages_error").show(),
setTimeout(function(){d.load_old_messages(b)},5E3)))}})};d.reset_load_more_status=function(){have_scrolled_away_from_top=g=!0;ui.hide_loading_more_messages_indicator()};d.load_more_messages=function(a){var b;g&&(ui.show_loading_more_messages_indicator(),g=!1,b=void 0===a.first()?page_params.initial_pointer:a.first().id,d.load_old_messages({anchor:b.toFixed(),num_before:100,num_after:0,msg_list:a,cont:function(a){ui.hide_loading_more_messages_indicator();100<=a.length&&(g=!0)}}))};d.clear=function(){this.stored_messages=
{}};util.execute_early(function(){function a(b){-1===home_msg_list.selected_id()&&!home_msg_list.empty()&&home_msg_list.select_id(page_params.initial_pointer,{then_scroll:!0,use_closest:!0,target_scroll_offset:page_params.initial_offset});if(0!==b.length&&(b=b[b.length-1].id,b<page_params.max_message_id)){d.load_old_messages({anchor:b.toFixed(),num_before:0,num_after:400,msg_list:home_msg_list,cont:a});return}server_events.home_view_loaded();$(document).idle({idle:1E4,onIdle:function(){var a=all_msg_list.first().id;
d.load_old_messages({anchor:a,num_before:1E3,num_after:0,msg_list:home_msg_list})}})}page_params.have_initial_messages?d.load_old_messages({anchor:page_params.initial_pointer,num_before:200,num_after:200,msg_list:home_msg_list,cont:a}):server_events.home_view_loaded();$(document).on("message_id_changed",function(a){var b=a.old_id,d=a.new_id;furthest_read===b&&(furthest_read=d);c[b]&&(c[d]=c[b],delete c[b]);_.each([all_msg_list,home_msg_list,narrowed_msg_list],function(a){void 0!==a&&(a.change_message_id(b,
d),void 0!==a.view&&a.view.change_message_id(b,d))})})});return d}();"undefined"!==typeof module&&(module.exports=message_store);var server_events=function(){function f(b){var c=[],f=[],g;_.each(b,function(a){try{k.last_event_id=Math.max(k.last_event_id,a.id)}catch(b){blueslip.error("Failed to update last_event_id",{event:_.pick(a,"id","type","op")},b.stack)}});if(tutorial.is_running())e=e.concat(b);else if(0<e.length&&(b=e.concat(b),e=[]),a)d=d.concat(b);else{0<d.length&&(b=d.concat(b),d=[]);var h=function(a){switch(a.type){case "message":var b=a.message;b.flags=a.flags;void 0!==a.local_message_id&&(b.local_id=a.local_message_id);
c.push(b);break;case "pointer":g=a.pointer;break;case "restart":reload.initiate({message:"The application has been updated; reloading!"});break;case "update_message":f.push(a);break;case "realm":"update"===a.op&&"name"===a.property?(page_params.realm_name=a.value,notifications.redraw_title()):"update"===a.op&&"invite_required"===a.property?page_params.realm_invite_required=a.value:"update"===a.op&&"invite_by_admins_only"===a.property?page_params.realm_invite_by_admins_only=a.value:"update"===a.op&&
"restricted_to_domain"===a.property&&(page_params.realm_restricted_to_domain=a.value);break;case "realm_user":"add"===a.op?people.add_in_realm(a.person):"remove"===a.op?people.remove(a.person):"update"===a.op&&people.update(a.person);break;case "realm_bot":"add"===a.op?bot_data.add(a.bot):"remove"===a.op?bot_data.remove(a.bot.email):"update"===a.op&&bot_data.update(a.bot.email,a.bot);break;case "stream":"update"===a.op&&subs.update_subscription_properties(a.name,a.property,a.value);break;case "subscription":"add"===
a.op?_.each(a.subscriptions,function(a){subs.mark_subscribed(a.name,a)}):"remove"===a.op?_.each(a.subscriptions,function(a){a=stream_data.get_sub_by_id(a.stream_id);subs.mark_sub_unsubscribed(a)}):"update"===a.op?subs.update_subscription_properties(a.name,a.property,a.value):("peer_add"===a.op||"peer_remove"===a.op)&&_.each(a.subscriptions,function(b){var c;"peer_add"===a.op?(c="peer_subscribe.zulip",stream_data.add_subscriber(b,a.user_email)):"peer_remove"===a.op&&(c="peer_unsubscribe.zulip",stream_data.remove_subscriber(b,
a.user_email));$(document).trigger(c,{stream_name:b,user_email:a.user_email})});break;case "presence":b={};b[a.email]=a.presence;activity.set_user_statuses(b,a.server_timestamp);break;case "update_message_flags":var d="add"===a.operation;switch(a.flag){case "starred":_.each(a.messages,function(a){ui.update_starred(a,d)});break;case "read":b=_.map(a.messages,function(a){return message_store.get(a)}),unread.mark_messages_as_read(b,{from:"server"})}break;case "referral":referral.update_state(a.referrals.granted,
a.referrals.used);break;case "realm_emoji":emoji.update_emojis(a.realm_emoji);break;case "alert_words":alert_words.words=a.alert_words;break;case "muted_topics":muting_ui.handle_updates(a.muted_topics);break;case "realm_filters":page_params.realm_filters=a.realm_filters;echo.set_realm_filters(page_params.realm_filters);break;case "update_global_notifications":notifications.handle_global_notification_updates(a.notification_name,a.setting);break;case "update_display_settings":"twenty_four_hour_time"===
a.setting_name&&(page_params.twenty_four_hour_time=a.twenty_four_hour_time),"left_side_userlist"===a.setting_name&&(page_params.left_side_userlist=a.left_side_userlist)}};_.each(b,function(a){try{h(a)}catch(b){blueslip.error("Failed to process an event\n"+blueslip.exception_msg(b),{event:_.pick(a,"id","type","op")},b.stack)}});if(0!==c.length)try{c=echo.process_from_server(c),message_store.insert_new_messages(c)}catch(l){blueslip.error("Failed to insert new messages\n"+blueslip.exception_msg(l),void 0,
l.stack)}void 0!==g&&g>furthest_read&&(server_furthest_read=furthest_read=g,home_msg_list.select_id(g,{then_scroll:!0,use_closest:!0}));-1===home_msg_list.selected_id()&&!home_msg_list.empty()&&home_msg_list.select_id(home_msg_list.first().id,{then_scroll:!1});if(0!==f.length)try{message_store.update_messages(f)}catch(p){blueslip.error("Failed to update messages\n"+blueslip.exception_msg(p),void 0,p.stack)}}}function h(a){a=_.extend({dont_block:!1},a);k.dont_block=a.dont_block||0<m;void 0===k.queue_id&&
(k.queue_id=page_params.event_queue_id,k.last_event_id=page_params.last_event_id);void 0!==c&&c.abort();void 0!==g&&clearTimeout(g);g=void 0;c=channel.post({url:"/json/get_events",data:k,idempotent:!0,timeout:page_params.poll_timeout,success:function(a){try{c=void 0,m=0,$("#connection-error").hide(),f(a.events)}catch(b){blueslip.error("Failed to handle get_events success\n"+blueslip.exception_msg(b),void 0,b.stack)}g=setTimeout(h,0)},error:function(a,b,d){try{c=void 0;if(400===a.status&&(-1!==$.parseJSON(a.responseText).msg.indexOf("too old")||
-1!==$.parseJSON(a.responseText).msg.indexOf("Bad event queue id")))page_params.event_queue_expired=!0,reload.initiate({immediate:!0,save_state:!1});if("abort"===b)return;"timeout"===b?(m=0,$("#connection-error").hide()):m+=1;5<=m?$("#connection-error").show():$("#connection-error").hide()}catch(e){blueslip.error("Failed to handle get_events error\n"+blueslip.exception_msg(e),void 0,e.stack)}a=Math.min(90,Math.exp(m/2));g=setTimeout(h,1E3*a)}})}var b={},a=!0,e=[],d=[],c,g,m=0,k={};b.assert_get_events_running=
function(a){void 0===c&&void 0===g&&(b.restart_get_events({dont_block:!0}),blueslip.error(a))};b.restart_get_events=function(a){h(a)};b.force_get_events=function(){g=setTimeout(h,0)};b.home_view_loaded=function(){a=!1;f([]);$(document).trigger("home_view_loaded.zulip")};var l=$.now();setInterval(function(){var a=$.now();2E4<a-l&&(l=a,$(document).trigger($.Event("unsuspend")));l=a},5E3);util.execute_early(function(){$(document).on("unsuspend",function(){blueslip.log("Restarting get_events due to unsuspend");
m=0;b.restart_get_events({dont_block:!0})});h()});b.cleanup_event_queue=function(){!0!==page_params.event_queue_expired&&channel.del({url:"/json/events",data:{queue_id:page_params.event_queue_id}})};window.addEventListener("beforeunload",function(a){b.cleanup_event_queue()});return b}();"undefined"!==typeof module&&(module.exports=server_events);var all_msg_list=new MessageList(void 0,void 0,{muting_enabled:!1}),home_msg_list=new MessageList("zhome",new Filter([{operator:"in",operand:"home"}]),{muting_enabled:!0}),narrowed_msg_list,current_msg_list=home_msg_list,recent_subjects=new Dict({fold_case:!0}),queued_mark_as_read=[],queued_flag_timer,have_scrolled_away_from_top=!0,recenter_pointer_on_display=!1,suppress_scroll_pointer_update=!1,last_viewport_movement_direction=1,furthest_read=-1,server_furthest_read=-1,unread_messages_read_in_narrow=
!1,pointer_update_in_flight=!1;
function keep_pointer_in_view(){function f(){if(viewport.at_top())return!0;var a=e.offset().top;return a>=d.visible_top||a+e.outerHeight(!0)>=c?!0:!1}function h(){return viewport.at_bottom()||e.offset().top<=g}function b(b,c){if(b(e))return!1;for(;!b(e);){a=c(e);if(0===a.length)break;e=a}return!0}var a,e=current_msg_list.selected_row();if(0!==e.length){var d=viewport.message_viewport_info(),c=d.visible_top+0.1*d.visible_height,g=d.visible_top+0.9*d.visible_height;b(f,rows.next_visible)||b(h,rows.prev_visible);
current_msg_list.select_id(rows.id(e),{from_scroll:!0})}}function recenter_view(f,h){h=h||{};var b=viewport.message_viewport_info(),a=b.visible_top,e=b.visible_top+b.visible_height,d=f.offset().top,c=f.outerHeight(!0),a=d<a,e=d+c>e;if(!h.from_scroll||!(a&&0<=last_viewport_movement_direction||e&&0>=last_viewport_movement_direction))a||h.force_center?viewport.set_message_position(d,c,b,0.5):e&&viewport.set_message_position(d,c,b,1/7)}
function scroll_to_selected(){var f=current_msg_list.selected_row();f&&0!==f.length&&recenter_view(f)}function maybe_scroll_to_selected(){recenter_pointer_on_display&&(scroll_to_selected(),recenter_pointer_on_display=!1)}
function get_private_message_recipient(f,h,b){var a,e=_.filter(f.display_recipient,function(a){return a.email!==page_params.email});if(0===e.length)return f.display_recipient[0][h];f=e[0][h];void 0===f&&void 0!==b&&(f=e[0][b]);for(a=1;a<e.length;a++){var d=e[a][h];void 0===d&&void 0!==b&&(d=e[a][b]);f+=", "+d}return f}
function respond_to_message(f){var h,b;compose.snapshot_message();h=current_msg_list.selected_message();if(void 0!==h){unread.mark_message_as_read(h);var a="",e="";"stream"===h.type&&(a=h.stream,e=h.subject);var d=h.reply_to;"personal"===f.reply_type&&"private"===h.type&&(d=h.sender_email);b="personal"===f.reply_type||"private"===h.type?"private":h.type;compose.start(b,{stream:a,subject:e,private_message_recipient:d,replying_to_message:h,trigger:f.trigger})}}
function update_pointer(){if(pointer_update_in_flight)return $.when();pointer_update_in_flight=!0;return channel.post({url:"/json/update_pointer",idempotent:!0,data:{pointer:furthest_read},success:function(){server_furthest_read=furthest_read;pointer_update_in_flight=!1},error:function(){pointer_update_in_flight=!1}})}function send_pointer_update(){furthest_read>server_furthest_read&&update_pointer()}
function unconditionally_send_pointer_update(){if(pointer_update_in_flight){var f=$.Deferred();setTimeout(function(){f.resolve(unconditionally_send_pointer_update())},100);return f}return update_pointer()}
function fast_forward_pointer(){channel.post({url:"/json/get_profile",idempotent:!0,data:{email:page_params.email},success:function(f){unread.mark_all_as_read(function(){furthest_read=f.max_message_id;unconditionally_send_pointer_update().then(function(){ui.change_tab_to("#home");reload.initiate({immediate:!0,save_state:!1})})})}})}
function consider_bankruptcy(){if(page_params.furthest_read_time){var f=(new XDate(!0)).getTime()/1E3;500<page_params.unread_count&&172800<f-page_params.furthest_read_time?(f=templates.render("bankruptcy_modal",{unread_count:page_params.unread_count}),$("#bankruptcy-unread-count").html(f),$("#bankruptcy").modal("show")):unread.enable()}else unread.enable()}
function process_loaded_for_unread(f){activity.process_loaded_messages(f);activity.update_huddles();unread.process_loaded_messages(f);unread.update_unread_counts();resize.resize_page_components()}
function main(){activity.set_user_statuses(page_params.initial_presences,page_params.initial_servertime);server_furthest_read=page_params.initial_pointer;void 0!==page_params.orig_initial_pointer&&page_params.orig_initial_pointer>server_furthest_read&&(server_furthest_read=page_params.orig_initial_pointer);furthest_read=server_furthest_read;consider_bankruptcy();$(document).idle({idle:1E3,onIdle:send_pointer_update,keepTracking:!0});$(document).on("message_selected.zulip",function(f){-1!==f.id&&(f.msg_list===
home_msg_list&&void 0===page_params.narrow_stream&&(f.id>furthest_read&&void 0===home_msg_list.get(f.id).local_id)&&(furthest_read=f.id),f.mark_read&&-1!==f.previously_selected&&(f=f.id<f.previously_selected?f.msg_list.message_range(f.id,f.previously_selected):f.msg_list.message_range(f.previously_selected,f.id),unread.mark_messages_as_read(f,{from:"pointer"})))})}$(function(){main()});var activity=function(){function f(a,b){a.sort(function(a,c){if("active"===b[a].status&&"active"!==b[c].status)return-1;if("active"===b[c].status&&"active"!==b[a].status)return 1;if("idle"===b[a].status&&"idle"!==b[c].status)return-1;if("idle"===b[c].status&&"idle"!==b[a].status)return 1;var d=a,e=c;people.get_by_email(a)&&(d=people.get_by_email(a).full_name);people.get_by_email(c)&&(e=people.get_by_email(c).full_name);return util.strcmp(d,e)});return a}function h(){if(!k.has_focus)return!1;k.has_focus=
!1}function b(a){var b=$(".user-list-filter");if(0!==b.length){b=b.expectOne().val().trim();if(""===b)return a;var c=b.toLowerCase().split(","),c=_.map(c,function(a){return a.trim()});return _.filter(a,function(a){a=people.get_by_email(a);if(!a||!a.full_name)return!1;var b=a.full_name.toLowerCase().split(/\s+/),b=_.map(b,function(a){return a.trim()});return _.any(c,function(a){return _.any(b,function(b){return 0===b.indexOf(a)})})})}}function a(){function a(b){var c=t[b].status,d=people.get_by_email(b).full_name,
e;e=unread.suppress_unread_counts?0:unread.num_unread_for_person(b);return{name:d,email:b,num_unread:e,type:c,type_desc:n[c],mobile:t[b].mobile}}if("mit.edu"!==page_params.domain){var c=Object.keys(t),c=b(c),c=_.filter(c,function(a){return people.get_by_email(a)}),c=f(c,t),c=_.map(c,a);$("#user_presences").html(templates.render("user_presence_rows",{users:c}));compose_fade.update_faded_users()}}function e(a,b){var c="offline",d=!1,e=!1;_.each(b,function(b,f){var g=a-b.timestamp;-1!==r.indexOf(f)&&
(d=b.pushable||d);if(g<l)switch(b.status){case "active":-1!==r.indexOf(f)?d=!0:e=!0;c=b.status;break;case "idle":"active"!==c&&(c=b.status);break;case "offline":"active"!==c&&"idle"!==c&&(c=b.status);break;default:blueslip.error("Unexpected status",{presence_object:b,device:f},void 0)}});return{status:c,mobile:!e&&d}}function d(){channel.post({url:"/json/update_active_status",data:{status:k.has_focus?k.ACTIVE:k.IDLE,new_user_input:k.new_user_input},idempotent:!0,success:function(a){t={};!1===a.zephyr_mirror_active?
$("#zephyr-mirror-error").show():$("#zephyr-mirror-error").hide();k.new_user_input=!1;_.each(a.presences,function(b,c){page_params.email!==c&&(t[c]=e(a.server_timestamp,b))});q();k.update_huddles()}})}function c(){k.has_focus||(k.has_focus=!0,d())}function g(a){13===a.keyCode&&(a.preventDefault(),a=$("#user_presences li.user_sidebar_entry").first().data("email"),void 0!==a&&compose.start("private",{trigger:"sidebar enter key",private_message_recipient:a}))}function m(a){a.stopPropagation()}var k=
{},l=140;k._OFFLINE_THRESHOLD_SECS=l;var r=["Android","ZulipiOS","ios"],n={active:"is active",idle:"is not active"};k.ACTIVE="active";k.IDLE="idle";k.has_focus=document.hasFocus&&document.hasFocus();k.new_user_input=!0;$("html").on("mousemove",function(){k.new_user_input=!0});var t={},s=new Dict;k.process_loaded_messages=function(a){_.each(a,function(a){if("private"===a.type&&0<a.reply_to.indexOf(",")){var b=s.get(a.reply_to);(!b||b<a.timestamp)&&s.set(a.reply_to,a.timestamp)}})};k.get_huddles=function(){var a=
s.keys(),a=_.sortBy(a,function(a){return s.get(a)});return a.reverse()};k.full_huddle_name=function(a){a=a.split(",");return _.map(a,function(a){var b=people.get_by_email(a);return b?b.full_name:a}).join(", ")};k.short_huddle_name=function(a){var b=a.split(",");a=_.map(b.slice(0,3),function(a){var b=people.get_by_email(a);return b?b.full_name:a});b=b.length-3;1===b?a.push("+ 1 other"):2<=b&&a.push("+ "+b+" others");return a.join(", ")};k.huddle_fraction_present=function(a,b){var c=a.split(","),d=
0;_.each(c,function(a){b[a]&&(a=b[a].status)&&"offline"!==a&&++d});return(d/c.length).toFixed(2)};k._sort_users=f;var q=_.throttle(a,5E3),v=_.throttle(function(){a();resize.resize_page_components()},50);k.update_huddles=function(){if("mit.edu"!==page_params.domain){var a=$("#group-pm-list").expectOne(),b=k.get_huddles().slice(0,10);if(0===b.length)a.hide();else{var c=_.map(b,function(a){return{emails:a,name:k.full_huddle_name(a),fraction_present:k.huddle_fraction_present(a,t),short_name:k.short_huddle_name(a)}}),
c=templates.render("group_pms",{group_pms:c});$("#group-pms").expectOne().html(c);_.each(b,function(a){var b=unread.num_unread_for_person(a);stream_list.set_presence_list_count(a,b)});a.show()}}};k._status_from_timestamp=e;k.initialize=function(){$(window).focus(c);$(window).idle({idle:3E5,onIdle:h,onActive:c,keepTracking:!0});setInterval(d,5E4);d()};k.set_user_statuses=function(a,b){_.each(a,function(a,c){c!==page_params.email&&(t[c]=e(b,a))});q();k.update_huddles()};k.searching=function(){return $(".user-list-filter").expectOne().is(":focus")};
k.escape_search=function(){var a=$(".user-list-filter").expectOne();""===a.val()?a.blur():(a.val(""),v())};k.initiate_search=function(){$(".user-list-filter").expectOne().focus()};k.blur_search=function(){$(".user-list-filter").blur()};$(function(){$(".user-list-filter").expectOne().on("click",m).on("input",v).on("keydown",g)});return k}();"undefined"!==typeof module&&(module.exports=activity);var colorspace=function(){return{sRGB_to_linear:function(f){f/=255;return 0.04045>=f?f/12.92:Math.pow((f+0.055)/1.055,2.4)},rgb_luminance:function(f){return 0.2126*f[0]+0.7152*f[1]+0.0722*f[2]},luminance_to_lightness:function(f){return 116*(f<=216/24389?841/108*f+4/29:Math.pow(f,1/3))-16},getDecimalColor:function(f){return{r:parseInt(f.substr(1,2),16),g:parseInt(f.substr(3,2),16),b:parseInt(f.substr(5,2),16)}},getLighterColor:function(f,h){return{r:(255*h+(1-h)*f.r).toFixed(),g:(255*h+(1-h)*f.g).toFixed(),
b:(255*h+(1-h)*f.b).toFixed()}},getHexColor:function(f){return"#"+parseInt(f.r,10).toString(16)+parseInt(f.g,10).toString(16)+parseInt(f.b,10).toString(16)}}}();var timerender=function(){function f(a){var b=e(new XDate),c=e(a.clone()),b=Math.round(c.diffDays(b));return 0===b?["Today",!0]:1===b?["Yesterday",!0]:[a.toString("MMM\u00a0dd"),!1]}function h(a,b,c){a.text("");return void 0!==c?a.append('<i class="date-direction icon-vector-caret-up"></i>'+c).append($('<hr class="date-line">')).append('<i class="date-direction icon-vector-caret-down"></i>'+b):a.append(b)}var b={},a=0,e=function(a){return a.setMilliseconds(0).setSeconds(0).setMinutes(0).setHours(0)},
d=[],c;$(function(){c=e(new XDate).addDays(1)});b.render_date=function(b,c){var e="timerender"+a;a++;var l=f(b),r=$("<span />").attr("id",e);if(void 0!==c)var n=f(c),r=h(r,l[0],n[0]);else r=h(r,l[0]);l[1]&&(void 0!==c?d.push([e,b,c]):d.push([e,b]));return r};b.update_timestamps=function(){var a=new XDate;if(a>=c){var b=d;d=[];_.each(b,function(a){var b=a[0],c=document.getElementById(b);if(null!==c){var e=a[1],g,m=f(e);3===a.length?(g=a[2],a=f(g),h($(c),m[0],a[0])):h($(c),m[0]);m[1]&&(void 0!==g?d.push([b,
e,g]):d.push([b,e]))}});c=e(a.clone().addDays(1))}};setInterval(b.update_timestamps,6E4);b.set_full_datetime=function(a,b){if(void 0===a.full_date_str){var c=new XDate(1E3*a.timestamp),d=-c.getTimezoneOffset()/60;a.full_date_str=c.toLocaleDateString();a.full_time_str=c.toLocaleTimeString()+" (UTC"+(0>d?"":"+")+d+")";b.attr("title",a.full_date_str+" "+a.full_time_str)}};return b}();var tutorial=function(){function f(a,b,c,d){setTimeout(function(){$.ajax({dataType:"json",url:"/json/tutorial_send_message",type:"POST",data:{type:"stream",recipient:a,topic:b,content:c}})},1E3*d)}function h(){$("#alert-bar-container").slideUp(100)}function b(a){$("#custom-alert-bar-content").html(a);$("#alert-bar-container").show();$("#alert-bar-container .close-alert-icon").expectOne().click(h)}function a(){$("body").css({overflow:"hidden"});_.each(["keydown","keyup","keypress","scroll"],function(a){var b=
$(document).data("events")[a];void 0===b&&(b=[]);F[a]=b;$(document).data("events")[a]=[]})}function e(){$("body").css({overflow:"auto"});_.each(["keydown","keyup","keypress","scroll"],function(a){$(document).data("events")[a]=F[a]})}function d(a,b){return channel.post({url:"/json/tutorial_status",data:{status:a},success:b})}function c(a,b,c,d){var e=$(document).width(),f=$(document).height();$("#top-screen").css({opacity:0.7,width:e,height:b});$("#bottom-screen").offset({top:b+d,left:0});$("#bottom-screen").css({opacity:0.7,
width:e,height:f});$("#left-screen").offset({top:b,left:0});$("#left-screen").css({opacity:0.7,width:a,height:d});$("#right-screen").offset({top:b,left:a+c});$("#right-screen").css({opacity:0.7,width:a,height:d});$("#clear-screen").css({opacity:0,width:e,height:f})}function g(){var a=viewport.message_viewport_info(),b=a.visible_top,c=a.visible_height,a=rows.get_message_recipient_row(rows.last_visible());return $.merge(a,a.prevAll()).filter(function(a,d){var e=$(d).offset();return e.top>b&&e.top<b+
c})}function m(a){if($("#left-sidebar").is(":visible"))return a;if("left"===a)return"bottom";if("bottom"===a)return"right"}function k(a,b,c,d){$(".popover").remove();a.popover("destroy");a.popover({placement:b,title:templates.render("tutorial_title",{title:c,placement:b}),content:templates.render(d,{placement:b,page_params:page_params}),trigger:"manual"});a.popover("show");$(".popover").css("z-index",20001);$(".popover-title").addClass("popover-"+b)}function l(){var a=$("#tutorial-finale");$(".screen").css({opacity:0});
a.css("z-index",20001);a.modal("show");$("#tutorial-get-started").click(function(){a.modal("hide");$(".screen").css({opacity:0,width:0,height:0})}).focus();d("finished");x=!1;current_msg_list.clear();D=void 0;server_events.force_get_events();stream_color.default_color=B;$("#first_run_message").show();current_msg_list.rerender();e();_.each(A,function(a){a()});A=[];b(page_params.prompt_for_invites?"<i class='icon-vector-heart alert-icon'></i>It's lonely in here! <a href='#invite-user' data-toggle='modal'>Invite some coworkers</a>.":
"<i class='icon-vector-desktop alert-icon'></i>What's better than "+page_params.product_name+" in your browser? The <a href='/apps' target='_blank'>"+page_params.product_name+" desktop app</a>!");stream_data.in_home_view(page_params.notifications_stream)&&narrow.activate([{operator:"stream",operand:page_params.notifications_stream}]);if(page_params.first_in_realm){var c;c=stream_data.in_home_view("engineering")?"engineering":_.find(stream_data.home_view_stream_names(),function(a){return"social"!==
a&&a!==page_params.notifications_stream});stream_data.in_home_view(page_params.notifications_stream)&&(f(page_params.notifications_stream,"welcome","Practice sending sending some messages here, or starting a new topic.",15),f(page_params.notifications_stream,page_params.product_name+" tips","Here's a message on a new topic: `"+page_params.product_name+" tips`.\n\nAs you settle into "+page_params.product_name+", customize your account and notifications on your [Settings page](#settings).",30),f(page_params.notifications_stream,
page_params.product_name+" tips","You might also enjoy:\n\n* Our lightweight !modal_link(#markdown-help, message formatting) (including emoji! :thumbsup:)\n* !modal_link(#keyboard-shortcuts, Keyboard shortcuts)\n* [Desktop and mobile apps](/apps)",40));void 0!==c&&(f(c,"projects","This is a message on stream `"+c+"` with the topic `projects`.",60),f(c,"projects","Take a peek at our [integrations](/integrations). Now's a great time to set one up!",65));stream_data.in_home_view("social")&&f("social",
"cute animals","This is a message on stream `social` with the topic `cute animals`. Try uploading or pasting in some pictures. Here's a [guinea pig](https://humbug-user-uploads.s3.amazonaws.com/byqgM1qjol1mzje_KzeNRT5F/guinea.jpg) to get you started:",75)}}function r(){var a=rows.first_visible(),b=rows.get_message_recipient_row(a),d=b.find(".message_header"),e=b.offset().left,f=b.offset().top,a=d.height()+a.height(),b=b.width();c(e,f,b,a)}function n(){var a=rows.get_message_recipient_row(rows.first_visible()),
b=a.offset().left,d=a.offset().top,e=0;_.each(g(),function(a){e+=$(a).height()});c(b,d,a.width(),e)}function t(){var a=rows.get_message_recipient_row(rows.first_visible());n();k(a,m("left"),"Replying","tutorial_reply");var b=$("#tutorial-reply").closest(".popover");b.offset({left:b.offset().left-10});D=t;$("#tutorial-reply-next").click(function(){a.popover("destroy");l()}).focus()}function s(){var a=rows.get_message_recipient_header(rows.first_visible());n();k(a,m("left"),"Narrowing","tutorial_home");
var b=$("#tutorial-home").closest(".popover");b.offset({left:b.offset().left-10});D=s;$("#tutorial-home-next").click(function(){a.popover("destroy");t()}).focus()}function q(){var a=rows.first_visible(),b=rows.get_message_recipient_header(a),a=m("bottom");r();k(b,a,"Topics","tutorial_subject");var c=$("#tutorial-subject").closest(".popover");"bottom"===a?c.offset({left:b.offset().left+140-c.width()/2}):c.offset({left:b.offset().left+194});D=q;$("#tutorial-subject-next").click(function(){b.popover("destroy");
s()}).focus()}function v(){var a=rows.get_message_recipient_header(rows.first_visible()),b=m("bottom");r();k(a,b,"Streams","tutorial_stream");var c=$("#tutorial-stream").closest(".popover");"bottom"===b?c.offset({left:a.offset().left+50-c.width()/2}):c.offset({left:a.offset().left+98});D=v;$("#tutorial-stream-next").click(function(){a.popover("destroy");q()}).focus()}function p(){$("#top-screen").css({opacity:0.7,width:$(document).width(),height:$(document).height()});var a=rows.first_visible(),b=
rows.get_message_recipient_header(a);r();k(b,m("left"),"Welcome","tutorial_message");a=$("#tutorial-message").closest(".popover");a.offset({left:a.offset().left-10});D=p;$("#tutorial-message-next").click(function(){b.popover("destroy");v()}).focus()}var y={},x=!1,F={},A=[],D,B,G=(new Date).getTime()/1E3,u=[{id:1,content:"<p>We're working on some new screenshots for our landing page!</p>",is_stream:!0,sender_full_name:"Abbie Patel",sender_email:"abbie@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/5a8d2b3836d546d523f460924a8a9973",
display_recipient:"engineering",stream:"engineering",subject:"screenshots",timestr:"12:11",timestamp:G,type:"stream"},{id:2,content:"<p>Here's the <a href='https://zulip.com/static/images/app-screenshots/zulip-desktop-windows.png' target='_blank' title='https://zulip.com/static/images/app-screenshots/zulip-desktop-windows.png'>latest version</a>:<div class='message_inline_image'><a href='https://zulip.com/static/images/app-screenshots/zulip-desktop-windows.png' target='_blank' title='https://zulip.com/static/images/app-screenshots/zulip-desktop-windows.png'><img src='https://zulip.com/static/images/app-screenshots/zulip-desktop-windows.png'></a></div> for the Windows app -- thoughts? I'm particularly wondering whether people think the screenshot should be from Windows 7 or some other version.</p>",
is_stream:!0,sender_full_name:"Abbie Patel",sender_email:"abbie@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/5a8d2b3836d546d523f460924a8a9973",display_recipient:"engineering",stream:"engineering",subject:"screenshots",timestr:"12:11",timestamp:G,type:"stream"},{id:3,content:"<p>Looks good to me! <img alt=':+1:' class='emoji' src='static/third/gemoji/images/emoji/+1.png' title=':+1:'></p>",is_stream:!0,sender_full_name:"Jeff Arnold",sender_email:"jeff@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/dd0cf69d6d1989aa0b0d8c722f7d5840",
display_recipient:"engineering",stream:"engineering",subject:"screenshots",timestr:"12:16",timestamp:G,type:"stream"},{id:4,content:"<p>Adam and I just finished a brainstorming session for the next set of integrations we want to support.</p><p><a href=''>Here</a> are our notes. I'll open tickets for the action items.</p>",is_stream:!0,sender_full_name:"Jessica McKellar",sender_email:"jessica@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/2a1ffb4ef0b4a20c04d540a35f430cf6",display_recipient:"engineering",
stream:"engineering",subject:"integrations",timestr:"12:25",timestamp:G,type:"stream"},{id:5,content:"<p>Yay, Twitter integration. <img alt=':heart_eyes:' class='emoji' src='static/third/gemoji/images/emoji/heart_eyes.png' title=':heart_eyes:'></p>",is_stream:!0,sender_full_name:"Leo Franchi",sender_email:"leo@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/4309007c980e1e8b9a2453488586482a",display_recipient:"engineering",stream:"engineering",subject:"integrations",timestr:"12:25",timestamp:G,
type:"stream"},{id:6,content:"<p>We need to add support for a few more markdown features before we can do GitHub integration.</p>",is_stream:!0,sender_full_name:"Li Jing",sender_email:"li@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/2950c2c87fe7daaa56fd6a403ecc2ee0",display_recipient:"engineering",stream:"engineering",subject:"integrations",timestr:"12:26",timestamp:G,type:"stream"},{id:7,content:"<p>Good point, I'll add that to the ticket.</p>",is_stream:!0,sender_full_name:"Jessica McKellar",
sender_email:"jessica@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/2a1ffb4ef0b4a20c04d540a35f430cf6",display_recipient:"engineering",stream:"engineering",subject:"integrations",timestr:"12:26",timestamp:G,type:"stream"},{id:8,content:"<p><img alt=':clock1130:' class='emoji' src='static/third/gemoji/images/emoji/clock1130.png' title=':clock1130:'> Reminder: engineering meeting in 1 hour. <img alt=':clock1130:' class='emoji' src='static/third/gemoji/images/emoji/clock1130.png' title=':clock1130:'></p>",
is_stream:!0,sender_full_name:"Reminder Bot",sender_email:"reminder-bot@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/78873d7213d102dc36773046560d403a",display_recipient:"engineering",stream:"engineering",subject:"weekly meeting",timestr:"12:30",timestamp:G,type:"stream"},{id:9,content:"<p>Quickly brainstorming my remaining TODO list out loud for you all:</p>",is_stream:!0,sender_full_name:"Abbie Patel",sender_email:"abbie@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/5a8d2b3836d546d523f460924a8a9973",
display_recipient:"engineering",stream:"engineering",subject:"screenshots",timestr:"12:32",timestamp:G,type:"stream"},{id:10,content:"<p><ul><li>Redo iPhone shot</li><li>Double-check layout on iPad</li><li>Update copy for new iOS app version</li><li>Check with Android team on timeline for login redesign</li></ul></p>",is_stream:!0,sender_full_name:"Abbie Patel",sender_email:"abbie@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/5a8d2b3836d546d523f460924a8a9973",display_recipient:"engineering",
stream:"engineering",subject:"screenshots",timestr:"12:32",timestamp:G,type:"stream"},{id:11,content:"<p>Oops, I actually took care of the text for iOS and forgot to update the ticket -- I'll do that now.</p>",is_stream:!0,sender_full_name:"Jeff Arnold",sender_email:"jeff@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/dd0cf69d6d1989aa0b0d8c722f7d5840",display_recipient:"engineering",stream:"engineering",subject:"screenshots",timestr:"12:16",timestamp:G,type:"stream"},{id:12,content:"<p>No problem, less work for me. <img alt=':smile:' class='emoji' src='static/third/gemoji/images/emoji/smile.png' title=':smile:'></p>",
is_stream:!0,sender_full_name:"Abbie Patel",sender_email:"abbie@zulip.com",avatar_url:"https://secure.gravatar.com/avatar/5a8d2b3836d546d523f460924a8a9973",display_recipient:"engineering",stream:"engineering",subject:"screenshots",timestr:"12:32",timestamp:G,type:"stream"}];y.is_running=function(){return x};y.defer=function(a){A.push(a)};y.start=function(){ui.home_tab_obscured()&&ui.change_tab_to("#home");narrow.deactivate();B=stream_color.default_color;stream_color.default_color="#76ce90";current_msg_list.add_and_rerender(u);
a();x=!0;d("started");p()};y.initialize=function(){page_params.needs_tutorial&&y.start();$(window).resize($.debounce(100,function(){void 0!==D&&D()}))};return y}();"undefined"!==typeof module&&(module.exports=tutorial);var templates=function(){var f={render:function(f,b){if(void 0===Handlebars.templates)throw"Cannot find compiled templates!";return Handlebars.templates[f](b)}};Handlebars.registerHelper("partial",function(h){var b={},a=arguments.length,e;for(e=1;e<a-2;e+=2)b[arguments[e]]=arguments[e+1];b=_.extend({},this,b);return new Handlebars.SafeString(f.render(h,b))});Handlebars.registerHelper("plural",function(f,b,a){return 1===f?b:a});Handlebars.registerHelper("if_and",function(){var f=arguments[arguments.length-
1],b;for(b=0;b<arguments.length-1;b++)if(!arguments[b])return f.inverse(this);return f.fn(this)});Handlebars.registerHelper("if_or",function(){var f=arguments[arguments.length-1],b;for(b=0;b<arguments.length-1;b++)if(arguments[b])return f.fn(this);return f.inverse(this)});return f}();"undefined"!==typeof module&&(module.exports=templates);var avatar=function(){function f(b){b=b.type;return!b?!1:0<=_.indexOf(["image/jpeg","image/png","image/gif","image/svg+xml"],b)}var h={build_bot_create_widget:function(){var b=$("#bot_avatar_file"),a=$("#bot_avatar_file_input_error"),e=$("#bot_avatar_clear_button"),d=$("#bot_avatar_upload_button");return h.build_widget(function(){return $("#bot_avatar_file_input")},b,a,e,d)},build_bot_edit_widget:function(b){var a=b.find(".edit_bot_avatar_file"),e=b.find(".edit_bot_avatar_error"),d=b.find(".edit_bot_avatar_clear_button"),
c=b.find(".edit_bot_avatar_upload_button");return h.build_widget(function(){return b.find(".edit_bot_avatar_file_input")},a,e,d,c)},build_widget:function(b,a,e,d,c){function g(){var e=b(),f=e.clone(!0);e.replaceWith(f);a.text("");d.hide();c.show()}d.on("click",function(a){g();a.preventDefault()});c.on("drop",function(a){var c=a.dataTransfer.files;if(null===c||void 0===c||0===c.length)return!1;b().get(0).files=c;a.preventDefault();return!1});b().on("change",function(b){0===b.target.files.length?e.hide():
1===b.target.files.length?(b=b.target.files[0],5242880<b.size?(e.text("File size must be < 5Mb."),e.show(),g()):f(b)?(a.text(b.name),e.hide(),d.show(),c.hide()):(e.text("File type is not supported."),e.show(),g())):e.text("Please just upload one file.")});c.on("click",function(a){b().trigger("click");a.preventDefault()});return{clear:g,close:function(){g();d.off("click");c.off("drop");b().off("change");c.off("click")}}},build_user_avatar_widget:function(b){return h.build_direct_upload_widget(function(){return $("#user_avatar_file_input").expectOne()},
$("#user_avatar_file_input_error").expectOne(),$("#user_avatar_upload_button").expectOne(),b)},build_direct_upload_widget:function(b,a,e,d){function c(){var a=b(),c=a.clone(!0);a.replaceWith(c)}e.on("drop",function(a){var c=a.dataTransfer.files;if(null===c||void 0===c||0===c.length)return!1;b().get(0).files=c;a.preventDefault();return!1});b().on("change",function(e){0===e.target.files.length?a.hide():1===e.target.files.length?(e=e.target.files[0],5242880<e.size?(a.text("File size must be < 5Mb."),
a.show(),c()):f(e)?(a.hide(),d(b())):(a.text("File type is not supported."),a.show(),c())):a.text("Please just upload one file.")});e.on("click",function(a){b().trigger("click");a.preventDefault()})}};return h}();var settings=function(){function f(a,b){void 0===b&&(b=[]);d.done(function(d){var e=function(a){return $("<option>").attr("value",a[0]).text(a[1])},f=_.chain(d).where({invite_only:!1}).pluck("name").map(function(a){return[a,a]}).value(),f=_.chain(b.concat(f)).map(e).reduce(function(a,b){return a.append(b)},$('<optgroup label="Public"/>')).value();d=_.chain(d).where({invite_only:!0}).pluck("name").map(function(a){return[a,a]}).map(e).reduce(function(a,b){return a.append(b)},$('<optgroup label="Private"/>')).value();
a.empty();a.append(f);a.append(d)})}function h(a,b,d){feature_flags.new_bot_ui&&(""!==b&&a.append("default_sending_stream",b),"__all_public__"===d?(a.append("default_all_public_streams",JSON.stringify(!0)),a.append("default_events_register_stream",null)):""!==d&&(a.append("default_all_public_streams",JSON.stringify(!1)),a.append("default_events_register_stream",d)))}function b(){$("#bots_list").empty();_.each(bot_data.get_editable(),function(a){a={name:a.full_name,email:a.email,avatar_url:a.avatar_url,
api_key:a.api_key,default_sending_stream:a.default_sending_stream,default_events_register_stream:a.default_events_register_stream,default_all_public_streams:a.default_all_public_streams};a.id_suffix=_.uniqueId("_bot_");var b=$(templates.render("bot_avatar_row",a)),d=b.find("select[name=bot_default_sending_stream]"),e=b.find("select[name=bot_default_events_register_stream]");feature_flags.new_bot_ui||b.find(".new-bot-ui").hide();var h=[];null===a.default_sending_stream&&h.push(["","No default selected"]);
f(d,h);d.val(a.default_sending_stream,h);d=[["__all_public__","All public streams"]];null===a.default_events_register_stream&&!a.default_all_public_streams&&d.unshift(["","No default selected"]);f(e,d);a.default_all_public_streams?e.val("__all_public__"):e.val(a.default_events_register_stream);$("#bots_list").append(b);$("#bots_list").show()})}var a={},e=$.Deferred(),d=e.promise();a.avatar_stamp=Math.floor(100*Math.random());a.setup_page=function(){function c(){$("#old_password, #new_password, #confirm_password").val("")}
function d(a,b){viewport.scrollTop(0);ui.report_error(a,b,$("#settings-status").expectOne())}function m(a,b,c,d){a=$.parseJSON(c.responseText);b=$("#notify-settings-status").expectOne();void 0!==a.enable_stream_desktop_notifications&&(page_params.stream_desktop_notifications_enabled=a.enable_stream_desktop_notifications);void 0!==a.enable_stream_sounds&&(page_params.stream_sounds_enabled=a.enable_stream_sounds);void 0!==a.enable_desktop_notifications&&(page_params.desktop_notifications_enabled=a.enable_desktop_notifications);
void 0!==a.enable_sounds&&(page_params.sounds_enabled=a.enable_sounds);void 0!==a.enable_offline_email_notifications&&(page_params.enable_offline_email_notifications=a.enable_offline_email_notifications);void 0!==a.enable_offline_push_notifications&&(page_params.enable_offline_push_notifications=a.enable_offline_push_notifications);void 0!==a.enable_digest_emails&&(page_params.enable_digest_emails=a.enable_digest_emails);ui.report_success("Updated notification settings!",b)}function k(a,b,c){ui.report_error("Error changing settings",
a,$("#notify-settings-status").expectOne())}function l(a,b){var c={};c[a]=b;channel.post({url:"/json/notify_settings/change",data:c,success:m,error:k})}function r(a){l("enable_stream_desktop_notifications",a);subs.set_all_stream_desktop_notifications_to(a)}function n(a){l("enable_stream_sounds",a);subs.set_all_stream_audible_notifications_to(a)}function t(a,b){var c=templates.render("propagate_notification_change"),d=a.closest(".control-group"),e=a.is(":checked");d.find(".propagate_stream_notifications_change").html(c);
d.find(".yes_propagate_notifications").on("click",function(a){b(e);d.find(".propagate_stream_notifications_change").empty()});d.find(".no_propagate_notifications").on("click",function(a){d.find(".propagate_stream_notifications_change").empty()})}e.isResolved()||channel.get({url:"/json/streams",success:function(a){e.resolve(a.streams);f($("#create_bot_default_sending_stream"));f($("#create_bot_default_events_register_stream"),[["__all_public__","All public streams"]])}});var s=templates.render("settings_tab",
{page_params:page_params});$("#settings").html(s);$("#settings-status").hide();$("#notify-settings-status").hide();$("#display-settings-status").hide();$("#ui-settings-status").hide();alert_words_ui.set_up_alert_words();$("#api_key_value").text("");$("#get_api_key_box").hide();$("#show_api_key_box").hide();$("#api_key_button_box").show();c();$("#api_key_button").click(function(a){!1!==page_params.password_auth_enabled?$("#get_api_key_box").show():$("#get_api_key_box form").submit();$("#api_key_button_box").hide()});
$("#pw_change_link").on("click",function(a){a.preventDefault();$("#pw_change_link").hide();$("#pw_change_controls").show()});$("#new_password").on("change keyup",function(){password_quality($("#new_password").val(),$("#pw_strength .bar"))});page_params.show_digest_email||$("#other_notifications").hide();feature_flags.new_bot_ui||$(".new-bot-ui").hide();$("form.your-account-settings").ajaxForm({dataType:"json",beforeSubmit:function(a,b,c){if(!1!==page_params.password_auth_enabled&&(a=$("#new_password").val(),
""!==a)){a=password_quality(a);if(void 0===a)return d("An internal error occurred; try reloading the page. Sorry for the trouble!"),!1;if(!a)return d("New password is too weak"),!1}return!0},success:function(a,b,c,d){viewport.scrollTop(0);ui.report_success("Updated settings!",$("#settings-status").expectOne())},error:function(a,b,c){d("Error changing settings",a)},complete:function(a,b){c()}});$("#change_notification_settings").on("click",function(a){var b={};_.each("enable_stream_desktop_notifications enable_stream_sounds enable_desktop_notifications enable_sounds enable_offline_email_notifications enable_offline_push_notifications enable_digest_emails".split(" "),
function(a){b[a]=$("#"+a).is(":checked")});channel.post({url:"/json/notify_settings/change",data:b,success:m,error:k})});$("#enable_stream_desktop_notifications").on("click",function(a){a=$("#enable_stream_desktop_notifications");t(a,r)});$("#enable_stream_sounds").on("click",function(a){a=$("#enable_stream_sounds");t(a,n)});$("#left_side_userlist").change(function(){var a={};a.left_side_userlist=JSON.stringify(this.checked);channel.patch({url:"/json/left_side_userlist",data:a,success:function(a,
b,c,d){ui.report_success("Updated display settings!  You will need to reload the window for your changes to take effect.",$("#display-settings-status").expectOne())},error:function(a,b,c){ui.report_error("Error updating display settings",a,$("#display-settings-status").expectOne())}})});$("#twenty_four_hour_time").change(function(){var a={},b=$("#twenty_four_hour_time").is(":checked");a.twenty_four_hour_time=JSON.stringify(b);channel.patch({url:"/json/time_setting",data:a,success:function(a,b,c,d){ui.report_success("Updated display settings!  You will need to reload the window for your changes to take effect",
$("#display-settings-status").expectOne())},error:function(a,b,c){ui.report_error("Error updating display settings",a,$("#display-settings-status").expectOne())}})});$("#get_api_key_box").hide();$("#show_api_key_box").hide();$("#get_api_key_box form").ajaxForm({dataType:"json",success:function(a,b,c,d){a=$.parseJSON(c.responseText);b=$("#settings-status").expectOne();$("#get_api_key_password").val("");$("#api_key_value").text(a.api_key);$("#show_api_key_box").show();$("#get_api_key_box").hide();b.hide()},
error:function(a,b,c){ui.report_error("Error getting API key",a,$("#settings-status").expectOne());$("#show_api_key_box").hide();$("#get_api_key_box").show()}});avatar.build_user_avatar_widget(function(b){var c=new FormData;c.append("csrfmiddlewaretoken",csrf_token);jQuery.each(b[0].files,function(a,b){c.append("file-"+a,b)});b=$("#upload_avatar_spinner").expectOne();loading.make_indicator(b,{text:"Uploading avatar."});channel.post({url:"/json/set_avatar",data:c,cache:!1,processData:!1,contentType:!1,
success:function(b){loading.destroy_indicator($("#upload_avatar_spinner"));b=b.avatar_url+"&stamp="+a.avatar_stamp;$("#user-settings-avatar").expectOne().attr("src",b);a.avatar_stamp+=1}})});page_params.name_changes_disabled&&$("#name_change_container").hide();b();$(document).on("zulip.bot_data_changed",b);$.validator.addMethod("bot_local_part",function(a,b){return this.optional(b)||/^[\-!#$%&'*+\/=?\^_`{}|~0-9A-Z]+(\.[\-!#$%&'*+\/=?\^_`{}|~0-9A-Z]+)*$/i.test(a+"-bot")},"Please only use characters that are valid in an email address");
var q=avatar.build_bot_create_widget();$("#create_bot_form").validate({errorClass:"text-error",success:function(){$("#bot_table_error").hide()},submitHandler:function(){var a=$("#create_bot_name").val(),b=$("#create_bot_short_name").val(),c=$("#create_bot_default_sending_stream").val(),d=$("#create_bot_default_events_register_stream").val(),e=new FormData;e.append("csrfmiddlewaretoken",csrf_token);e.append("full_name",a);e.append("short_name",b);h(e,c,d);jQuery.each($("#bot_avatar_file_input")[0].files,
function(a,b){e.append("file-"+a,b)});$("#create_bot_button").val("Adding bot...").prop("disabled",!0);channel.post({url:"/json/bots",data:e,cache:!1,processData:!1,contentType:!1,success:function(a){$("#bot_table_error").hide();$("#create_bot_name").val("");$("#create_bot_short_name").val("");$("#create_bot_button").show();q.clear()},error:function(a,b,c){$("#bot_table_error").text(JSON.parse(a.responseText).msg).show()},complete:function(a,b){$("#create_bot_button").val("Create bot").prop("disabled",
!1)}})}});$("#bots_list").on("click","button.delete_bot",function(a){var b=$(a.currentTarget).data("email");channel.del({url:"/json/bots/"+encodeURIComponent(b),success:function(){var b=$(a.currentTarget).closest("li");b.hide("slow",function(){b.remove()})},error:function(a){$("#bot_delete_error").text(JSON.parse(a.responseText).msg).show()}})});$("#bots_list").on("click","button.regenerate_bot_api_key",function(a){var b=$(a.currentTarget).data("email");channel.post({url:"/json/bots/"+encodeURIComponent(b)+
"/api_key/regenerate",idempotent:!0,success:function(b){var c=$(a.currentTarget).closest("li");c.find(".api_key").find(".value").text(b.api_key);c.find("api_key_error").hide()},error:function(b){$(a.currentTarget).closest("li").find(".api_key_error").text(JSON.parse(b.responseText).msg).show()}})});var v=0;$("#bots_list").on("click","button.open_edit_bot_form",function(a){function b(){f.show();g.show();d.hide();l.close()}var c=$(a.currentTarget).closest("li"),d=c.find("div.edit_bot"),e=c.find(".edit_bot_form"),
f=c.find(".image"),g=c.find(".bot_info");a=c.find(".reset_edit_bot");var k=g.find(".name").text();e.find(".edit_bot_name").attr("value",k);f.hide();g.hide();d.show();var l=avatar.build_bot_edit_widget(c);a.click(function(a){b();$(this).off(a)});var m=e.find(".bot_edit_errors");e.validate({errorClass:"text-error",success:function(a){m.hide()},submitHandler:function(){var a=e.data("email"),d=e.find(".edit_bot_name").val(),k=c.find(".edit_bot_avatar_file_input"),l=e.find(".edit_bot_default_sending_stream").val(),
n=e.find(".edit_bot_default_events_register_stream").val(),p=e.find(".edit_bot_spinner"),q=e.find(".edit_bot_button"),r=new FormData;r.append("csrfmiddlewaretoken",csrf_token);r.append("full_name",d);h(r,l,n);jQuery.each(k[0].files,function(a,b){r.append("file-"+a,b)});loading.make_indicator(p,{text:"Editing bot"});q.hide();channel.patch({url:"/json/bots/"+encodeURIComponent(a),data:r,cache:!1,processData:!1,contentType:!1,success:function(a){loading.destroy_indicator(p);m.hide();q.show();b();g.find(".name").text(d);
a.avatar_url&&(v+=1,f.find("img").attr("src",a.avatar_url+"&v="+v.toString()))},error:function(a,b,c){loading.destroy_indicator(p);q.show();m.text(JSON.parse(a.responseText).msg).show()}})}})});$("#show_api_key_box").on("click","button.regenerate_api_key",function(a){channel.post({url:"/json/users/me/api_key/regenerate",idempotent:!0,success:function(a){$("#api_key_value").text(a.api_key)},error:function(a){$("#user_api_key_error").text(JSON.parse(a.responseText).msg).show()}})});$("#ui-settings").on("click",
"input[name='change_settings']",function(a){var b={};_.each(["autoscroll_forever","default_desktop_notifications"],function(a){b[a]=$("#"+a).is(":checked")});channel.post({url:"/json/ui_settings/change",data:b,success:function(a,b,c,d){a="Updated "+page_params.product_name+" Labs settings!";c=$.parseJSON(c.responseText);b=$("#ui-settings-status").expectOne();void 0!==c.autoscroll_forever&&(page_params.autoscroll_forever=c.autoscroll_forever,resize.resize_page_components());ui.report_success(a,b)},
error:function(a,b,c){ui.report_error("Error changing settings",a,$("#ui-settings-status").expectOne())}})})};return a}();var tab_bar=function(){function f(a,b,c,f,h){return{active:"inactive",cls:f||"",title:a,hash:b,data:c,home:h||!1}}function h(){var a=[],b=narrow.filter();void 0!==b&&(b.has_operator("stream")&&!stream_data.in_home_view(b.operands("stream")[0])||b.has_operand("in","all"))?a.push(f("All Messages","#narrow/in/all",void 0,"root")):void 0!==page_params.narrow?(a.push(f("Stream "+page_params.narrow_stream,hashchange.operators_to_hash([page_params.narrow[0]]),page_params.narrow_stream,"stream")),void 0!==
page_params.narrow_topic&&a.push(f("Topic "+page_params.narrow_topic,hashchange.operators_to_hash(page_params.narrow),null))):a.push(f("Home","#","home","root",!0));if(narrow.active()&&0<narrow.operators().length){var c,g=narrow.operators();hashchange.operators_to_hash(g);var h=hashchange.operators_to_hash(g.slice(0,1));b.has_operator("stream")?(c=b.operands("stream")[0],a.push(f(c,h,c,"stream"))):b.has_operator("pm-with")||b.has_operand("is","private")?(a.push(f("Private Messages","#narrow/is/private",
void 0,"private_message ")),b.has_operator("pm-with")&&(c=b.operands("pm-with")[0].split(","),c=_.map(c,function(a){return!people.get_by_email(a)?a:people.get_by_email(a).full_name}),a.push(f(c.join(", "),h)))):b.has_operand("is","starred")?a.push(f("Starred",h)):b.has_operator("near")?a.push(f("Near "+b.operands("near")[0],h)):b.has_operator("id")?a.push(f("ID "+b.operands("id")[0],h)):b.has_operand("is","mentioned")?a.push(f("Mentions",h)):b.has_operator("sender")?(c=b.operands("sender")[0],people.get_by_email(c)&&
(c=people.get_by_email(c).full_name),a.push(f("Sent by "+c,h))):b.has_operator("search")&&a.push(f("Search results",!1));b.has_operator("stream")&&b.has_operator("topic")&&(c=b.operands("stream")[0],b=b.operands("topic")[0],h=hashchange.operators_to_hash(g.slice(0,2)),a.push(f(b,h,null)))}a[a.length-1].hash=null;return a}function b(){var b=h(),d=$("#tab_bar");d.empty();b[b.length-1].active="active";b=templates.render("tab_bar",{tabs:b});d.append(b);a.colorize_tab_bar();d.removeClass("notdisplayed")}
var a={colorize_tab_bar:function(){var a=$("#tab_list .stream");if(0<a.length){var b=a.data("name");if(void 0!==b){var b=b.toString(),c=stream_data.get_color(b),b=stream_color.get_color_class(c),f=colorspace.getHexColor(colorspace.getLighterColor(colorspace.getDecimalColor(c),0.2));a.hasClass("stream")&&(a.css("border-left-color",c).css("background-color",c),a.hasClass("inactive")&&a.hover(function(){$(this).css("border-left-color",f).css("background-color",f)},function(){$(this).css("border-left-color",
c).css("background-color",c)}),a.removeClass(stream_color.color_classes),a.addClass(b))}}}};$(function(){$(document).on("narrow_activated.zulip",function(a){b()});$(document).on("narrow_deactivated.zulip",function(a){b()});b()});return a}();var emoji=function(){var f={emojis:[],emojis_by_name:{}},h=[],b="+1 -1 100 1234 8ball a ab abc abcd accept aerial_tramway airplane alarm_clock alien ambulance anchor angel anger angry anguished ant apple aquarius aries arrow_backward arrow_double_down arrow_double_up arrow_down arrow_down_small arrow_forward arrow_heading_down arrow_heading_up arrow_left arrow_lower_left arrow_lower_right arrow_right arrow_right_hook arrow_up arrow_up_down arrow_up_small arrow_upper_left arrow_upper_right arrows_clockwise arrows_counterclockwise art articulated_lorry astonished athletic_shoe atm b baby baby_bottle baby_chick baby_symbol back baggage_claim balloon ballot_box_with_check bamboo banana bangbang bank bar_chart barber baseball basketball bath bathtub battery bear bee beer beers beetle beginner bell bento bicyclist bike bikini bird birthday black_circle black_joker black_large_square black_medium_small_square black_medium_square black_nib black_small_square black_square black_square_button blossom blowfish blue_book blue_car blue_heart blush boar boat bomb book bookmark bookmark_tabs books boom boot bouquet bow bowling boy bread bride_with_veil bridge_at_night briefcase broken_heart bug bulb bullettrain_front bullettrain_side bus busstop bust_in_silhouette busts_in_silhouette cactus cake calendar calling camel camera cancer candy capital_abcd capricorn car card_index carousel_horse cat cat2 cd chart chart_with_downwards_trend chart_with_upwards_trend checkered_flag cherries cherry_blossom chestnut chicken children_crossing chocolate_bar christmas_tree church cinema circus_tent city_sunrise city_sunset cl clap clapper clipboard clock1 clock10 clock1030 clock11 clock1130 clock12 clock1230 clock130 clock2 clock230 clock3 clock330 clock4 clock430 clock5 clock530 clock6 clock630 clock7 clock730 clock8 clock830 clock9 clock930 closed_book closed_lock_with_key closed_umbrella cloud clubs cn cocktail coffee cold_sweat collision computer confetti_ball confounded confused congratulations construction construction_worker convenience_store cookie cool cop copyright corn couple couple_with_heart couplekiss cow cow2 credit_card crescent_moon crocodile crossed_flags crown cry crying_cat_face crystal_ball cupid curly_loop currency_exchange curry custard customs cyclone dancer dancers dango dart dash date de deciduous_tree department_store diamond_shape_with_a_dot_inside diamonds disappointed disappointed_relieved dizzy dizzy_face do_not_litter dog dog2 dollar dolls dolphin door doughnut dragon dragon_face dress dromedary_camel droplet dvd e-mail ear ear_of_rice earth_africa earth_americas earth_asia egg eggplant eight eight_pointed_black_star eight_spoked_asterisk electric_plug elephant email end envelope envelope_with_arrow es euro european_castle european_post_office evergreen_tree exclamation expressionless eyeglasses eyes facepunch factory fallen_leaf family fast_forward fax fearful feet ferris_wheel file_folder fire fire_engine fireworks first_quarter_moon first_quarter_moon_with_face fish fish_cake fishing_pole_and_fish fist five flags flashlight flipper floppy_disk flower_playing_cards flushed foggy football footprints fork_and_knife fountain four four_leaf_clover fr free fried_shrimp fries frog frowning fuelpump full_moon full_moon_with_face game_die gb gem gemini ghost gift gift_heart girl globe_with_meridians goat golf grapes green_apple green_book green_heart grey_exclamation grey_question grimacing grin grinning guardsman guitar gun haircut hamburger hammer hamster hand handbag hankey hash hatched_chick hatching_chick headphones hear_no_evil heart heart_decoration heart_eyes heart_eyes_cat heartbeat heartpulse hearts heavy_check_mark heavy_division_sign heavy_dollar_sign heavy_exclamation_mark heavy_minus_sign heavy_multiplication_x heavy_plus_sign helicopter herb hibiscus high_brightness high_heel hocho honey_pot honeybee horse horse_racing hospital hotel hotsprings hourglass hourglass_flowing_sand house house_with_garden hushed ice_cream icecream id ideograph_advantage imp inbox_tray incoming_envelope information_desk_person information_source innocent interrobang iphone it izakaya_lantern jack_o_lantern japan japanese_castle japanese_goblin japanese_ogre jeans joy joy_cat jp key keycap_ten kimono kiss kissing kissing_cat kissing_closed_eyes kissing_heart kissing_smiling_eyes koala koko kr lantern large_blue_circle large_blue_diamond large_orange_diamond last_quarter_moon last_quarter_moon_with_face laughing leaves ledger left_luggage left_right_arrow leftwards_arrow_with_hook lemon leo leopard libra light_rail link lips lipstick lock lock_with_ink_pen lollipop loop loudspeaker love_hotel love_letter low_brightness m mag mag_right mahjong mailbox mailbox_closed mailbox_with_mail mailbox_with_no_mail man man_with_gua_pi_mao man_with_turban mans_shoe maple_leaf mask massage meat_on_bone mega melon memo mens metro microphone microscope milky_way minibus minidisc mobile_phone_off money_with_wings moneybag monkey monkey_face monorail moon mortar_board mount_fuji mountain_bicyclist mountain_cableway mountain_railway mouse mouse2 movie_camera moyai muscle mushroom musical_keyboard musical_note musical_score mute nail_care name_badge necktie negative_squared_cross_mark neutral_face new new_moon new_moon_with_face newspaper ng nine no_bell no_bicycles no_entry no_entry_sign no_good no_mobile_phones no_mouth no_pedestrians no_smoking non-potable_water nose notebook notebook_with_decorative_cover notes nut_and_bolt o o2 ocean octopus oden office ok ok_hand ok_woman older_man older_woman on oncoming_automobile oncoming_bus oncoming_police_car oncoming_taxi one open_book open_file_folder open_hands open_mouth ophiuchus orange_book outbox_tray ox package page_facing_up page_with_curl pager palm_tree panda_face paperclip parking part_alternation_mark partly_sunny passport_control paw_prints peach pear pencil pencil2 penguin pensive performing_arts persevere person_frowning person_with_blond_hair person_with_pouting_face phone pig pig2 pig_nose pill pineapple pisces pizza point_down point_left point_right point_up point_up_2 police_car poodle poop post_office postal_horn postbox potable_water pouch poultry_leg pound pouting_cat pray princess punch purple_heart purse pushpin put_litter_in_its_place question rabbit rabbit2 racehorse radio radio_button rage railway_car rainbow raised_hand raised_hands raising_hand ram ramen rat recycle red_car red_circle registered relaxed relieved repeat repeat_one restroom revolving_hearts rewind ribbon rice rice_ball rice_cracker rice_scene ring rocket roller_coaster rooster rose rotating_light round_pushpin rowboat ru rugby_football runner running running_shirt_with_sash sa sagittarius sailboat sake sandal santa satellite satisfied saxophone school school_satchel scissors scorpius scream scream_cat scroll seat secret see_no_evil seedling seven shaved_ice sheep shell ship shirt shit shoe shower signal_strength six six_pointed_star ski skull sleeping sleepy slot_machine small_blue_diamond small_orange_diamond small_red_triangle small_red_triangle_down smile smile_cat smiley smiley_cat smiling_imp smirk smirk_cat smoking snail snake snowboarder snowflake snowman sob soccer soon sos sound space_invader spades spaghetti sparkle sparkler sparkles sparkling_heart speak_no_evil speaker speech_balloon speedboat star star2 stars station statue_of_liberty steam_locomotive stew straight_ruler strawberry stuck_out_tongue stuck_out_tongue_closed_eyes stuck_out_tongue_winking_eye sun_with_face sunflower sunglasses sunny sunrise sunrise_over_mountains surfer sushi suspension_railway sweat sweat_drops sweat_smile sweet_potato swimmer symbols syringe tada tanabata_tree tangerine taurus taxi tea telephone telephone_receiver telescope tennis tent thought_balloon three thumbsdown thumbsup ticket tiger tiger2 tired_face tm toilet tokyo_tower tomato tongue top tophat tractor traffic_light train train2 tram triangular_flag_on_post triangular_ruler trident triumph trolleybus trophy tropical_drink tropical_fish truck trumpet tshirt tulip turtle tv twisted_rightwards_arrows two two_hearts two_men_holding_hands two_women_holding_hands u5272 u5408 u55b6 u6307 u6708 u6709 u6e80 u7121 u7533 u7981 u7a7a uk umbrella unamused underage unlock up us v vertical_traffic_light vhs vibration_mode video_camera video_game violin virgo volcano vs walking waning_crescent_moon waning_gibbous_moon warning watch water_buffalo watermelon wave wavy_dash waxing_crescent_moon waxing_gibbous_moon wc weary wedding whale whale2 wheelchair white_check_mark white_circle white_flower white_large_square white_medium_small_square white_medium_square white_small_square white_square white_square_button wind_chime wine_glass wink wolf woman womans_clothes womans_hat womens worried wrench x yellow_heart yen yum zap zero zzz".split(" ");
b.push("zulip");_.each(b,function(a){h.push({emoji_name:a,emoji_url:"static/third/gemoji/images/emoji/"+a+".png"})});f.update_emojis=function(a){f.emojis=h.slice(0);_.each(a,function(a,b){f.emojis.push({emoji_name:b,emoji_url:a})});f.emojis_by_name={};_.each(f.emojis,function(a){f.emojis_by_name[a.emoji_name]=a.emoji_url})};f.update_emojis(page_params.realm_emoji);return f}();"undefined"!==typeof module&&(module.exports=emoji);var referral=function(){function f(a){a.stop();a.css({opacity:100});a.show().delay(4E3).fadeOut(1E3,ui.resize_page_components)}var h={},b="nikola.tesla@example.com sam.morse@example.com c.shannon@example.com hedy.lamarr@example.com grace.hopper@example.com ada.lovelace@example.com".split(" "),a,e,d=!1;h.update_state=function(c,f){if(!(a===c&&e===f)){a=c;e=f;if(0>=c||feature_flags.do_not_share_the_love)$("#share-the-love").hide();else{$("#referral-form input").attr("placeholder",_.shuffle(b).pop());
$("#invite-hearts").empty();var h;for(h=0;h<f;h++)$("#invite-hearts").append($('<i class="icon-vector-heart"> </i>'));var k=Math.max(0,c-f);for(h=0;h<k;h++)$("#invite-hearts").append($('<i class="icon-vector-heart-empty"> </i>'));$(".invite-count").text(k);1===k?$(".invite-count-is-plural").hide():$(".invite-count-is-plural").show();0<k?(d=!0,$(".still-have-invites").show(),$(".no-more-invites").hide()):($(".still-have-invites").hide(),$("#referral-form input").blur(),d&&$(".no-more-invites").show());
0<f&&$("#encouraging-invite-message").hide();$("#share-the-love").show()}resize.resize_page_components()}};$(function(){var b=$("#referral-form").validate({errorClass:"text-error",submitHandler:function(){channel.post({url:"/json/refer_friend",data:{email:$("#referral-form input").val()},error:function(){}});f($("#tell-a-friend-success"));$("#referral-form input").val("");h.update_state(a,e+1)},success:function(){resize.resize_page_components()},showErrors:function(){this.defaultShowErrors();resize.resize_page_components()}});
$("#referral-form input").on("blur",function(a){""===$("#referral-form input").val()&&(b.resetForm(),resize.resize_page_components())});$("#referral-form").on("click",function(a){a.stopPropagation()});$("#share-the-love-expand-collapse").click(function(a){$("#share-the-love-contents").toggle();$("#share-the-love-expand-collapse .toggle").toggleClass("icon-vector-caret-right icon-vector-caret-down");resize.resize_page_components();a.stopPropagation()});h.update_state(page_params.referrals.granted,
page_params.referrals.used)});return h}();var custom_markdown=function(){(function(){function f(a,b){channel.post({url:"/json/subscriptions/add",data:{subscriptions:JSON.stringify([{name:a}])}}).then(function(a){$.isEmptyObject(a.already_subscribed)||ui.report_success("Already subscribed to "+a.already_subscribed[page_params.email][0],b)},function(a){ui.report_error("Error adding subscription",a,b)})}function h(a,b){channel.post({url:"/json/subscriptions/remove",data:{subscriptions:JSON.stringify([a])}}).then(function(a){b.hide()},function(a){ui.report_error("Error removing subscription",
a,b)})}function b(a,b){a.text("Subscribe to "+stream_data.canonicalized_name(b)).removeClass("btn-success").addClass("btn-default")}function a(a,b){a.text("Unsubscribe from "+stream_data.canonicalized_name(b)).removeClass("btn-default").addClass("btn-success")}var e={};$(function(){$("#main_div").delegate(".inline-subscribe-button","click",function(a){var b=$(a.target),d=b.closest(".inline-subscribe").attr("data-stream-name"),b=b.siblings(".inline-subscribe-error");a.preventDefault();a.stopPropagation();
stream_data.is_subscribed(d)?h(d,b):f(d,b)})});$(document).on("message_rendered.zulip",function(c){var d,f,h;c=$(c.target).find(".inline-subscribe");0!==c.length&&(f=c.attr("data-stream-name"),d=c.find(".inline-subscribe-button"),e[f]?h=e[f]:(h=_.uniqueId("inline-subscribe-id-"),e[f]=h),c.attr("data-stream-ui-id",h),stream_data.is_subscribed(f)?a(d,f):b(d,f))});var d=function(c){c=c.sub.name;var d=e[c],d=$("#main_div").find('.inline-subscribe[data-stream-ui-id="'+d+'"] .inline-subscribe-button');
stream_data.is_subscribed(c)?a(d,c):b(d,c)};$(document).on("subscription_add_done.zulip",d);$(document).on("subscription_remove_done.zulip",d)})();return{}}();"undefined"!==typeof module&&(module.exports=custom_markdown);var bot_data=function(){var f={},h={},b="api_key avatar_url default_all_public_streams default_events_register_stream default_sending_stream email full_name owner".split(" "),a=_.debounce(function(){$(document).trigger("zulip.bot_data_changed")},50),e=function(a){a.can_admin=page_params.is_admin?!0:page_params.email===a.owner?!0:!1};f.add=function(d){var c=_.pick(d,b);h[d.email]=c;e(c);a()};f.remove=function(b){delete h[b];a()};f.update=function(d,c){var f=h[d];_.extend(f,_.pick(c,b));e(f);a()};f.get_editable=
function(){return _.filter(h,function(a){return a.can_admin})};f.get=function(a){return h[a]};$(function(){_.each(page_params.bot_list,function(a){f.add(a)})});return f}();"undefined"!==typeof module&&(module.exports=bot_data);(function(f){function h(a){if(b[a])return b[a].exports;var e=b[a]={exports:{},id:a,loaded:!1};f[a].call(e.exports,e,e.exports,h);e.loaded=!0;return e.exports}var b={};h.m=f;h.c=b;h.p="";return h(0)})([function(f,h){}]);
